C
C
C
      SUBROUTINE   SIVLOD
     I                    (MESSFL, FINV,
     O                     ERRFLG)
C
C     + + + PURPOSE + + +
C     This routine read independent and explanatory valiables from
C     users sequential files and reads input for GLS.
C     Z IS INPUT DATA
C     R IS CROSS CORRELATION MATRIX
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, FINV, ERRFLG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of ANNIE message file
C     FINV   - Fortran unit number of users input file
C     ERRFLG - Error flag on file reads, 0 = OK, 1 = error on reads
C
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'pglsiz.inc'
      INCLUDE 'cgls.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,J,KODE,RESP,SGRP,L80,L8,L4,JUST,OLEN,MISFLG(3),LOC,
     #          LOOP,PHI,IRET,SCNFG,L1,L2,L3,SCLU,INUM,CNUM,RNUM,LEN,
     #          IVAL(6),CVAL(3,6),L65
      CHARACTER*1  ANS(8),VAR(8),BLNK,TBUFF(80,MAXINP),FBUFF(65)
      REAL      RVAL(6)
      CHARACTER*65 FORMT
C
C     + + + EXTERNALS + + +
      EXTERNAL   ZIPC, INTCHR, CHRCHR, FIND, QRESCX, QGETI
      EXTERNAL   PRNTXT, Q1EDIT, Q1INIT, QGTCOB, QGTCTF, CARVAR
      EXTERNAL   PRNTXI, QSTCTF
C
C     + + + DATA INITIALIZATION + + +
      DATA VAR/'V','A','R',' ',' ',' ',' ',' '/, BLNK/' '/
      DATA L80/80/, L8/8/, L4/4/, L1/1/, L2/2/, L3/3/, L65/65/
      DATA FBUFF/'(','8','A','1',',','2','3','E','1','3','.','5',')',
     &           52*' '/
C
C     + + + END SPECIFICATIONS + + +
C
      SCLU = 106
C
C     Analysis for PEAKS or n-day HIGH or LOW flow?
C     number of variables, format, change names.
      SGRP = 124
      CALL Q1INIT (MESSFL, SCLU, SGRP)
      CALL QSTCTF (L2, L65, FBUFF)
      CALL Q1EDIT (IRET)
      CALL QGETI (L1, NV)
      CALL QGTCOB (L1, L1, PHI)
      CALL QGTCTF (L2, L65, FBUFF)
      CALL CARVAR (L65,FBUFF, L65, FORMT)
      CALL QGTCOB (L1, L3, RESP)
      IF (PHI .EQ. 3) THEN
C       low flow
        ILOW = 1
      ELSE
C       high flow
        ILOW = 0
      END IF
C     read input file
      NSITES=0
      ERRFLG = 0
      DO 10 I=1,MAXPTS
        READ(FINV,FMT=FORMT,END=14,ERR=12)(STANO(J,I),J=1,8),
     &                                     (Z(I,J),J=1,NV)
        NSITES=NSITES+1
 10   CONTINUE
      GO TO 14
C
 12   CONTINUE
        ERRFLG = 1
C       Read error, format problem.
        SGRP = 118
        CALL PRNTXI (MESSFL, SCLU, SGRP, NSITES)
 14   CONTINUE
C
      IF (ERRFLG .EQ. 0) THEN
        CALL ZIPC (8*NV,BLNK,XLABS)
        JUST = 1
        DO 20 J=1,NV
          CALL INTCHR (J,L4,JUST,OLEN,VAR(4))
C         use default
          CALL CHRCHR (L8,VAR,XLABS(1,J))
 20     CONTINUE
        JUST = 0
        IF (RESP .EQ. 1) THEN
C         change variable names
          INUM = 1
          CNUM = 1
          RNUM = 1
          SGRP = 5
          SCNFG = 1
          DO 21 J=1,NV
            CALL ZIPC (L80, BLNK, TBUFF(1,J))
            CALL INTCHR (J,L2,JUST,OLEN,TBUFF(1,J))
            CALL CHRCHR (L8, XLABS(1,J), TBUFF(3,J))
 21       CONTINUE
          CALL QRESCX (MESSFL,SCLU,SGRP,INUM,RNUM,CNUM,NV,SCNFG,
     &                 IVAL,RVAL,CVAL,TBUFF)
          DO 22 J=1,NV
            LOC = 1
            CALL CHRCHR (L8, TBUFF(3,J), XLABS(1,J))
            LOC = LOC + 8
 22       CONTINUE
        ENDIF
C       enter name of mean, std. dev and skew.
        SGRP = 6
        CALL Q1INIT (MESSFL, SCLU, SGRP)
C       put out first 9 names
        LEN = 8*NV
        IF (LEN .GT. 72) LEN = 72
        CALL QSTCTF (L4, LEN, XLABS)
        CALL Q1EDIT (IRET)
C       identify columns
        LOOP = 0
 23     CONTINUE
          LOOP = LOOP + 1
          CALL QGTCTF (L1,L8,ANS)
          KODE=1
          CALL FIND(MESSFL,KODE,NV,XLABS,ANS,ICOL,MISFLG(1))
          CALL QGTCTF (L2,L8,ANS)
          KODE=2
          CALL FIND(MESSFL,KODE,NV,XLABS,ANS,ICOL,MISFLG(2))
          CALL QGTCTF (L3,L8,ANS)
          KODE=3
          CALL FIND(MESSFL,KODE,NV,XLABS,ANS,ICOL,MISFLG(3))
          IF ((MISFLG(1)+MISFLG(2)+MISFLG(3)) .NE. 0) THEN
            SGRP = 7
            CALL PRNTXT (MESSFL, SCLU, SGRP)
            LOOP = 0
          END IF
        IF (LOOP .EQ. 0) GO TO 23
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   SCRLOD
     I                     (MESSFL, FIN8)
C
C     + + + PURPOSE + + +
C     This routine read the concurrent record matrix from the users
C     sequential file.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   FIN8, MESSFL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of GLSNET message file
C     FIN8   - Fortran unit number of users input sequential file
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'pglsiz.inc'
      INCLUDE 'cgls.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I, J, SCLU, SGRP,ICHK, IVAL(6), CVAL(3,6), NROW, SCNFG,
     #          II,IR,IC,L8,NP,RESP,L80
      REAL       A, PH, RLS, RVAL(6), H
      CHARACTER*1  BUFF(80), BLNK, SSS(8)
      CHARACTER*8  VSSS
C
C     + + + INTRINSICS + + +
      INTRINSIC   REAL, INT, ALOG
C
C     + + + FUNCTIONS + + +
      INTEGER   CHKSTR
C
C     + + + EXTERNALS + + +
      EXTERNAL   PRNTXT, QRESP, QRESCX, CHRCHR, CHKSTR, CARVAR, ZIPC
C
C     + + + INPUT FORMAT + + +
 1012 FORMAT (20I4)
C
C     + + + DATA INITIALIZATIONS + + +
      DATA   L8/8/, L80/80/, BLNK/' '/
C
C     + + + END SPECIFICATIONS + + +
C
      SCLU = 106
C
C     read in data on variables
      DO 30 I=1,NSITES
        READ(FIN8,1012,ERR=99,END=99) (MCON(I,J),J=1,I)
 30   CONTINUE
C
      IF (ILOW .EQ. 0) THEN
C     Was historic information used in the frequency analysis?
C     (1=no,2=yes)
        SGRP = 127
        CALL QRESP (MESSFL,SCLU,SGRP,RESP)
        IF (RESP .EQ. 2) THEN
 60     CONTINUE
C           Station number, historic record length, # historic peaks
            CALL ZIPC (L80, BLNK, BUFF)
            II = 1
            IR = 1
            IC = 1
            NROW = 6
            SCNFG = 1
            SGRP = 128
            CALL QRESCX (MESSFL,SCLU,SGRP,II,IR,IC,NROW,SCNFG,
     &                   IVAL,RVAL,CVAL,BUFF)
            I = 0
            DO 70 I=1,6
              J = J + 8
              CALL CHRCHR (L8,BUFF(J),SSS)
              CALL CARVAR (L8,SSS,L8,VSSS)
              IF (VSSS .NE. '        ') THEN
                ICHK = CHKSTR (L8,NSITES,SSS,STANO)
                IF (ICHK .EQ. 0) THEN
C                 no station match
                  SGRP = 129
                  CALL PRNTXT (MESSFL,SCLU,SGRP)
                  ICHK = 1
                ELSE
C                 station match, so calculate
                  H = RVAL(I)
                  NP = IVAL(I)
                  RLS = REAL(MCON(ICHK,ICHK))
                  H = H - RLS
                  IF (H .GT. 200.) H = 200.
                  PH = 1.0 - REAL(NP)/(H+RLS)
                  PH = ALOG(PH/(1.0-PH))
                  A = 0.55 - 0.1*PH
                  MCON(ICHK,ICHK) = INT(A*H + RLS)
                END IF
              END IF
 70         CONTINUE
C           More? (1=y,2=N)
            SGRP = 145
            CALL QRESP (MESSFL,SCLU,SGRP,ICHK)
          IF (ICHK .EQ. 1) GO TO 60
        END IF
      END IF
C
      GO TO 100
 99   CONTINUE
C       input error
        SGRP = 29
        CALL PRNTXT (MESSFL, SCLU, SGRP)
 100  CONTINUE
C
      RETURN
      END
C
C
C
      SUBROUTINE   SCCLOD
     I                    (FINC,MESSFL)
C
C     + + + PURPOSE + + +
C     This routine reads cross-correlation matrix from users input
C     sequential file.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   FINC, MESSFL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     FINC   - Fortran unit number of users input sequential file
C     MESSFL - Fortran unit number of GLSNET message file
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'pglsiz.inc'
      INCLUDE 'cgls.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,J,SCLU,SGRP
C
C     + + + EXTERNALS + + +
      EXTERNAL   PRNTXT
C
C     + + + INPUT FORMAT + + +
 1002 FORMAT(20F4.0)
C
C     + + + END SPECIFICATIONS + + +
C
      SCLU = 106
C
C     read in cross correlation matrix
      DO 9 I=1,NSITES
        READ(FINC,1002,ERR=99,END=99)(RHOC(I,J),J=1,I)
 9    CONTINUE
C
      GO TO 100
 99   CONTINUE
C       input error
        SGRP = 29
        CALL PRNTXT (MESSFL, SCLU, SGRP)
 100  CONTINUE
C
      RETURN
      END
