C
C
C
      PROGRAM   GLSNET
C
C     GLSNET is an interactive program that does ordinary least squares,
C     generalized least squares, and network analysis.  It also
C     preprocesses partial record stations for generalized least squares.
C
C     + + + PARAMETERS + + +
      INCLUDE 'pmesfl.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      SCLU,SGRP,RESP,ERRFL,I,I0,I1,I21,WDMSFL,BLDOPT,
     &                DEL
      CHARACTER*16 WNAME
      CHARACTER*64 FNAME, VERSN
      CHARACTER*8  PTHNAM,LGNAM
C
C     + + + EXTERNALS + + +
      EXTERNAL     PRWFLE, PROGLS, PRONET, QFCLOS
      EXTERNAL     ANINIZ, ZANSET, ZSTCMA, PROSLS
      EXTERNAL     PMXCNW, ZMNSST, QRESP, PRTPRO
      EXTERNAL     GPCLOS, GPOPEN, ANCLOS, PRNTXT
C
C     + + + DATA INITIALIZATIONS + + +
      DATA   I0,I1,I21/0,1,21/
C
C     + + + END SPECIFICATIONS + + +
C
C     Initialize environment
C     version info for unix what
C     names of application, log file, and message file
      INCLUDE 'fglsms.inc'
C     open message file and log file
      CALL ANINIZ (MESSFL,FNAME,LGNAM)
C     set program name for window
      CALL ZANSET (WNAME)
C     output diagnostic and transaction file
C     open GKS
      CALL GPOPEN (ERRFL)
C     turn off XPAD command
      CALL ZSTCMA (I21,I0)
C     init to no WDM file in use
      WDMSFL= 0
C
C     cluster for top of GLS
      SCLU= 151
C     default is to start to open the wdm file
      RESP= 1
C
 10   CONTINUE
C       opening screen
C       file, partial-record, ols, gls, network, query, return
        SGRP= 1
        CALL QRESP (MESSFL,SCLU,SGRP,
     M              RESP)
C
        IF (RESP .EQ. 1) THEN
C         get or close a WDM file
          PTHNAM = ' '
          BLDOPT = 0
          CALL PRWFLE (MESSFL,BLDOPT,PTHNAM,WDMSFL)
        ELSE IF (RESP .EQ. 2) THEN
C         want to do GLS
          IF (WDMSFL .EQ. 0) THEN
C           need wdm file open first
            SGRP = 3
            CALL PRNTXT(MESSFL,SCLU,SGRP)
            RESP = 1
          ELSE
C           partial record analysis
            CALL PRTPRO (MESSFL,WDMSFL,ERRFL)
          END IF
        ELSE IF (RESP .EQ. 3) THEN
C         ordinary least squares
          CALL PROSLS (MESSFL,WDMSFL)
        ELSE IF (RESP .EQ. 4) THEN
C         GLS analysis
          CALL PROGLS (MESSFL,WDMSFL,ERRFL,VERSN)
        ELSE IF (RESP .EQ. 5) THEN
C         network analysis
          CALL PRONET (MESSFL,VERSN)
        ELSE IF (RESP .EQ. 6) THEN
C         provide user support info
          SGRP = 4
          CALL PRNTXT (MESSFL, SCLU, SGRP)
        END IF
      IF (RESP .NE. 7) GO TO 10
C
C     shut down aide
      CALL ANCLOS (MESSFL)
C     close out GKS
      CALL GPCLOS (ERRFL)
      DEL = 0
      IF (WDMSFL .GT. 0) CALL QFCLOS (WDMSFL,DEL)
C
      STOP
      END
