C
C
C
      SUBROUTINE   WIVLOD
     I                    (MESSFL,WDMSFL,DONEFG)
C
C     + + + PURPOSE + + +
C     This routine gets input variables from WDM file attributes for
C     use in Generalized Least Squares analysis.
C
C     + + + KEYWORDS + + +
C     WDM file, message file
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, WDMSFL, DONEFG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of GLSNET message file
C     WDMSFL - Fortran unit number of WDM file
C     DONEFG - done flag, 1 if got set up ok, 0 if not.
C
C     + + + PARAMETERS + + +
      INCLUDE 'pglsiz.inc'
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cgls.inc'
      INCLUDE 'cgldsn.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      I, I1, J, JJ, K, L0, L1, L4, L5, L6, L8, L9, L78, N, 
     $             CODES(MAXINP), RESP, DORV, SGRP, SCLU, PHI, IVL,
     $             ICNT, IDROP, JM1, NCODES, RETCOD, IB, IBD, 
     $             IT, BADDSN(MAXPTS), TRCODE(3,MAXINP), JUST, 
     $             OLEN, K1(3,MAXINP), KODE, KOUNT, M1, LOC, 
     $             IBA, MISFLG, IBDATT(20), IBDA, LEN, IP, IR, 
     $             IFLG, GOPT, DSNX(DSNBMX), IDXP(DSNBMX), SALEN, 
     $             SAIND, CLEN(MAXINP), IRET, INUM, RNUM, CNUM, 
     $             SCNFG, BADCOD(MAXINP), STAFLG, ATTFLG, DATAFG, MXL, 
     $             IWRT, CLN(2),TRSHFT(11), CVAL(4,3,MAXINP), 
     $             IVAL(MAXINP), KA, KB, BDFG2, ONUM, OTYP(21), CVL(1),
     $             ZIPLEN, IGOOD, JUSTL, DNUM, NMFLDS, UIMIN(1), 
     $             UIMAX(1), UIDEF(1), VLINFG(1), UCCNT(1), UCDEF(1),
     $             USTRLN(1), NMPAR
      REAL         C1(3,MAXINP), C2(3,MAXINP), SUM, RDUM(1), 
     $             RVAL(6,MAXINP), ATTVAL(MAXPTS,MAXINP), R0, URMIN(1), 
     $             URMAX(1), URDEF(1)
      DOUBLE PRECISION  DDUM(1), UDMIN(1), UDMAX(1), UDDEF(1)
      CHARACTER*1  SS(8,2),SD(8,2),SM(8,2),ANS(8,2),TBUFF(120), BLNK,
     $             TRBUF(80,MAXINP), CMATCH(6), NONE(4), CCHK(8),
     $             CBUFF(8,MAXINP), TXTBUF(10), URSPST(1)
      CHARACTER*8  PTHNAM
C
C     + + + FUNCTIONS + + +
      INTEGER      LENSTR
C
C     + + + INTRINSICS + + +
      INTRINSIC    SNGL, MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL     WDBSGR, WDSAFI, WDATGT
      EXTERNAL     PRNTXI, PRNTXT, PRWMSE, PMXTXI, PMXTXA
      EXTERNAL     QRESP, QRESPI, QRESCX, Q1INIT, Q1EDIT, QSTCTF
      EXTERNAL     QGTCTF, QSETI, QSETCO, QGETCO, ZSTADD, ZMNSST, QSCSET
      EXTERNAL     ZIPI, ZIPR, ZIPC, INTCHR, DECCHR, CARVAR, CHRCHR
      EXTERNAL     LENSTR, LFTSTR
      EXTERNAL     ALGEBR, FIND, VARPLT, VWDATA, STATVR
C
C     + + + DATA INITIALIZATION + + +
      DATA SS/'W','R','C','S','K','W',' ',' ','S','K','W','N','D',' ',
     $        ' ',' '/
      DATA SM/'W','R','C','M','N',' ',' ',' ','M','E','A','N','N','D',
     $        ' ',' '/
      DATA SD/'W','R','C','S','D',' ',' ',' ','S','D','N','D',' ',' ',
     $        ' ',' '/
      DATA  BLNK/' '/,  L9/9/,  M1/-1/,  NONE/'N','O','N','E'/
      DATA TRSHFT/ 0, 2, 3,10,11,13,14,15,16,17,18/           
C
C     + + + END SPECIFICATIONS + + +
C
      DATAFG = 0
      STAFLG = 0
      I1 = 1
      SCLU = 106
      L8 = 8
      L1 = 1
      L4 = 4
      L5 = 5
      L0 = 0
      R0 = 0.0
      L6 = 6
      L78 = 78
      JUST = 0
      JUSTL = 1
      MXL = 10
      SCNFG = 1
      CALL ZIPI (3*MAXINP, L0, K1)
      CALL ZIPR (3*MAXINP, 0.0, C1)
      CALL ZIPR (3*MAXINP, 0.0, C2)
      CALL ZIPI (MAXINP, L0, CODES)
      CALL ZIPI (MAXINP, L0, IBDATT)
      NCODES = 0
      CALL ZIPC (8*MAXINP, BLNK, XLABS)
C     assign dummy values to arrays passed to--but not used in--QSCSET
      URMIN(1) = 0
      URMAX(1) = 0
      URDEF(1) = 0
      UDMIN(1) = 0
      UDMAX(1) = 0
      UDDEF(1) = 0
      VLINFG(1) = 0
      UCCNT(1) = 1
      UCDEF(1) = 1
      USTRLN(1) = 1
      URSPST(1) = ' '
C
 5    CONTINUE
C
C     stations(1), variables(2), get(3), help(4), transform(5),
C     plot data(7), view data(6), return(8)
C     return
      SGRP = 109
      CALL QRESP (MESSFL, SCLU, SGRP, GOPT)
C
      IF (GOPT .EQ. 4) THEN
C       provide explanation
        SGRP = 20
        CALL PRNTXT (MESSFL, SCLU, SGRP)
C
      ELSE IF (GOPT .EQ. 1) THEN
C       select stations
 10     CONTINUE
C         loop to work on getting enough stations
          PTHNAM = 'GP      '
          CALL PRWMSE (MESSFL,WDMSFL,DSNBMX,PTHNAM,DSNBUF,NSITES)
          RESP = 1
          IF (NSITES .LE. 5) THEN
C           Do you want to reselect datasets? 1=Y,2=N
            SGRP = 36
            CALL QRESP (MESSFL, SCLU, SGRP, RESP)
          ELSE
            STAFLG = 1
          END IF
        IF (STAFLG .EQ. 0 .AND. RESP .EQ. 1) GO TO 10
C
      ELSE IF (GOPT .EQ. 2) THEN
C       Analysis for PEAKS or n-day HIGH or LOW flow?
        SGRP = 25
        CALL QRESP (MESSFL, SCLU, SGRP, PHI)
        IF (PHI .EQ. 3) THEN
C         low flow
          ILOW = 1
        ELSE
C         high flow
          ILOW = 0
        END IF
        IF (PHI .EQ. 1) THEN
C         for peaks
          CODES(1) = 78
          CODES(2) = 79
          CODES(3) = 77
        ELSE
C         n-day high or low
          CODES(1) = 280
          CODES(2) = 281
          CODES(3) = 282
        END IF
C
        IF (ILOW .EQ. 1) THEN
C         low flow analysis so check for sites without mean and stddev
C         and put them last
          IFLG = 0
          L0 = 0
          SALEN = 1
          CALL ZIPI (DSNBMX,L0,IDXP)
          DO 20 I = 1,NSITES
            SAIND = 280
            CALL WDBSGR (WDMSFL, DSNBUF(I), SAIND, SALEN, 
     O                   RDUM, RETCOD)
            IF (RETCOD .NE. 0) THEN
C             missing mean
              IDXP(I) = 1
              IFLG = IFLG +  1
            ELSE
              SAIND = 281
              CALL WDBSGR (WDMSFL, DSNBUF(I), SAIND, SALEN, 
     O                     RDUM, RETCOD)
              IF (RETCOD .NE. 0) THEN
C               missing standard deviation
                IDXP(I) = 1
                IFLG = IFLG + 1
              END IF
            END IF
 20       CONTINUE
C         store number of site w/o mean or stddev in common block
          NUMPAR = IFLG
          NMPAR = NUMPAR
          IF (IFLG .GE. 1) THEN
C           need to resort DSN's to put those w/o mean or stddev last
            IP = NSITES
            IR = 1
            DO 22 I = 1,NSITES
              IF (IDXP(I) .EQ. 0) THEN
C               regular
                DSNX(IR) = DSNBUF(I)
                IR = IR + 1
              ELSE
C               partial
                DSNX(IP) = DSNBUF(I)
                IP = IP - 1
              END IF
 22         CONTINUE
            IF (IP+1 .NE. IR) WRITE(99,*) 'ERROR in WIVLOD,',
     $                                   ' IP,IR,NSITES=',IP,IR,NSITES
            DO 23 I = 1,NSITES
              DSNBUF(I) = DSNX(I)
 23         CONTINUE
          END IF
        END IF
C
C       Log of mean, standard deviation and skew variable names are:
        IF (PHI .EQ. 1) THEN
          IT = 1
        ELSE
          IT = 2
        END IF
        CALL ZIPC (L78,BLNK,TBUFF(1))
        CALL CHRCHR(L8,SM(1,IT),TBUFF(5))
        CALL CHRCHR(L8,SD(1,IT),TBUFF(15))
        CALL CHRCHR(L8,SS(1,IT),TBUFF(25))
C       put in status block
C       add mean, std, skew names to XLABS array
        CALL CHRCHR(L8,SM(1,IT),XLABS(1,1))
        CALL CHRCHR(L8,SD(1,IT),XLABS(1,2))
        CALL CHRCHR(L8,SS(1,IT),XLABS(1,3))
C       no additional transformations for mean, stddev and skew
        CALL ZIPI (L9, M1, TRCODE)
C
C       now select the variables (search attributes)
        SGRP = 151
        CALL Q1INIT (MESSFL, SCLU, SGRP)
C       default the ones that are currently included
        DO 24 I = 1,16
          J = I + 3
          CALL QSTCTF (I,L8,XLABS(1,J))
 24     CONTINUE
        CALL Q1EDIT (IRET)
        NCODES = 3
        DO 25 I=1,16
          CALL QGTCTF (I, L8, CCHK)
          IF (LENSTR(L8, CCHK) .NE. 0) THEN
            NCODES = NCODES + 1
C           left justify variable name if necessary
            IF (CCHK(1) .EQ. ' ') CALL LFTSTR (L8, CCHK)
            CALL CHRCHR (L8, CCHK, XLABS(1,NCODES))
          END IF
 25     CONTINUE
        write (99,*) 'XLABS',XLABS
C
        write (99,*) 'NCODES',NCODES
C       find codes from XLABS
        IF (NCODES .GT. 3) THEN
          K = 0
          J = 3
          IBDA = 0
          DO 27 I = 4,NCODES
            SAIND = 1
            CALL WDSAFI (MESSFL,XLABS(1,I),SAIND,CMATCH,RETCOD)
            IF (RETCOD .EQ. 0) THEN
              J = J + 1
              CODES(J) = SAIND
              CALL CHRCHR (L8, XLABS(1,I), XLABS(1,J))
            ELSE
C             not a valid variable
              IBDA = IBDA + 1
              CALL COPYC (L8, XLABS(1,I), CBUFF(1,IBDA))
            END IF
 27       CONTINUE
          IF (IBDA .GT. 0) THEN
C           blank out rest of XLABS
            I = 8 * IBDA
            CALL ZIPC (I, BLNK, XLABS(1,J+1))
          END IF
          write (99,*) 'CODES',CODES
C
          IF (IBDA .GT. 0) THEN
C           display invalid variable names entered
            MXL = 10
            SCNFG = 1
            IWRT = 0
            CNUM = 20
            I = MAXINP
            CALL ZIPI (I, L4, OTYP)
            CALL ZIPI (I, L8, CLEN)
            SGRP = 153
            CALL PMXTXA (MESSFL, SCLU, SGRP, MXL, SCNFG, IWRT, CNUM, 
     I                   CLEN, CBUFF)
            NCODES = NCODES - IBDA
          END IF
        ELSE
C         no attributes entered
          ATTFLG = 0
        END IF
        IF (NCODES .GT. 3) ATTFLG = 1
C     
      ELSE IF (GOPT .EQ. 3) THEN
        IF (ATTFLG.EQ.0 .OR. STAFLG.EQ.0) THEN
C         can't get values, no attributes and/or stations identified
          SGRP = 200
          CALL PRNTXT (MESSFL, SCLU, SGRP)
        ELSE
C         ok to get values
C         get attribute values
          write(99,*) 'before WDATGT calls to get attributes'
          CALL WDATGT (WDMSFL, NSITES, NCODES, CODES, ILOW, NMPAR,
     I                 DSNBMX, DSNBUF, 
     O                 ATTVAL, IBD, BADDSN, IBDATT, STANO, RETCOD)
          ZIPLEN = MAXINP * 8
          CALL ZIPC (ZIPLEN, BLNK, CBUFF)
          IBDA = 0
          DO 30 I = 1, NCODES
            DO 28 J = 1, NSITES
              Z(J,I) = DBLE(ATTVAL(J,I))
 28         CONTINUE
            IF (IBDATT(I) .EQ. 1) THEN
C             this attrib. is "bad"--add to counter, place name in CBUFF
              IBDA = IBDA + 1
              CALL COPYC (L8, XLABS(1,I), CBUFF(1,IBDA))
            END IF
 30       CONTINUE
          IF (IBD .GT. 0) THEN
C           1 or more stations do not have a value for 1 or more attr.s
            IWRT = 0
            CNUM = 20
            I = MAXINP
            CALL ZIPI (I, L8, CLEN)
            SGRP = 195
            CALL PMXTXA (MESSFL, SCLU, SGRP, MXL, SCNFG, IWRT, CNUM, 
     I                   CLEN, CBUFF)
          END IF
C
          write(99,*) 'getting attributes after WDATGT'
          IF (NUMPAR .GT. 0) THEN
C           for sites with no mean attribute, set skew to 0.0
            J = NSITES + 1 - NUMPAR
            DO 35 I = J,NSITES
              Z(I,3) = 0.0
 35         CONTINUE
          END IF
C
          ICNT = NSITES - IBD
C
          IF (ICNT .LT. 5) THEN
C           not enough complete datasets, need at least 5
            IWRT = 0
            INUM = 2
            IVAL(1) = NSITES
            IVAL(2) = IBD
            SGRP = 35
            CALL PMXTXI (MESSFL, SCLU, SGRP, MXL, SCNFG, IWRT, INUM,
     I                   IVAL)
            DATAFG = 0
          ELSE IF (ILOW.EQ.1 .AND. (NSITES-NUMPAR).LT.5) THEN
C           not enough stations have mean and stddev
            IVL = NSITES - NUMPAR
            SGRP = 28
            CALL PRNTXI (MESSFL, SCLU, SGRP, IVL)
            DATAFG = 0
          ELSE IF (ICNT .EQ. NSITES) THEN
C           all ok
            DATAFG = 1
          ELSE
 60         CONTINUE
C             some bad data: & stations selected, but & had incomplete data
              IWRT = -1
              CNUM = 2
              JUSTL = 1
              CALL INTCHR (NSITES, L5, JUSTL,
     O                     CLN(1), TXTBUF(1))
              CALL INTCHR (IBD, L5, JUSTL,
     O                     CLN(2), TXTBUF(CLN(1)+1))
              SGRP = 40
              CALL PMXTXA (MESSFL, SCLU, SGRP, MXL, SCNFG, IWRT, CNUM,
     I                     CLN, TXTBUF)
              CALL ZMNSST
C             what to drop? (1-stations, 2-variables, 3-simulation)
              SGRP = 41
              CALL Q1INIT (MESSFL, SCLU, SGRP)
              CNUM = 1
              CVL(1) = 3
              CALL QSETCO (CNUM, CVL)
              CALL Q1EDIT (IRET)
C           if user chose 'Oops', redraw screen
            IF (IRET .EQ. -1) GOTO 60
C
C           retrieve user's response
            CALL QGETCO (CNUM, CVL)
            DORV = CVL(1)
            IF (DORV .EQ. 1) THEN
C             drop bad data sets from dsn buffer
              IGOOD = 1
              IB = 1
              DO 70 I = 1,NSITES
                IF (DSNBUF(I) .NE. BADDSN(IB)) THEN
                  IF (IGOOD .NE. I) THEN
C                   move values forward in arrays, overwriting bad val.s
                    DO 65 J = 1,NCODES
                      Z(IGOOD,J) = Z(I,J)
 65                 CONTINUE
                    DO 66 J = 1,8
                      STANO(J,IGOOD) = STANO(J,I)
 66                 CONTINUE
                    DSNBUF(IGOOD) = DSNBUF(I)
                  END IF
                  IGOOD = IGOOD + 1
                ELSE
                  IB = IB + 1
C                 data set __ deleted
                  SGRP = 88
                  CALL PRNTXI (MESSFL, SCLU, SGRP, DSNBUF(I))
                END IF
 70           CONTINUE
              IB = IB - 1
              CALL ZIPI (IB, L0, DSNBUF(IGOOD))
              NSITES = ICNT
C
            ELSE IF (DORV .EQ. 2) THEN
C             delete variables
 71           CONTINUE
C               display variable names in status window
                CALL STATVR (NCODES, XLABS)
C               Which independent variable do you want to drop?
                IDROP = 4
C               set min/max/default for input field
                INUM = 1
                RNUM = 1
                DNUM = 1
                CNUM = 1
                NMFLDS = 1
                UIMIN(1) = 4
                UIMAX(1) = NCODES
                UIDEF(1) = IDROP
                CALL QSCSET (INUM, RNUM, DNUM, CNUM, NMFLDS, UIMIN,
     I                       UIMAX, UIDEF, URMIN, URMAX, URDEF, UDMIN,
     I                       UDMAX, UDDEF, VLINFG, UCCNT, UCDEF, USTRLN,
     I                       URSPST)
                SGRP = 16
                CALL QRESPI (MESSFL, SCLU, SGRP, IDROP)
C               drop column out of the Z array
                DO 76 I = 1,NSITES
                  DO 75 J = IDROP+1,NCODES
                    JM1 = J - 1
                    Z(I,JM1) = Z(I,J)
 75               CONTINUE
 76             CONTINUE
C               drop column heading out of list
                DO 79 J = IDROP+1,NCODES
                  JM1 = J - 1
                  DO 78 I = 1,8
                    XLABS(I,JM1) = XLABS(I,J)
 78               CONTINUE
 79             CONTINUE
                NCODES = NCODES - 1
C               redisplay variable names in status window
                CALL STATVR (NCODES, XLABS)
C
                RESP = 2
                IF (NCODES .GT. 3) THEN
C                 Another? 1=Y,2=N
                  SGRP = 13
                  CALL QRESP (MESSFL, SCLU, SGRP, RESP)
                END IF
              IF (RESP .EQ. 1) GO TO 71
            END IF
C
            IF (NSITES .LE. 5) THEN
C             not enough complete datasets
              SGRP = 35
              CALL PRNTXT (MESSFL, SCLU, SGRP)
              DATAFG = 0
            ELSE IF (NCODES .LE. 3) THEN
C             no explanatory variables
              SGRP = 172
              CALL PRNTXT (MESSFL, SCLU, SGRP)
              ATTFLG = 0
              DATAFG = 0
            ELSE IF (DORV .NE. 3) THEN
C             enough data to proceed
              DATAFG = 1
            ELSE
C             incomplete data and user wants to start over
              DATAFG = 0
            END IF
          END IF
C
          IF (DATAFG .EQ. 1) THEN
C           Continue analysis
C           number of variables = number of codes
            NV = NCODES
C
C           identify columns
C           sample mean
            KODE=1
            CALL CHRCHR (L8,SM(1,IT),ANS)
            CALL FIND(MESSFL,KODE,NV,XLABS,ANS,ICOL,MISFLG)
            IF (MISFLG .NE. 0) THEN
C             sample mean not found
              SGRP = 92
              CALL PRNTXT (MESSFL, SCLU, SGRP)
              DATAFG = 0
            END IF
C           sample STD. DEV. variable
            KODE=2
            CALL CHRCHR (L8,SD(1,IT),ANS)
            CALL FIND(MESSFL,KODE,NV,XLABS,ANS,ICOL,MISFLG)
            IF (MISFLG .NE. 0) THEN
C             sample mean not found
              SGRP = 93
              CALL PRNTXT (MESSFL, SCLU, SGRP)
              DATAFG = 0
            END IF
C           sample skew
            KODE=3
            CALL CHRCHR (L8,SS(1,IT),ANS)
            CALL FIND(MESSFL,KODE,NV,XLABS,ANS,ICOL,MISFLG)
            IF (MISFLG .NE. 0) THEN
C             sample mean not found
              SGRP = 94
              CALL PRNTXT (MESSFL, SCLU, SGRP)
              DATAFG = 0
            END IF
          END IF
        END IF
C
        IF (DATAFG .EQ. 1) THEN
C         data successfully retrieved
          SGRP = 173
          CALL PRNTXT (MESSFL, SCLU, SGRP)
        END IF
C
      ELSE IF (GOPT .EQ. 5) THEN
        IF (DATAFG .EQ. 0) THEN
C         no data to do transforms
          SGRP = 205
          CALL PRNTXT (MESSFL, SCLU, SGRP)
        ELSE
C         get transformation options
          SGRP = 152
          DO 182 N=1,NCODES
            CALL ZIPC (L78,BLNK,TRBUF(1,N))
            DO 180 K=1,6
              TRBUF(K,N) = XLABS(K,N)
 180        CONTINUE
            CALL CHRCHR (L4,NONE,TRBUF(10,N))         
            CALL DECCHR (R0,L6,JUST,OLEN,TRBUF(14,N))
            CALL DECCHR (R0,L6,JUST,OLEN,TRBUF(20,N))
            CALL CHRCHR (L4,NONE,TRBUF(26,N))        
            CALL DECCHR (R0,L6,JUST,OLEN,TRBUF(30,N))
            CALL DECCHR (R0,L6,JUST,OLEN,TRBUF(36,N))
            CALL CHRCHR (L4,NONE,TRBUF(42,N))          
            CALL DECCHR (R0,L6,JUST,OLEN,TRBUF(46,N))
            CALL DECCHR (R0,L6,JUST,OLEN,TRBUF(52,N))
 182      CONTINUE
          INUM = 1
          RNUM = 6
          CNUM = 4
C
C         write(99,*) 'calling screen for tranformations'
          CALL QRESCX (MESSFL, SCLU, SGRP, INUM, RNUM, CNUM, NCODES, 
     I                 SCNFG, 
     M                 IVAL, RVAL, CVAL, TRBUF)
          DO 185 N=1,NCODES
            DO 183 K=1,3
              KA = 1 + 2*(K-1)
              KB = KA + 1
              C1(K,N) = RVAL(KA,N)
              C2(K,N) = RVAL(KB,N)
              I = CVAL(K+1,1,N)
              TRCODE(K,N) = TRSHFT(I)
 183        CONTINUE
            DO 184 K=1,6
              XLABS(K,N) = TRBUF(K,N)
 184        CONTINUE
 185      CONTINUE
C         transformations if needed
          BDFG2 = 0
          DO 88 N = 1,NCODES
            K = 0
 82         CONTINUE
C             loop for transformations
              K = K + 1
              IF (TRCODE(K,N) .GT. 0) THEN
C               do transformations
                KOUNT = 0
                SUM = 0.0
                DO 84 I = 1,NSITES
                  ATTVAL(I,N) = SNGL(Z(I,N))
 84             CONTINUE
                CALL ALGEBR (MESSFL, TRCODE(K,N), NSITES, I1, C1(K,N), 
     I                       C2(K,N), K1(K,N), ATTVAL(1,N), ATTVAL(1,N),
     M                       SUM, KOUNT, 
     O                       ATTVAL(1,N))
                IF (KOUNT .EQ. 0) THEN
                  DO 86 I = 1,NSITES
                    Z(I,N) = DBLE(ATTVAL(I,N))
 86               CONTINUE
                ELSE
C                 transformation for varaible _ not possible
                  SGRP = 180
                  CALL PRNTXI (MESSFL, SCLU, SGRP, N)
                  BDFG2 = 1
                END IF
              END IF
            IF (K .LT. 3) GO TO 82
 88       CONTINUE
          IF (BDFG2 .EQ. 0) THEN
C           transformations complete.
            SGRP = 178
            CALL PRNTXT (MESSFL, SCLU, SGRP)
          ELSE
C           transformations complete except as previously indicated
            SGRP = 181
            CALL PRNTXT (MESSFL, SCLU, SGRP)
          END IF
        END IF
C
      ELSE IF (GOPT .EQ. 7) THEN
C       call routine to plot variables
C       IF (DONEFG .EQ. 1) THEN
C         Do not try to plot flow estimates!
C         SGRP = 95
C         CALL PRNTXT (MESSFL, SCLU, SGRP)
C       END IF
        IF (DATAFG .EQ. 0) THEN
C         no data to plot
          SGRP = 156
          CALL PRNTXT (MESSFL, SCLU, SGRP)
        ELSE
          IBA = 1
          CALL VARPLT (MESSFL, IBA)
        ENDIF
C
      ELSE IF (GOPT .EQ. 6) THEN
        IF (DATAFG .EQ. 0) THEN
C         no data to view    
          SGRP = 160
          CALL PRNTXT (MESSFL, SCLU, SGRP)
        ELSE
C         show the data
          CALL VWDATA (MESSFL, SCLU, NCODES, NSITES, MAXINP, MAXPTS,
     $                 XLABS, Z)
        END IF
      END IF
C
C     return to top for menu
      IF (GOPT .LT. 8) GO TO 5
      DONEFG = DATAFG
C
      RETURN
      END
C
C
C
      SUBROUTINE   WCRLOD
     I                    (MESSFL,WDMSFL,
     O                     IRET)
C
C     + + + PURPOSE + + +
C     This routine computes the concurrent year matrix from data from
C     the users WDM file.
C
C     + + + KEYWORDS + + +
C     WDM file, message file
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL, MESSFL, IRET
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of GLSNET message file
C     WDMSFL - Fortran unit number of WDM file
C     IRET   - user's return code for AIDE command line, 1 - accept,
C              7 - interupt
C
C     + + + COMMONS + + +
      INCLUDE 'pglsiz.inc'
      INCLUDE 'cgls.inc'
      INCLUDE 'cglsx.inc'
      INCLUDE 'cgldsn.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      STYR, SCLU, SGRP, I, J, K, NCNT,
     $             NP, NHIST, EY, PRS, NX, L0, L1, L16, L12,
     $             SAIND, SALEN, RETCOD
      REAL         A, PH, RLS, H, HSTRET, REY
      CHARACTER*1  BLNK, C(12)
C
C     + + + INTRINSICS + + +
      INTRINSIC   ALOG, INT, REAL
C
C     + + + FUNCTIONS + + +
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDBSGI, WDBSGR 
      EXTERNAL   PRNTXT, PRNTXI, ZSTCMA, ZGTRET
      EXTERNAL   ZIPC
      EXTERNAL   CNTYRS
C
C     + + + DATA INITIALIZATIONS + + +
      DATA L0,L1,L12,L16/0,1,12,16/,  BLNK /' '/
C
C     + + + END SPECIFICATIONS + + +
C
      STYR = 2000 - MAXYRS
      SCLU = 106
C
C     make interupt available
      CALL ZSTCMA (L16, L1)
C
C     concurrent record matrix being computed
      SGRP = 63
      CALL PRNTXT (MESSFL, SCLU, SGRP)
      CALL ZGTRET (IRET)
C
      IF (IRET .EQ. 1) THEN
        CALL ZIPC (L12, BLNK, C)
        C(1) = 'Z'
        DO 10 I = 1,NSITES
          CALL CNTYRS (WDMSFL, MESSFL, DSNBUF(I), STYR, MAXYRS,
     M                 C,
     O                 ANNDAT(1,I))
 10     CONTINUE
C
C       make counts
        DO 16 I = 1,NSITES
          DO 15 J = 1,I
            MCON(I,J) = 0
 15       CONTINUE
 16     CONTINUE
C
        DO 40 I = 1,NSITES
          DO 30 J = 1,I
            DO 20 K = 1,MAXYRS
              IF (ANNDAT(K,I) .GT. 0.0 .AND. ANNDAT(K,J) .GT. 0.0)
     $          MCON(I,J) = MCON(I,J) + 1
 20         CONTINUE
 30       CONTINUE
 40     CONTINUE
C
C       for low flow, check for partial record sites and reset MCON
C       diagonal if value for YRSLOW(equiv yrs record) is larger
        IF (ILOW .EQ. 1) THEN
          SALEN = 1
          NX = 0
          DO 35 I = 1,NSITES
            SAIND = 57
            CALL WDBSGI (WDMSFL,DSNBUF(I),SAIND,SALEN,PRS,RETCOD)
            IF (PRS .EQ. 99) THEN
C             partial record site, get the equivalent years
              SAIND = 219
              CALL WDBSGR (WDMSFL,DSNBUF(I),SAIND,SALEN,REY,RETCOD)
              IF (RETCOD .EQ. 0) THEN
C               check against diagonal
                EY = INT(REY)
                IF (EY .GT. MCON(I,I)) THEN
                  MCON(I,I) = EY
                  NX = NX + 1
                END IF
              END IF
            END IF
35        CONTINUE
          IF (NX .GT. 0) THEN
C           Diagonal of concurrent year matrix modified for & partial
C           record sites to equivalent years estimate
            SGRP = 137
            CALL PRNTXI (MESSFL,SCLU,SGRP,NX)
            CALL ZGTRET (IRET)
          END IF
        END IF
C
        IF (IRET .EQ. 1) THEN
          IF (ILOW .EQ. 0) THEN
C           Use historic information if available.
C           Searching for historic information.
            SGRP = 122
            CALL PRNTXT (MESSFL, SCLU, SGRP)
            CALL ZGTRET (IRET)
C
            IF (IRET .EQ. 1) THEN
              NCNT = 0
              DO 60 I = 1,NSITES
C               Get number of historic peaks
                SAIND = 274
                SALEN = 1
                CALL WDBSGI (WDMSFL,DSNBUF(I),SAIND,SALEN,NHIST,RETCOD)
                IF (RETCOD .EQ. 0 .AND. NHIST .GT. 0) THEN
C                 Get historic recurrence interval.
                  SAIND = 81
                  SALEN = 1
                  CALL WDBSGR(WDMSFL,DSNBUF(I),SAIND,SALEN,
     O                        HSTRET,RETCOD)
                  IF (RETCOD .EQ. 0 .AND. HSTRET .GT. 0.0) THEN
                    NCNT = NCNT + 1
                    H = HSTRET
                    NP = NHIST
                    RLS = REAL(MCON(I,I))
                    H = H - RLS
                    IF (H .GT.200.) H = 200.
                    PH = 1.0 - REAL(NP)/(H+RLS)
                    PH = ALOG(PH/(1.0-PH))
                    A = 0.55 - 0.1*PH
                    MCON(I,I) = INT(A*H + RLS)
                  END IF
                END IF
 60           CONTINUE
C
              IF (NCNT .GT. 0) THEN
C               & stations adjusted for historic peaks
                SGRP = 123
                CALL PRNTXI (MESSFL, SCLU, SGRP, NCNT)
                CALL ZGTRET (IRET)
              END IF
            END IF
C
            IF (IRET .EQ. 1) THEN
C             completed computation of concurrent year matrix. 
C             now processing for cross-correlation matrix.
              SGRP = 157
              CALL PRNTXT (MESSFL, SCLU, SGRP)
              CALL ZGTRET (IRET)
            END IF
          END IF
        END IF
      END IF
C
C     remove interupt
      CALL ZSTCMA (L16, L0)
C
      RETURN
      END
C
C
C
      SUBROUTINE   WCCLOD
     I                    (MESSFL, WDMSFL,
     O                     ALPHA, THETA, IRET)
C
C     + + + PURPOSE + + +
C     This routine computes the cross-correlation matrix from
C     data from the users WDM file.  It also plots the distance vs.
C     cross-correlations computed and then uses the relation developed
C     to recompute the cross-correlations based on distance between
C     sites.
C
C     + + + KEYWORDS + + +
C     WDM file, message file, DISSPLA
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, WDMSFL, IRET
      REAL      ALPHA, THETA
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of GLSNET message file
C     WDMSFL - Fortran unit number of WDM file
C     ALPHA  - coefficient for cross-correlation vs. distance equation
C     THETA  - coefficient for cross-correlation vs. distance equation
C     IRET   - user's return code for AIDE command line, 1 - accept,
C              7 - interupt
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'pglsiz.inc'
      INCLUDE 'cgls.inc'
      INCLUDE 'cglsx.inc'
      INCLUDE 'cgldsn.inc'
C
C     + + + LOCAL COMMONS + + +
      COMMON /CDIST/ DIST
      REAL   DIST(MAXPTS,MAXPTS)
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   RETCOD, SALEN, ILAT, ILONG, ICNT, ISTEP, LEN, OLEN,
     $          CNT(4), CODE1, CODE2, I, J, PRS, IVAL(6), INUM,L16,
     $          K, N, SCLU, NYRS, NY(4), NYR, SGRP, SCNFG, MXLN,L1,
     $          IREPT, NPTS, IDXP(DSNBMX), SAIND, IWRT, JUST, L0, L7,
     $          KNT, MAXL
      REAL   LATAVE, LATDIF, RLAT, RLNG, RVAL(2),
     $       LNGDIF, OP1, OP2, OP3, RADIAN,
     $       A, E2, YY(900),XX(900), YMIN(18), YMAX(18)
      DOUBLE PRECISION   S0,S1,S2,SX,SY,SX2,SY2,SXY
      CHARACTER*1   BUFF(78)
C
C     + + + FUNCTIONS + + +
      REAL   CNVTDG
C
C     + + + INTRINSICS + + +
      INTRINSIC   ABS, SQRT, SIN, COS, DSQRT, MOD, REAL,
     $            DBLE
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDBSGL, WDBSGI, PRNTXI, ZIPI, QRESP, PRNTXT
      EXTERNAL   GPINIT, PMXTXI, GETTXT, INTCHR, ZSTADD
      EXTERNAL   CNVTDG, CCDPLT, PMXTXR, ZQUIET, ZSTCMA, ZGTRET
C
C     + + + DATA INITIALIZATION + + +
      DATA NY/4,10,30,50/,  L0,L1,L16/0,1,16/
C
C     + + + END SPECIFICATIONS + + +
C
      SCLU = 106
C
C     enable interupt command
      CALL ZSTCMA (L16,L1)
C
      I = 0
      KNT = 0
      SCNFG = 1
      IWRT = 1
      MAXL = 1
 10   CONTINUE
C       loop for each site
        I = I + 1
 20     CONTINUE
C         loop to repeat if needed to delete a site because no lat/long
          IREPT = 0
C         get lat and long for data set
          CALL WDBSGL ( WDMSFL, DSNBUF(I), RLAT, RLNG, RETCOD )
          IF (RETCOD .EQ. 0) THEN
C           successfully retrieved latitude and longitude
            DLAT(I) = DBLE ( RLAT )
            DLNG(I) = DBLE ( RLNG )
          ELSE
C           missing lat/long for this data set
            SGRP = 43
            IF (KNT .GT. 49) THEN
C             screen is full (knt 1 for later check)
              SCNFG = 1
              KNT  = 1
            END IF
            CALL PMXTXI ( MESSFL, SCLU, SGRP, MAXL,
     I                    SCNFG, IWRT, L1, DSNBUF(I) )
            SCNFG = -1
            KNT  = KNT + 1
C           remove data set number from buffer
            NSITES = NSITES - 1
            DO 30 J = I,NSITES
              DSNBUF(J) = DSNBUF(J+1)
 30         CONTINUE
            DSNBUF(NSITES+1) = 0
            IREPT = 1
          END IF
        IF (IREPT .EQ. 1) GO TO 20
      IF (I .LT. NSITES) GO TO 10
      IF (KNT .EQ. 0) THEN
C       all sites had lat/long, continue
        IRET = 1
      ELSE
C       lat/long missing Accept (F2) to continue or Interrupt (F6)
        SGRP = 182
        CALL PRNTXT ( MESSFL, SCLU, SGRP )
        CALL ZGTRET ( IRET )
      END IF
C
      IF (IRET .EQ. 1) THEN
C       continue processing, convert to radians
        RADIAN = 3.14159265/180.0
C
        A = 6378206.0
        E2 = 0.00676866
        DO 60 I = 1,NSITES
          DO 50 J = 1,I
C           compute distance between stations
            LATDIF = ABS (DLAT(I)-DLAT(J))*RADIAN
            LNGDIF = ABS (DLNG(I)-DLNG(J))*RADIAN
            LATAVE = (DLAT(I)+DLAT(J))*RADIAN*0.5
            OP1 = A/SQRT(1.0-E2*SIN(LATAVE)**2)
            OP2 = ((1.0-E2)**2*(LATDIF)**2)/((1.0-E2*SIN(LATAVE)**2)**2)
            OP3 = COS(LATAVE)**2 * LNGDIF**2
            DIST(I,J) = (OP1*SQRT(OP2+OP3))/1000.0
C           convert to miles from kilometers
            DIST(I,J) = DIST(I,J)/1.609
   50     CONTINUE
   60   CONTINUE
C
C       count pairs of stations for 4, 10, 30, 50 concurrent YRS
        CALL ZIPI (4,0,CNT)
        DO 70 I = 1,NSITES
          DO 65 J = 1,I
            IF (I.NE.J) THEN
              IF (MCON(I,J) .GE. 4) CNT(1) = CNT(1) + 1
              IF (MCON(I,J) .GE. 10) CNT(2) = CNT(2) + 1
              IF (MCON(I,J) .GE. 30) CNT(3) = CNT(3) + 1
              IF (MCON(I,J) .GE. 50) CNT(4) = CNT(4) + 1
            END IF
   65     CONTINUE
   70   CONTINUE
C
C       write out number of points
        SGRP = 46
        LEN = 78
        CALL GETTXT (MESSFL, SCLU, SGRP, LEN, BUFF)
        LEN = 6
        JUST = 0
        CALL INTCHR (CNT(1), LEN, JUST, OLEN, BUFF(2))
        BUFF(29) = '4'
        CALL ZSTADD (1, BUFF)
        BUFF(29) = '0'
        CALL INTCHR (CNT(2), LEN, JUST, OLEN, BUFF(2))
        BUFF(28) = '1'
        CALL ZSTADD (2, BUFF)
        CALL INTCHR (CNT(3), LEN, JUST, OLEN, BUFF(2))
        BUFF(28) = '3'
        CALL ZSTADD (3, BUFF)
        CALL INTCHR (CNT(4), LEN, JUST, OLEN, BUFF(2))
        BUFF(28) = '5'
        CALL ZSTADD (4,BUFF)
C
   75   CONTINUE
C         ask which criteria, ie no. of years
          NYR = 3
          SGRP = 50
          CALL QRESP (MESSFL, SCLU, SGRP, NYR)
          CALL ZGTRET (IRET)
          IF (IRET.EQ.1 .AND. CNT(NYR).LE.2) THEN
C           insufficient station pairs
C           disable Intrpt
            CALL ZSTCMA (L16, L0)
            SGRP = 59
            CALL PRNTXI (MESSFL, SCLU, SGRP, NY(NYR))
C           enable Intrpt
            CALL ZSTCMA (L16, L1)
          ELSE
            NYRS = NY(NYR)
          END IF
        IF (IRET.EQ.1 .AND. CNT(NYR).LE.2) GOTO 75
      END IF
C
      IF (IRET .EQ. 1) THEN
C       set number of points based on number of years criteria
        DO 90 I = 1,NSITES
          DO 85 J = 1,I
            SXY = 0.0
            SX = 0.0
            SY = 0.0
            SX2 = 0.0
            SY2 = 0.0
            N = 0
            DO 80 K = 1,MAXYRS
              IF (ANNDAT(K,I).GT.0.0 .AND. ANNDAT(K,J).GT.0.0) THEN
                N = N + 1
                SX = SX + DBLE(ANNDAT(K,I))
                SX2 = SX2 + DBLE(ANNDAT(K,I)**2)
                SY = SY + DBLE(ANNDAT(K,J))
                SY2 = SY2 + DBLE(ANNDAT(K,J)**2)
                SXY = SXY + DBLE(ANNDAT(K,I)*ANNDAT(K,J))
              END IF
 80         CONTINUE
            IF (N .LT. 10) THEN
              RHOC(I,J) = -999.0
            ELSE
C             concurrent values, so compute
              S1 = SX2 - SX*SX/DBLE(N)
              S2 = SY2 - SY*SY/DBLE(N)
              S0 = SXY - SX*SY/DBLE(N)
              IF (S1 .GT. 1.0D-50 .AND. S2 .GT. 1.0D-50) THEN
                RHOC(I,J) = S0/(DSQRT(S1*S2))
              ELSE
C               all zero values for dataset & or &
                SGRP = 100
                INUM = 2
                SCNFG = 1
                MXLN = 20
                IWRT = 0
                IVAL(1) = DSNBUF(I)
                IVAL(2) = DSNBUF(J)
                CALL PMXTXI(MESSFL, SCLU, SGRP, MXLN, SCNFG, IWRT, 
     I                      INUM, IVAL)
                RHOC(I,J) = -999.0
              END IF
            END IF
 85       CONTINUE
 90     CONTINUE
C       cross-correlations computed from data
        SGRP = 51
        CALL PRNTXT (MESSFL, SCLU, SGRP)
        CALL ZGTRET (IRET) 
C
         IF (IRET .EQ. 1) THEN
C         fill plot buffer
          CALL GPINIT
          YMIN(2) = 1.0E9
          YMIN(1) = 1.0E9
          YMAX(1) = -1.0E9
          YMAX(2) = -1.0E9
          NPTS = CNT(NYR)
          ISTEP = 1
          IF (NPTS .GT. 200) THEN
C           only plot up to 200 points
            ISTEP = NPTS/200
            NPTS = 200
C           ONLY 200 POINTS WILL BE SELECTED FOR PLOTTING.
            SGRP = 74
            CALL PRNTXT (MESSFL, SCLU, SGRP)
            CALL ZGTRET (IRET)
          END IF
          IF (IRET .EQ. 1) THEN
            N = 0
            ICNT = 0
            SALEN = 1
            SAIND = 57
            DO 100 I = 1,NSITES
C             check for partial record sites
              CALL WDBSGI (WDMSFL,DSNBUF(I),SAIND,SALEN,PRS,RETCOD)
              IF (PRS .EQ. 99) IDXP(I) = 1
              DO 95 J = 1,I
                IF (I.NE.J .AND. IDXP(I).NE.1 .AND. IDXP(J).NE.1) THEN
C                 eliminate diagonals and partial record sites
                  IF (MCON(I,J) .GE. NYRS) THEN
C                   set index for plot data
                    ICNT = ICNT + 1
                    IF (MOD(ICNT,ISTEP) .EQ. 0) THEN
                      N = N + 1
                      IF (N .LE. NPTS) THEN
C                       should always be the case, extra protection
                        XX(N) = DIST(I,J)
                        IF (DIST(I,J) .GT. YMAX(2)) YMAX(2)=DIST(I,J)
                        IF (DIST(I,J) .LT. YMIN(2)) YMIN(2)=DIST(I,J)
                        YY(N) = REAL(RHOC(I,J))
                        IF (REAL(RHOC(I,J)) .GT. YMAX(1))
     $                    YMAX(1) = REAL(RHOC(I,J))
                        IF (REAL(RHOC(I,J)) .LT. YMIN(1))
     $                    YMIN(1) = REAL(RHOC(I,J))
                      END IF
                    END IF
                  END IF
                END IF
 95           CONTINUE
 100        CONTINUE
            IF (YMAX(1) .GT. 0.999) YMAX(1) = 0.999
            IF (YMIN(1) .LT. -0.999) YMIN(1) = -0.999
C
            CALL CCDPLT (MESSFL,NPTS,N,NYRS,YY,XX,YMIN,YMAX,
     $                   ALPHA,THETA)
C
C           note: if you intend to use network analysis program,
C           write down these numbers
            SGRP = 119
            RVAL(1) = ALPHA
            RVAL(2) = THETA
            MXLN = 10
            SCNFG = 1
            IWRT = 0
            INUM = 2
            CALL PMXTXR (MESSFL,SCLU,SGRP,MXLN,SCNFG,IWRT,INUM,RVAL)
            CALL ZGTRET (IRET)
C
            IF (IRET .EQ. 1) THEN
C             use equation to compute cross-correlation matrix
              DO 110 I = 1,NSITES
                DO 105 J = 1,I
                  RHOC(I,J) = DBLE(THETA**(DIST(I,J)/
     $                        (ALPHA*DIST(I,J)+1.0)))
 105            CONTINUE
 110          CONTINUE
C             cross-correlations recomputed
              SGRP = 55
              CALL PRNTXT (MESSFL, SCLU, SGRP)
              CALL ZGTRET (IRET)
C
              IF (IRET .EQ. 1) THEN
C               clear status window
                CALL ZQUIET
                L7 = 7
                CALL ZSTCMA (L7,L0)
              END IF
            END IF
          END IF
        END IF
      END IF
C   
C     turn off interupt
      CALL ZSTCMA (L16, L0)
C
      RETURN
      END
C
C
C
      SUBROUTINE   CNTYRS
     I                    (WDMSFL, MESSFL, DSN, STYR, NYRS,
     M                     C,
     O                     X)
C
C     + + + PURPOSE + + +
C     This routine gets annual data from the users WDM file.
C
C     + + + KEYWORDS + + +
C     WDM file
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DSN, STYR, NYRS, WDMSFL, MESSFL
      REAL   X(NYRS)
      CHARACTER*1  C(12)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     MESSFL - Fortran unit number for GLSNET message file
C     DSN    - dataset number on WDM file
C     STYR   - start year
C     NYRS   - number of years to retrieve
C     C      - qualification codes to drop peaks from analysis
C     X      - array of annual values
C
C     + + + PARAMETERS + + +
      INTEGER  MAXYRS
      PARAMETER (MAXYRS=200)
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   N, SYR(6), EYR(6), GPFLG, DELT, RETCOD, I, J,
     $          TUNITS, T, TDSFRC, IB, SCLU, SGRP, WYR(MAXYRS),
     $          TABID, LREC, NROW, K, L, BFLG, KLEN, LEN, INITFG,
     $          GRP, QNU, TGRPT, TBCNT, QFLG, J407FG, IRET, L1, DTYPE
      REAL    PK(MAXYRS)
      CHARACTER*1 CFLG(16,MAXYRS), MFID(2)
      CHARACTER*16 TNAME
C
C     + + + FUNCTIONS + + +
      INTEGER   SIMAX, SIMIN, LENSTR, WDCKDT
C
C     + + + EXTERNALS + + +
      EXTERNAL   ZIPR,   WTFNDT, WDTGET, PRNTXI, GETTB, WDTBFX, Q1INIT
      EXTERNAL   QRESPI, Q1EDIT, QGTCTF, WDCKDT
      EXTERNAL   SIMAX,  SIMIN,  LFTSTR, LENSTR
C
C     + + + DATA INITIALIZATIONS + + +
      DATA TNAME/'AN.PEAKS        '/
C
C     + + + END SPECIFICATIONS + + +
C
      L1 = 1
      CALL ZIPR (NYRS,-999.,X)
      SCLU = 106
C
      DTYPE = WDCKDT (WDMSFL, DSN)
C 
C
      IF (DTYPE .EQ. 1) THEN
C       get start and end date (SYR,EYR) from WDM file
        GPFLG = 1
        CALL WTFNDT (WDMSFL,DSN,GPFLG,TDSFRC,SYR,EYR,RETCOD)
        IF (RETCOD .EQ. 0) THEN
C         retrieve data from time series data set
          QFLG = 30
          IF (SYR(1) .LT. STYR) SYR(1) = STYR
          N = EYR(1) - SYR(1) + 1
          DELT = 1
          TUNITS = 6
          T = 0
          IB = SYR(1) -STYR +1
C         fill arrays
          IF (IB+N .GT. MAXYRS) N = MAXYRS - IB
          CALL WDTGET (WDMSFL,DSN,DELT,SYR,N,T,QFLG,TUNITS,X(IB),RETCOD)
        ELSE
          WRITE(99,*) 'Data set', DSN, 'had no time-series values.'
        END  IF
C
      ELSE
C       must be table dataset, get beg and end
        IF (C(1) .EQ. 'Z') THEN
C         qualification codes to drop peak from analysis
          LEN = 12
          SGRP = 138
          CALL Q1INIT(MESSFL, SCLU, SGRP)
          CALL Q1EDIT(IRET)
          CALL QGTCTF (L1, LEN, C)
        END IF
C       length of response
        CALL LFTSTR ( LEN, C )
        KLEN = LENSTR (LEN,C)
C
        TABID = 1
        CALL WDTBFX(WDMSFL,DSN,TABID,TNAME,TBCNT,LREC,TGRPT,
     $              MFID,GRP,QNU,NROW,RETCOD)
        IF (RETCOD .EQ. 0 .AND. NROW .GT. 0) THEN
C         set flag to only get yrs of record used in J407 to compute
C         statistics
          J407FG = 1
          INITFG = 1
          CALL GETTB(MESSFL,TNAME,WDMSFL,DSN,MAXYRS,J407FG,INITFG,
     $               NROW,PK(1),WYR(1),CFLG(1,1),RETCOD)
          IF (RETCOD .EQ. 0) THEN
            SYR(1) = SIMIN(NROW,WYR)
            EYR(1) = SIMAX(NROW,WYR)
            DO 10 I = 1,NROW
              J = WYR(I) + 1 - STYR
              IF (J .LE. NYRS .AND. J .GT. 0) THEN
C               peak within requested time span
                X(J) = PK(I)
                IF (KLEN .GT. 0) THEN
C                 may be peaks to be excluded
                  DO 9 K = 1, KLEN
                    IF (C(K) .NE. ' ') THEN
C                     don't include peak if matching qualification code
                      DO 7 L = 1, 12
                        IF (C(K) .EQ. CFLG(L,I)) X(J) = -999999.
    7                 CONTINUE
                    END IF
    9             CONTINUE
                END IF
              END IF
  10        CONTINUE
          END IF
        ELSE
C         set retcod to -1 cause no rows (data)
          RETCOD = -1
        END IF
      END IF
C
      IF (RETCOD .NE. 0) THEN
C       Could not retrieve data for dataset &.
        SGRP = 130
        CALL PRNTXI(MESSFL, SCLU, SGRP, DSN)
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   CCDPLT
     I                   (MESSFL, NPTS, N, NYRS,Y,X,YMIN,YMAX,
     O                    ALPHA, THETA)
C
C     + + + PURPOSE + + +
C     This routine plots cross-correlation coefficients vs distance
C     to help user to get ALPHA and THETA parameters for the relation.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   NPTS, N, NYRS, MESSFL
      REAL      ALPHA, THETA, Y(NPTS), X(NPTS), YMIN(18), YMAX(18)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number for GLSNET message file
C     NPTS   - space allocated for possible number of pairs
C     N      - actual number of pairs to plot
C     NYRS   - number of years for analysis
C     Y      - data to plot
C     X      - data to plot
C     YMIN   - minimum value
C     YMAX   - maximum value
C     ALPHA  - parameter selected by the user for the relation
C     THETA  - parameter selected by the user for the realtion
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   LEN, SGRP, SCLU, LOC, L3, L4, L6, WHICH(6), YTYPE(2), 
     $          L40, L240, L2, L1, JUST, RESP, TICS(4), I, OLEN, LOC2, 
     $          XTYPE, CPR, CTYPE(18), SYMBL(18), LNTYP(18), NCRV, IRET,
     $          NVAR, RETCOD, NCHR, PATTRN(18), COLOR(18), TRANSF(18), 
     $          BVALFG(4), L19,  IND, DEVCOD, DEVTYP, WSID, IVAL(265),
     $          IWAIT, ICLOS, L5, CHKTYP, ICHK(7), WNDFLG, GMOD
      REAL      R1, D1, RMIN, XD(3), XDIF, ALEN, FYT, FXT, PLMN(4), 
     $          PLMX(4),  SIZEL, XLEN, YLEN, RVAL(64), XVAR(20), 
     $          YVAR(20), YSET
      CHARACTER*1  TXTN(80), BLNK, CTXT(120), YLABL(80), YXLABL(80), 
     $             TITL(240), YALABL(80), LBV(20, 18),  LBC(20, 18),
     $             CVAL(1400)
      CHARACTER*8  WNAM(2)
      LOGICAL      CURVE1
C
C     + + + INTRINSICS + + +
      INTRINSIC   ALOG, REAL
C
C     + + + EXTERNALS + + +
      EXTERNAL   ANPRGT, GPDEVC, PSTUPW, PLTONE, PDNPLT, GGXYLN, GGLSIZ
      EXTERNAL   SCALIT, GPDATR, GPLABL, GPCURV, GPWCXY, GPLBXB, GGDVTY
      EXTERNAL   GPSCLE, GPVAR, GPTEXT, DOPLOT, GPNCRV, GPINIT
      EXTERNAL   Q1EDIT, Q1INIT, QGETRB, QGTCOB, QSETRB, QRESPR, QTSTR 
      EXTERNAL   GETTXT, CHRCHR, PRNTXT, ZIPC, DECCHR, INTCHR 
C
C     + + + INPUT FORMATS + + +
C1000 FORMAT(2X,130A1)
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  BLNK/' '/,  LBV/360*' '/,  TRANSF/18*1/, LBC/360*' '/
      DATA  L40/40/, L240/240/, L1/1/, L2/2/,  L4/4/, L6/6/, L5/5/
      DATA  L3/3/, L19/19/, TICS/10,10,10,10/, BVALFG/4*1/
      DATA  YALABL/80*' '/
      DATA  ICHK/1,2,1,1,1,1,1/
      DATA  WNAM/'Process','GP'/
C
C    + + + END SPECIFICATIONS + + +
C
      SCLU = 106
      RMIN = 0.1
      D1 = YMIN(2) * 0.67 + YMAX(2) * 0.33
      YSET = YMIN(1)
      IF (YSET .LT. 0.01) YSET = 0.01
      R1 = YSET + 0.3*(YMAX(1) - YSET)
      RMIN = R1 * 0.5
      GMOD = 1
      RESP = 1
      CURVE1 = .TRUE.
C
      CALL GPINIT
C
C     first time thru, not plot curve
C     not special case
      NCRV = 1
      NVAR = 2
      CALL GPNCRV (NCRV, NVAR)
      WHICH(1) = 1
      WHICH(2) = 4
C     standard x-y plot
      CALL GPWCXY (L1,L1,L2)
      LOC = 1
      CALL GPDATR (L1, LOC, N, Y(1), RETCOD)
      LOC = LOC + N
      CALL GPDATR (L2, LOC, N, X(1), RETCOD)
      XTYPE = 1
      YTYPE(1) = 1
      YTYPE(2) = 0
C     normal x-y plot
      CTYPE(1) = 6
      NCHR = 0
      SYMBL(1) = 4
      LNTYP(1) = 0
      PATTRN(1) = 1
      COLOR(1) = 1
C     use dashed line, no symbol
      LNTYP(2) = 2
      COLOR(2) = 1
      PATTRN(2) = 1
      SYMBL(2) = 0
      CTYPE(2) = 6
C     for select point
      LNTYP(3) = 0
      COLOR(3) = 2
      PATTRN(3) = 0
      SYMBL(3) = 3
      CTYPE(3) = 6
C     set buffer location for 2nd + plots
      LOC2 = LOC + N
C     dist vs cross-correlation
      SGRP = 56
      OLEN = 40
      CALL GETTXT (MESSFL, SCLU, SGRP, OLEN, YXLABL)
      CALL ZIPC (L40, BLNK, YXLABL(41))
      SGRP = 70
      OLEN = 40
      CALL GETTXT (MESSFL, SCLU, SGRP, OLEN, YLABL)
      CALL ZIPC (L40, BLNK, YLABL(41))
      CALL ZIPC (L240, BLNK, TITL(1))
C     Minimum years of concurrent data
Caml  SGRP = 177
Caml  OLEN = 40
Caml  CALL GETTXT (MESSFL,SCLU,SGRP,OLEN,TITL(1))
Caml  JUST = 0
Caml  LOC = OLEN + 2
Caml  CALL INTCHR (NYRS,L2,JUST,OLEN,TITL(LOC))
      PLMN(1) = -0.25
      PLMX(1) = 1.0
      CALL SCALIT (L1, YMIN(2), YMAX(2), PLMN(4), PLMX(4))
      CALL GPCURV (CTYPE, LNTYP, SYMBL, COLOR, PATTRN, LBC)
      ALEN = 0.0
      CALL GPLBXB (YXLABL)
      CALL GPLABL (XTYPE, YTYPE, ALEN, YLABL, YXLABL, YALABL, TITL)
      CALL GPSCLE (PLMN, PLMX, TICS, BVALFG)
C
C     set device code
      IND = 40
      DEVTYP = 1
      CALL ANPRGT (IND,DEVCOD)
      CALL GPDEVC (DEVTYP,DEVCOD)
C
 10   CONTINUE
C       loop for plotting and replotting cross-corr vs dist
C       plot the values
C
        IF (RESP .EQ. 2) THEN
C         add curve to the plot (if 2nd time around)
          NCRV = 3
          NVAR = 6
          CALL GPNCRV (NCRV, NVAR)
          WHICH(1) = 1
          WHICH(2) = 4
          WHICH(3) = 1
          WHICH(4) = 4
          WHICH(5) = 1
          WHICH(6) = 4
          CALL GPWCXY (L2,L3,L4)
          CALL GPWCXY (L3,L5,L6)
C         fill buffer with data (19 line segments)
          XDIF = (YMAX(2) - YMIN(2))/19.0
          DO 20 I = 1,20
            XVAR(I) = YMIN(2) + REAL(I-1)*XDIF
            YVAR(I) = THETA**(XVAR(I)/(ALPHA*XVAR(I)+1.0))
 20       CONTINUE
          CALL GPDATR (L3,LOC2,L19,YVAR(1),RETCOD)
          LOC2 = LOC2 + 19
          CALL GPDATR (L4,LOC2,L19,XVAR(1),RETCOD)
          LOC2 = LOC2 + 19
          CALL GPDATR (L5,LOC2,L1,R1,RETCOD)
          LOC2 = LOC2 + 1
          CALL GPDATR (L6,LOC2,L1,D1,RETCOD)
          IF (CURVE1) THEN
C           1st time curve added to plot, assign curve spec.s 
            CALL GPCURV (CTYPE, LNTYP, SYMBL, COLOR, PATTRN, LBC)
            CURVE1 = .FALSE.
C           write equation on plot
            LEN = 10
            SGRP = 44
            OLEN = 80
            CALL GETTXT (MESSFL, SCLU, SGRP, OLEN, TXTN)
            LOC = 1
            L4 = 4
            L6 = 6
            JUST = 1
            CALL ZIPC (L40, BLNK, CTXT(1))
            CALL CHRCHR (L4, TXTN(1), CTXT(LOC))
            LOC = LOC + L4
            CALL DECCHR (THETA, LEN, JUST, OLEN, CTXT(LOC))
            LOC = LOC + OLEN
            CALL CHRCHR (L6, TXTN(6), CTXT(LOC))
            LOC = LOC + L6
            CALL DECCHR (ALPHA, LEN, JUST, OLEN, CTXT(LOC))
            LOC = LOC + OLEN
            CALL CHRCHR (L6, TXTN(13), CTXT(LOC))
            CALL CHRCHR (L40, TXTN(41), CTXT(41))
            CALL GGXYLN (XLEN, YLEN)
            CALL GGLSIZ (SIZEL)
            FYT = (YLEN - 3.0 * SIZEL) / YLEN
            FXT = (XLEN - 30.0 * SIZEL) / XLEN
            CPR = 40
            NCHR = 80
            CALL GPTEXT (NCHR, CPR, FYT, FXT, CTXT)
          END IF
        END IF
C
        CALL GPVAR (YMIN, YMAX, WHICH, TRANSF, LBV)
C
C       create the plot
        WSID = DEVTYP
        IWAIT = 0
        ICLOS = 0
        CALL PSTUPW (WSID, RETCOD)
        CALL PLTONE
        CALL PDNPLT (WSID,ICLOS,IWAIT)
C
C       get RMIN from user, get coordinate from user
C       Do you want to plot the equation? (1-N,2-Y)
        SGRP = 54
        CALL Q1INIT (MESSFL,SCLU,SGRP)
        XD(1) = D1
        XD(2) = R1
        XD(3) = RMIN
        CALL QSETRB (L3, L1, XD)
        CALL Q1EDIT (IRET)
        CALL QGETRB (L3, L1, XD)
        CALL QGTCOB (L1, L1, RESP)
        CALL QGTCOB (L1, L2, GMOD)
        D1 = XD(1)
        R1 = XD(2)
        RMIN = XD(3)
C
C       calculate alpha and theta
        ALPHA = (-ALOG(R1))/(D1*(ALOG(R1)-ALOG(RMIN)))
        THETA = RMIN**ALPHA
C
        IF (GMOD .EQ. 2) THEN
C         user wants to modify graphics--save current device type
          CHKTYP = DEVTYP
          CALL PROPLT (MESSFL, ICHK, WNAM, WNDFLG)
C         see if user changed device
          CALL GGDVTY (DEVTYP)
          IF (CHKTYP .NE. DEVTYP) THEN
C           close the current device
            ICLOS = 1
            CALL PDNPLT (CHKTYP, ICLOS, IWAIT)
          END IF
C         in case user confused make sure to replot 
          RESP = 2
        END IF
C
      IF (RESP .EQ. 2) GO TO 10
C
C     close workstation
      ICLOS = 1
      CALL PDNPLT (WSID,ICLOS,IWAIT)
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDATGT
     I                    (WDMSFL, NSITES, NCODES, CODES, ILOW, NMPAR,
     I                     DSNBMX, DSNBUF,
     O                     ATTVAL, IBD, BADDSN, IBDATT, STANO, ERRCOD)
C
C     + + + PURPOSE + + +
C     This routine gets values of pre-selected attributes from the
C     users WDM file and put them in a buffer.
C
C     + + + PARAMETERS + + +
      INCLUDE 'pglsiz.inc'
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER      WDMSFL, NSITES, NCODES, CODES(NCODES), ILOW, NMPAR,
     $             DSNBMX, DSNBUF(DSNBMX), IBD, BADDSN(DSNBMX), 
     $             IBDATT(NCODES), ERRCOD
      REAL         ATTVAL(MAXPTS, MAXINP)
      CHARACTER*1  STANO(8,NSITES)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     NSITES - number of stations or sites
C     NCODES - number of codes or variables
C     CODES  - index number of variables
C     ILOW   - low-flow flag
C              1 - low flow
C              0 - other
C     NMPAR  - number of partial record data sets (data sets w/o mean
c              or stddev)
C     DSNBMX - size of buffer for dataset numbers
C     DSNBUF - buffer of dataset numbers to use
C     ATTVAL - values for variables (attributes)
C     IBD    - number of datasets in BADDSN buffer which had bad values
C              for an attribute
C     BADDSN - dataset numbers that do not have an attribute
C     IBDATT - bad attribute flag
C              0 - ok
C              1 - bad
C     STANO  - station number for the site
C     ERRCOD - return code
C              0 - ok
C              1 - NSITES>DSNBMX
C              used NSITES = DSNBMX
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      SALEN, IC, ISTA, L8, I, L20, IZ, JUST, OLEN, IS(1), 
     $             L16, IBCHK, N, NS, RETCOD, CODE1
      REAL         RZ(1)
      CHARACTER*1  BLNK,CTMP(16)
C
C     + + + INTRINSICS + + +
      INTRINSIC    IABS
C
C     + + + EXTERNALS + + +
      EXTERNAL     ZIPI, WDBSGI, INTCHR, WDBSGC, CHRCHR, ZIPC, WDBSGR
C
C     + + + DATA INITIALIZATION + + +
      DATA BLNK/' '/
C
C     + + + END SPECIFICATIONS + + +
C
      L8 = 8
      L16 = 16
      L20 = 20
      IZ = 0
      JUST = 0
      IBCHK = 0
      NS = NSITES
      IF (NS .GT. DSNBMX) THEN
        NS = DSNBMX
        ERRCOD = 1
      ELSE
        ERRCOD = 0
      END IF
C     get the values for the selected variables from wdm attributes
      SALEN = 1
      IBD = 0
      CALL ZIPI (DSNBMX, IZ, BADDSN)
      CALL ZIPI (NCODES, IZ, IBDATT)
      DO 50 I = 1,NS
C       get station id
        IC = 51
        CALL WDBSGI (WDMSFL, DSNBUF(I), IC, SALEN, 
     O               IS(1), RETCOD)
        ISTA = IS(1)
        IF (RETCOD .EQ. 0) THEN
C         got id, put in array
          CALL INTCHR (ISTA,L8,JUST,OLEN,STANO(1,I))
        ELSE
C         no integer id, try char string
          IC = 2
          CALL WDBSGC (WDMSFL, DSNBUF(I), IC, L16, 
     O                 CTMP, RETCOD)
          IF (RETCOD .EQ. 0) THEN
C           found it
            CALL CHRCHR (L8,CTMP,STANO(1,I))
          ELSE
C           no station id info
            CALL ZIPC (L8,BLNK,STANO(1,I))
          END IF
        END IF
        IBCHK = 0
        DO 30 N = 1, NCODES
C         get attribute
          CALL WDBSGR (WDMSFL, DSNBUF(I), CODES(N), SALEN, RZ(1), 
     O                 RETCOD)
          ATTVAL(I,N) = RZ(1)
          IF (RETCOD.NE.0 .AND. 
     $       .NOT.(ILOW.EQ.1 .AND. I.GT.NSITES-NMPAR)) THEN
            IF (IBCHK .EQ. 0) THEN
              IBD = IBD + 1
C             new bad dataset
              BADDSN(IBD) = DSNBUF(I)
              IBCHK = 1
            END IF
            IBDATT(N) = 1
          END IF
 30     CONTINUE
 50   CONTINUE
C
      RETURN
      END
C
C
C
      SUBROUTINE   VWDATA
     I                    (MESSFL, SCLU, NCODES, NROW,
     I                     MAXINP, MAXPTS,  XLABS, Z)
C
C     + + + PURPOSE + + +
C     This routine displays the data to be used in the GLS
C     analysis to an AIDE screen.
C
C     + + + DUMMY ARGUMENTS + + + 
      INTEGER   MESSFL, SCLU, NCODES, NROW, MAXINP, MAXPTS
      CHARACTER*1 XLABS(8,MAXINP)
      DOUBLE PRECISION Z(MAXPTS,MAXINP)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number for applications message file
C     SCLU   - cluster number on message file
C     NCODES - number of dependent and explanatory variables
C     NROW   - number of rows in the Z array
C     XLABS  - labels for the variables
C     Z      - data to be shown   
C     
C     + + + LOCAL VARIABLES + + + 
      INTEGER      AGAIN, I, INIT, IWRT, IRET, LOC, COLWID, LEN,
     $             L78, IROW, JUST, OLEN, ISCREN, NCOL,
     $             CMD, INO, IYES, N1, N2, SGRP, FORL, L4, L8
      REAL         X
      CHARACTER*1  BUFF(78), HEADER(78), BLNK
      CHARACTER*48 WNDNAM
C
C     + + + FUNCTIONS + + +
      INTEGER      LENSTR
C
C     + + + INTRINSICS + + + 
      INTRINSIC    REAL
C
C     + + + EXTERNALS + + +
      EXTERNAL     ZBLDWR, ZSTCMA, ZGTRET, ZWNSET
      EXTERNAL     CHRCHR, ZIPC, DECCHR, INTCHR, LENSTR
C 
C     + + + END SPECIFICATIONS + + +
C
C     turn on prev
      IYES = 1
      INO = 0
      CMD = 4
      CALL ZSTCMA (CMD,IYES)
C     set window name
      WNDNAM = 'Look (GPL)'
      CALL ZWNSET (WNDNAM)
C
      IF (NCODES .GT. 10) THEN
C       too many columns, first or last set?
        SGRP = 174
        CALL QRESP (MESSFL, SCLU, SGRP, FORL)
        IF (FORL .EQ. 1) THEN
C         first set
          NCOL = (NCODES+1)/2
          N1 = 1
          N2 = NCOL
        ELSE
          NCOL = NCODES/2
          N1 = NCODES + 1 - NCOL
          N2 = NCODES
        END IF
      ELSE
C       all columns fit
        NCOL = NCODES
        N1 = 1
        N2 = NCODES
      END IF
C
C     get return code
      CALL ZGTRET (IRET)
      IF (IRET .EQ. 1) THEN
C       not prev so continue
        IF (NCOL .EQ. 1) THEN
          COLWID = 40
        ELSE IF (NCOL .EQ. 2) THEN
          COLWID = 25
        ELSE
          COLWID = 74/NCOL
        END IF
        L4 = 4
        L78 = 78
        L8 = 8
        BLNK = ' '
        JUST = 0
C
C       build header line
        CALL ZIPC (L78,BLNK,HEADER)
C       determine space between columns
        LOC = 5     
        DO 10 I = N1,N2 
          LEN = LENSTR (L8,XLABS(1,I))
          LOC = LOC + COLWID - LEN
          CALL CHRCHR (LEN, XLABS(1,I), HEADER(LOC))
          LOC = LOC + LEN 
 10     CONTINUE
C
C       make intrpt available, but not help
        CMD = 16  
        CALL ZSTCMA (CMD,IYES)
        CMD = 1
        CALL ZSTCMA (CMD,INO)

        IROW = 1       
 15     CONTINUE
C         write header
          IWRT = 1
          INIT = 1
          CALL ZBLDWR (L78,HEADER,INIT,IWRT,IRET) 
          INIT = 0 
          ISCREN = 1
C         loop to write 14 rows
 20       CONTINUE
            LOC = 1
            CALL ZIPC (L78,BLNK,BUFF)
C           put row number on screen
            CALL INTCHR (IROW,L4,JUST,OLEN,BUFF(LOC)) 
            LOC = LOC + 4
            DO 30 I = N1,N2  
              X = REAL(Z(IROW,I))
              CALL DECCHR (X,COLWID,JUST,OLEN,BUFF(LOC))
              LOC = LOC + COLWID
 30         CONTINUE
C       
C           write the line
            IF (ISCREN.EQ.14 .OR. IROW.EQ.NROW) THEN
C             set flag to wait for user response
              IWRT = 0
            END IF
            CALL ZBLDWR (L78,BUFF,INIT,IWRT,IRET)  
            IROW = IROW + 1
            ISCREN = ISCREN + 1
          IF (ISCREN .LE. 14 .AND. IROW .LE. NROW) GO TO 20
C
          AGAIN = 0
          IF (IRET .EQ. 1) THEN
            IF (IROW .LE. NROW) AGAIN = 1
          ELSE IF (IRET .EQ. 2) THEN
            IROW = IROW - (ISCREN-1) - 14
            IF (IROW .GE. 1) AGAIN = 1
          END IF
C
        IF (AGAIN .EQ. 1) GO TO 15
      END IF

C     make prev, intrpt unavailable, and help available
      INO = 0
      CMD = 16
      CALL ZSTCMA (CMD,INO)
      CMD = 4
      CALL ZSTCMA (CMD,INO)
      CMD = 1
      CALL ZSTCMA (CMD,IYES)
C
      RETURN
      END
C
C
C
      SUBROUTINE   STATVR
     I                   (NCODES, XLBS)
C
C     + + + PURPOSE + + +
C     Displays variables names in status window.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER      NCODES
      CHARACTER*1  XLBS(8, NCODES)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     NCODES - number of variables
C     XLBS   - character array of variable names
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      I, L78, LEN, LOC, JUST, OLEN, ROW
      CHARACTER*1  TBUFF(78), BLNK
      CHARACTER*78 SCRBUF
C
C     + + + INTRINSICS + + +
      INTRINSIC    MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL     ZSTADD
      EXTERNAL     CARVAR, CHRCHR, INTCHR, ZIPC
C
C     + + + END SPECIFICATIONS + + +
C
      BLNK = ' '
      JUST = 0
      L78 = 78
C
C     list variables following format:
C     b##bVARIABLE...bbbbb##bVARIABLE... etc.
      CALL ZIPC (L78, BLNK, TBUFF)
      LOC = 2
      DO 10 I = 1,NCODES
C       put order number of variable in TBUFF
        LEN = 2
        CALL INTCHR (I, LEN, JUST, 
     O               OLEN, TBUFF(LOC))
C       put variable name in TBUFF
        LEN = 8
        LOC = LOC + 3
        CALL CHRCHR (LEN, XLBS(1,I), TBUFF(LOC))
C       leave 5 spaces after variable name
        LOC = LOC + 13
        IF (LOC.GT.68 .OR. I.EQ.NCODES) THEN
C         put TBUFF in status block
          ROW = I/5
          IF (MOD(I,5) .NE. 0) ROW = ROW + 1
          CALL CARVAR (L78, TBUFF, L78, SCRBUF)
          CALL ZSTADD (ROW, SCRBUF)
          CALL ZIPC (L78, BLNK, TBUFF)
          LOC = 2
        END IF
 10   CONTINUE
C
C     blank out remaining lines in status window
      DO 20 I = 1, 78
        SCRBUF(I:I) = ' '
 20   CONTINUE
      DO 30 I = ROW+1, 4
        CALL ZSTADD (I, SCRBUF)
 30   CONTINUE
C
      RETURN
      END
