C
C
C
      SUBROUTINE   PROGLS
     I                    (MESSFL,WDMSFL,ERRFL,VERSN)
C
C     + + + PURPOSE + + +
C     This routine calls all the routines for Generalized Least Squares
C     analysis.
C
C     + + + KEYWORDS + + +
C     message file
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, WDMSFL, ERRFL
      CHARACTER*64 VERSN
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of ANNIE message file
C     SMESFL - Fortran unit number of statistics message file
C              0 - lots
C              1 - some
C              2 - none
C     ERRFL  - Fortran unit number of output error file
C     VERSN  - current version number and date of program
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   WORS,DEL,DONEFG,RETCOD,SCLU,SGRP,GOPT,ERRFLG,
     &          IANS,FNET,FINV,FINC,FIN8,FOUT,INFLG,OTFLG,I,IRET,
     &          EFLG1,EFLG2,EFLG3,EFLG4,EFLG1A,EFLG2A,EFLG3A
      REAL     ALPHA, THETA
C
C     + + + EXTERNALS + + +
      EXTERNAL   PRNTXT, QRESP, QFOPEN, SIVLOD, WIVLOD, WCRLOD
      EXTERNAL   SCRLOD, WCCLOD, SCCLOD, GLSCAL, QFCLOS, VARDMP
C
C     + + + END SPECIFICATIONS + + +
C
      ALPHA = -999.
      THETA = -999.
      DONEFG = 0
      SCLU = 106
      IANS = 1
      INFLG = 0
      OTFLG = 0
      EFLG1 = -1
      EFLG2 = -1
      EFLG3 = -1
      EFLG4 = -1
      EFLG1A = -1
      EFLG2A = -1
      EFLG3A = -1
C
 10   CONTINUE
C
C       main options (process WDM(1), save(2), open(3), gls print
C       file(4), network print file(5), execute(6), return(7)
        SGRP = 1
        CALL QRESP(MESSFL,SCLU,SGRP,GOPT)
C
        IF (GOPT .EQ. 1) THEN
          IF (WDMSFL .EQ. 0) THEN
C           must open WDM file first
            SGRP = 2
            CALL PRNTXT (MESSFL, SCLU, SGRP)
          ELSE
C           develop input from WDM file
            CALL WIVLOD (MESSFL,WDMSFL,DONEFG)
            IF (DONEFG .EQ. 1) THEN
C             compute from WDM file
C             concurrent record from WDM file.
              CALL WCRLOD (MESSFL,WDMSFL,IRET)
              IF (IRET .EQ. 1) THEN
C               cross-correlation from WDM file.
                CALL WCCLOD (MESSFL, WDMSFL, ALPHA, THETA, IRET)
                IF (IRET .EQ. 1) INFLG = 1
              END IF
            END IF
          END IF
C
        ELSE IF (GOPT .EQ. 2) THEN
C         create sequential files of input
          IF (INFLG .EQ. 0) THEN
C           must process Input with WDM option first
            SGRP = 159
            CALL PRNTXT (MESSFL, SCLU, SGRP)
          ELSE
C           create three files
C           write ASCII sequential files of input
            DO 90 I=1,3
              CALL VARDMP (MESSFL,I)
 90         CONTINUE
          END IF
C
        ELSE IF (GOPT .EQ. 3) THEN
C         input from sequential file
C         Name of file with variables?
          SGRP = 144
          CALL QFOPEN (MESSFL, SCLU, SGRP, FINV, EFLG1)
          IF (EFLG1 .EQ. 0) THEN
            CALL SIVLOD (MESSFL,FINV,EFLG1A)
            IF (EFLG1A .EQ. 0) THEN
C             name of file for concurrent record
              SGRP = 143
              CALL QFOPEN (MESSFL, SCLU, SGRP, FIN8, EFLG2)
              IF (EFLG2 .EQ. 0) THEN
                CALL SCRLOD (MESSFL,FIN8,EFLG2A)
C               cross-correlation from sequential file
                SGRP = 142
                CALL QFOPEN (MESSFL, SCLU, SGRP, FINC, EFLG3)
                IF (EFLG3 .EQ. 0) THEN
                  CALL SCCLOD (FINC,MESSFL,EFLG3A)
                  INFLG =1
                END IF
              END IF
            END IF
          END IF

        ELSE IF (GOPT .EQ. 4) THEN
C         Name of output file
          SGRP = 140
          CALL QFOPEN (MESSFL, SCLU, SGRP, FOUT, RETCOD)
          IF (RETCOD .EQ. 0) OTFLG = 1
C
        ELSE IF (GOPT .EQ. 5) THEN
C         file name
          SGRP = 141
          CALL QFOPEN (MESSFL, SCLU, SGRP, FNET, EFLG4)
          IANS = 2
          IF (EFLG4 .NE. 0) IANS = 1
C         
        ELSE IF (GOPT .EQ. 6) THEN
          IF (INFLG .EQ. 0) THEN
C           can't analyze until input option successfully completed.
            SGRP = 48
            CALL PRNTXT (MESSFL, SCLU, SGRP)
          ELSE IF (OTFLG .EQ. 0) THEN
C           can't analyze until output file successfully opened.
            SGRP = 49
            CALL PRNTXT (MESSFL, SCLU, SGRP)
          ELSE
C           run generalized least squares
            CALL GLSCAL (FNET, MESSFL, IANS, FOUT,
     I                   ALPHA, THETA, VERSN)
C           Process complete
            SGRP = 98
            CALL PRNTXT (MESSFL, SCLU, SGRP)
C           reinitialize
            IF (IANS .EQ. 2) CALL QFCLOS (FNET,DEL)
            IF (EFLG1 .EQ. 0) CALL QFCLOS (FINV,DEL)
            IF (EFLG3 .EQ. 0) CALL QFCLOS (FINC,DEL)
            IF (EFLG2 .EQ. 0) CALL QFCLOS (FIN8,DEL)
            IF (EFLG4 .EQ. 0) CALL QFCLOS (FOUT, DEL)
            IANS = 1
            INFLG = 0
            OTFLG = 0
            EFLG1 = -1
            EFLG2 = -1
            EFLG3 = -1
            EFLG4 = -1
            EFLG1A = -1
            EFLG2A = -1
            EFLG3A = -1
          END IF
        END IF
      IF (GOPT .NE. 7) GO TO 10
C
C     close all files used
      DEL = 0
      IF (IANS .EQ. 2) CALL QFCLOS (FNET,DEL)
      IF (EFLG1 .EQ. 0) CALL QFCLOS (FINV,DEL)
      IF (EFLG3 .EQ. 0) CALL QFCLOS (FINC,DEL)
      IF (EFLG2 .EQ. 0) CALL QFCLOS (FIN8,DEL)
      IF (EFLG4 .EQ. 0) CALL QFCLOS (FOUT, DEL)
C
      RETURN
      END
C
C
C
      SUBROUTINE   VARDMP
     I                    (MESSFL, FLG)
C
C     + + + PURPOSE + + +
C     This routine writes sequential files of matrices calculated
C     from the WDM file.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   FLG, MESSFL
C
C     + + + KEYWORDS + + +
C     message file
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of GLSNET message file
C     FLG    -   1 - variables
C                2 - concurrent record
C                3 - cross-correlaation
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'pglsiz.inc'
      INCLUDE 'cgls.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I, J, FO, RETCOD, SGRP, SCLU, DEL
C
C     + + + EXTERNALS + + +
      EXTERNAL   QFOPEN, PRNTXT, QFCLOS
C
C     + + + OUTPUT FORMATS + + +
 2001 FORMAT (8A1,25E13.5)
 2002 FORMAT (20I4)
 2003 FORMAT (20F4.2)
C
C     + + + END SPECIFICATIONS + + +
C
      SCLU = 106
C     file name
      SGRP = 145 + FLG
      CALL QFOPEN (MESSFL, SCLU, SGRP, FO, RETCOD)
C
      IF (RETCOD .EQ. 0) THEN
C       file ok
        DO 20 I = 1,NSITES
          IF (FLG .EQ. 1) THEN
C           variables
            WRITE(FO,2001) (STANO(J,I),J=1,8),(Z(I,J),J=1,NV)
          ELSE IF (FLG.EQ.2) THEN
C           concurrent record
            WRITE(FO, 2002, ERR=30) (MCON(I,J),J=1,I)
          ELSE
C           must be cross-correlation
            WRITE(FO, 2003, ERR=30) (RHOC(I,J),J=1,I)
          END IF
 20     CONTINUE
        GO TO 40
 30     CONTINUE
C         write error
          SGRP = 57
          CALL PRNTXT (MESSFL, SCLU, SGRP)
 40     CONTINUE
C
C       close file, so unit can be used again
        ENDFILE (FO)
        DEL = 0
        CALL QFCLOS (FO,DEL)
C
      ELSE
C       file not opened, file not written
        SGRP = 58
        CALL PRNTXT (MESSFL, SCLU, SGRP)
      END IF
C
      RETURN
      END
