C
C
C
      SUBROUTINE   PRTPRO
     I                   (MESSFL,WDMSFL,ERRFL)
C
C     + + + PURPOSE + + +
C     Partial record processing
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER      MESSFL,WDMSFL,ERRFL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     WDMSFL - Fortran unit number of WDM file
C     ERRFL  - Fortran unit number for diagnostic output
C
C     + + + PARAMETERS + + +
      INTEGER    DSNMX
      PARAMETER  (DSNMX=12)
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,I0,I1,I2,I3,I4,I16,SCLU,SGRP,RESP,NSTAT,FLAG,N,
     1            SAIND,SATYP,RETCOD,DSNP(DSNMX),NDAY(DSNMX),
     2            ITYP(2),CLEN(1),ISTANO,ISTANX,ARESP
      REAL        RVAL
      CHARACTER*1 CTYPE(4),STANO(16),STANX(16)
      CHARACTER*8 PTHNAM
      DOUBLE PRECISION DVAL
C
C     + + + FUNCTIONS + + +
      INTEGER     CHRINT, CHKSTR
C
C     + + + EXTERNALS + + +
      EXTERNAL    QRESP, PRWMSE, WDBSGC, WDBSGI, PMXTXM, PRTNEW, PRTADD
      EXTERNAL    CHRINT, CHKSTR, PRNTXT, ZIPI
C
C     + + + DATA INITIALIZATIONS + + +
      DATA   I0,I1,I2,I3,I4,I16/0,1,2,3,4,16/
C
C     + + + END SPECIFICATIONS + + +
C
C     cluster for partial record processing
      SCLU = 152
C     no stations initially available
      NSTAT= 0
      CALL ZIPI (DSNMX,I0,NDAY)
C     assume good stations
      FLAG = 0
C     assume select
      RESP = 1
C
C     begin loop for options
 10   CONTINUE
C       select existing, create new, add to existing, done
        SGRP= 1
        CALL QRESP (MESSFL,SCLU,SGRP,RESP)
C
        IF (RESP .EQ. 1) THEN
C         select existing partial record datasets
          PTHNAM= 'P'
          CALL PRWMSE (MESSFL,WDMSFL,DSNMX, PTHNAM,
     M                 DSNP,NSTAT)
C         assume good stations
          FLAG= 0
C         are they valid partial record datasets?
          IF (NSTAT .GT. 0) THEN
            N= 0
 12         CONTINUE
              N= N+ 1
C             get TSTYPE
              SAIND= 1
              CALL WDBSGC (WDMSFL,DSNP(N),SAIND,I4,CTYPE,RETCOD)
              NDAY(N)= CHRINT(I3,CTYPE(2))
              IF (NDAY(N) .EQ. 0) THEN
C               This dataset has wrong TSTYPE. Last 3 char must be
C               integer numbers
                ITYP(1)= 1
                ITYP(2)= 4
                CLEN(1)= 4
                SGRP= 2
                CALL PMXTXM (MESSFL,SCLU,SGRP,I16,I1,I2,ITYP,I0,
     1                       DSNP(N),RVAL,DVAL,CLEN,CTYPE)
                FLAG= 1
              END IF
              IF (CTYPE(1) .NE. 'L') THEN
C               This data set has wrong TSTYPE attribute.  It must
C               begin with 'L'.
                ITYP(1)= 1
                ITYP(2)= 4
                CLEN(1)= 4
                SGRP= 3
                CALL PMXTXM (MESSFL,SCLU,SGRP,I16,I1,I2,ITYP,I0,
     1                       DSNP(N),RVAL,DVAL,CLEN,CTYPE)
                FLAG= 1
              END IF
            IF (FLAG .EQ. 0 .AND. N .LT. NSTAT) GO TO 12
C
            IF (FLAG .EQ. 0 .AND. NSTAT .GT. 1) THEN
              WRITE(ERRFL,*) 'checking for same station id'
              SAIND= 2
              CALL WDBSGC (WDMSFL,DSNP(1),SAIND,I16,
     O                     STANO(1),RETCOD)
              IF (RETCOD .NE. 0) THEN
C               must be integer sta id
                WRITE(ERRFL,*) 'look for integer station id'
                SAIND= 51
                CALL WDBSGI (WDMSFL,DSNP(1),SAIND,I1,
     O                       ISTANO,RETCOD)
              ELSE
                WRITE(ERRFL,*) 'found character station id'
              END IF
              IF (RETCOD .EQ. 0) THEN
C               got station id, now check
                DO 14 N = 2, NSTAT
                  IF (SAIND .EQ. 2) THEN
C                   character station id
                    CALL WDBSGC (WDMSFL,DSNP(N),SAIND,I16,
     O                           STANX(1),RETCOD)
                    IF (CHKSTR(I16,I1,STANO,STANX) .NE. 1) THEN
C                     character station id's don't match
                      WRITE(ERRFL,*) '**** char id ',DSNP(N),' fails'
                      FLAG= 2
                    ELSE
                      WRITE(ERRFL,*) 'char id ',DSNP(N),' matches'
                    END IF
                  ELSE
C                   integer sta id
                    CALL WDBSGI (WDMSFL,DSNP(N),SAIND,I1,
     O                           ISTANX,RETCOD)
                    IF (ISTANO .NE. ISTANX) THEN
C                     integer station id's don't match
                      WRITE(ERRFL,*) '**** int id ',DSNP(N),' fails'
                      FLAG= 2
                    ELSE
                      WRITE(ERRFL,*) 'integer id',DSNP(N),' matches'
                    END IF
                  END IF
 14             CONTINUE
C
                IF (FLAG .EQ. 2) THEN
C                 Data sets not all same station (STANO or ISTANO).
                  SGRP= 4
                  CALL PRNTXT (MESSFL,SCLU,SGRP)
                END IF
              END IF
            END IF
          END IF
C
        ELSE IF (RESP .EQ. 2) THEN
C         create partial record datasets
          IF (NSTAT .GT. 0) THEN
C           stations in buffer, keep it?
            ARESP= 2
            SGRP = 7
            CALL QRESP (MESSFL,SCLU,SGRP,ARESP)
          ELSE
C           no problem
            ARESP= 1
          END IF
C
          IF (ARESP .EQ. 1) THEN
C           no stations in buffer
            NSTAT= 0
C           create datasets
            CALL PRTNEW (MESSFL,SCLU,WDMSFL,ERRFL,DSNMX,
     M                   NSTAT,NDAY,
     O                   DSNP)
            FLAG= 0
          END IF
C
        ELSE IF (RESP .EQ. 3) THEN
C         add partial record data
          IF (NSTAT .EQ. 0) THEN
C           no stations to add data for
            SGRP= 5
            CALL PRNTXT (MESSFL,SCLU,SGRP)
          ELSE IF (FLAG .NE. 0) THEN
C           error in selection, must reselect first
            SGRP= 6
            CALL PRNTXT (MESSFL,SCLU,SGRP)
          ELSE
C           add partial record data
            CALL PRTADD (MESSFL,SCLU,WDMSFL,ERRFL,NSTAT,DSNP,NDAY)
          END IF
        END IF
      IF (RESP .NE. 4) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   PRTNEW
     I                   (MESSFL,SCLU,WDMSFL,ERRFL,DSNMX,
     M                    NSTAT,NDAY,
     O                    DSNP)
C
C     + + + PURPOSE + + +
C     This routine creates a new data set for a partial record site
C     and adds basic attributes and basin characteristics.  It returns
C     assigned data set numbers.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     MESSFL,SCLU,WDMSFL,ERRFL,DSNMX,
     1            NSTAT,NDAY(DSNMX),DSNP(DSNMX)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     SCLU   - Cluster containing text information for this routine
C     WDMSFL - Fortran unit number of WDM file
C     ERRFL  - Fortran unit number for diagnostic output
C     DSNMX  - Maximum number of datasets allowed in buffer
C     NSTAT  - Number of stations in buffer
C     NDAY   - Durations for new datasets
C     DSNP   - Datasets added
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      SGRP,RESP,DSNX,INUM,RNUM,CNUM,IDUM(1),CDUM(3,3),
     &             I,N,I0,I1,LEN,NBC,BCIND(20),IVAL(2,12),I9,I8,I16,
     &             RETCOD,SATYP,SALEN,SARQWD,SAUPFG,DPTR,I48,NASAP,NDP,
     &             DSATI(6),TSATI(12),CVAL(1,3,20),DSTYP,NDN,NUP,NSA,
     &             GFLG,MAKFG,IRET,VAL(7),SAI(7),SAIND,PSA,I2,RETCK,
     &             ISTANO, CLEN(2), TLEN
      REAL         RDUM(1),BCVAL(20),DSATR(6),TSATR(1),LATLNG(2),TSFILL
      CHARACTER*1  CTYP(4),CBUFF(80,20),STANAM(48),AGENCY(8),
     &             ATTR(6),MATTR(6),BLNK, CTXT(56)
      DOUBLE PRECISION DTMP
C
C     + + + FUNCTIONS + + +
      INTEGER   WDCKDT
C
C     + + + EXTERNALS + + +
      EXTERNAL  QRESP,  QRESCX, QRESPI, QRESCN, QSETI, QGETIB
      EXTERNAL  WDBSAR, WDSAFI, WDCKDT, WDSAGY, WDLBAX
      EXTERNAL  PRNTXA, PRNTXT, PRNTXI, PMXTXA, WDBSAI
      EXTERNAL  CHRCHR, LFTSTR, INTCHR, ZIPC, ZIPR, WDBSAC
      EXTERNAL  ZGTRET, ZSTCMA, Q1EDIT, Q1INIT, QGETI, QGETR, QGETCT
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  I0,I1,I2,I8,I9,I16,I48/0,1,2,8,9,16,48/
      DATA  DSATI/5*0,99/
      DATA  DSATR/-999.,-999.,-999.,-999.,-999.,-999./
      DATA  TSATI/6,1,7,1,1,1,1800,1,1,2201,1,1/
      DATA  TSATR/-99999./
      DATA  BLNK/' '/
      DATA  SAI/85,17,33,34,27,84,83/
      DATA  VAL/1,6,1,7,1800,5,1/
      DATA  DSTYP,NDN,NUP,NSA,NASAP,NDP
     &      /  1,  10, 10,100, 120, 10/
C
C     + + + END SPECIFICATIONS + + +
C
      TSFILL = -999999.
C     set datasets not made
      MAKFG= 0
C     initialize general attribute buffer
      LEN  = 100
C     no basin characteristics specified
      NBC  = 0
C     ask about general attributes first
      RESP = 1
C     general attributes not input
      GFLG = 0
C     loop to create partial record datasets
 10   CONTINUE
C       which create option, attributes, durations, basin char, make, done
        SGRP= 20
        CALL QRESP (MESSFL,SCLU,SGRP,RESP)
C
        IF (RESP .EQ. 1) THEN
C         get general attributes
          SGRP= 21
          CALL Q1INIT (MESSFL, SCLU, SGRP)
C         set initial data set number to none
          DSNX = -999
          CALL QSETI (I1,DSNX)
          CALL Q1EDIT (IRET)
C         get values user entered
          CALL QGETI (I1,DSNX)
          CALL QGETIB (I1,I2,ISTANO)
          CALL QGETR (I2,LATLNG)
          CLEN(1) = 8
          CLEN(2) = 48
          TLEN = 56
          CALL QGETCT (I2, CLEN, TLEN,
     O                 CTXT)
          CALL CHRCHR (CLEN(1), CTXT, AGENCY)
          CALL CHRCHR (CLEN(2), CTXT(CLEN(1)+1), STANAM)
          GFLG= 1
C
        ELSE IF (RESP .EQ. 2) THEN
C         specify duration values
          WRITE(ERRFL,*) '**** get duration values',NSTAT
C         make prev available
          I= 4
          CALL ZSTCMA(I,I1)
C         come back here on prev
C         allow up to 12 low-flow durations
          NSTAT = 12
C         user wants to continue, enter durations (in days)
          DO 30 N= 1,NSTAT
            IVAL(1,N)= N
            IVAL(2,N)= NDAY(N)
 30       CONTINUE
          INUM= 2
          SGRP= 23
          CALL QRESCN (MESSFL,SCLU,SGRP,INUM,I1,I1,NSTAT,I1,
     M                 IVAL,RDUM,CDUM,CBUFF)
C         get user exit command value
          CALL ZGTRET (IRET)
          IF (IRET .EQ. 1) THEN
C           user wants to continue, count and save durations
            NSTAT = 0
            I = 1
 40         CONTINUE
              IF (IVAL(2,I) .GT. 0) THEN
                NSTAT = NSTAT + 1
                NDAY(NSTAT) = IVAL(2,I)
              END IF
              I = I + 1
            IF (I .LE. 12) GO TO 40
          END IF
          IF (NSTAT .LT. 12) THEN
C           set remaining values to 0
            DO 44 I = NSTAT+1,12
              NDAY(I) = 0
 44         CONTINUE
          END IF
C         make prev not available
          I= 4
          CALL ZSTCMA(I,I0)
C
        ELSE IF (RESP .EQ. 3) THEN
C         basin characteristics
          WRITE(ERRFL,*) '**** get basin chars',NBC
          LEN= 1600
          CALL ZIPC (LEN,BLNK,CBUFF)
          IF (NBC .GT. 0) THEN
C           fill in existing characteristic names
            DO 45 I= 1, NBC
              CALL WDSAGY (MESSFL,BCIND(I),
     O                     CBUFF(1,I),DPTR,SATYP,SALEN,SARQWD,SAUPFG)
              WRITE(ERRFL,*) 'found name for bc attribute',BCIND(I)
 45         CONTINUE
          ELSE
C           initialize current values
            RDUM(1)= -999.
            I= 20
            CALL ZIPR (I,RDUM,BCVAL)
          END IF
C         make prev available
          I= 4
          CALL ZSTCMA(I,I1)
C         come back here on prev
 50       CONTINUE
C           how many basin characteristics?
            SGRP= 24
            CALL QRESPI (MESSFL,SCLU,SGRP,
     M                   NBC)
C           get user exit command value
            CALL ZGTRET (IRET)
            IF (IRET .EQ. 1) THEN
C             user wants to continue, get characteristics
              INUM= 1
              RNUM= 1
              CNUM= 1
              SGRP= 25
              CALL QRESCX (MESSFL,SCLU,SGRP,INUM,RNUM,CNUM,NBC,I1,
     O                     IDUM,BCVAL,CVAL,CBUFF)
C             get user exit command value
              CALL ZGTRET (IRET)
              IF (IRET .EQ. 1) THEN
C               check basin characteristic names and values
                I= 0
 60             CONTINUE
                  I  = I+ 1
C                 get specs on basin characteristic attribute
                  LEN= 6
                  CALL LFTSTR (LEN,CBUFF(1,I))
                  CALL CHRCHR (LEN,CBUFF(1,I),ATTR)
                  BCIND(I)= 1
                  CALL WDSAFI (MESSFL,ATTR,
     M                         BCIND(I),
     O                         MATTR,RETCOD)
C
                  IF (RETCOD .NE. 0)  THEN
C                   characteristic not found
                    SGRP= 26
                    CALL PRNTXA (MESSFL,SCLU,SGRP,LEN,CBUFF(1,I))
                    CALL ZGTRET (IRET)
                  ELSE
                    CALL WDSAGY (MESSFL,BCIND(I),
     O                           ATTR,DPTR,SATYP,SALEN,SARQWD,SAUPFG)
                    WRITE(ERRFL,*) 'found index',BCIND(I),' for attrib'
                    IF (SATYP .NE. 2) THEN
C                     attribute must be for decimal numbers
                      SGRP= 27
                      CALL PRNTXA (MESSFL,SCLU,SGRP,LEN,CBUFF(1,I))
                      CALL ZGTRET (IRET)
                    END IF
                  END IF
                IF (I .LT. NBC .AND. IRET .EQ. 1) GO TO 60
              END IF
            ELSE
C             user wants back to main n-day menu
              IRET= 1
            END IF
          IF (IRET .EQ. 2) GO TO 50
C         make prev not available
          I= 4
          CALL ZSTCMA(I,I0)
C
        ELSE IF (RESP .EQ. 4) THEN
C         execute - make the labels
          IF (GFLG .EQ. 0) THEN
C           cant add labels without general attributes
            SGRP= 28
            CALL PRNTXT(MESSFL,SCLU,SGRP)
          ELSE IF (NSTAT .EQ. 0) THEN
C           no durations available
            SGRP= 32
            CALL PRNTXT(MESSFL,SCLU,SGRP)
          ELSE
C           put attributes on data set
            WRITE(ERRFL,*) 'loop for new datasets, base:',DSNX
            CTYP(1)= 'L'
            N= 0
 80         CONTINUE
              N= N+ 1
C             loop for each new dataset
              DSNP(N)= DSNX+ N- 1
C             does this dataset exist?
              I= WDCKDT(WDMSFL,DSNP(N))
              IF (I .GT. 0) THEN
C               problem, data set exists
                SGRP= 33
                CALL PRNTXI (MESSFL,SCLU,SGRP,DSNP(N))
C               force exit
                N= NSTAT
              ELSE
                WRITE(ERRFL,*) '***** creating dataset',DSNP(N)
                I= 3
                CALL INTCHR (NDAY(N),I,I0,
     O                       LEN,CTYP(2))
                IF (CTYP(2) .EQ. BLNK) CTYP(2) = '0'
                IF (CTYP(3) .EQ. BLNK) CTYP(3) = '0'
C               create dataset and put attributes
                CALL WDLBAX (WDMSFL,DSNP(N),DSTYP,NDN,NUP,NSA,
     &                       NASAP,NDP,PSA)
                IF (PSA .EQ. 0) THEN
C                 Data set could not be created for TSTYPE:
                  LEN = 4
                  SGRP= 29
                  CALL PRNTXA (MESSFL,SCLU,SGRP,LEN,CTYP(1))
                ELSE
                  RETCK = 0
C                 add TSTYPE
                  SAIND = 1
                  SALEN = 4
                  CALL WDBSAC (WDMSFL, DSNP(N), MESSFL, SAIND,
     I                         SALEN, CTYP, 
     O                         RETCOD)
                  IF (RETCOD .NE. 0) RETCK = RETCK + 1
C                 add integer attributes to define storage of data
C                 vbtime, tcode, tsstep, tgroup, tsbyr, tsform, compfg
C                 values from data statement
                  DO 66 I = 1,7
                    CALL WDBSAI (WDMSFL, DSNP(N), MESSFL, SAI(I),
     I                           I1, VAL(I), 
     O                           RETCOD)
                    IF (RETCOD .NE. 0) RETCK = RETCK + 1
 66               CONTINUE
C                 add lat, long, agency code, station name and number
                  SALEN = 1
                  SAIND = 8
                  CALL WDBSAR (WDMSFL, DSNP(N), MESSFL, SAIND,
     I                         SALEN, LATLNG(1), 
     O                         RETCOD)
                  IF (RETCOD .NE. 0) RETCK = RETCK + 1
                  SAIND = 9
                  CALL WDBSAR (WDMSFL, DSNP(N), MESSFL, SAIND,
     I                         SALEN, LATLNG(2), 
     O                         RETCOD)
                  IF (RETCOD .NE. 0) RETCK = RETCK + 1
                  SALEN = 16
                  SAIND = 40
                  CALL WDBSAC (WDMSFL, DSNP(N), MESSFL, SAIND,
     I                         SALEN, AGENCY, 
     O                         RETCOD)
                  IF (RETCOD .NE. 0) RETCK = RETCK + 1
                  SALEN = 48
                  SAIND = 45
                  CALL WDBSAC (WDMSFL, DSNP(N), MESSFL, SAIND,
     I                         SALEN, STANAM, 
     O                         RETCOD)
                  IF (RETCOD .NE. 0) RETCK = RETCK + 1
                  SALEN = 8
                  SAIND = 51
                  CALL WDBSAI (WDMSFL, DSNP(N), MESSFL, SAIND,
     I                         SALEN, ISTANO, 
     O                         RETCOD)
                  IF (RETCOD .NE. 0) RETCK = RETCK + 1
C                 add TSFILL of -999999.
                  SALEN = 1
                  SAIND = 32
                  CALL WDBSAR (WDMSFL, DSNP(N), MESSFL, SAIND,
     I                         SALEN, TSFILL, 
     O                         RETCOD)
                  IF (RETCOD .NE. 0) RETCK = RETCK + 1
                  IF (NBC .GT. 0) THEN
C                   add basin characteristics
                    DO 70 I= 1, NBC
                      CALL WDBSAR (WDMSFL,DSNP(N),MESSFL,
     I                             BCIND(I),I1,BCVAL(I),
     O                             RETCOD)
                      IF (RETCOD .NE. 0) RETCK = RETCK + 1
                      WRITE(ERRFL,*) 'add attr:',BCIND(I),' val:',
     &                                BCVAL(I)
 70                 CONTINUE
                  END IF
                END IF
                IF (RETCOD .EQ. 0) THEN
                  I   = 15
                  LEN = 4
                  IF (RETCK .EQ. 0) THEN
C                   dataset added ok
                    SGRP= 30
                  ELSE
C                   data set created but not all attributes added
                    SGRP = 34
                  END IF
                  CALL PMXTXA (MESSFL,SCLU,SGRP,I,I1,I0,I1,LEN,CTYP)
                END IF
              END IF
            IF (N .LT. NSTAT) GO TO 80
C           set flag showing labels made
            MAKFG= 1
          END IF
C
        ELSE IF (RESP .EQ. 5) THEN
C         return, have labels been created
          IF (MAKFG .EQ. 0) THEN
C           no labels created
            IF (GFLG .EQ. 1) THEN
C             general info specified, ask
              SGRP= 31
              CALL QRESP (MESSFL,SCLU,SGRP,
     M                    GFLG)
              IF (GFLG .EQ. 2) THEN
C               user wants another chance
                RESP= 4
              END IF
            END IF
          END IF
        END IF
      IF (RESP .NE. 5) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   PRTADD
     I                   (MESSFL,SCLU,WDMSFL,ERRFL,NSTAT,DSNP,NDAY)
C
C     + + + PURPOSE + + +
C     This routine adds data for a partial record site using the
C     Stedinger technique or with manual input from the terminal
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     MESSFL,SCLU,WDMSFL,ERRFL,NSTAT,DSNP(NSTAT),
     &            NDAY(NSTAT)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     SCLU   - Cluster containing text information for this routine
C     WDMSFL - Fortran unit number of WDM file
C     ERRFL  - Fortran unit number for diagnostic output
C     NSTAT  - Number of stations in buffer
C     DSNP   - Datasets to add data into
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      SGRP,RESP
C
C     + + + EXTERNALS + + +
      EXTERNAL     QRESP,PRTSTE,PRTMAN
C
C     + + + END SPECIFICATIONS + + +
C
      RESP= 1
 10   CONTINUE
C       how to add data?
        SGRP= 40
        CALL QRESP (MESSFL,SCLU,SGRP,
     M              RESP)
        IF (RESP .EQ. 1) THEN
C         compute with stedinger technique
          CALL PRTSTE (MESSFL,WDMSFL,ERRFL,NSTAT,DSNP,NDAY)
        ELSE IF (RESP .EQ. 2) THEN
C         manually add data
          CALL PRTMAN (MESSFL,SCLU,WDMSFL,ERRFL,NSTAT,DSNP)
        END IF
      IF (RESP .NE. 3) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   PRTMAN
     I                   (MESSFL,SCLU,WDMSFL,ERRFL,NSTAT,DSNP)
C
C     + + + PURPOSE + + +
C     This routine adds data for a partial record site using manual
C     data entry from terminal
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL,SCLU,WDMSFL,ERRFL,NSTAT,DSNP(NSTAT)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     SCLU   - Cluster containing text information for this routine
C     WDMSFL - Fortran unit number of WDM file
C     ERRFL  - Fortran unit number for diagnostic output
C     NSTAT  - Number of stations in buffer
C     DSNP   - Datasets to add data into
C
C     + + + PARAMETERS + + +
C     maxinum number of years allowed
      INTEGER   NVAL
      PARAMETER (NVAL=200)
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   SGRP,RESP,YRESP,XRESP,FFLG,YFLG,I,J,SAIND,SALEN,BDAT(6),
     1          GPFLG,TDSFRC,SDAT(6),EDAT(6),RETCOD,TUNIT,TSTEP,
     2          GVAL,DTOVWR,QUALGT,QUALPT,YPOS,INUM,RNUM,CNUM,CVAL(3),
     3          IVAL,IRANGE(2),IRET,I0,I1,I2,I50,RANFG,WRTFG,ITMP,
     4          SAINDQ(3),DTRAN,I6,YPOS1,YPOS2,N,SYRIDX,EYRIDX,TMP(6),
     5          BGNDAT(6),ENDDAT(6),RESP2
      REAL      RTMP,RVAL(1),QVAL(3),RDATA(NVAL)
      CHARACTER*1 TBUFF(80)
C
C     + + + EXTERNALS + + +
      EXTERNAL  ZIPR,QRESP,QRESPI,QRESPM,WTFNDT,TIMDIF,WDTGET,WDTPUT
      EXTERNAL  ZGTRET,ZSTCMA,PRNTXI,PMXTXI,PRNTXT,ZBLDWR
      EXTERNAL  WDBSGI,WDBSGR,WDBSAR,PMXCNW,COPYI
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  I0,I1,I2,I6,I50/0,1,2,6,50/
C     attribute indices for 7q2,10,20
      DATA  SAINDQ/162,164,165/
C
C     + + + END SPECIFICATIONS + + +
C
      BGNDAT(1) = 0
      BGNDAT(2) = 1
      BGNDAT(3) = 1
      BGNDAT(4) = 0
      BGNDAT(5) = 0
      BGNDAT(6) = 0
      ENDDAT(1) = 0
      ENDDAT(2) = 12
      ENDDAT(3) = 31
      ENDDAT(4) = 24
      ENDDAT(5) = 0
      ENDDAT(6) = 0
C
      WRITE(ERRFL,*) '****** manual data add ******'
C     assume no years to add
      YFLG = 0
C     assume no q's to add
      FFLG = 0
C     initialize years available to no
      RTMP = 0.0
      CALL ZIPR(NVAL,RTMP,RDATA)
C     timseries parms
      TUNIT = 6
      TSTEP = 1
      DTRAN = 0
      DTOVWR= 1
      QUALGT= 31
      QUALPT= 0
C
      RESP= 1
 10   CONTINUE
C       main manual loop (1-specify yr.s, 2-specify stats, 3-add data,
C                         4-return)
        SGRP= 50
        CALL QRESP(MESSFL,SCLU,SGRP,
     M             RESP)
        IF (RESP .EQ. 1) THEN
C         specify years with data,
C         get base year attribute
          SAIND= 27
          SALEN= 1
          CALL WDBSGI (WDMSFL,DSNP(1),SAIND,SALEN,
     O                 BDAT(1),RETCOD)
C         mininum BDAT(1)=1800 or might get subscript range error later
          IF (BDAT(1) .LT. 1800) BDAT(1) = 1800 
          WRITE(ERRFL,*) 'base year:',BDAT(1),RETCOD
          BDAT(2)= 1
          BDAT(3)= 1
          BDAT(4)= 0
          BDAT(5)= 0
          BDAT(6)= 0
C         does data already exist?
          GPFLG= 1
          CALL WTFNDT (WDMSFL,DSNP(1),GPFLG,
     O                 TDSFRC,SDAT,EDAT,RETCOD)
          WRITE(ERRFL,*) 'looking for data',DSNP(1),RETCOD,SDAT,EDAT
          IF (RETCOD .EQ. 0) THEN
C           data exists, use it?
            YRESP= 1
            SGRP = 51
            CALL QRESP(MESSFL,SCLU,SGRP,
     M                 YRESP)
          ELSE
C           no data exists
            YRESP= 2
          END IF
          IF (YRESP .EQ. 1) THEN
C           fill in existing data (one year data)
            CALL TIMDIF (SDAT,EDAT,TUNIT,TSTEP,
     O                   GVAL)
            CALL COPYI (I6, ENDDAT, TMP)
            TMP(1) = SDAT(1)
            CALL TIMDIF (BDAT,TMP,TUNIT,TSTEP,
     O                   YPOS)
            WRITE(ERRFL,*) 'about to get data for ',DSNP(1),GVAL,YPOS
            CALL WDTGET (WDMSFL,DSNP(1),TSTEP,SDAT,GVAL,
     I                   DTRAN,QUALGT,TUNIT,
     O                   RDATA(YPOS),RETCOD)
            WRITE(ERRFL,*) 'data gotten:',RETCOD
          END IF
C
          RESP2 = 1
 20       CONTINUE
C           loop to specify years with data
            SGRP= 52
            CALL QRESP(MESSFL,SCLU,SGRP,
     M                 RESP2)
            IF (RESP2 .EQ. 1) THEN
C             make prev available
              I= 4
              CALL ZSTCMA(I,I1)
C             single year
              IVAL= -999
              SGRP= 53
              CALL QRESPI(MESSFL,SCLU,SGRP,
     M                    IVAL)
              CALL ZGTRET(IRET)
C             make prev not available
              I= 4
              CALL ZSTCMA(I,I0)
              IF (IRET .NE. 2) THEN
C               use did not choose prev
                IF (IVAL .LT. BDAT(1)) THEN
C                 start year before base year
                  SGRP= 54
                  CALL PRNTXI (MESSFL,SCLU,SGRP,BDAT(1))
                ELSE
                  CALL COPYI (I6, ENDDAT, EDAT)
                  EDAT(1)= IVAL
                  CALL TIMDIF (BDAT,EDAT,TUNIT,TSTEP,
     O                         YPOS)
                  WRITE(ERRFL,*) 'set single year',IVAL,' at pos',YPOS
                  RDATA(YPOS)= 1.0
                  YFLG= 1
                END IF
              END IF
C
            ELSE IF (RESP2 .EQ. 2) THEN
C             span of years, make prev available
              I= 4
              CALL ZSTCMA(I,I1)
              IRANGE(1)= -999
              IRANGE(2)= -999
              INUM= 2
              RNUM= 1
              CNUM= 1
              SGRP= 57
              CALL QRESPM(MESSFL,SCLU,SGRP,INUM,RNUM,CNUM,
     M                    IRANGE,RVAL,CVAL,TBUFF)
              CALL ZGTRET(IRET)
C             make prev not available
              I= 4
              CALL ZSTCMA(I,I0)
              IF (IRET .NE. 2) THEN
C               use did not choose prev
                IF (IRANGE(1) .LT. BDAT(1)) THEN
C                 start year before base year
                  SGRP= 58
                  CALL PRNTXI (MESSFL,SCLU,SGRP,BDAT(1))
                ELSE IF (IRANGE(1) .GT. IRANGE(2)) THEN
C                 start year after end year
                  SGRP= 59
                  CALL PRNTXT (MESSFL,SCLU,SGRP)
                ELSE
                  CALL COPYI (I6, ENDDAT, EDAT)
                  EDAT(1)= IRANGE(1)
                  CALL TIMDIF (BDAT,EDAT,TUNIT,TSTEP,
     O                         YPOS1)
                  EDAT(1)= IRANGE(2)
                  CALL TIMDIF (BDAT,EDAT,TUNIT,TSTEP,
     O                         YPOS2)
                  WRITE(ERRFL,*) 'set mult yrs bet pos',IRANGE
                  DO 25 YPOS= YPOS1, YPOS2
                    RDATA(YPOS)= 1.0
 25               CONTINUE
                  YFLG= 1
                END IF
              END IF
C
            ELSE IF (RESP2 .EQ. 3) THEN
C             list years available
              WRTFG= 0
C             start not in a range
              RANFG= 0
              DO 30 I= 1,NVAL
                IVAL= RDATA(I)
                IF (IVAL .EQ. 1) THEN
C                 data exists
                  IF (RANFG .EQ. 0) THEN
C                   start a range
                    RANFG   = 1
                    IRANGE(1)= I+ BDAT(1)
                  END IF
                END IF
C
                IF (RANFG .EQ. 1 .AND. (IVAL.EQ.0 .OR. I.EQ.NVAL)) THEN
C                 now no data or clear out last buffer
                  IRANGE(2)= I+ BDAT(1)- 1
                  IF (WRTFG .EQ. 0) THEN
C                   header for output screen
                    SGRP= 60
                    CALL PMXCNW (MESSFL,SCLU,SGRP,I50,I1,-I1,IRET)
                  END IF
                  SGRP = 61
                  CALL PMXTXI (MESSFL,SCLU,SGRP,I50,-I1,-I1,I2,IRANGE)
                  WRTFG= 1
                  WRITE(ERRFL,*) 'found range',IRANGE
                  RANFG= 0
                END IF
 30           CONTINUE
C
              IF (WRTFG .EQ. 0) THEN
C               no data to list
                SGRP= 62
                CALL PRNTXT (MESSFL,SCLU,SGRP)
              ELSE
C               pause for user response
                CALL ZBLDWR(I0,TBUFF,I0,I0,IRET)
              END IF
C
            ELSE IF (RESP2 .EQ. 4) THEN
C             clear available data
              CALL ZIPR(NVAL,RTMP,RDATA)
              YFLG= 0
            END IF
          IF (RESP2 .NE. 5) GO TO 20
C
        ELSE IF (RESP .EQ. 2) THEN
C         specify flow stats, existing values?
          DO 35 I= 1, 3
            CALL WDBSGR(WDMSFL,DSNP(1),SAINDQ(I),I1,
     O                  QVAL(I),RETCOD)
            IF (RETCOD .NE. 0) THEN
C             attr not available
              QVAL(I)= -999
            END IF
 35       CONTINUE
C         make prev available
          I= 4
          CALL ZSTCMA(I,I1)
          INUM= 1
          RNUM= 3
          CNUM= 1
          SGRP= 63
          CALL QRESPM(MESSFL,SCLU,SGRP,INUM,RNUM,CNUM,
     M                ITMP,QVAL,CVAL,TBUFF)
          CALL ZGTRET(IRET)
C         make prev not available
          I= 4
          CALL ZSTCMA(I,I0)
          IF (IRET .NE. 2) THEN
C           use did not choose prev
            FFLG= 1
          END IF
C
        ELSE IF (RESP .EQ. 3) THEN
C         add data to the datasets
          IF (YFLG .EQ. 0 .AND .FFLG .EQ. 0) THEN
C           nothing to add
            SGRP= 65
            CALL PRNTXT (MESSFL,SCLU,SGRP)
          ELSE
            IF (YFLG .EQ. 1) THEN
C             add years of data
              CALL COPYI (I6, BGNDAT, SDAT)
              CALL COPYI (I6, ENDDAT, EDAT)
              SYRIDX = 0
              EYRIDX = 0
              DO 37 I = 1, NVAL
                IF (RDATA(I).GT.0. .AND. SYRIDX.EQ.0) SYRIDX = I
                IF (RDATA(NVAL+1-I).GT.0 .AND. EYRIDX.EQ.0) 
     $              EYRIDX = NVAL+1-I
 37           CONTINUE
              YPOS = SYRIDX
              SDAT(1) = BDAT(1) + SYRIDX - 1
              EDAT(1) = BDAT(1) + EYRIDX - 1
              CALL TIMDIF (SDAT, EDAT, TUNIT, TSTEP, 
     O                     N)
              IF (N .GT. 0) THEN
                DO 40 I= 1, NSTAT
C                 for each station
                  CALL WDTPUT (WDMSFL,DSNP(I),TSTEP,SDAT,N,
     I                         DTOVWR,QUALPT,TUNIT,RDATA(YPOS),
     O                         RETCOD)
                  WRITE(ERRFL,*) 'data added',DSNP(I),RETCOD,TSTEP,N,
     $                                        DTOVWR,QUALPT,TUNIT,SDAT
 40             CONTINUE
C               set flag to data added
                YFLG= 0
              ELSE
                WRITE(ERRFL,*) 'no data to add'
              END IF
            END IF
C
            IF (FFLG .EQ. 1) THEN
C             add flow stats
              DO 50 I= 1, NSTAT
C               for each station
                DO 45 J= 1, 3
C                 add three attributes
                  WRITE(ERRFL,*) 'flow attr',DSNP(I),SAINDQ(J),QVAL(J)
                  CALL WDBSAR(WDMSFL,DSNP(I),MESSFL,SAINDQ(J),
     I                        I1,QVAL(J),
     O                        IRET)
                  WRITE(ERRFL,*) '   retcod',IRET
 45             CONTINUE
 50           CONTINUE
C             set flag to data added
              FFLG= 0
            END IF
          END IF
C
        ELSE IF (RESP .EQ. 4) THEN
C         return to add screen
          IF (FFLG .EQ. 1 .OR. YFLG .EQ. 1) THEN
C           data specified but not yet added, continue?
            XRESP= 2
            SGRP = 66
            CALL QRESP(MESSFL,SCLU,SGRP,
     M                 XRESP)
            IF (XRESP .EQ. 2) THEN
C             dont continue
              RESP= 1
            END IF
          END IF
        END IF
      IF (RESP .NE. 4) GO TO 10
C
      RETURN
      END
