C
C
C
      SUBROUTINE   GLSCAL
     I                    (FNET, MESSFL, IANS, FOUT,
     I                     ALPHA, THETA, VERSN)
C
C     + + + PURPOSE + + +
C     The purpose of this routine is to make the GLS analysis, getting the
C     independent variable from the user, and generating the output files.
C
C     + + + HISTORY + + +
C     Dropped the requirement for regression on the mean and
C     writing XMGAMA to the network file.  Computation of RHOMS
C     deleted -1.  XMGAMA not used anymore.  ERRMOD computation set
C     to GAMASQ and not dependent on ILOW. AML 6/30/93
C
C     + + + KEYWORDS + + +
C     message file
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   FNET, MESSFL, IANS, FOUT
      REAL      ALPHA, THETA
      CHARACTER*64 VERSN
C
C     + + + ARGUMENT DEFINITIONS + + +
C     FNET   - Fortran unit number for output file for input to network
C              analysis
C     MESSFL - Fortran unit number of GLSNET message file
C     IANS   - flag
C              1 - no file
C              2 - make file for input to network
C              analysis
C     FOUT   - Fortran unit number of output file.
C     ALPHA  - coefficient for cross-correlation vs. distance equation
C     THETA  - exponent for cross-correlation vs. distance equation
C     VERSN  - current version number and date of program
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'pglsiz.inc'
      INCLUDE 'cgls.inc'
      INCLUDE 'cglsp.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,J,NE,RESP,DEL,IBA,NDF,ICHK,SGRP,SCLU,NUMMIS,L1,L2,
     #          M,IDX,IDXS,IDXT,ICOLS(MAXINP),ICOLT(MAXINP),K,L78,
     #          IDMP(MAXINP),L0,L20,L8,DONES,DONEV,
     #          KODE, MISFLG, ICOLX(MAXINP),GOPT,               IRET,
     #          IM3,RETCOD
      REAL   TV4, PV4, TEMP(MAXVAR), POBS(MAXPTS)
      DOUBLE PRECISION   COOKD,CX(1,1),ERRMOD,HATDIG,PRED,RESID,
     #                   RHOMS,SAMERR,SDBETA,SMOD,PRESS,SSQPRE,
     #                   SSAM,STDRES,TBETA,VARPRE,VARRES,EQYRS,
     #                   WORK1(MAXPTS,1),WORK2(MAXVAR,MAXPTS),
     #                   XV(1,MAXVAR),XTV(MAXVAR,1),PREOBS,SEQY
      CHARACTER*1  ANS(8),           BLNK8(8)
      CHARACTER*78        BLNKLN
Ckmf  March 23, 2004, added variable
      CHARACTER*78 PRTROW(20)
C
C     + + + FUNCTIONS + + +
      INTEGER   CKNBLK
      REAL      STUTP
C
C     + + + INTRINSICS + + +
      INTRINSIC   DSQRT, ABS, SNGL, DBLE, INT
C
C     + + + EXTERNALS + + +
      EXTERNAL   OLS, MULTPY, RELOAD, COEFMT, SECANT, QRESP, QFCLOS
      EXTERNAL   VARPLT, STUTP, PRNTXT, PRNTXI, GLSVEW, Q1INIT
      EXTERNAL   ZIPI, MTXLOD,  FIND, QSTCTF, QGTCTF, Q1EDIT
      EXTERNAL   CKNBLK, ZQUIET
Ckmf  March 23, added externals
      EXTERNAL   Q2INIT, Q2SCTF, Q2EDIT
      EXTERNAL   STATVR
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  L0, L1, L2, L8, L20, L78, BLNK8
     $     / 0,  1,  2,  8,  20,  78, 8*' ' /
C
C     + + + INPUT FORMAT + + +
C1000 FORMAT (30X,I10)
C
C     + + + OUTPUT FORMATS + + +
 2001 FORMAT (  ' DIAGONAL IN MCON ARRAY ZERO FOR ONE OF THE SITES',
     $        /, ' ******** MUST STOP ********',
     $        /, '  SITE   # VALUES',
     $        /, '  ----   --------',
     $        /, ( I6, I10 ) )
 2003 FORMAT (80A1)
 2006 FORMAT(1X,'   CONSTANT  ',9(5X,8A1) )
 2007 FORMAT(2X,10G13.5)
 2101 FORMAT (     66X,         'STANDARD        MODEL    SAMPLING   ',
     $           '  EQUIV.',
     $        /, '    ID         OBSERVED     PREDICTED      WEIGHTED',
     $           '     RESIDUAL  RESIDUAL        ERROR       ERROR   ',
     $           '   YEARS  LEVERAGE   COOKS D',
     $        / )
 2102 FORMAT (1X,8A1,3G14.6,G13.5,F10.3,2G13.5,F10.1,F10.3,F10.2)
 2200 FORMAT(A1,5X,A38)
 2204 FORMAT('  MODEL ERROR VARIANCE =',G13.5)
 2301 FORMAT(' SUMMARY OF REGRESSION FOR MEAN')
 2303 FORMAT('  MODEL ERROR FOR MEAN =',G13.5)
 2402 FORMAT(' MODEL ERROR FOR T-YEAR LOW FLOW =',G13.4)
 2405 FORMAT(' MODEL ERROR FOR ',6A1,' LOW FLOW=',G13.4)
 2500 FORMAT( ' ' )
 2501 FORMAT(/)
 2502 FORMAT(//)
 2503 FORMAT(///)
Ckmf  March 23, 2004 - combined 2501 & 2519-2522 into 2519
 2519 FORMAT (//,'  AVERAGE SAMPLING ERROR             ', F10.4,
     $        /, '  AVERAGE MODEL ERROR                ', F10.4,
     $        /, '  PRESS / N                          ', F10.4,
     $        /, '  AVERAGE EQUIVALENT YEARS OF RECORD ', F8.2  )
 2705 FORMAT (9F13.7)
 2706 FORMAT (2X,8A1,13F12.7)
Ckmf  March 23, 2004 - combined 2708 & 2710-2712 into 2708
 2708 FORMAT (   F12.7, 18X, ' MODEL ERROR FOR SIGMA',
     $        /, F12.7, 18X, ' CORRELATION BETWEEN MU AND SIGMA',
     $        /, F12.7, 18X, ' RECURRENCE INTERVAL',
     $        /, 3X, I2,26X, ' NO. OF PARAMETERS FOR REGRESSION' )
Ckmf  Nov 18, 2004 added 2710 so write agrees with read in netinp
 2710 FORMAT (I5)
 2714 FORMAT (2F13.5)
 2715 FORMAT (20I4)
 2716 FORMAT (20F4.2)
C     + + + new formats + + +
 2201 FORMAT (   ' SUMMARY OF REGRESSION FOR SIGMA',
     $        /, ' ',
     $        /, '  REGRESSION COEFFICIENTS',
     $        /,  ' ',
     $        /, '  VARIABLE     COEFFICIENT   STANDARD ERROR   ',
     $           'T FOR H0:BETA=0       PROB>|T|',
     $       //, ( A ) )
 2011 FORMAT (   '   CONSTANT', F15.5, 2X, F15.5, 3X, F15.5 )
 2008 FORMAT (   '   ',    8A1, F15.5, 2X, F15.5, 3X, F15.5, F15.4 )
 2203 FORMAT (   '  MODEL ERROR FOR SIGMA = ', G13.5, 38(' ') )
c                 ----+----1----+----2----+----3----+----4----+----
c
 2202 FORMAT (   ' SUMMARY OF REGRESSION FOR', I4, '-YEAR RECURRENCE ',
     $           'INTERVAL' )
 2205 FORMAT (   ' SUMMARY OF REGRESSION FOR ', 8A1 )
 2005 FORMAT (   '           T    -1   -1',
     $        /, '         (X (COV  )X)  ',
     $        // )
c2009 FORMAT (//,'  REGRESSION COEFFICIENTS',
c    $        //,'  VARIABLE     COEFFICIENT   STANDARD ERROR   ',
c    $         /,'T FOR H0:BETA=0       PROB>|T|'
c
C2009 FORMAT (//,'  REGRESSION COEFFICIENTS',
C    $       //, ' VARIABLE      COEFFICIENT   STANDARD ERROR   ',
C    $        /, 'T FOR H0:BETA=0       PROB>|T|',
C    $       //, A,
C    $       (/, A ) )
 2009 FORMAT (///,'  REGRESSION COEFFICIENTS',
     $        /,  ' ',
     $        /, '  VARIABLE     COEFFICIENT   STANDARD ERROR   ',
     $           'T FOR H0:BETA=0       PROB>|T|',
     $       //, ( A ) )
C
C     + + + recoded formats + + +
C2001 FORMAT (' DIAGONAL IN MCON ARRAY ZERO FOR ONE OF THE SITES'/
C    #        ' ******** MUST STOP ********'/
C    #        '  SITE   # VALUES'/'  ----   --------',(I6,I10))
C2004 FORMAT (132A1)
C2005 FORMAT(1X,T12,'T',T17,'-1',T22,'-1',/,1X,T10,'(X (COV  )X)',//)
C2008 FORMAT(3X, 8A1, F15.5, 2X, F15.5, 3X, F15.5, F15.4)
C2009 FORMAT('  REGRESSION COEFFICIENTS')
C2010 FORMAT('  VARIABLE',5X,'COEFFICIENT',3X,'STANDARD ERROR'3X,
C    1       'T FOR H0:BETA=0',7X,'PROB>|T|')
C2011 FORMAT('   CONSTANT', F15.5, 2X, F15.5, 3X, F15.5)
C2101 FORMAT(1H1,T36,'VARIANCE',T57,'WEIGHTED',T98,'  EQUIVALENT',
C    1/,T39,'OF',T58,'AVERAGE',T68,'STANDARD ',T82,'MODEL',T90,
C    2'SAMPLING',T100,' YEARS OF ',T115,'HAT',/,T7,'NUM',T15,
C    3'ACTUAL',T23,'PREDICTED',T35,'PREDICTED',T46,'RESIDUAL',T57,
C    4'OBS+PRED',T68,'RESIDUAL',T82,'ERROR',T93,'ERROR',T100,
C    5'   RECORD  ',T112,'DIAGONAL',T124,'COOKS D',/)
C2101 FORMAT(1X,T67,'STANDARD',T83,'MODEL',T92,'SAMPLING',T105,
C    1       'EQUIV.' / 1X,'   ID  ',T16,'OBSERVED',T29,'PREDICTED',
C    2       T44,'WEIGHTED',T57,'RESIDUAL',T67,'RESIDUAL',T83,'ERROR',
C    3       T95,'ERROR',T106,'YEARS',T113,'LEVERAGE',T124,'COOKS D' /)
C2102 FORMAT(1X,8A1,11F11.3)
C2201 FORMAT(' SUMMARY OF REGRESSION FOR SIGMA')
C2202 FORMAT(' SUMMARY OF REGRESSION FOR',I4,
C    1       '-YEAR RECURRENCE INTERVAL')
C2203 FORMAT('  MODEL ERROR FOR SIGMA = ',G13.5)
C2205 FORMAT(' SUMMARY OF REGRESSION FOR ',8A1)
C2401 FORMAT(1H1,' TRANSFORMED DATA')
C2402 FORMAT('    X1       ',5(5X,8A1),/,1X,6(5X,8A1))
C2403 FORMAT(6E13.5)
C2701 FORMAT (2X,I3,T31,' NUMBER OF STATIONS')
C2702 FORMAT (2X,8A1,20I4,(/10X,20I4))
C2703 FORMAT (2X,8A1,20F4.2,(/10X,20F4.2))
C2704 FORMAT (3X,I2,T31,' NUMBER OF PARAMETERS FOR SIGMA REG')
C
C     + + + END SPECIFICATIONS + + +
C
      DO 2 I = 1, 78
        BLNKLN(I:I) = ' '
 2    CONTINUE
C
      SCLU = 106
      DONES = 0
      DONEV = 0
C
      WRITE(FOUT,2200) '1', VERSN(6:43)
      WRITE(FOUT,2503)
C
 5    CONTINUE
C       sigma, dependent, graphic, view, return
        SGRP = 19
        CALL QRESP (MESSFL, SCLU, SGRP, GOPT)
C
      IF (GOPT .EQ. 1) THEN
C       analysis only for sites with std dev estimates
        NSITES = NSITES - NUMPAR
        KODE = 3
C       fill status block with variable names
Ckmf    CALL ZIPC (L78,BLNK8(1),OBUF)
Ckmf    CALL COPYC (L56,XLABS(1,1),OBUF(10))
Ckmf    CALL ZSTADD (L1,OBUF)
Ckmf    CALL COPYC (L56,XLABS(1,8),OBUF(10))
Ckmf    CALL ZSTADD (L2,OBUF)
Ckmf    CALL COPYC (L48,XLABS(1,15),OBUF(10))
Ckmf    CALL ZSTADD (L3,OBUF)
        CALL STATVR ( L20, XLABS, L2 )
 8      CONTINUE
C         explanatory variable for SIGMA
          SGRP = 9
          CALL Q1INIT(MESSFL,SCLU,SGRP)
          CALL Q1EDIT(IRET)
          NUMMIS = 0
          DO 9 I = 1,9
C           get user response
            CALL QGTCTF (I,L8,ANS)
            IF (CKNBLK(L8,ANS) .GT. 0 .AND. KODE.LT.NV) THEN
C             not blanks, check if on the list
              KODE = KODE + 1
             CALL FIND(MESSFL,KODE,NV,XLABS,ANS,ICOL,MISFLG)
              IF (MISFLG .NE. 0) THEN
C               couldn't find
                KODE = KODE - 1
                NUMMIS = NUMMIS - 1
                CALL QSTCTF (I,L8,BLNK8)
              ELSE
C               found ok, reset if user trys again
                IM3 = KODE - 3
                CALL QSTCTF (IM3,L8,ANS)
              END IF
            END IF
 9        CONTINUE
C
          IF (NUMMIS .GT. 0) THEN
C           one or more variables didn't match, do you want to view
C           ones found and try again? (1-y,2-n)
            SGRP = 134
            CALL QRESP (MESSFL,SCLU,SGRP,RESP)
          END IF
        IF ((RESP .EQ. 1 .AND. KODE .LT. 9) .OR. KODE .EQ. 3) GO TO 8
        CALL ZQUIET
        CALL MTXLOD (KODE)
C
C       estimate covar mat
C
        AJ=0.
C       CALL COEFMT
C
C       estimate E(SIGMA|X)
C
C       CHECK DIAGONALS IN MCON ARRAY
        DO 10 I = 1,NSITES
          IF (MCON(I,I) .LE. 0) THEN
C           Must stop, concurrent matrix written on output file.
C           and contains a zero diagonal for station &
            SGRP = 102
            CALL PRNTXI (MESSFL,SCLU,SGRP,I)
            WRITE(FOUT,2001) (J,MCON(J,J),J=1,NSITES)
            GOPT = 5
          END IF
 10     CONTINUE
C
        IF (GOPT .NE. 5) THEN
C         sigma regression
          IYS=2
          CALL OLS (FOUT)
C
C         write results for sigma regression
          NE=NEXP+1
          IF (IANS .EQ. 2) THEN
C           put data on file for NET.F77
C           format changed from 2715 to 2710 to agree with netinp
            WRITE(FNET,2710) NSITES
            WRITE (FNET,2714) ALPHA, THETA
            DO 18 I = 1,NSITES
              WRITE(FNET,2715) (MCON(I,J),J=1,I)
 18         CONTINUE
            DO 20 I = 1,NSITES
              WRITE (FNET,2716) (RHOC(I,J),J=1,I)
 20         CONTINUE
            WRITE (FNET,2715) NE
            WRITE (FNET,2705) (BHAT(I,1),I=1,NE)
            CALL ZIPI (L20,L0,ICOLX)
            DO 30 I = 1,17
              ICOLX(I) = ICOL(I+3)
 30         CONTINUE
          END IF
C
C         setup output to print file and screen
          SDBETA=DSQRT(XTXINV(1,1))
          TBETA=BHAT(1,1)/SDBETA
          WRITE (PRTROW(1),2011) BHAT(1,1), SDBETA, TBETA
          DO 35, I = 2, NE
            SDBETA=DSQRT(XTXINV(I,I))
            TBETA=BHAT(I,1)/SDBETA
            NDF = NSITES - NE
            TV4 = ABS(SNGL(TBETA))
            PV4 = 2.0*STUTP(-TV4,NDF)
            IF (PV4 .LT. 0.0001) PV4 = 0.0001
            WRITE (PRTROW(I),2008) (YLABS(M,I), M = 1, 8),
     $                             BHAT(I,1), SDBETA, TBETA, PV4
 35       CONTINUE
          PRTROW(NE+1) = BLNKLN
          WRITE (PRTROW(NE+2),2203) SIGAM2
C
C         output to print file
          WRITE (FOUT,2201) (PRTROW(I), I = 1, NE+2)
          WRITE (FOUT,2503)
C
C         output to screen
          SGRP = 210
          CALL Q2INIT ( MESSFL, SCLU, SGRP )
          CALL Q2SCTF ( L1, L78, NE+2, PRTROW )
          CALL Q2EDIT ( NE+2, IRET )
C
          CALL MULTPY (X, BHAT, NSITES, NE, 1, MAXPTS, MAXPTS, MAXVAR,
     O                 WORK1)
C         finished regression for standard deviation
          DONES = 1
          DONEV = 0
C         add back in sites without mean and stddev
          NSITES = NSITES + NUMPAR
        END IF
C
      ELSE IF (GOPT .EQ. 2) THEN
        IF (DONES .NE. 1) THEN
C         must do std dev regression before dependent variable
          SGRP = 47
          CALL PRNTXT (MESSFL, SCLU, SGRP)
        ELSE IF (DONEV .EQ. 1) THEN
C         must redo regression on std dev before dependent variable
          SGRP = 52
          CALL PRNTXT (MESSFL, SCLU, SGRP)
        ELSE
C         set up matrix for regression of dependent variable
          IYS=1
          CALL ZIPI (L20,L0,ICOL)
          CALL RELOAD (MESSFL, RETCOD)
          IF (RETCOD .EQ. 0) THEN
            CALL OLS (FOUT)
C
C           Program running, wait for next prompt.
            SGRP = 105
            CALL PRNTXT (MESSFL,SCLU,SGRP)
C
            AJ=1.0
            CALL COEFMT
            CALL SECANT(FOUT)
            RHOMS=GAMASQ
C
C           write X-T X -INV
            NE=NEXP+1
C
            IF (IANS .EQ. 2) THEN
C             put data on file for NET.F77
C             ICOLX = positions for explanatory variables for SIGMA
C             ICOL  = positions for explanatory variables for T-year peak
C             IDX   = total number of different explanatory variables
C             IDMP  = array of positions for explanatory variables
C             IDXS  = number of explanatory variables for SIGMA
C             IDXT  = number of explanatory variables for Tyear peak
C             ICOLT = IDXT columns for explanatory variables for T-yr
C                     peak
C             ICOLS = IDXS columns for explanatory variables for SIGMA
              IDXS = 0
              IDXT = 0
              IDX = 0
              CALL ZIPI (L20,L0,IDMP)
              CALL ZIPI (L20,L0,ICOLT)
              CALL ZIPI (L20,L0,ICOLS)
C             put out explanatory variables for SIGMA first
              I = 0
              IDX = 0
 55           CONTINUE
                I = I + 1
                IDX = IDX + 1
                IDMP(IDX) = ICOLX(I)
                ICOLS(I) = IDX
              IF (ICOLX(I+1) .GT. 0 .AND. I .LT. 10) GO TO 55
              IDXS = I
C             now put out explanatory variables for T-year peak
              I = 0
 60           CONTINUE
                I = I + 1
C               check if column already there
                ICHK = 0
                DO 62 J = 1,IDXS
                  IF (ICOL(I) .EQ. IDMP(J)) ICHK = J
 62             CONTINUE
                IF (ICHK .EQ. 0) THEN
C                 explanatary variable not already there
                  IDX = IDX + 1
                  ICOLT(I) = IDX
                  IDMP(IDX) = ICOL(I)
                ELSE
C                 explanatory variable already there
                  ICOLT(I) = ICHK
                END IF
              IF (ICOL(I+1) .GT. 0 .AND. I .LT. 10) GO TO 60
              IDXT = I
C
              WRITE(FNET,2715) IDXS, (ICOLS(I),I=1,IDXS)
C
Ckmf          March 23, 2004 - combine 2708 & 2710-2712
Ckmf          WRITE (FNET,2708) SIGAM2
Ckmf          WRITE (FNET,2710) RHOMS
Ckmf          WRITE (FNET,2711) RECINV
Ckmf          WRITE (FNET,2712) NE
              WRITE (FNET,2708) SIGAM2, RHOMS, RECINV, NE
              WRITE (FNET,2715) IDXT, (ICOLT(I),I=1,IDXT)
              WRITE (FNET,2715) IDX
              DO 70 I = 1,NSITES
                DO 68 J = 1,IDX
                  K = IDMP(J)
                  TEMP(J) = Z(I,K)
 68             CONTINUE
                WRITE (FNET,2706) (STANO(J,I),J=1,8),DLAT(I),DLNG(I),
     #                            ASKU(I),(TEMP(J),J=1,IDX)
 70           CONTINUE
C
              DO 74 I = 1,IDX
                K = IDMP(I)
                WRITE (FNET,2003) (XLABS(J,K),J=1,8)
 74           CONTINUE
              ENDFILE (FNET)
C             file for network analysis completed
              SGRP = 103
              CALL PRNTXT (MESSFL,SCLU,SGRP)
C           end if (ans .eq. 2)
            END IF
C
            IF (RECINV .GT. 0.0) THEN
C             computed T-year events
              WRITE(FOUT,2202) INT(RECINV)
            ELSE
C             dependent variable from input variable
              WRITE(FOUT,2205) (YLABS(I,NEXP+2),I=1,8)
            END IF
            WRITE(FOUT,2500)
            WRITE(FOUT,2005)
            WRITE(FOUT,2006)((YLABS(M,I),M=1,8),I=2,NE)
            DO 75 I=1,NE
              WRITE(FOUT,2007)(XTXINV(I,J),J=1,NE)
 75         CONTINUE
C
C           write BETAS
C           set up output to print file and screen
            SDBETA=DSQRT(XTXINV(1,1))
            TBETA=BHAT(1,1)/SDBETA
            WRITE (PRTROW(1),2011) BHAT(1,1), SDBETA, TBETA
            DO 80 I=2,NE
              SDBETA=DSQRT(XTXINV(I,I))
              TBETA=BHAT(I,1)/SDBETA
              NDF = NSITES - NE
              TV4 = ABS(SNGL(TBETA))
              PV4 = 2.0*STUTP(-TV4,NDF)
              IF (PV4 .LT. 0.0001) PV4 = 0.0001
              WRITE(PRTROW(I),2008) (YLABS(M,I), M = 1, 8),
     $                              BHAT(I,1), SDBETA, TBETA, PV4
 80         CONTINUE
            PRTROW(NE+1) = BLNKLN
C           SIGME=DEXP(SIGAM2)-1.
            IF (ILOW .EQ. 0) THEN
C             high flows
              WRITE(PRTROW(NE+2),2204) RHOMS
            ELSE
C             low flows
              IF (RECINV .GT. 0.0) THEN
C               T-year event
                WRITE(PRTROW(NE+2),2402) GAMASQ
              ELSE
C               mean or std dev
                WRITE(PRTROW(NE+2),2405) (YLABS(I,NEXP+2), I = 1, 6),
     $                                   GAMASQ
              END IF
            END IF
C
C           output to print file
            WRITE (FOUT,2009) (PRTROW(I), I = 1, NE+2)
C
C           output to screen
            SGRP = 211
            CALL Q2INIT ( MESSFL, SCLU, SGRP )
            CALL Q2SCTF ( L1, L78, NE+2, PRTROW )
            CALL Q2EDIT ( NE+2, IRET )
C
            CALL MULTPY (X, BHAT, NSITES,NE,1, MAXPTS, MAXPTS, MAXVAR,
     O                   WORK1)
C
C           write predicted values etc.
            WRITE(FOUT,2501)
            WRITE(FOUT,2101)
            SMOD=0.
            SSAM=0.
            SEQY = 0.0
            SSQPRE = 0.0
            CALL MULTPY (XTXINV, XT,
     I                   NE, NE, NSITES, MAXVAR, MAXVAR, MAXVAR,
     O                   WORK2)
            CALL MULTPY (X, WORK2,
     I                   NSITES, NE, NSITES, MAXPTS, MAXPTS, MAXVAR,
     O                   RHOC)
            CALL MULTPY (RHOC, COVINV,
     I                   NSITES, NSITES, NSITES, MAXPTS, MAXPTS, MAXPTS,
     O                   STA)
            DO 110 I=1,NSITES
              PRED=WORK1(I,1)
              RESID=YS(I,1)-WORK1(I,1)
C             compute variance of observed value
C             HARD2=(AJ+AJ*AK(I)*ASKU(I)+0.5*AK(I)**2*(1.0+0.75
C    #              *ASKU(I)**2))
C             *****************  not used ? *******************
C             VAROBS = HARDR2*XSIG(I,1)**2/DBLE(MCON(I,I))
C             *************************************************
              DO 100 J=1,NE
                XTV(J,1)=XT(J,I)
                XV(1,J)=X(I,J)
 100          CONTINUE
              CALL MULTPY (XTXINV, XTV,
     I                     NE, NE, 1, MAXVAR, MAXVAR, MAXVAR,
     O                     WORK2)
              CALL MULTPY (XV, WORK2, 1, NE, 1, 1, 1, MAXVAR,
     O                     CX)
              SAMERR=CX(1,1)
              HATDIG=STA(I,I)
C             compute delete residuals and sum sq for PRESS
              PRESS = RESID/(1.0-HATDIG)
              SSQPRE = SSQPRE + PRESS**2
              ERRMOD = GAMASQ
              VARPRE=ERRMOD+SAMERR
              EQYRS = (DBLE(HARD2)*SIGOLS(I)**2)/VARPRE
              PREOBS = (YS(I,1)*DBLE(MCON(I,I))+PRED*EQYRS)/
     #                 (DBLE(MCON(I,I))+EQYRS)
C             RMDSAM=SAMERR/VARPRE
              VARRES=COV(I,I)-SAMERR
              STDRES=RESID/DSQRT(VARRES)
              COOKD=STDRES**2*RHOC(I,I)/(NE*(COV(I,I)-RHOC(I,I)))
              WRITE(FOUT,2102)(STANO(J,I),J=1,8),YS(I,1),PRED,PREOBS,
     #                        RESID,STDRES,ERRMOD,SAMERR,EQYRS,HATDIG,
     #                        COOKD
              SMOD=SMOD+ERRMOD
              SSAM=SSAM+SAMERR
              SEQY = SEQY + EQYRS
C
C             fill arrays for plotting and screen viewing
              PLOT(I,1) = SNGL(PRED)
              PLOT(I,2) = SNGL(RESID)
              PLOT(I,3) = SNGL(SAMERR)
              PLOT(I,4) = SNGL(HATDIG)
              PLOT(I,5) = SNGL(ERRMOD)
              PLOT(I,6) = SNGL(VARPRE)
              PLOT(I,7) = SNGL(VARRES)
              PLOT(I,8) = SNGL(STDRES)
              PLOT(I,9) = SNGL(COOKD)
              POBS(I)   = SNGL(YS(I,1))
 110        CONTINUE
C
C           write avg sampling error and model error
C
            SSAM=SSAM/DBLE(NSITES)
            SMOD=SMOD/DBLE(NSITES)
            SSQPRE = SSQPRE/DBLE(NSITES)
            SEQY = SEQY/DBLE(NSITES)
Ckmf        March 23, 2004 - begin change
Ckmf        WRITE(FOUT,2501)
Ckmf        WRITE(FOUT,2519) SSAM
Ckmf        WRITE(FOUT,2520) SMOD
Ckmf        WRITE(FOUT,2521) SSQPRE
Ckmf        WRITE(FOUT,2522) SEQY
            WRITE (FOUT,2519) SSAM, SMOD, SSQPRE, SEQY
Ckmf        March 23,2004 - end change
            ENDFILE (FOUT)
            DONEV = 1
          ELSE
            DONEV = 0
C         end if (retcod .eq. 0)
          END IF
        END IF
C
      ELSE IF (GOPT .EQ. 4) THEN
C       view variables
        IF (DONEV .EQ. 1) THEN
          CALL GLSVEW (MESSFL,SCLU,NSITES,MAXPTS,STANO,POBS,PLOT)
        ELSE
C         can't view variables until regression completed
          SGRP = 104
          CALL PRNTXT (MESSFL,SCLU,SGRP)
        END IF
      ELSE IF (GOPT .EQ. 3) THEN
C
C       plot variables
        IF (DONEV .EQ. 1) THEN
C         do some plotting
          IBA = 2
          CALL VARPLT (MESSFL, IBA)
        ELSE
C         can't plot until regression completed on a dependent variable
          SGRP = 39
          CALL PRNTXT (MESSFL, SCLU, SGRP)
        END IF
      END IF
      IF (GOPT .LT. 5) GO TO 5
C
C     Close output file
      DEL = 0
      CALL QFCLOS (FOUT,DEL)
C
      RETURN
      END
C
C
C
      SUBROUTINE   MTXLOD
     I                    (KODE)
C
C     + + + PURPOSE + + +
C     This routine loads input variables in appropriate arrays in the
C     common block.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   KODE
C
C     + + + ARGUMENT DEFINITIONS + + +
C     KODE   - total number of variables to use
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'pglsiz.inc'
      INCLUDE 'cgls.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I, J, L8, JP, I1, I2
C
C     + + + INTRINSICS + + +
      INTRINSIC   DLOG, REAL, SNGL
C
C     + + + EXTERNALS + + +
      EXTERNAL   CHRCHR
C
C     + + + END SPECIFICATIONS + + +
C
      L8 = 8
C
C     load up matrix
      AVGSK = 0.0
      DO 20 I=1,NSITES
        YS(I,2)=DLOG(Z(I,ICOL(2)))
        YS(I,3)=Z(I,ICOL(1))
        XMEANS(I)=Z(I,ICOL(1))
C       L(I)=MCON(I,I)
C       L array not needed, use MCON diagonal
        AK(I)=1.
        XT(1,I)=1.
        X(I,1)=1.
        ASKU(I)=Z(I,ICOL(3))
        XSIG(I,1)=Z(I,ICOL(2))
        DO 10 J=4,KODE
          JP=J-2
C         YLABS(JP)=XLABS(ICOL(J))
          CALL CHRCHR (L8, XLABS(1,ICOL(J)), YLABS(1,JP))
          X(I,JP)=Z(I,ICOL(J))
          XT(JP,I)=Z(I,ICOL(J))
 10     CONTINUE
C       compute average skew of all stations
        AVGSK = AVGSK + SNGL(ASKU(I))/REAL(NSITES)
 20   CONTINUE
C
C     load skews for partial sites also
      IF (NUMPAR .GT. 0) THEN
        I1 = NSITES + 1
        I2 = NSITES + NUMPAR
        DO 30 I = I1,I2
          ASKU(I) = Z(I,ICOL(3))
          X(I,1) = 1.0
          DO 25 J = 4,KODE
            JP = J - 2
            X(I,JP) = Z(I,ICOL(J))
 25       CONTINUE
 30     CONTINUE
      END IF
      NEXP=KODE - 3
C
      RETURN
      END
C
C
C
      SUBROUTINE   RELOAD
     I                    (MESSFL,
     O                     RETCOD)
C
C     + + + PURPOSE + + +
C     This routine reloads the input arrays for GLS analysis with a new
C     set of explanatory variables and sets up matrix for GLS.
C     Used for regression on mean, std dev, or T-year event.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, RETCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of statistics message file
C     RETCOD - return code
C              0 - all ok
C              1 - some partial record sta.s missing mean or stddev--
C                  can't compute recurrence interval
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'pglsiz.inc'
      INCLUDE 'cgls.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   KMINUS, KODE, MISFLG, ERRFLG, DEPV, NUMMIS,
     $          SCLU, SGRP, SGR(3,3), IRET, OLEN, IQ, IR, AGAIN,
     $          I, J, JP, L2, L8, L9, L18, L20, L72, L80, L144,
     $          LENS(18)
      REAL      KP, KQ, KSKEW, XKP, AVGK
      CHARACTER*1  ANS(8), AX0(8), AMEAN(8), ATYRQ(8), ASTDV(8),
     $             BUFF(80), QLABS(8,9), SLABS(8,18), BLNK
      CHARACTER*80 TBUFF
C
C     + + + FUNCTIONS + + +
      REAL   WILFRT, GAUSEX
      INTEGER   CKNBLK
C
C     + + + INTRINSICS + + +
      INTRINSIC   SNGL, DBLE
C
C     + + + EXTERNALS + + +
      EXTERNAL   WILFRT, GAUSEX
      EXTERNAL   QRESPR, QRESP, QTSTR, PRNTXT, GETTXT
      EXTERNAL                   Q1INIT, Q1EDIT,         ZQUIET
      EXTERNAL           CARVAR, CHRCHR,        CKNBLK
      EXTERNAL   FIND
      EXTERNAL   STATVR
C
C     + + + INPUT FORMATS + + +
 1003 FORMAT (5X,7(8A1))
C
C     + + + OUTPUT FORMATS + + +
C2014 FORMAT(1X,' REG SKEW, STD NORM DEV, K',3F12.3)
C
C     + + + DATA INITIALIZATIONS + + + 
      DATA  BLNK, ASTDV
     $    /  ' ', 'S','T','D','.','D','E','V','.' /
      DATA  L2, L8, L9, L18, L20, L72, L80, L144, LENS
     $    /  2,  8,  9,  18,  20,  72,  80,  144, 18*8 /
      DATA  SCLU, SGR
     $    /  106, 115,12,9, 111,113,114, 120,121,122 /
C
C     + + + END SPECIFICATIONS + + +
C
      OLEN = 80
      RETCOD = 0
C
      SGRP = 10
      CALL GETTXT (MESSFL, SCLU, SGRP, OLEN, BUFF)
      CALL CARVAR (L80, BUFF, L80, TBUFF)
      READ (TBUFF, 1003) AX0,AMEAN,ATYRQ
C
      DEPV = 0
C     read dependent variable info
C     Regression on 1) compute RECURrence interval, 2) select
C     t-yr attribute, 3) MEAN or 4) STANDard deviation?
      SGRP = 131
      CALL QRESP (MESSFL, SCLU, SGRP, DEPV)
      IF (NUMPAR.GT.0 .AND. DEPV.EQ.1) THEN
C       not all sta.s have mean and stddev--can't
C       compute recurrence interval 
        SGRP = 185
        CALL PRNTXT (MESSFL, SCLU, SGRP)
        RETCOD = 1
      ELSE
        RETCOD = 0
        IF (DEPV .LE. 2) THEN
C         Enter recurrence interval for response variable?
          KP = 10.0
          SGRP = 11
          CALL QRESPR (MESSFL,SCLU,SGRP,KP)
C
          RECINV=KP
          XKP=1./KP
          IF (ILOW .EQ. 1) XKP = 1.0-XKP
          XKP=GAUSEX(XKP)
          AVGK = WILFRT (AVGSK, XKP, ERRFLG)
          AJ = 1.0
          DO 10 I=1,NSITES
            KQ=SNGL(ASKU(I))
            KSKEW=WILFRT(KQ,XKP,ERRFLG)
C           WRITE(FOUT,2014)KQ,XKP,KSKEW
            AK(I)=DBLE(KSKEW)
 10       CONTINUE
        ELSE IF (DEPV .EQ. 3) THEN
C         for mean regression
          AJ = 1.0
          AVGK = 0.0
          DO 20 I=1,NSITES
            AK(I)=0.
 20       CONTINUE
        ELSE IF (DEPV .EQ. 4) THEN
C         user selected standard deviation
          AJ = 0.0
          AVGK = 1.0
          DO 30 I=1,NSITES
            AK(I)=1.
 30       CONTINUE
        END IF
C
C       determine type of question
        IF (IYS .EQ. 1 .AND. DEPV .LE. 2) THEN
C         T-yr event
          IQ = 1
        ELSE IF (IYS .EQ. 3 .OR. DEPV .EQ. 3) THEN
C         mean
          IQ = 2
        ELSE
C         must be standard deviation
          IQ = 3
        END IF
        CALL ZIPC ( L144, BLNK, SLABS )
C       identify COL for explanatory VAR
        KODE=0
        IR = 1
 50     CONTINUE
C         fill status block with variable names
          CALL STATVR ( L20, XLABS, L2 )
C         Enter name of explanatory variable(s)
          SGRP = SGR(IQ,IR)
          CALL Q1INIT(MESSFL,SCLU,SGRP)
          CALL QSETCT ( L18, LENS, L144, SLABS )
          CALL Q1EDIT ( IRET )
          IF (IRET .EQ. 1) THEN
C           Accept - continue
            CALL QGETCT ( L9, LENS, L72, QLABS )
            CALL ZIPC ( L144, BLNK, SLABS )
            NUMMIS = 0
            DO 55 I = 1, 9
              IF (CKNBLK(L8,QLABS(1,I)) .GT. 0  .AND.  KODE.LT.NV) THEN
C               not blanks, check if on the list
                KODE = KODE + 1
                CALL FIND ( MESSFL, KODE, NV, XLABS, QLABS(1,I),
     O                      ICOL, MISFLG )
                IF (MISFLG .NE. 0) THEN
C                 couldn't find, save to try again
                  KODE = KODE - 1
                  NUMMIS = NUMMIS + 1
                  CALL CHRCHR ( L8, QLABS(1,I), SLABS(1,NUMMIS+9) )
                ELSE
C                 found ok, save in case user trys again
                  CALL CHRCHR ( L8, QLABS(1,I), SLABS(1,KODE) )
                END IF
              END IF
 55         CONTINUE
            IF (NUMMIS .GT. 0) THEN
C             one or more variables didn't match, try again
              IR = 2
              KODE = 0
              CALL ZIPI (L20, KODE, ICOL )
              AGAIN = 1
            ELSE IF (KODE .EQ. 0) THEN
C             no variables specified
              IR = 3
              AGAIN = 1
            ELSE
              AGAIN = 0
            END IF
          ELSE IF (IRET .EQ. -1) THEN
C           Oops, try again
            AGAIN = 1
          ELSE
C           assume Prev (2) or Intrpt (7)
            AGAIN = 0
          END IF
        IF (AGAIN .EQ. 1) GO TO 50
        CALL ZQUIET
C
        IF (DEPV .EQ. 2) THEN
C         Enter name of dependent variable.
          SGRP = 132
 60       CONTINUE
C           loop until ok variable
            CALL QTSTR (MESSFL, SCLU, SGRP, L8, ANS)
            KODE=KODE+1
            CALL FIND(MESSFL,KODE,NV,XLABS,ANS,ICOL,MISFLG)
            IF (MISFLG .NE. 0) KODE = KODE - 1
          IF (MISFLG .NE. 0) GO TO 60
        ELSE
C         increment code for other cases
          KODE = KODE + 1
        END IF
C
C
        HARD2 = SNGL(AJ) + SNGL(AJ)*AVGK*AVGSK
     &          + 0.5*(AVGK**2)*(1.0+0.75*AVGSK**2)
C
C       load matrix
        KMINUS=KODE-1
        CALL CHRCHR (L8, AX0, YLABS(1,1))
        DO 80 I=1,NSITES
          X(I,1) = 1.0
          XT(1,I) = 1.0
          DO 70 J=1,KMINUS
            JP=J+1
            CALL CHRCHR (L8, XLABS(1,ICOL(J)), YLABS(1,JP))
            X(I,JP)=Z(I,ICOL(J))
            XT(JP,I)=Z(I,ICOL(J))
 70       CONTINUE
C
          IF (DEPV .EQ. 2) THEN
C           dependent variable from selected variables
            YS(I,IYS) = Z(I,ICOL(KODE))
          ELSE   
C           dependent variable computed
            YS(I,IYS)=AJ*XMEANS(I)+AK(I)*XSIG(I,1)
          END IF
 80     CONTINUE
C       set variable name for dependent variable
        IF(DEPV .EQ. 3) THEN
          CALL CHRCHR (L8, AMEAN, YLABS(1,KODE+1))
        ELSE IF (DEPV .EQ. 1) THEN
          CALL CHRCHR (L8, ATYRQ, YLABS(1,KODE+1))
        ELSE IF (DEPV .EQ. 2) THEN
C         from input variable
          CALL CHRCHR (L8, ANS, YLABS(1,KODE+1))
        ELSE
C         standard deviation
          CALL CHRCHR (L8, ASTDV, YLABS(1,KODE+1))
        END IF
C
        NEXP=KODE-1
C
        IF (IYS .EQ. 3 .OR. DEPV .GT. 2) THEN
C         dependent variable not computed t-year , flag with RECINV
          RECINV = -1.0
        END IF
C     end else if (numpar.eq.0 .or. depv.ne.1)
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   FIND
     I                  (MESSFL, KODE, NV, XLABS, ANS,
     O                   ICOL, MISFLG)
C
C     + + + PURPOSE + + +
C     This routine matches users selected name with list of
C     explanatory variables and sets ICOL array when found.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER      KODE, MISFLG, MESSFL, NV
      INTEGER      ICOL(NV)
      CHARACTER*1  ANS(8), XLABS(8,NV)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of GLSNET message file
C     KODE   - location in ICOL array of position of
C              explanatory variable in the buffer
C     NV     - number of names in XLABS
C     XLABS  - list of names of explanatory variables
C     ANS    - desired name of explanatory variable
C     ICOL   - array of locations for explanatory variable
C     MISFLG - 0 - match found
C              1 - match not found
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      I, J, L8, FLAG
      CHARACTER*1  TMPANS(8)
C
C     + + + EXTERNALS + + +
      EXTERNAL     COPYC, LFTSTR, QUPCAS
C
C     + + + END SPECIFICATIONS + + +
C
      L8 = 8
      MISFLG = 0
C
      CALL COPYC (L8, ANS, TMPANS)
C     left justify variable name if necessary
      IF (TMPANS(1) .EQ. ' ') CALL LFTSTR (L8, TMPANS)
C     convert variable name to upper case B4 attempt to match
      CALL QUPCAS (L8, TMPANS)
C
      J = 0
 15   CONTINUE
        J = J + 1
        FLAG = 0
        DO 20 I = 1, 8
          IF (XLABS(I,J) .NE. TMPANS(I)) FLAG = 1
 20     CONTINUE
      IF (FLAG .NE. 0 .AND. J .LT. NV) GO TO 15
C
      IF (FLAG .EQ. 0) THEN
C       found a match
        ICOL(KODE) = J
      ELSE
C       match not found
        MISFLG = 1
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   SECANT
     I                    (FOUT)
C
C     + + + PURPOSE + + +
C     This routine computes method of moments GAMASG for GLS.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   FOUT
C
C     + + + ARGUMENT DEFINITIONS + + +
C     FOUT   - Fortran unit number of output file for any error
C              messages.
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'pglsiz.inc'
      INCLUDE 'cgls.inc'
C     COMMON /COVIVD/ WORK(1,75), C(1,1)
C     VARIABLES NOT USED IN THIS ROUTINE
      COMMON /COLS/ YVAR
      DOUBLE PRECISION   YVAR
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,J
      DOUBLE PRECISION   F1,F2,F3,FNEW,X1,X2,X3,XNEW
C
C     + + + FUNCTIONS + + +
      DOUBLE PRECISION   GLS
C
C     + + + INTRINSICS + + +
      INTRINSIC   DMIN1, DABS
C
C     + + + EXTERNALS + + +
      EXTERNAL   GLS
C
C     + + + OUTPUT FORMATS + + +
 2091    FORMAT(' CANNOT FIND ROOT IN SECANT. IYR,X2 = ',I5, F10.5)
C2050 FORMAT(' X3 =',F10.3)
 2000 FORMAT(1X,' NO CONVERGENCE IN SECANT')
 2092 FORMAT( ' X1,X2 =',2F10.5/' F1,F2 =',2F10.5)
C
C     + + + END SPECIFICATIONS + + +
C
      X1=0.
      X3=0.
      IF(IYS .EQ. 3) THEN
        X2=YVAR*2.
        F2 =  GLS(X2,FOUT)
      ELSE
        X2 = 1.0
        F2 = GLS(X2,FOUT)
        IF (IYS .NE. 1) THEN
          DO 15 I = 1,4
            IF( F2.GT. 0.D+0) GO TO 16
            X2 = 2.*X2
            F2 =  GLS(X2,FOUT)
 15       CONTINUE
 16       CONTINUE
        END IF
      END IF
C
C     check to see if a root can be found less than X2---
      IF( F2.LT. 0.D+0) THEN
C       can't be found
        WRITE(FOUT,2091) IYS,X2
        GAMASQ = X2
      ELSE
C
C       can be found
        F1 = GLS(X1,FOUT)
        IF (F1.LT.0.) THEN
C
C         do midpoint search to find good starting point
C         for secant search
C
          DO 20 J=1,3
            XNEW = (X1+X2)/2.
            FNEW = GLS(XNEW,FOUT)
            IF(FNEW.LT.0.) THEN
              X1 = XNEW
              FNEW = FNEW
            ELSE
              X2=XNEW
              F2=FNEW
            END IF
 20       CONTINUE
C
C         search for GAMA SQ using SECANT search
C
          DO 30 I=1,30
            X3 = X1 - F1*(X2-X1)/(F2-F1)
C           WRITE(FOUT,2050)X3
            IF(X3.LT.0.) THEN
              X3=DMIN1(X2,X1)/2.
              F3 = GLS(X3,FOUT)
            ELSE
              F3 =  GLS(X3,FOUT)
            END IF
C
            IF(DABS(F3).LT..0001)GO TO 100
C           kick out of loop, search got close enough
C
            IF(DABS(F1).LT.DABS(F2)) THEN
              X2=X3
              F2=F3
            ELSE
              X1=X3
              F1=F3
            END IF
 30       CONTINUE
C
C         if search fails to get close enough in 30 tries,
C         write message
C
          WRITE(FOUT,2000)
          WRITE(FOUT,2092) X1,X2,F1,F2
 100      CONTINUE
        END IF
        GAMASQ=X3
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   COEFMT
C
C     + + + PURPOSE + + +
C     This routine calculates the covariance matrices of Y-hat, if
C     at-site estimators of MU and SIGMA**2 are employed.  Note: no
C     weighting matrices are needed in this case.  The covariance of
C     of Y-hat are calculated in two ways.  SIGOLS is used to get STA
C     used by GLS while SIGBEST is used to provide a better estimate
C     of the true sampling covariance matrix to be used to improve our
C     estimate of the accuracy of the GLS-BETAS.
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'pglsiz.inc'
      INCLUDE 'cgls.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I, J
      DOUBLE PRECISION   RHO
C
C     + + + INTRINSICS + + +
      INTRINSIC   DBLE
C
C     + + + END SPECIFICATIONS + + +
C
      DO 100 I = 1,NSITES
        DO 90 J = 1,I
          IF( I.NE.J ) THEN
            RHO = RHOC(I,J)
          ELSE
            RHO = 1
          END IF
          IF(IYS.EQ.2)THEN
            SIGOLS(I)=1.0
            SIGOLS(J)=1.0
          END IF
          STA(I,J)=(AJ+AJ*AK(I)*ASKU(I)*0.5+AJ*AK(J)*ASKU(J)*0.5
     #            +AK(I)*AK(J)*0.5*
     #            (RHO+0.75*ASKU(I)*ASKU(J)))*
     #            RHO*DBLE(MCON(I,J))*SIGOLS(I)*SIGOLS(J)
     #            /DBLE(MCON(I,I)*MCON(J,J))
C         Note: AML replaced L with MCON diagonal  9/4/86
          STA(J,I) = STA(I,J)
          COV(I,J)=STA(I,J)
          COV(J,I)=STA(I,J)
 90     CONTINUE
 100  CONTINUE
C
      RETURN
      END
C
C
C
      SUBROUTINE   OLS
     I                 (FOUT)
C
C     + + + PURPOSE + + +
C     This routine computes sample T-yr event and regression equation.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   FOUT
C
C     + + + ARGUMENT DEFINITIONS + + +
C     FOUT   - Fortran unit number for output file
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'pglsiz.inc'
      INCLUDE 'cgls.inc'
      COMMON /COLS/ YVAR
      DOUBLE PRECISION   YVAR
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I, IS, NE, NSITP
      DOUBLE PRECISION   SS, SUM, YBAR
C
C     + + + INTRINSICS + + +
      INTRINSIC   DEXP, DBLE
C
C     + + + EXTERNALS + + +
      EXTERNAL   COEFMT, SECANT, MULTPY
C
C     + + + END SPECIFICATIONS + + +
C
      IF(IYS.EQ.2) THEN
        NE=NEXP+1
        CALL COEFMT
        CALL SECANT(FOUT)
C       change number of sites to include both regular and partial
        NSITP = NSITES + NUMPAR
        SIGAM2=GAMASQ
        CALL MULTPY (X, BHAT, NSITP, NE, 1, MAXPTS, MAXPTS, MAXVAR, 
     O               SIGOLS)
        DO 10 I=1,NSITP
          SIGOLS(I)=DEXP(SIGOLS(I))
 10     CONTINUE
C
      ELSE
        SUM=0.
        SS=0.
        DO 20 IS=1,NSITES
          SUM=SUM+YS(IS,IYS)
          SS=SS+YS(IS,IYS)**2
 20     CONTINUE
C
C       calculate variance of at site estimators
        YBAR=SUM/DBLE(NSITES)
        YVAR=(SS-DBLE(NSITES)*YBAR**2)/(DBLE(NSITES)-1.0)
      END IF
C
      RETURN
      END
C
C
C
      DOUBLE PRECISION FUNCTION   GLS
     I                               (GAMA2,FOUT)
C
C     + + + PURPOSE + + +
C     This routine to computes likelihood function.
C     E is N*1 matrix of residuals.
C     DET is determinant of covariance matrix.
C
C     + + + HISTORY + + +
C     DO 10 loop to compute COV dropped the condition if IYS.eq.1
C     and ILOW.eq.0.  AML 7/1/93
C
C     + + + DUMMY ARGUMENTS + + +
      DOUBLE PRECISION   GAMA2
      INTEGER   FOUT
C
C     + + + ARGUMENT DEFINITIONS + + +
C     GAMA2  - ?????????????
C     FOUT   - Fortran unit number for output file
C
C     + + + COMMONS + + + 
      INCLUDE 'pglsiz.inc'
      INCLUDE 'cgls.inc'
C     COMMON /COVIVD/ WORK(1,75),C(1,1)
      COMMON /WORKC/ WORK1, WORK2, WORK3, WORK
      DOUBLE PRECISION   WORK1(MAXVAR,MAXPTS), WORK2(MAXVAR,MAXPTS),
     #                   WORK3(MAXPTS,1), WORK(1,MAXPTS)
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   N, NE, I
      DOUBLE PRECISION   DET, C(1,1)
C
C     + + + INTRINSICS + + +
      INTRINSIC   DEXP,        DBLE
C
C     + + + EXTERNALS + + +
      EXTERNAL   INVERT, MULTPY
C
C     + + + OUTPUT FORMATS + + +
C2040 FORMAT(' GLS CK- COV, SIGOLS, GAMA2, STA ',4F10.2)
C2031 FORMAT(' COV ',10G12.2)
C2032 FORMAT(' COVINV ',10G12.2)
C
C     + + + END SPECIFICATIONS + + +
C
C     COMPUTE GLS FIT WITH GAMA2 VALUE
C
C     GENERALIZED LEAST SQUARES
C
C     Y IS A N*1 MATRIX OF OBSERVED DEPENDENT VARIABLES
C     X IS A N*2 MATRIX OF OBSERVED IN DEPENDENT VARIABLES
C     B IS A 2*1 MATRIX OF PARAMETERS TO BE ESTIMATED
C     SINV IS THE INVERSE OF COVARIANCE MATRIX OF ERRORS (N*N)
C     E IS A N*1 MATRIX OF RESIDUALS
C
      DO 10 I = 1,NSITES
        IF (IYS.EQ.2) THEN
          COV(I,I) = SIGOLS(I)**2*(DEXP(GAMA2)-1.) + STA(I,I)
C         IF(COV(I,I).LT.0.)
C    #       WRITE(FOUT,2040)COV(I,I),SIGOLS(I),GAMA2,STA(I,I)
        ELSE
          COV(I,I)=GAMA2 +STA(I,I)
        END IF
 10   CONTINUE
C
C     WRITE(FOUT,2031)((COV(I,J),J=1,31),I=1,31)
      CALL INVERT(NSITES,MAXPTS,COV,1,FOUT,DET,COVINV)
C     WRITE(FOUT,2032)((COVINV(I,J),J=1,31),I=1,31)
C
C     solve (XT*COVINV*X)(-1)*XT*COVINV*YS
      N = NSITES
      NE=NEXP+1
c                   x       y  k1 k2 k3      n1    n2    n3
      CALL MULTPY (XT, COVINV, NE, N, N, MAXVAR, MAXVAR, MAXPTS, 
     O             WORK1)
      CALL MULTPY (WORK1, X, NE, N, NE, MAXVAR, MAXVAR, MAXPTS, 
     O             WORK2)
      CALL INVERT(NE,10,WORK2,0,FOUT,DET,XTXINV)
      CALL MULTPY (XTXINV, XT, NE, NE, N, MAXVAR, MAXVAR, MAXVAR, 
     O             WORK1)
      CALL MULTPY (WORK1, COVINV, NE, N, N, MAXVAR, MAXVAR, MAXPTS, 
     O             WORK2)
      DO 20 I=1,NSITES
        E(I,1)=YS(I,IYS)
 20   CONTINUE
      CALL MULTPY (WORK2, E, NE, N, 1, MAXVAR, MAXVAR, MAXPTS, 
     O             BHAT)
      CALL MULTPY (X, BHAT, N, NE, 1, MAXPTS, MAXPTS, MAXVAR, 
     O             WORK3)
C
      DO 30 I=1,N
        ET(1,I)=YS(I,IYS)-WORK3(I,1)
        E(I,1)=ET(1,I)
 30   CONTINUE
C
C     AA=0.9189385*NSITES
C     BB = 0.5*DLOG(DET)
      CALL MULTPY (ET, COVINV, 1, NSITES, NSITES, 1, 1, MAXPTS, 
     O             WORK)
      CALL MULTPY (WORK, E, 1, NSITES, 1, 1, 1, MAXPTS, 
     O             C)
C     XLKLHD=-AA-BB-0.5*C(1,1)
      GLS = DBLE(NSITES - NEXP - 1)/C(1,1) - DBLE(1.)
C     IF(IYS.EQ.2)  GLS = DLOG(GLS+1.)
C
      RETURN
      END
C
C
C
      SUBROUTINE   GLSVEW 
     I                   (MESSFL,SCLU,NSITES,MAXPTS,STANO,OBS,PLOT)
C
C     + + + PURPOSE + + +
C     This routine places results of a GLS analysis into an AIDE 
C     PRM2 screen with all fields protected from modification.
C
C     + + + DUMMY ARGUMENTS + + + 
      INTEGER   MESSFL, SCLU, NSITES, MAXPTS
      REAL      PLOT(MAXPTS,9), OBS(NSITES)
      CHARACTER*1  STANO(8,NSITES)
C
C     + + + ARGUMENT DEFINITIONS + + + 
C     MESSFL - Fortran unit number of GLS message file
C     SCLU   - cluster number on file for GLSCAL screens
C     NSITES - number of sites (stations) used in analysis
C     MAXPTS - maximum number of sites (stations) to size PLOT array
C     OBS    - observed values of dependent variable
C     PLOT   - array of computed results
C
C     + + + LOCAL VARIABLES + + + 
      INTEGER   IS,IE,NROW,SGRP,I,J,  N,L1,L0,L4,L16,RNUM,
     $               IDUM(1),IRET,SCNFG,L8,CVAL(3,12),L36,LEN,
     $          JUST,OLEN,LOC
      REAL      RBUF(10,12)
      CHARACTER*1 CBUF(80,12),BLNK
C
C     + + + EXTERNALS + + + 
      EXTERNAL  QRESCX, ZGTRET, ZQUIET, ZSTCMA, CHRCHR, ZIPI
      EXTERNAL  DECCHR, ZIPC
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  L0, L1, L4, L8, L16, L36, BLNK
     $     / 0,  1,  4,  8,  16,  36,  ' ' /
C
C     + + + END SPECIFICATIONS + + + 
C 
      SGRP = 179
      RNUM = 10
      SCNFG = 1
      CALL ZIPI (L36,L0,CVAL)
      IS = 1
      IE = 12
      IF (NSITES .LT. IE) IE = NSITES
      CALL ZQUIET
C     add intrpt and prev
      CALL ZSTCMA (L4,L1)
      CALL ZSTCMA (L16,L1)
C
 10   CONTINUE
C       fill arrays
        JUST = 0
        LEN = 12*80  
        CALL ZIPC (LEN,BLNK,CBUF)
        LEN = 6
        DO 20 I = IS,IE
          J = I - IS + 1
          CALL CHRCHR(L8,STANO(1,I),CBUF(1,J))
          LOC = 9
          CALL DECCHR (OBS(I),LEN,JUST,OLEN,CBUF(LOC,J))
          LOC = LOC + 6
          DO 15 N = 1,9
            CALL DECCHR (PLOT(I,N),LEN,JUST,OLEN,CBUF(LOC,J))
            IF (N .LE. 6) THEN
C             1st 6 are 6 wide, last 3 are 5 wide
              LOC = LOC + 6
            ELSE
              LOC = LOC + 5
            END IF
 15       CONTINUE
 20     CONTINUE
        NROW = IE -IS + 1
C
        CALL QRESCX (MESSFL,SCLU,SGRP,L1,RNUM,L1,NROW,
     &               SCNFG,IDUM,RBUF,CVAL,CBUF)
C       get return code
        CALL ZGTRET (IRET)
        IF (IRET .EQ. 1) THEN
C         accept - go to next screen
          IF (IE .LT. NSITES) THEN
C           set range for next screen
            IS = IS + 12
            IE = IE + 12
            IF (IE .GT. NSITES) IE = NSITES
          ELSE
C           that was last screen, user done, return to calling screen
            IRET = 7
          END IF
        ELSE IF (IRET .EQ. 2) THEN
C         user selected previous
          IF (IS .EQ. 1) THEN
C           use wants out because on first screen
            IRET = 7
          ELSE
C           go back to previous screen
            IS = IS - 12
            IE = IE - 12
            IRET = 1
          END IF
        END IF
C
      IF (IRET .EQ. 1) GO TO 10
C
C     remove intrpt and prev
      CALL ZSTCMA (L4,L0)
      CALL ZSTCMA (L16,L0)

      RETURN
      END
