C
C
C
      SUBROUTINE   ROPNIO
     I                    ( MESSFL, SCLU, SGRP1, SGRP2,
     M                      FOUT,
     O                      FINP )
C
C     + + + PURPOSE + + +
C     Open an input file and an output file.  If the output file
C     is already open, the name is displayed on the screen and the
C     user may continue using the file or specify a different file.
C     The output file should be the first file defined in SGRP1 and
C     the input file should be the second file.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER      MESSFL, SCLU, SGRP1, SGRP2, FOUT, FINP
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     SCLU   - cluster group in message file
C     SGRP1  - group number for case where no file is open
C     SGRP2  - group number for case where file is open
C     FOUT   - Fortran unit number of output file
C     FINP   - Fortran unit number of input file
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      RTCMND, L1, L2, L64, KEEP, LENO, LENN,
     $             MATCHO, MATCHN
      CHARACTER*64 FNAMEO, FNAME
C
C     + + + FUNCTIONS + + +
      INTEGER   ZLNTXT
C
C     + + + INTRINSICS + + +
      INTRINSIC  INDEX
C
C     + + + EXTERNALS + + +
      EXTERNAL   Q1INIT, QSTCTF, Q1EDIT, QGETF, QGETFB, QGTCTF
      EXTERNAL   QFSTAT, QFCLOS, GETFUN
      EXTERNAL   ZLNTXT
C
C     + + + DATA INITIALIZATIONS + + +
      DATA   L1, L2, L64, KEEP
     $      / 1,  2,  64,    0 /
C
C     + + + END SPECIFICATIONS + + +
C
      IF (FOUT .LE. 0) THEN
C       no output file open
 100    CONTINUE
          CALL Q1INIT ( MESSFL, SCLU, SGRP1 )
          CALL Q1EDIT ( RTCMND )
          IF (RTCMND .EQ. 1) then
C           files opened, get unit numbers
            CALL QGETF  ( L1, FINP )
            CALL QGETFB ( L1, L2, FOUT )
          END IF
        IF (RTCMND .EQ. -1) GO TO 100
      ELSE
C       an output file is already open, get the name
        CALL QFSTAT ( FOUT, FNAME )
 200    CONTINUE
C         set text field to output file name
          CALL Q1INIT ( MESSFL, SCLU, SGRP2 )
          CALL QSTCTF ( L1, L64, FNAME )
          CALL Q1EDIT ( RTCMND )
          IF (RTCMND .EQ. 1) THEN
C           get input file unit
            CALL QGETF ( L1, FINP )
C           get output file name
            CALL QGTCTF ( L1, L64, FNAMEO )
            LENO   = ZLNTXT ( FNAME )
            LENN   = ZLNTXT ( FNAMEO)
            MATCHO = INDEX ( FNAMEO(1:LENO), FNAME(1:LENN) )
            MATCHN = INDEX ( FNAME(1:LENN), FNAMEO(1:LENO) )
            IF (MATCHO .EQ. 0  .OR.  MATCHN .EQ. 0) THEN
C             new file name, close old and open new
              CALL QFCLOS ( FOUT, KEEP )
              CALL GETFUN ( L1, FOUT )
              OPEN ( UNIT = FOUT,
     $               FILE = FNAMEO,
     $             STATUS = 'UNKNOWN' )
            END IF
          END IF
        IF (RTCMND .EQ. -1) GO TO 200
      END IF
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   YRSEAS
     I                            ( MOBEG, MOEND, YRCALN, MONTH )
C
C     + + + PURPOSE + + +
C     Based on beginning and ending months for a season, determinc
C     if a year/mo date should be the year of the date or the next
C     year.  The year used is the year that the end of the season
C     occures in.  For example, for the water year, months October
C     thru December are associated with the following year; for the
C     climate year April - March, months May - December are
C     associated with the following year.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MOBEG, MOEND, YRCALN, MONTH
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MOBEG  - beginning month of season
C     MOEND  - ending month of season
C     YRCALN - calendar year of date
C     MONTH  - calendar month of date
C
C     + + + END SPECIFICATIONS + + +
C
      IF (1 .LE. MOBEG  .AND.  MOBEG .LE. 12  .AND.
     $    1 .LE. MOEND  .AND.  MOEND .LE. 12) THEN
C       valid begin and end months for season
        IF (MONTH .EQ. 0) THEN
C         no month, default to year provided
          YRSEAS = YRCALN
        ELSE IF (MOBEG .LE. MOEND ) THEN
C         season contained within a calendar year
          YRSEAS = YRCALN
        ELSE
C         season crosses dec-jan boundry
          IF (MONTH .GE. MOEND) THEN
C           month before jan, increment to year season ends
            YRSEAS = YRCALN + 1
          ELSE
C           month after dec
            YRSEAS = YRCALN
          END IF
        END IF
      ELSE
C       ivalid begin or/and end month
        YRSEAS = 0
      END IF
C
      RETURN
      END
