C
C
C
      PROGRAM   GLSNET
C
C     GLSNET is an interactive program that does ordinary least squares,
C     generalized least squares, and network analysis.  It also
C     preprocesses partial record stations for generalized least squares.
C
C     + + + PARAMETERS + + +
      INCLUDE 'pmesfl.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      SCLU,SGRP,RESP,ERRFL,  I0,I1,I21,WDMSFL,BLDOPT,
     &                DEL
      CHARACTER*16 WNAME
      CHARACTER*64 FNAME, VERSN
      CHARACTER*8  PTHNAM,LGNAM
C
C     + + + EXTERNALS + + +
Ckmf  EXTERNAL     GPCLOS                  QFCLOS
      EXTERNAL     PRWFLE, PROGLS, PRONET
      EXTERNAL     ANINIZ, ZANSET, ZSTCMA, PROSLS
      EXTERNAL     PMXCNW, ZMNSST, QRESP, PRTPRO
      EXTERNAL             GPOPEN, ANCLOS, PRNTXT
      EXTERNAL     WDFLCL, GCLKS
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT (//, ' *** ERROR',
     $         /, ' *** ERROR',
     $         /, ' *** ERROR  Problem closing wdm data file',
     $         /, ' *** ERROR          Return code =', I6,
     $         /, ' *** ERROR',
     $         /, ' *** ERROR' )
C
C     + + + DATA INITIALIZATIONS + + +
      DATA   I0,I1,I21/0,1,21/
C
C     + + + END SPECIFICATIONS + + +
C
C     Initialize environment
C     version info for unix what
C     names of application, log file, and message file
      INCLUDE 'fglsms.inc'
C     open message file and log file
      CALL ANINIZ (MESSFL,FNAME,LGNAM)
C     set program name for window
      CALL ZANSET (WNAME)
C     output diagnostic and transaction file
C     open GKS
      CALL GPOPEN (ERRFL)
C     turn off XPAD command
      CALL ZSTCMA (I21,I0)
C     init to no WDM file in use
      WDMSFL= 0
C
C     cluster for top of GLS
      SCLU= 151
C     default is to start to open the wdm file
      RESP= 1
C
 10   CONTINUE
C       opening screen options:
C           1-File (wdm), 2-Partial record, 3-Ols, 4-Gls,
C           5-Network, 6-Query, 7-Return
        SGRP= 1
        CALL QRESP (MESSFL,SCLU,SGRP,
     M              RESP)
C
        IF (RESP .EQ. 1) THEN
C         get or close a WDM file
          PTHNAM = ' '
          BLDOPT = 0
          CALL PRWFLE (MESSFL,BLDOPT,PTHNAM,WDMSFL)
          RESP = 4
        ELSE IF (RESP .EQ. 2) THEN
C         want to do GLS
          IF (WDMSFL .EQ. 0) THEN
C           need wdm file open first
            SGRP = 3
            CALL PRNTXT(MESSFL,SCLU,SGRP)
            RESP = 1
          ELSE
C           partial record analysis
            CALL PRTPRO (MESSFL,WDMSFL,ERRFL)
            RESP = 4
          END IF
        ELSE IF (RESP .EQ. 3) THEN
C         ordinary least squares
          CALL PROSLS (MESSFL,WDMSFL)
          RESP = 4
        ELSE IF (RESP .EQ. 4) THEN
C         GLS analysis
          CALL PROGLS (MESSFL,WDMSFL,ERRFL,VERSN)
          RESP = 5
        ELSE IF (RESP .EQ. 5) THEN
C         network analysis
          CALL PRONET (MESSFL,VERSN)
        ELSE IF (RESP .EQ. 6) THEN
C         provide user support info
          SGRP = 4
          CALL PRNTXT (MESSFL, SCLU, SGRP)
        END IF
      IF (RESP .NE. 7) GO TO 10
C
Ckmf  Mar 04, 2004
Ckmf  gpclos closes unit 99 and then calls gclks.  gclks
Ckmf  (as well as other code) may still want to write to 99.
Ckmf  shut down aide
Ckmf  CALL ANCLOS (MESSFL)
Ckmf  close out GKS
Ckmf  CALL GPCLOS (ERRFL)
Ckmf  DEL = 0
Ckmf  IF (WDMSFL .GT. 0) CALL QFCLOS (WDMSFL,DEL)
C
      CALL GCLKS
C     close wdm file if still open
      DEL = 0
      IF (WDMSFL .GT. 0) THEN
        CALL WDFLCL ( WDMSFL, DEL )
        WDMSFL = 0
      END IF
C     close message file, scratch and log files
      CALL ANCLOS (MESSFL)
C
      IF (DEL .NE. 0) THEN
C       problem closing wdm file
        WRITE (99,2000) DEL
        WRITE (*,2000)  DEL
      END IF
C
      STOP
      END
