C
C
C
      SUBROUTINE   VARPLT
     I                    (MESSFL,IBA)
C
C     + + + PURPOSE + + +
C     This routine plots variables selected by user on the device
C     selected by the user.  The source of the data is the common
C     block used by the GLS procedures.
C
C     + + + KEYWORDS + + +
C     message file, DISSPLA
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, IBA
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of statistics message file
C     IBA    - 1 = plotting before gls analysis (plot to screen data)
C              2 = plotting after gls analysis (plot to see results)
C
C     + + + COMMONS + + +
      INCLUDE 'pglsiz.inc'
      INCLUDE 'cgls.inc'
      INCLUDE 'cglsp.inc'
C
C     + + + SAVES + + +
Ckmf
      INTEGER   FILOLD
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,  L13,SCLU,L8,K,MISFLG,JUST,OLEN,L20,SGRP,MORE,IXP,
     #          IYP,IXQ(MAXINP),IYQ(MAXINP),HORL,ERRFLG,NSP1,
     #          L160,               ICHK(7),                          
     #          SYMBL(18),LNTYP(18),PATTRN(18),COLOR(18),XAXTY,YAXTY,
     #          TRANSF(2),BVALFG(4),             NCRV,NVAR,BADV,
     #          L80,WHICH(18),TICS(4),XTYPE,YTYPE(2),CTYPE(2),IRET,
     #          L40,RETCOD,L1, L2, L3, L4, DEVTYP,DEVCOD,LEN,IND,L0,
     #          IWAIT,WSID,ICLOS, L5, L6, L7, L9, L10,      IRSP(10),
     #          IR1(10),IR2(10),WNDFLG,CNUM
Ckmf  March 4, 2004
      INTEGER   CMPTYP, FILNEW, KEEP
      REAL   TR1,TR2,         PLMN(4),PLMX(4),VMIN(18),YY(MAXPTS),
     #       VMAX(18),ALEN,                            XX(MAXPTS),
     &                    RMIN,RMAX
      CHARACTER*1  BLNK,ANS1(8),ANS2(8),CHAL(13,2),         TITL(240),
     #             YLABL(80),YXLABL(80),YALABL(80),XLABL(80),
     &             LBV(20,18)
      CHARACTER*8  CVAL(2), WNAM(2)
      CHARACTER*78 CTEXT
C
C     + + + INTRINSICS + + +
      INTRINSIC   INT, ABS, SNGL
C
C     + + + EXTERNALS + + +
      EXTERNAL   ZIPC, QRESP, FIND, QRESPR, PEKEST, INTCHR
      EXTERNAL   CHRCHR, PROPLT, GPINIT, GPNCRV, PLTONE, CARVAR
      EXTERNAL   GPWCXY, GPLBXB, PSTUPW, PDNPLT,         ZWNSOP
      EXTERNAL   GETTXT, QGTCTF, GPTEXT, GPVAR, GPSCLE, GPLABL
      EXTERNAL   GPCURV, GPDATR, Q1EDIT, Q1INIT, ZQUIET
      EXTERNAL   GPDEVC, SCALIT, ANPRGT, ZIPR, ZIPI, QSETRB
      EXTERNAL   ZSTCMA, QGETCO, QSETCO, QSTCTF, COPYI, QGETRB
Ckmf  March 4, 2004
      EXTERNAL   GETFUN, GGMTFL, STATVR
C
C     + + + DATA INITIALIZATION + + +
      DATA CHAL /'-','Y','R',' ','P','E','A','K',' ','F','L','O','W',
     #           '-','Y','R',' ','L','O','W',' ','F','L','O','W',' '/
      DATA ICHK/1,2,1,1,1,1,1/,       WNAM/'Modify','GPPM'/
      DATA TICS/10,10,2,10/,BVALFG/4*3/,YALABL/80*' '/
      DATA L1,L2,L3,L4,L5,L6,L7,L8,L9,L10,L13,L20,L40,L80,L160
     $    / 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 13, 20, 40, 80, 160/ 
      DATA CTEXT/' Input variables that can be plotted:'/
      DATA IR1/1,0,1,1,1,2,0,1,1,1/, IR2/2,0,1,1,1,0,1,1,0,0/
C
C     + + + INPUT FORMAT + + +
C1000 FORMAT ( 2X, 80A1 )
C
C     + + + END SPECIFICATIONS + + +
C
Ckmf  March 4, 2004
C     get computer type
      I = 1
      CALL ANPRGT (I, CMPTYP)
Ckmf  end of March 4, 2004 addition
      SCLU = 106
      WNDFLG = 0
      MORE = 0
      JUST = 0
      BLNK = ' '
      LEN = 360
      CALL ZIPC (LEN,BLNK,LBV)
      LEN = 80
      CALL ZIPC (LEN,BLNK,YLABL)
      CALL ZIPC (LEN,BLNK,XLABL)
      CALL ZIPC (LEN,BLNK,YXLABL)
      LEN = 18
      L0 = 0
      CALL ZIPI (LEN,L0,SYMBL)
      CALL ZIPI (LEN,L0,COLOR)
      CALL ZIPI (LEN,L0,LNTYP)
      CALL ZIPI (LEN,L0,PATTRN)
      CALL ZIPI (LEN,L0,WHICH)
      RMIN = -1E9
      RMAX = 1E9
C     initialize values
      CALL GPINIT
C     set plotting device to screen
      DEVTYP = 1
      IND = 39 + DEVTYP
      CALL ANPRGT (IND,DEVCOD)
      CALL GPDEVC (DEVTYP,DEVCOD)
C
C     set defaults for screen
      CALL ZIPC (L10,BLNK,ANS1)
      CALL ZIPC (L10,BLNK,ANS2)
      IF (IBA .EQ. 1) THEN
        CALL COPYI (L10,IR1,IRSP)
      ELSE
        CALL COPYI (L10,IR2,IRSP)
      END IF
      TR1 = -999.
      TR2 = -999.
C
C     put input variables in status block
Ckmf  LOC = 5
Ckmf  LINE = 1
Ckmf  CALL ZSTADD (LINE,CTEXT)
Ckmf  LINE = 2
Ckmf  CBUF = ' '
Ckmf  DO 10 I = 1,MAXINP
Ckmf    CALL CARVAR (L8, XLABS(1,I),L8,CBUF(LOC:LOC+7))
Ckmf    LOC = LOC + 10
Ckmf    IF (LOC .GT. 70 .OR. I .EQ. MAXINP) THEN
Ckmf      LOC = 5
Ckmf      CALL ZSTADD (LINE, CBUF)
Ckmf      LINE = LINE + 1
Ckmf      CBUF = ' '
Ckmf    END IF
C10   CONTINUE
      CALL STATVR ( L20, XLABS, L3 )
C

 20   CONTINUE
C       loop to select and plot data
        IYP = 1
        IXP = 2
C       title and labels for axes
        IF (IBA .EQ. 2) THEN
          SGRP = 24
        ELSE
          SGRP = 176
        END IF
        OLEN = 80
        CALL GETTXT (MESSFL, SCLU, SGRP, OLEN, TITL)
        CALL ZIPC (L160, BLNK, TITL(81))
C
 25     CONTINUE
          BADV = 0
          IF (IBA .EQ. 2) THEN
C           plots after analysis
C           which variable for y-axis? x-axis? transformations?
C           (pred,resid,samerr,hatdig,errmod,varpre,varres,stdres,cookd,
C            obs,invarb(1-10)
            SGRP = 22
            CALL Q1INIT (MESSFL,SCLU,SGRP)
C           reset to defaults or to values from before
            CALL QSETCO (L8,IRSP)
            CALL QSTCTF (L2,L8,ANS1)
            CALL QSTCTF (L6,L8,ANS2)
            CALL Q1EDIT (IRET)
            IF (IRET .EQ. 1) THEN
C             not previous, wants to continue
C             get info for Y-axis
              CALL QGETCO (L8,IRSP)
              IYP = IRSP(1)
              IXP = IRSP(5)
              IF (IYP .EQ. 11) THEN
                CALL QGTCTF (L2,L8,ANS1)         
                K = 1
                CALL FIND (MESSFL,K,NV,XLABS,ANS1,IYQ,MISFLG)
                IF (MISFLG .EQ. 0) THEN
                  CALL CHRCHR (L8, XLABS(1,IYQ(1)), YLABL(1))
                  CALL CHRCHR (L20, YLABL, LBV(1,1))
                ELSE
                  BADV = 1
                END IF
              ELSE
C               get name of variable
                SGRP = 160 + IYP
                OLEN = 40
                CALL GETTXT (MESSFL, SCLU, SGRP, OLEN, YLABL)
                CALL CHRCHR (L20, YLABL, LBV(1,1))
              END IF
C             get transformation info
              YTYPE(1) = IRSP(3)
              YAXTY = IRSP(4)
C             get info for X-axis
              IF (IXP .EQ. 11) THEN
                CALL QGTCTF (L6,L8,ANS2)         
                K = 1
                CALL FIND (MESSFL,K,NV,XLABS,ANS2,IXQ,MISFLG)
                IF (MISFLG .EQ. 0) THEN
                  CALL CHRCHR (L8, XLABS(1,IXQ(1)), XLABL(1))
                  CALL CHRCHR (L20, XLABL, LBV(1,2))
                ELSE
                  BADV = 1
                END IF
              ELSE
C               get name of varriable
                SGRP = 160 + IXP
                OLEN = 40
                CALL GETTXT (MESSFL, SCLU, SGRP, OLEN, XLABL)
                CALL CHRCHR (L20, XLABL, LBV(1,1))
              END IF
C             get transformation info
              XTYPE = IRSP(7)
              XAXTY = IRSP(8)
            END IF
          ELSE
C           plots before analysis
C           which variable for y-axis? (1=FLOOD EST,2=INPUT VAR)
            SGRP = 85
C           which variable for y-axis? x-axis? transformations?
C           (pred,resid,samerr,hatdig,errmod,varpre,varres,stdres,cookd,
C            obs,invarb(1-10)
            CNUM = 2
            IF (MORE .EQ. 0) THEN
C             displaying screen in response to selection of Plot (GPP)
              CVAL(1) = 'Plot'
              CVAL(2) = 'P'
            ELSE
C             displaying screen in response to selection of Select (GPPS)
              CVAL(1) = 'Select'
              CVAL(2) = 'PS'
            END IF
C           put CVAL strings into window name
            CALL ZWNSOP (CNUM, CVAL)
            SGRP = 23
            CALL Q1INIT (MESSFL,SCLU,SGRP)
C           reset to defaults or to values from before
            CALL QSETCO (L10,IRSP)
            CALL QSTCTF (L2,L8,ANS1)
            CALL QSTCTF (L7,L8,ANS2)
            CALL QSETRB (L1,L1,TR1)
            CALL QSETRB (L1,L2,TR2)
            CALL Q1EDIT (IRET)
            IF (IRET .EQ. 1) THEN
C             not previous, wants to continue
C             get info for Y-axis
              CALL QGETCO (L10,IRSP)
              IYP = IRSP(1)
              IXP = IRSP(6)
              IF (IYP .EQ. 2) IYP = 11
              IF (IYP .Eq. 11) THEN
C               find which variable it is
                CALL QGTCTF (L2,L8,ANS1)         
                K = 1
                CALL FIND (MESSFL,K,NV,XLABS,ANS1,IYQ,MISFLG)
                IF (MISFLG .EQ. 0) THEN
                  CALL CHRCHR (L8, XLABS(1,IYQ(1)), YLABL(1))
                  CALL CHRCHR (L20, YLABL, LBV(1,1))
                ELSE
                  BADV = 1
                END IF
              ELSE
                HORL = IRSP(3)
                CALL QGETRB (L1,L1,TR1)
                CALL PEKEST (TR1, NSITES, HORL, ERRFLG, PLOT(1,IYP))
                CALL INTCHR (INT(TR1),L8,JUST,OLEN,YLABL(1))
                CALL CHRCHR (L13,CHAL(1,HORL),YLABL(OLEN+1))
                CALL CHRCHR (L20, YLABL, LBV(1,1))
              END IF
C             get transformation info
              YTYPE(1) = IRSP(4)
              YAXTY = IRSP(5)
C             get info for X-axis
              IF (IXP .EQ. 2) IXP = 11
              IF (IXP .EQ. 11) THEN
                CALL QGTCTF (L7,L8,ANS2)        
                K = 1
                CALL FIND (MESSFL,K,NV,XLABS,ANS2,IXQ,MISFLG)
                IF (MISFLG .EQ. 0) THEN
                  CALL CHRCHR (L8, XLABS(1,IXQ(1)), XLABL(1))
                  CALL CHRCHR (L20, XLABL, LBV(1,2))
                ELSE
                  BADV = 1
                END IF
              ELSE
                CALL QGETRB (L1,L2,TR2)
                HORL = IRSP(8)
                CALL PEKEST (TR2, NSITES, HORL, ERRFLG, PLOT(1,IXP))
                CALL INTCHR (INT(TR2),L8,OLEN,JUST,XLABL(1))
                CALL CHRCHR (L13,CHAL(1,HORL),XLABL(OLEN+1))
                CALL CHRCHR (L20, XLABL, LBV(2,1))
              END IF
C             get transformation info
              XTYPE = IRSP(9)
              XAXTY = IRSP(10)
            END IF
          END IF
C
          IF (BADV .EQ. 1) THEN
C           could not match variable to one in status block
C           Do you want to try again?
            SGRP = 175 
            CALL QRESP (MESSFL, SCLU, SGRP, BADV)
          END IF
        IF (BADV .EQ. 1) GO TO 25
        IF (BADV .EQ. 2) IRET = 4
C
        IF (IRET .EQ. 1) THEN           
C         1st variable on y-axis
          WHICH(1) = 1
C         2nd variable on x-axis
          WHICH(2) = 4
C
C         fill plot arrays with data
          CALL ZIPR (LEN,RMIN,VMAX)
          CALL ZIPR (LEN,RMAX,VMIN)
          NVAR = 2
          NCRV = 1
          CALL GPNCRV (NCRV, NVAR)
          DO 30 I = 1,NSITES
C           fill plot array
            IF (IXP .LT. 10) THEN
              XX(I) = PLOT(I,IXP)
            ELSE IF (IXP .EQ. 11) THEN
              XX(I) = Z(I,IXQ(1))
            ELSE
              XX(I) = YS(I,1)
            END IF
            IF (XX(I) .GT. VMAX(2)) VMAX(2) = XX(I)
            IF (XX(I) .LT. VMIN(2)) VMIN(2) = XX(I)
C
            IF (IYP .LT. 10) THEN
              YY(I) = PLOT(I,IYP)
            ELSE IF (IYP .EQ. 11) THEN
              YY(I) = Z(I,IYQ(1))
            ELSE
              YY(I) = YS(I,1)
            END IF
            IF (YY(I) .LT. VMIN(1)) VMIN(1) = YY(I)
            IF (YY(I) .GT. VMAX(1)) VMAX(1) = YY(I)
 30       CONTINUE
C
C         normal x-y plot
          CALL GPWCXY (L1,L1,L2)
          CTYPE(1) = 6
C
          SYMBL(1) = 4
          LNTYP(1) = 0
          PATTRN(1) = 0
          COLOR(1) = 1
          YTYPE(2) = 0
C         axes types, were transformation made?
C         x-axis   transformed  y-axis    transformed
C         -------  -----------  ------    -----------
C         1-arith     1 = no    1-arith     1 = no
C         2 = log     2 = yes   2 = log     2 = yes
C         4 cases for each axis
C         want arith, data arith,  want arith, data log
C         want lo, data arith,     want log, data log
C         for x-axis
          IF (XTYPE .EQ. 1 .AND. XAXTY .EQ. 1) THEN
C           arithmetic axis, no transforming
            TRANSF(2) = 1
          ELSE IF (XTYPE .EQ. 2 .AND. XAXTY .EQ. 1) THEN
C           log axis, data not transformed
            TRANSF(2) = 2
          ELSE IF (XTYPE .EQ. 2 .AND. XAXTY .EQ. 2) THEN
C           log axis, data transformed
            TRANSF(2) = 2
            DO 55 I = 1,NSITES
              XX(I) = 10.0**XX(I)
 55         CONTINUE
            VMAX(2) = 10.0**VMAX(2)
            VMIN(2) = 10.0**VMIN(2)
          ELSE IF (XTYPE .EQ. 1 .AND. XAXTY .EQ. 2) THEN
C            arith  axis, data transformed
            TRANSF(2) = 1
            DO 56 I = 1,NSITES
              XX(I) = 10.0**XX(I)
 56         CONTINUE
            VMAX(2) = 10.0**VMAX(2)
            VMIN(2) = 10.0**VMIN(2)
          END IF
C         for y-axis
          IF (YTYPE(1) .EQ. 1 .AND. YAXTY .EQ. 1) THEN
C           arithmetic axis, no transforming
            TRANSF(1) = 1
          ELSE IF (YTYPE(1) .EQ. 2 .AND. YAXTY .EQ. 1) THEN
C           log axis, data not transformed
            TRANSF(1) = 2
          ELSE IF (YTYPE(1) .EQ. 2 .AND. YAXTY .EQ. 2) THEN
C           log axis, data transformed
            TRANSF(1) = 2
            DO 57 I = 1,NSITES
              YY(I) = 10.0**YY(I)
 57         CONTINUE
            VMAX(1) = 10.0**VMAX(1)
            VMIN(1) = 10.0**VMIN(1)
          ELSE IF (YTYPE(1) .EQ. 1 .AND. YAXTY .EQ. 2) THEN
C           arith  axis, data transformed
            TRANSF(1) = 1
            DO 58 I = 1,NSITES
              YY(I) = 10.0**YY(I)
 58         CONTINUE
            VMAX(1) = 10.0**VMAX(1)
            VMIN(1) = 10.0**VMIN(1)
          END IF
C
C         put the data to plot in data structure
          CALL GPDATR(L1,L1,NSITES,YY(1),RETCOD)
          NSP1 = NSITES + 1
          CALL GPDATR(L2,NSP1,NSITES,XX(1),RETCOD)
C         set plotting specs
          CALL GPCURV (CTYPE, LNTYP, SYMBL, COLOR, PATTRN, LBV)
          ALEN = 0.0
          CALL GPLBXB (XLABL)
          CALL GPLABL (XTYPE, YTYPE, ALEN, YLABL, YXLABL, YALABL, TITL)
          CALL GPVAR (VMIN, VMAX, WHICH, TRANSF, LBV)
          CALL SCALIT (XTYPE,VMIN(2),VMAX(2),PLMN(4), PLMX(4))
          IF (PLMX(4)-PLMN(4) .LT. 1.0E-9) PLMX(4) = PLMX(4) + 1.0
          CALL SCALIT (YTYPE(1),VMIN(1),VMAX(1),PLMN(1), PLMX(1))
          IF (PLMX(1)-PLMN(1) .LT. 1.0E-9) PLMX(1) = PLMX(1) + 1.0
          CALL GPSCLE (PLMN, PLMX, TICS, BVALFG)
C
 60       CONTINUE
            WSID = 1
C           plot, modify, select, done
            SGRP = 60
            CALL QRESP (MESSFL, SCLU, SGRP, MORE)
            IF (MORE .EQ. 1) THEN
C             create the plot
              IWAIT = 0
              ICLOS = 0
              CALL PSTUPW (WSID, RETCOD)
              CALL PLTONE
Ckmf          March 4, 2004
              IF (CMPTYP .EQ. 1) THEN
                ICLOS = 1
              ELSE
                ICLOS = 0
              END IF
Ckmf          end of addition, March 4, 2004
              CALL PDNPLT (WSID,ICLOS,IWAIT)
            ELSE IF (MORE .EQ. 2) THEN
C             modify specs
              CALL PROPLT (MESSFL, ICHK, WNAM,
     O                     WNDFLG)
              IF (WNDFLG .EQ. 1) THEN
C               close current workstation and reset device type
C               and code
                IWAIT = 0
                ICLOS = 1
                CALL PDNPLT (WSID,ICLOS,IWAIT)
Ckmf            March 4, 2004
                CALL GGMTFL ( FILNEW )
                IF (FILOLD .NE. FILNEW) THEN
C                 changed output file
                  IF (FILOLD .NE. 0) THEN
C                   free the unit number for the old file
                    KEEP = 2
                    CALL GETFUN ( KEEP, FILOLD )
                  END IF
                  FILOLD = FILNEW
                END IF
Ckmf            end March 4, 2004 addition
              END IF
            END IF
          IF (MORE .LE. 2) GO TO 60
        ELSE
C         user selected previous or not to continue
          MORE = 4
        END IF
      IF (MORE .EQ. 3)  GO TO 20
C
Ckmf  March 4, 2004
Ckmf  close all workstations
Ckmf  ICLOS = 1
Ckmf  IWAIT = 0
Ckmf  DO 80 I = 1,4
Ckmf    CALL PDNPLT (I,ICLOS,IWAIT)
C80   CONTINUE
Ckmf
      ICLOS = 1
      IWAIT = 0
      CALL PDNPLT (WSID,ICLOS,IWAIT)
Ckmf  end changes March 4, 2004
C
C     clear status window
      CALL ZSTCMA (L7,L0)
      CALL ZQUIET
C
      RETURN
      END
C
C
C
      SUBROUTINE   PEKEST
     I                    (TR, NS, HORL,
     O                     ERRFLG, Q)
C
C     + + + PURPOSE + + +
C     This routine computes peak flow for the specified return period
C     for all stations in the GLS common block.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   NS, HORL, ERRFLG
      REAL   TR, Q(NS)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     TR     - return period in years
C     NS     - number of sites
C     HORL   - 1 - high flow
C              2 - low flow
C     ERRFLG - 0 - ok
C              1 - excessive skew truncated
C     Q( )   - peak flows for selected return period
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'pglsiz.inc'
      INCLUDE 'cgls.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I, J, K, L
      REAL      XTR, SKEW
C
C     + + + FUNCTIONS + + +
      REAL   WILFRT, GAUSEX
C
C     + + + INTRINSICS + + +
      INTRINSIC   SNGL, DBLE
C
C     + + + EXTERNALS + + +
      EXTERNAL   GAUSEX, WILFRT
C
C     + + + END SPECIFICATIONS + + +
C
      XTR = 1.0/TR
      IF (HORL .EQ. 2) XTR = 1.0 - XTR
      XTR = GAUSEX (XTR)
      J = ICOL(1)
      K = ICOL(2)
      L = ICOL(3)
      DO 10 I = 1, NS
        Q(I) = SNGL(Z(I,L))
        SKEW = WILFRT(Q(I),XTR,ERRFLG)
        AK(I) = DBLE(SKEW)
        Q(I) = SNGL(Z(I,J)+AK(I)*Z(I,K))
        Q(I) = 10.0**Q(I)
 10   CONTINUE
C
      RETURN
      END
