
C
C
      SUBROUTINE   WIVLOD
     I                    (MESSFL,WDMSFL,DONEFG)
C
C     + + + PURPOSE + + +
C     This routine gets input variables from WDM file attributes for
C     use in Generalized Least Squares analysis.
C
C     + + + KEYWORDS + + +
C     WDM file, message file
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, WDMSFL, DONEFG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of GLSNET message file
C     WDMSFL - Fortran unit number of WDM file
C     DONEFG - done flag, 1 if got set up ok, 0 if not.
C
C     + + + PARAMETERS + + +
      INCLUDE 'pglsiz.inc'
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cgls.inc'
      INCLUDE 'cgldsn.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      I, I1, J, K, L0, L1, L3, L4, L5, L6, L8, L9, L78, N, 
     $             CODES(MAXINP), RESP, DORV, SGRP, SCLU, PHI, IVL,
     $             ICNT, IDROP, JM1, NCODES, RETCOD, IB, IBD, L160,
     $             IT, BADDSN(MAXPTS), TRCODE, JUST, 
     $             K1, K2, KP, KODE, KOUNT, M1, 
     $             IBA, MISFLG, IBDATT(20), IBDA,      IP, IR, 
     $             IFLG, GOPT, DSNX(DSNBMX), IDXP(DSNBMX), SALEN, 
     $             SAIND, CLEN(MAXINP), IRET, INUM, RNUM, CNUM, 
     $             SCNFG,                 STAFLG, ATTFLG, DATAFG, MXL, 
     $             IWRT, CLN(2),TRSHFT(11), 
     $             IVAL(MAXINP),        OTYP(21), CVL(1),
     $             ZIPLEN, IGOOD, JUSTL, DNUM, NMFLDS, UIMIN(1), 
     $             UIMAX(1), UIDEF(1), VLINFG(1), UCCNT(1), UCDEF(1),
     $             USTRLN(1), NMPAR, NPRT, TRANSF(MAXINP,3)
      REAL         C1(MAXINP,3), C2(MAXINP,3), SUM, RDUM(1), 
     $             ATTVAL(MAXPTS,MAXINP), R0, URMIN(1), 
     $             URMAX(1), URDEF(1), ATTOUT(MAXPTS,MAXINP)
      DOUBLE PRECISION           UDMIN(1), UDMAX(1), UDDEF(1)
      CHARACTER*1  SS(8,2),SD(8,2),SM(8,2),ANS(8,2), BLNK,
     $             TRBUF(80,MAXINP), CMATCH(6), NONE(4), CCHK(8),
     $             CBUFF(8,MAXINP), TXTBUF(10), URSPST(1)
      CHARACTER*6  TRNSNO(3)
      CHARACTER*8  PTHNAM
      CHARACTER*78 PRTROW(MAXINP)
C
C     + + + FUNCTIONS + + +
      INTEGER      LENSTR
C
C     + + + INTRINSICS + + +
      INTRINSIC    SNGL, MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL     WDBSGR, WDSAFI, WDATGT
      EXTERNAL     PRNTXI, PRNTXT, PRWMSE, PMXTXI, PMXTXA
      EXTERNAL     QRESP, QRESPI, QRESCX, Q1INIT, Q1EDIT, QSTCTF
      EXTERNAL     QGTCTF, QSETI, QSETCO, QGETCO, ZMNSST, QSCSET
      EXTERNAL     ZIPI, ZIPR, ZIPC, INTCHR, DECCHR, CARVAR, CHRCHR
      EXTERNAL     LENSTR, LFTSTR, QUPCAS
      EXTERNAL     ALGEBR, FIND, VARPLT, VWDATA, STATVR
C
C     + + + OUTPUT FORMAT + + +
 2501 FORMAT ( 6X, 8A1, 5X, A6 )
C
C     + + + DATA INITIALIZATION + + +
      DATA SS/'W','R','C','S','K','W',' ',' ',
     $        'S','K','W','N','D',' ',' ',' '/
      DATA SM/'W','R','C','M','N',' ',' ',' ',
     $        'M','E','A','N','N','D',' ',' '/
      DATA SD/'W','R','C','S','D',' ',' ',' ',
     $        'S','D','N','D',' ',' ', ' ',' '/
      DATA  BLNK/' '/,  L9/9/,  M1/-1/,  NONE/'N','O','N','E'/
      DATA TRSHFT / 0, 2, 3,10,11,13,14,15,16,17,18/           
      DATA TRNSNO / 'first ', 'second', 'third ' /
C     assign dummy values to arrays passed to--but not used in--QSCSET
      DATA  URMIN, URMAX, URDEF, UDMIN, UDMAX, UDDEF
     $     /  0.0,   0.0,   0.0,   0.0,   0.0,   0.0 /
      DATA  VLINFG, UCCNT, UCDEF, USTRLN, URSPST
     $     /     0,     1,     1,      1,    ' ' /
      DATA  I1, L0, L1, L3, L4, L5, L6, L8, L78, L160, R0
     $     / 1,  0,  1,  3,  4,  5,  6,  8,  78,  160, 0.0 /
      DATA  SCLU, JUST, JUSTL, MXL, SCNFG
     $     / 106,    0,     1,  10,     1 /
C
C     + + + END SPECIFICATIONS + + +
C
      DATAFG = 0
      STAFLG = 0
      NCODES = 0
      CALL ZIPI (MAXINP, L0, CODES)
      CALL ZIPI (MAXINP, L0, IBDATT)
      CALL ZIPC (8*MAXINP, BLNK, XLABS)
      CALL ZIPC (8*MAXINP, BLNK, YLABS)
      CALL ZIPI (8*MAXINP, L1, TRANSF )
      CALL ZIPR (3*MAXINP, 0.0, C1 )
      CALL ZIPR (3*MAXINP, 0.0, C2 )
Ckmf---------------------------------------------------------Note
Ckmf                                                         Note
Ckmf  added initialization for YLABS above                   Note
Ckmf                                                         Note
Ckmf---------------------------------------------------------Note
C
      GOPT = 1
 5    CONTINUE
C
C     Options:  1-Select stations, 2-Choose variables,
C               3-get variables, 4-help, 5-Transform
C               6-View, 7-Plot, 8-Return
      SGRP = 109
      CALL QRESP (MESSFL, SCLU, SGRP, GOPT)
C
C     ---------------------------------------------- 4 - help
      IF (GOPT .EQ. 4) THEN
C       provide explanation
        SGRP = 20
        CALL PRNTXT (MESSFL, SCLU, SGRP)
        GOPT = 1
C
C     ---------------------------------------------- 1 - stations
      ELSE IF (GOPT .EQ. 1) THEN
C       select stations
 100    CONTINUE
C         loop to work on getting enough stations
          PTHNAM = 'GP      '
          CALL PRWMSE (MESSFL,WDMSFL,DSNBMX,PTHNAM,DSNBUF,NSITES)
          RESP = 1
          IF (NSITES .LE. 5) THEN
C           Do you want to reselect datasets? 1=Y,2=N
            SGRP = 36
            CALL QRESP (MESSFL, SCLU, SGRP, RESP)
          ELSE
            STAFLG = 1
            GOPT = 2
          END IF
        IF (STAFLG .EQ. 0 .AND. RESP .EQ. 1) GO TO 100
C
C     ---------------------------------------------- 2 - variables
      ELSE IF (GOPT .EQ. 2) THEN
C       Analysis for PEAKS or n-day HIGH or LOW flow?
        SGRP = 25
        CALL QRESP (MESSFL, SCLU, SGRP, PHI)
        IF (PHI .EQ. 3) THEN
C         low flow
          ILOW = 1
        ELSE
C         high flow
          ILOW = 0
        END IF
        IF (PHI .EQ. 1) THEN
C         for peaks
          IT       = 1
          CODES(1) = 78
          CODES(2) = 79
          CODES(3) = 77
        ELSE
C         n-day high or low
          IT       = 2
          CODES(1) = 280
          CODES(2) = 281
          CODES(3) = 282
        END IF
C       add appropriate mean, std, skew names to XLABS array
        CALL CHRCHR ( L8, SM(1,IT), XLABS(1,1) )
        CALL CHRCHR ( L8, SD(1,IT), XLABS(1,2) )
        CALL CHRCHR ( L8, SS(1,IT), XLABS(1,3) )
C
        IF (ILOW .EQ. 1) THEN
C         low flow analysis so check for sites without mean and stddev
C         and put them last
          IFLG = 0
          L0 = 0
          SALEN = 1
          CALL ZIPI (DSNBMX,L0,IDXP)
          DO 220 I = 1,NSITES
            SAIND = 280
            CALL WDBSGR (WDMSFL, DSNBUF(I), SAIND, SALEN, 
     O                   RDUM, RETCOD)
            IF (RETCOD .NE. 0) THEN
C             missing mean
              IDXP(I) = 1
              IFLG = IFLG +  1
            ELSE
              SAIND = 281
              CALL WDBSGR (WDMSFL, DSNBUF(I), SAIND, SALEN, 
     O                     RDUM, RETCOD)
              IF (RETCOD .NE. 0) THEN
C               missing standard deviation
                IDXP(I) = 1
                IFLG = IFLG + 1
              END IF
            END IF
 220      CONTINUE
C         store number of site w/o mean or stddev in common block
          NUMPAR = IFLG
          NMPAR = NUMPAR
          IF (IFLG .GE. 1) THEN
C           need to resort DSN's to put those w/o mean or stddev last
            IP = NSITES
            IR = 1
            DO 222 I = 1,NSITES
              IF (IDXP(I) .EQ. 0) THEN
C               regular
                DSNX(IR) = DSNBUF(I)
                IR = IR + 1
              ELSE
C               partial
                DSNX(IP) = DSNBUF(I)
                IP = IP - 1
              END IF
 222        CONTINUE
            IF (IP+1 .NE. IR) WRITE(99,*) 'ERROR in WIVLOD,',
     $                                   ' IP,IR,NSITES=',IP,IR,NSITES
            DO 223 I = 1,NSITES
              DSNBUF(I) = DSNX(I)
 223        CONTINUE
          END IF
        END IF
C
C       now select the variables (search attributes)
        SGRP = 151
        CALL Q1INIT (MESSFL, SCLU, SGRP)
C       default the ones that are currently included
        DO 224 I = 1,16
          J = I + 3
          CALL QSTCTF (I,L8,XLABS(1,J))
 224    CONTINUE
        CALL Q1EDIT (IRET)
        NCODES = 3
        DO 225 I=1,16
          CALL QGTCTF (I, L8, CCHK)
          IF (LENSTR(L8, CCHK) .NE. 0) THEN
            NCODES = NCODES + 1
C           left justify variable name if necessary
            IF (CCHK(1) .EQ. ' ') CALL LFTSTR (L8, CCHK)
            CALL CHRCHR (L8, CCHK, XLABS(1,NCODES))
          END IF
 225    CONTINUE
C       find codes from XLABS
        IF (NCODES .GT. 3) THEN
          K = 0
          J = 3
          IBDA = 0
          DO 227 I = 4,NCODES
C           (note:  wdsafi will complete and uppercase attribute names)
            SAIND = 1
            CALL WDSAFI (MESSFL,XLABS(1,I),SAIND,CMATCH,RETCOD)
            IF (RETCOD .EQ. 0) THEN
              J = J + 1
              CODES(J) = SAIND
              CALL CHRCHR (L8, XLABS(1,I), XLABS(1,J))
            ELSE
C             not a valid variable
              IBDA = IBDA + 1
              CALL COPYC (L8, XLABS(1,I), CBUFF(1,IBDA))
            END IF
 227      CONTINUE
          IF (IBDA .GT. 0) THEN
C           blank out rest of XLABS
            I = 8 * IBDA
            CALL ZIPC (I, BLNK, XLABS(1,J+1))
          END IF
C
          IF (IBDA .GT. 0) THEN
C           display invalid variable names entered
            IWRT = 0
            CNUM = 20
            I = MAXINP
            CALL ZIPI (I, L4, OTYP)
            CALL ZIPI (I, L8, CLEN)
            SGRP = 153
            CALL PMXTXA (MESSFL, SCLU, SGRP, MXL, SCNFG, IWRT, CNUM, 
     I                   CLEN, CBUFF)
            NCODES = NCODES - IBDA
          END IF
          GOPT = 3
        ELSE
C         no attributes entered
          ATTFLG = 0
        END IF
        IF (NCODES .GT. 3) ATTFLG = 1
C     
C     ---------------------------------------------- 3 - get
      ELSE IF (GOPT .EQ. 3) THEN
        IF (ATTFLG.EQ.0 .OR. STAFLG.EQ.0) THEN
C         can't get values, no attributes and/or stations identified
          SGRP = 200
          CALL PRNTXT (MESSFL, SCLU, SGRP)
          GOPT = 2
        ELSE
C         ok to get values
C         get attribute values
          CALL WDATGT (WDMSFL, NSITES, NCODES, CODES, ILOW, NMPAR,
     I                 DSNBMX, DSNBUF, 
     O                 ATTVAL, IBD, BADDSN, IBDATT, STANO, RETCOD)
          ZIPLEN = MAXINP * 8
          CALL ZIPC (ZIPLEN, BLNK, CBUFF)
          IBDA = 0
          DO 315 I = 1, NCODES
            DO 310 J = 1, NSITES
              Z(J,I) = DBLE(ATTVAL(J,I))
 310        CONTINUE
            IF (IBDATT(I) .EQ. 1) THEN
C             this attrib. is "bad"--add to counter, place name in CBUFF
              IBDA = IBDA + 1
              CALL COPYC (L8, XLABS(1,I), CBUFF(1,IBDA))
            END IF
 315      CONTINUE
          IF (IBD .GT. 0) THEN
C           1 or more stations do not have a value for 1 or more attr.s
            IWRT = 0
            CNUM = 20
            I = MAXINP
            CALL ZIPI (I, L8, CLEN)
            SGRP = 195
            CALL PMXTXA (MESSFL, SCLU, SGRP, MXL, SCNFG, IWRT, CNUM, 
     I                   CLEN, CBUFF)
          END IF
C
          IF (NUMPAR .GT. 0) THEN
C           for sites with no mean attribute, set skew to 0.0
            J = NSITES + 1 - NUMPAR
            DO 320 I = J,NSITES
              Z(I,3) = 0.0
 320        CONTINUE
          END IF
C
          ICNT = NSITES - IBD
C
          IF (ICNT .LT. 5) THEN
C           not enough complete datasets, need at least 5
            IWRT = 0
            INUM = 2
            IVAL(1) = NSITES
            IVAL(2) = IBD
            SGRP = 35
            CALL PMXTXI (MESSFL, SCLU, SGRP, MXL, SCNFG, IWRT, INUM,
     I                   IVAL)
            DATAFG = 0
          ELSE IF (ILOW.EQ.1 .AND. (NSITES-NUMPAR).LT.5) THEN
C           not enough stations have mean and stddev
            IVL = NSITES - NUMPAR
            SGRP = 28
            CALL PRNTXI (MESSFL, SCLU, SGRP, IVL)
            DATAFG = 0
          ELSE IF (ICNT .EQ. NSITES) THEN
C           all ok
            DATAFG = 1
          ELSE
 330        CONTINUE
C             some bad data: & stations selected, but & had incomplete data
              IWRT = -1
              CNUM = 2
              CALL INTCHR (NSITES, L5, JUSTL,
     O                     CLN(1), TXTBUF(1))
              CALL INTCHR (IBD, L5, JUSTL,
     O                     CLN(2), TXTBUF(CLN(1)+1))
              SGRP = 40
              CALL PMXTXA (MESSFL, SCLU, SGRP, MXL, SCNFG, IWRT, CNUM,
     I                     CLN, TXTBUF)
              CALL ZMNSST
C             what to drop? (1-stations, 2-variables, 3-simulation)
              SGRP = 41
              CALL Q1INIT (MESSFL, SCLU, SGRP)
              CNUM = 1
              CVL(1) = 3
              CALL QSETCO (CNUM, CVL)
              CALL Q1EDIT (IRET)
C           if user chose 'Oops', redraw screen
            IF (IRET .EQ. -1) GOTO 330
C
C           retrieve user's response
            CALL QGETCO (CNUM, CVL)
            DORV = CVL(1)
            IF (DORV .EQ. 1) THEN
C             drop bad data sets from dsn buffer
              IGOOD = 1
              IB = 1
              DO 348 I = 1,NSITES
                IF (DSNBUF(I) .NE. BADDSN(IB)) THEN
                  IF (IGOOD .NE. I) THEN
C                   move values forward in arrays, overwriting bad val.s
                    DO 342 J = 1,NCODES
                      Z(IGOOD,J) = Z(I,J)
 342                CONTINUE
                    DO 346 J = 1,8
                      STANO(J,IGOOD) = STANO(J,I)
 346                CONTINUE
                    DSNBUF(IGOOD) = DSNBUF(I)
                  END IF
                  IGOOD = IGOOD + 1
                ELSE
                  IB = IB + 1
C                 data set __ deleted
                  SGRP = 88
                  CALL PRNTXI (MESSFL, SCLU, SGRP, DSNBUF(I))
                END IF
 348          CONTINUE
              IB = IB - 1
              CALL ZIPI (IB, L0, DSNBUF(IGOOD))
              NSITES = ICNT
C
            ELSE IF (DORV .EQ. 2) THEN
C             delete variables
 350          CONTINUE
C               display variable names in status window
                CALL STATVR ( NCODES, XLABS, L1 )
C               Which independent variable do you want to drop?
                IDROP = 4
C               set min/max/default for input field
                INUM = 1
                RNUM = 1
                DNUM = 1
                CNUM = 1
                NMFLDS = 1
                UIMIN(1) = 4
                UIMAX(1) = NCODES
                UIDEF(1) = IDROP
                CALL QSCSET (INUM, RNUM, DNUM, CNUM, NMFLDS, UIMIN,
     I                       UIMAX, UIDEF, URMIN, URMAX, URDEF, UDMIN,
     I                       UDMAX, UDDEF, VLINFG, UCCNT, UCDEF, USTRLN,
     I                       URSPST)
                SGRP = 16
                CALL QRESPI (MESSFL, SCLU, SGRP, IDROP)
C               drop column out of the Z array
                DO 354 I = 1,NSITES
                  DO 352 J = IDROP+1,NCODES
                    JM1 = J - 1
                    Z(I,JM1) = Z(I,J)
 352              CONTINUE
 354            CONTINUE
C               drop column heading out of list
                DO 358 J = IDROP+1,NCODES
                  JM1 = J - 1
                  DO 356 I = 1,8
                    XLABS(I,JM1) = XLABS(I,J)
 356              CONTINUE
 358            CONTINUE
                NCODES = NCODES - 1
C               redisplay variable names in status window
                CALL STATVR ( NCODES, XLABS, L1 )
C
                RESP = 2
                IF (NCODES .GT. 3) THEN
C                 Another? 1=Y,2=N
                  SGRP = 13
                  CALL QRESP (MESSFL, SCLU, SGRP, RESP)
                END IF
              IF (RESP .EQ. 1) GO TO 350
            END IF
C
            IF (NSITES .LE. 5) THEN
C             not enough complete datasets
              SGRP = 35
              CALL PRNTXT (MESSFL, SCLU, SGRP)
              DATAFG = 0
            ELSE IF (NCODES .LE. 3) THEN
C             no explanatory variables
              SGRP = 172
              CALL PRNTXT (MESSFL, SCLU, SGRP)
              ATTFLG = 0
              DATAFG = 0
            ELSE IF (DORV .NE. 3) THEN
C             enough data to proceed
              DATAFG = 1
            ELSE
C             incomplete data and user wants to start over
              DATAFG = 0
            END IF
          END IF
C
          IF (DATAFG .EQ. 1) THEN
C           Continue analysis
C           number of variables = number of codes
            NV = NCODES
C
C           identify columns
C           sample mean
            KODE=1
            CALL CHRCHR (L8,SM(1,IT),ANS)
            CALL FIND(MESSFL,KODE,NV,XLABS,ANS,ICOL,MISFLG)
            IF (MISFLG .NE. 0) THEN
C             sample mean not found
              SGRP = 92
              CALL PRNTXT (MESSFL, SCLU, SGRP)
              DATAFG = 0
            END IF
C           sample STD. DEV. variable
            KODE=2
            CALL CHRCHR (L8,SD(1,IT),ANS)
            CALL FIND(MESSFL,KODE,NV,XLABS,ANS,ICOL,MISFLG)
            IF (MISFLG .NE. 0) THEN
C             sample mean not found
              SGRP = 93
              CALL PRNTXT (MESSFL, SCLU, SGRP)
              DATAFG = 0
            END IF
C           sample skew
            KODE=3
            CALL CHRCHR (L8,SS(1,IT),ANS)
            CALL FIND(MESSFL,KODE,NV,XLABS,ANS,ICOL,MISFLG)
            IF (MISFLG .NE. 0) THEN
C             sample mean not found
              SGRP = 94
              CALL PRNTXT (MESSFL, SCLU, SGRP)
              DATAFG = 0
            END IF
          END IF
        END IF
C
        IF (DATAFG .EQ. 1) THEN
C         data successfully retrieved
          SGRP = 173
          CALL PRNTXT (MESSFL, SCLU, SGRP)
          GOPT = 5
        END IF
C
C     ---------------------------------------------- 5 - transform
      ELSE IF (GOPT .EQ. 5) THEN
        IF (DATAFG .EQ. 0) THEN
C         no data to do transforms
          SGRP = 205
          CALL PRNTXT (MESSFL, SCLU, SGRP)
          GOPT = 3
        ELSE
C         get transformation options: variable, transf, c1&c2 
C         [defaults transf=none, c1c2=0.0]
          SGRP = 152
          CALL Q2INIT ( MESSFL, SCLU, SGRP )
          CALL Q2SCTF ( L1, L8, NCODES, XLABS )
          K2 = 0
          DO 503 K = 1, 3
            K1 = K2 + 1
            K2 = K1 + 1
            KP = K + 1
            CALL Q2STRB ( L1, K1, NCODES, C1(1,K) )
            CALL Q2STRB ( L1, K2, NCODES, C2(1,K) )
            CALL Q2SCOB ( L1, KP, NCODES, TRANSF(1,K) )
 503      CONTINUE
          CALL Q2EDIT ( NCODES, IRET )
          CALL Q2GCTF ( L1, L8, NCODES, XLABS )
          CALL QUPCAS ( L160, XLABS )
          K2 = 0
          DO 505 K = 1, 3
            K1 = K2 + 1
            K2 = K1 + 1
            KP = K + 1
            CALL Q2GTRB ( L1, K1, NCODES, C1(1,K) )
            CALL Q2GTRB ( L1, K2, NCODES, C2(1,K) )
            CALL Q2GCOB ( L1, KP, NCODES, TRANSF(1,K) )
 505      CONTINUE
Ckmf  write (99,3501) ncodes
Ckmf  do 501, n = 1, ncodes
Ckmf    write (99,3502)(xlabs(k,n),k=1,8),
Ckmf $                 transf(n,1), c1(n,1), c2(n,1),
Ckmf $                 transf(n,2), c1(n,2), c2(n,2),
Ckmf $                 transf(n,3), c1(n,3), c2(n,3)
C501  continue
C3501 format (   ' ****',
Ckmf $         /,' **** nocdes =', i5,
Ckmf $         /,' ****',
Ckmf $         /,' ****            Trans                 ',
Ckmf $                            'Trans                 ',
Ckmf $                            'Trans           ',
Ckmf $         /,'         Variable code   C1    C2      ',
Ckmf $                            ' code   C1    C2      ',
Ckmf $                            ' code   C1    C2' )
C3502 format ( 9x, 8a1, 1x, 2( i5, 2g12.4, 9x ), i5, 2g12.4, 9x )
C
C         adjust transformation code as needed for algebra
          NPRT = 0
          DO 530 N = 1, NCODES
            K1 = -1
            DO 520, K = 1, 3
              TRCODE = TRSHFT( TRANSF(N,K) )
              IF (TRCODE .GT. 0) THEN
C               transform 
                KOUNT = 0
                SUM = 0.0
                DO 510 I = 1, NSITES
                  ATTVAL(I,N) = SNGL ( Z(I,N) )
 510            CONTINUE
                K1 = K1 + 2
                K2 = K1 + 1
                CALL ALGEBR ( MESSFL, TRCODE, NSITES, L1,
     I                        C1(N,K), C2(N,K), L0,
     I                        ATTVAL(1,N), ATTVAL(1,N),
     M                        SUM, KOUNT,
     O                        ATTOUT(1,N) )
                IF (KOUNT .EQ. 0) THEN
                  DO 515 I = 1, NSITES
                    Z(I,N) = DBLE ( ATTOUT(I,N) )
 515              CONTINUE
                ELSE
C                 problem with transformation
                  NPRT = NPRT + 1
                  WRITE (PRTROW(NPRT),2501)
     $                  (XLABS(I,N),I=1,8), TRNSNO(K)
                ENDIF
              END IF
 520        CONTINUE
 530      CONTINUE
          IF (NPRT .EQ. 0) THEN
C           transormation successfully completed
            SGRP = 178
            CALL PRNTXT ( MESSFL, SCLU, SGRP )
          ELSE
            SGRP = 181
            CALL Q2INIT ( MESSFL, SCLU, SGRP )
            CALL Q2SCTF ( L1, L78, NPRT, PRTROW )
            CALL Q2EDIT ( NPRT, IRET )
          END IF
          GOPT = 6
        END IF
C
C     ---------------------------------------------- 7 - plot
      ELSE IF (GOPT .EQ. 7) THEN
C       call routine to plot variables
C       IF (DONEFG .EQ. 1) THEN
C         Do not try to plot flow estimates!
C         SGRP = 95
C         CALL PRNTXT (MESSFL, SCLU, SGRP)
C       END IF
        IF (DATAFG .EQ. 0) THEN
C         no data to plot
          SGRP = 156
          CALL PRNTXT (MESSFL, SCLU, SGRP)
          GOPT = 1
        ELSE
          IBA = 1
          CALL VARPLT (MESSFL, IBA)
          GOPT = 6
        ENDIF
C
C     ---------------------------------------------- 6 - view
      ELSE IF (GOPT .EQ. 6) THEN
        IF (DATAFG .EQ. 0) THEN
C         no data to view    
          SGRP = 160
          CALL PRNTXT (MESSFL, SCLU, SGRP)
          GOPT = 1
        ELSE
C         show the data
          CALL VWDATA (MESSFL, SCLU, NCODES, NSITES, MAXINP, MAXPTS,
     $                 XLABS, Z)
          GOPT = 7
        END IF
      END IF
C
C     return to top for menu
      IF (GOPT .LT. 8) GO TO 5
      DONEFG = DATAFG
C
      RETURN
      END
C
C
C
      SUBROUTINE   WCRLOD
     I                    (MESSFL,WDMSFL,
     O                     IRET)
C
C     + + + PURPOSE + + +
C     This routine computes the concurrent year matrix from data from
C     the users WDM file.
C
C     + + + KEYWORDS + + +
C     WDM file, message file
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL, MESSFL, IRET
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of GLSNET message file
C     WDMSFL - Fortran unit number of WDM file
C     IRET   - user's return code for AIDE command line, 1 - accept,
C              7 - interupt
C
C     + + + PARAMETERS + + +
      INCLUDE 'pmxyrs.inc'
      INCLUDE 'pglsiz.inc'
C
C     + + + COMMONS + + +
      INCLUDE 'cgls.inc'
      INCLUDE 'cglsx.inc'
      INCLUDE 'cgldsn.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      SCLU, SGRP, I, J, K, NCNT,
     $             NP, NHIST, EY, PRS, NX, L1, INTRPT, OFF, ON,
     $             INDX(4), RETCOD
      REAL         A, PH, RLS, H, HSTRET, REY, MXYRSR
C
C     + + + INTRINSICS + + +
      INTRINSIC   ALOG, INT, REAL
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDBSGI, WDBSGR 
      EXTERNAL   PRNTXT, PRNTXI, ZSTCMA, ZGTRET
      EXTERNAL   CNTYRS
C
C     + + + formats + + +
 3000 format ( //, '****',
     $          /, '****',
     $          /, '**** mcon array' )
 3001 format (    5x, 40i3 )
 3002 format ( //, '****',
     $          /, '****',
     $          /, '**** anndat array',
     $          /, 5x, 20i8,
     $          /, (i5, 20f8.1) )
 3300 format ( //, '****',
     $          /, '****',
     $          /, '**** checking for historic record'
     $          /, '****        i     dsn   nhist  nhstret' )
 3301 format (     '****', 4i8 )
C
C     + + + DATA INITIALIZATIONS + + +
C                           indx = statcd, yrslow, j407nh, yrshpk
      DATA L1, INTRPT, OFF, ON, SCLU, INDX
     $    / 1,     16,   0,  1,  106, 57,219,274,81 /
C
C     + + + END SPECIFICATIONS + + +
C
      MXYRSR = REAL ( MXYRS )
C
C     make interupt available
      CALL ZSTCMA ( INTRPT, ON )
C
C     concurrent record matrix being computed
      SGRP = 190
      CALL PRNTXT (MESSFL, SCLU, SGRP)
      CALL ZGTRET (IRET)
      IF (IRET .EQ. 1) THEN
C       retrieve annual data
        CALL CNTYRS ( WDMSFL, MESSFL, DSNBUF, NSITES,
     O                ANNDAT )
ckmf    write (99,3002) (i,i=1,20), (k,(anndat(k,i),i=1,20),k=1,mxyrs)
ckmf    write (99,3002) (i,i=21,40),(k,(anndat(k,i),i=21,40),k=1,mxyrs)
        DO 140 I = 1,NSITES
          DO 130 J = 1,I
            MCON(I,J) = 0
            DO 120 K = 1,MXYRS
              IF (ANNDAT(K,I) .GT. 0.0 .AND. ANNDAT(K,J) .GT. 0.0)
     $          MCON(I,J) = MCON(I,J) + 1
 120        CONTINUE
 130      CONTINUE
 140    CONTINUE
ckmf    write (99,3000)
ckmf    do 150 j = 1, nsites
ckmf      write (99,3001) (mcon(i,j), i = 1, nsites)
c150    continue
        IF (ILOW .EQ. 1) THEN
C         low flows, check for partial record sites and reset MCON
C         diagonal if value for YRSLOW(equiv yrs record) is larger
Ckmf---------------------------------------------------------Note
Ckmf                                                         Note
Ckmf      The code checks for a value of 99 for attribute    Note
Ckmf      statcd, but prior to 10/26/2004, neither partial   Note
Ckmf      record option (manual nor stedinger) set statcd.   Note
Ckmf                                                         Note
Ckmf      As of 10/26/04, Gary Tasker believes the diagonal  Note
Ckmf      should not be updated to reflect the effective     Note
Ckmf      record length calculated in the Stedinger-Thomas   Note
Ckmf      method as it may slightly overestimate the         Note
Ckmf      effective record length and under estimate the     Note
Ckmf      the cross correlation among sites.                 Note
Ckmf                                                         Note
Ckmf      The code checking for partial records has been     Note
Ckmf      commented out.  10/26/04 - kmf                     Note
Ckmf                                                         Note
Ckmf---------------------------------------------------------Note
           NX = 0
Ckmf       DO 200 I = 1, NSITES
Ckmf         CALL WDBSGI ( WDMSFL, DSNBUF(I), INDX(1), L1, PRS, RETCOD )
Ckmf         IF (PRS .EQ. 99) THEN
C             partial record site, get the equivalent years
Ckmf           CALL WDBSGR ( WDMSFL, DSNBUF(I), INDX(2), L1, REY, RETCOD)
Ckmf           IF (RETCOD .EQ. 0) THEN
C               check against diagonal
Ckmf             EY = INT(REY)
Ckmf             IF (EY .GT. MCON(I,I)) THEN
Ckmf               MCON(I,I) = EY
Ckmf               NX = NX + 1
Ckmf             END IF
Ckmf           END IF
Ckmf         END IF
C200      CONTINUE
Ckmf       IF (NX .GT. 0) THEN
C           Diagonal of concurrent year matrix modified for & partial
C           record sites to equivalent years estimate
Ckmf         SGRP = 191
Ckmf         CALL PRNTXI (MESSFL,SCLU,SGRP,NX)
Ckmf         CALL ZGTRET (IRET)
Ckmf       END IF
        ELSE IF (ILOW .EQ. 0) THEN
C         peak flows, use historic information if available.
C         Searching for historic information.
          SGRP = 192
          CALL PRNTXT (MESSFL, SCLU, SGRP)
          CALL ZGTRET (IRET)
          IF (IRET .EQ. 1) THEN
            NCNT = 0
ckmf        write (99,3300)
            DO 300 I = 1, NSITES
C             Get number of historic peaks
              CALL WDBSGI ( WDMSFL, DSNBUF(I), INDX(3), L1,
     O                      NHIST, RETCOD )
              IF (RETCOD .EQ. 0 .AND. NHIST .GT. 0) THEN
C               Get historic recurrence interval.
                CALL WDBSGR ( WDMSFL, DSNBUF(I), INDX(4), L1, 
     O                        HSTRET, RETCOD )
ckmf            write (99,3301) i, dsnbuf(i), nhist, hstret
                IF (RETCOD .EQ. 0 .AND. HSTRET .GT. 0.0) THEN
                  NCNT = NCNT + 1
                  H = HSTRET
                  NP = NHIST
                  RLS = REAL(MCON(I,I))
                  H = H - RLS
Ckmf---------------------------------------------------------Note
Ckmf                                                         Note
Ckmf              200 used below appears to be related to    Note
Ckmf              original limit of 1800 - 1999.  Revised    Note
Ckmf              code to used parameter mxyrs from include  Note
Ckmf              plimit.inc for the upper limit (10/12/04)  Note
Ckmf                                                         Note
Ckmf---------------------------------------------------------Note
Ckmf              IF (H .GT. 200.) H = 200.                  Note
Ckmf---------------------------------------------------------Note
                  IF (H .GT. MXYRSR) H = MXYRSR
Ckmf---------------------------------------------------------Note
                  PH = 1.0 - REAL(NP)/(H+RLS)
                  PH = ALOG(PH/(1.0-PH))
                  A = 0.55 - 0.1*PH
                  MCON(I,I) = INT(A*H + RLS)
                END IF
              END IF
 300        CONTINUE
            IF (NCNT .GT. 0) THEN
C             & stations adjusted for historic peaks
              SGRP = 193
              CALL PRNTXI (MESSFL, SCLU, SGRP, NCNT)
              CALL ZGTRET (IRET)
ckmf          write (99,3000)
ckmf          do 350 j = 1, nsites
ckmf            write (99,3001) (mcon(i,j), i = 1, nsites)
c350          continue
            END IF
          END IF
        END IF
        IF (IRET .EQ. 1) THEN
C         completed computation of concurrent year matrix. 
C         now processing for cross-correlation matrix.
          SGRP = 194
          CALL PRNTXT (MESSFL, SCLU, SGRP)
          CALL ZGTRET (IRET)
        END IF
      END IF
C     turn off interupt
      CALL ZSTCMA ( INTRPT, OFF )
C
ckmf  write (99,*) '<<<<< leaving wcrlod, iret =', iret
      RETURN
      END
C
C
C
      SUBROUTINE   WCCLOD
     I                    (MESSFL, WDMSFL,
     O                     ALPHA, THETA, IRET)
C
C     + + + PURPOSE + + +
C     This routine computes the cross-correlation matrix from
C     data from the users WDM file.  It also plots the distance vs.
C     cross-correlations computed and then uses the relation developed
C     to recompute the cross-correlations based on distance between
C     sites.
C
C     + + + HISTORY + + +
C     gdt 01/06/22  had been using the annual peaks in CFS to compute
C                   the cross correlations plotted.  Should have been
C                   using the logs of the annual peaks to compute the
C                   cross correlatins.  Code modified to use alog10.
C     kmf 09/24/04  revised and renumbered items from message file
C     kmf 01/27/05  removed logic to buffer writting warning message
C                   about pairs of data sets with values of 1.0.
C
C     + + + KEYWORDS + + +
C     WDM file, message file, DISSPLA
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, WDMSFL, IRET
      REAL      ALPHA, THETA
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of GLSNET message file
C     WDMSFL - Fortran unit number of WDM file
C     ALPHA  - coefficient for cross-correlation vs. distance equation
C     THETA  - coefficient for cross-correlation vs. distance equation
C     IRET   - user's return code for AIDE command line, 1 - accept,
C              7 - interupt
C
C     + + + PARAMETERS + + +
      INCLUDE 'pmxyrs.inc'
      INCLUDE 'pglsiz.inc'
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cgls.inc'
      INCLUDE 'cglsx.inc'
      INCLUDE 'cgldsn.inc'
C
C     + + + LOCAL PARAMETERS + + +
      INTEGER    KNTMAX
      PARAMETER ( KNTMAX = 10 )
C  
C     + + + LOCAL COMMONS + + +
      COMMON /CDIST/ DIST
      REAL   DIST(MAXPTS,MAXPTS)
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   ICNT, ISTEP, CNT(5), IDXP(DSNBMX), INDX, PRS,
     $          NYR, NYRS, NY(4), IREPT, NPTS, KNT, DROP(KNTMAX),
     $          I, J, K, N, L1, L2, L78, LN, KNTDRP,
     $          NPRT, INTRPT, STATUS, ON, OFF,
     $          SCLU, SGRP, ERRFL, RETCOD
      REAL              YY(900),XX(900), YMIN(18), YMAX(18),
     $                  RLAT, RLNG, RVAL(2),
     $                  LATDIF, LNGDIF, LATAVE,
     $                  A, E2, OP1, OP2, OP3,
     $                  RADIAN
      DOUBLE PRECISION  S0, S1, S2, SX, SY, SX2, SY2, SXY
      CHARACTER*78      PRTROW
C
C     + + + INTRINSICS + + +
      INTRINSIC   ABS, SQRT, SIN, COS, DSQRT, MOD, REAL, DBLE, ALOG10
C
C     + + + EXTERNALS + + +
      EXTERNAL   CCDPLT
      EXTERNAL   WDBSGL, WDBSGI
      EXTERNAL   Q1INIT, QSETCO, QSETI, QSETR, Q1EDIT, QGETCO
      EXTERNAL   Q2INIT, Q2SCTF, Q2EDIT, QRESP
      EXTERNAL   ZSTCMA, ZSTADD, ZQUIET
      EXTERNAL   ZIPI
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT (   '*** The following data sets were dropped because ',
     $        /, '*** latitude and/or longitude was missing.' )
 2001 FORMAT ( '|   ', 10I6 )
 2200 FORMAT ( I7, ' station pairs have ', I2,
     $             ' or more years of concurrent record.' )
 2400 FORMAT (   I6, ' and', I6 )
 2401 FORMAT (/, '*** ',
     $        /   '*** The folowing data set pairs had 10 or more',
     $        /, '*** years where one or both stations had flow',
     $        /, '*** of 1.0.  The corresponding value in the',
     $        /, '*** cross correlation matrix has been set to',
     $        /, '*** -999. for these pairs.  This is normal if',
     $        /, '*** one or both of the stations is a low-flow',
     $        /, '*** partial record site.',
     $        /, '*** ' )
 2402 FORMAT (   '***      ', 2I10 )
 2600 FORMAT (   '***',
     $        /, '*** Computed values for alpha and theta:',
     $        /, '***',
     $        /, '***      ALPHA = ', G14.4,
     $        /, '***      THETA = ', G14.4,
     $        /, '***' )
 3000 FORMAT (   '***',
     $        /, '*** Computed values for rhoc:',
     $        /, '***',
     $        /, '***   i    j       rhoc          so          ',
     $           's1         s2   dsn(i) dsn(j)  nprt    n1'
     $        /, '*** ---- ----', 4( '  ----------'),
     $           4( ' -----') )
 3001 FORMAT (  2i6, 4g12.4 )
 3005 format (  2i6, 12x, 3g12.4, 2i7, 2i6 )
C
C     + + + DATA INITIALIZATION + + +
      DATA  L1, L2, L78, NY
     $    /  1,  2,  78, 4,10,30,50 /
      DATA  SCLU, INTRPT, STATUS, OFF, ON, ERRFL
     $    /  106,     16,      7,   0,  1,    99 /
C
C     + + + END SPECIFICATIONS + + +
C
C     enable interupt command
      CALL ZSTCMA ( INTRPT, ON )
C
      I      = 0
      KNT    = 0
      KNTDRP = 0
 100  CONTINUE
C       loop for each site
        I = I + 1
 120    CONTINUE
C         loop to repeat if needed to delete a site because no lat/long
          IREPT = 0
C         get lat and long for data set
          CALL WDBSGL ( WDMSFL, DSNBUF(I), RLAT, RLNG, RETCOD )
          IF (RETCOD .EQ. 0) THEN
C           successfully retrieved latitude and longitude
            DLAT(I) = DBLE ( RLAT )
            DLNG(I) = DBLE ( RLNG )
          ELSE
C           missing lat/long for this data set
            KNT = KNT + 1
            DROP(KNT) = DSNBUF(I)
            IF (KNT .EQ. KNTMAX) THEN
              IF (KNTDRP .EQ. 0) THEN
C               first time, need header
                WRITE (ERRFL,2000) 
              END IF
              KNTDRP = KNTDRP + KNT
              WRITE (ERRFL,2001)  (DROP(K), K = 1, KNT)
              KNT = 0
            END IF
C           remove data set number from buffer
            NSITES = NSITES - 1
            DO 130 J = I, NSITES
              DSNBUF(J) = DSNBUF(J+1)
 130        CONTINUE
            DSNBUF(NSITES+1) = 0
            IREPT = 1
          END IF
        IF (IREPT .EQ. 1) GO TO 120
      IF (I .LT. NSITES) GO TO 100
      IF (KNTDRP .EQ. 0  .AND.  KNT .EQ. 0) THEN
C       all data sets contained latitude and longitude
        IRET = 1
      ELSE
C       lat/long missing Accept (F2) to continue or Interrupt (F6)
        IF (KNT .GT. 0) THEN
C         still some dsn to print out
          IF (KNTDRP .EQ. 0) WRITE (ERRFL,2000)
          KNTDRP = KNTDRP + KNT
          WRITE (ERRFL,2001)  (DROP(K), K = 1, KNT)
        END IF
        SGRP = 221
        CALL Q1INIT ( MESSFL, SCLU, SGRP )
        CALL QSETI  ( L1, KNTDRP )
        CALL Q1EDIT ( IRET )
      END IF
C
      IF (IRET .EQ. 1) THEN
Ckmf---------------------------------------------------------Note
Ckmf                                                         Note
Ckmf    Should the following be double precision?            Note
Ckmf                                                         Note
Ckmf           RADIAN, A, E2                                 Note
Ckmf           LATDIF, LNGDIF, LATAVE                        Note
Ckmf           OP1, OP2, OP3                                 Note
Ckmf           DIST                                          Note
Ckmf                                                         Note
Ckmf    In WCCLOD,                                           Note
Ckmf                                                         Note
Ckmf         DIST is real from common CDIST                  Note
Ckmf         the other variables are real                    Note
Ckmf                                                         Note
Ckmf    In PRONET,                                           Note
Ckmf                                                         Note
Ckmf         RADIAN is double precision                      Note
Ckmf         DIST is real, but then set to DDIST which is    Note
Ckmf         double precision                                Note
Ckmf         the other variables are real                    Note
Ckmf                                                         Note
Ckmf    Also, in PRONET, DLAT is converted to Single         Note
Ckmf    precision (SNGL) in the computation of LATDIF        Note
Ckmf    and LNGDIF.                                          Note
Ckmf                                                         Note
Ckmf---------------------------------------------------------Note
C       continue processing, convert to radians
        RADIAN = 3.14159265/180.0
C
        A = 6378206.0
        E2 = 0.00676866
        DO 210 I = 1,NSITES
          DO 200 J = 1,I
C           compute distance between stations
            LATDIF = ABS (DLAT(I)-DLAT(J))*RADIAN
            LNGDIF = ABS (DLNG(I)-DLNG(J))*RADIAN
            LATAVE = (DLAT(I)+DLAT(J))*RADIAN*0.5
            OP1 = A/SQRT(1.0-E2*SIN(LATAVE)**2)
            OP2 = ((1.0-E2)**2*(LATDIF)**2)/((1.0-E2*SIN(LATAVE)**2)**2)
            OP3 = COS(LATAVE)**2 * LNGDIF**2
            DIST(I,J) = (OP1*SQRT(OP2+OP3))/1000.0
C           convert to miles from kilometers
            DIST(I,J) = DIST(I,J)/1.609
 200      CONTINUE
 210    CONTINUE
C
C       count pairs of stations for 4, 10, 30, 50 concurrent YRS
        CALL ZIPI (5,0,CNT)
        DO 240 I = 1,NSITES
          DO 230 J = 1,I
            IF (I.NE.J) THEN
              IF (MCON(I,J) .GE. 4) CNT(1) = CNT(1) + 1
              IF (MCON(I,J) .GE. 10) CNT(2) = CNT(2) + 1
              IF (MCON(I,J) .GE. 30) CNT(3) = CNT(3) + 1
              IF (MCON(I,J) .GE. 50) CNT(4) = CNT(4) + 1
            END IF
 230      CONTINUE
 240    CONTINUE
        DO 290 I = 1, 4
C         put numbers of station pairs in status window
          WRITE (PRTROW,2200) CNT(I), NY(I)
          CALL ZSTADD ( I, PRTROW )
 290    CONTINUE
C
Ckmf---------------------------------------------------------Note
Ckmf                                                         Note
Ckmf    does Prev need to be turned off?                     Note
Ckmf                                                         Note
Ckmf---------------------------------------------------------Note
        SGRP = 222
        LN   = 4
 300    CONTINUE
C         ask which criteria, ie no. of years 1-4, 2-10, 3-30, 4-50
          NYR  = 3
          IF (CNT(3) .LE. 2) NYR = 2
          IF (CNT(2) .LE. 2) NYR = 1
          CALL Q1INIT ( MESSFL, SCLU, SGRP )
          CALL QSETCO ( L1, NYR )
          CALL QSETI  ( LN, CNT )
          CALL Q1EDIT ( IRET )
          IF (IRET .EQ. 1) THEN
            CALL QGETCO ( L1, NYR )
            IF (CNT(NYR) .GT. 2) THEN
              NYRS = NY(NYR)
            ELSE
C             insufficient station pairs
              LN = 5
              SGRP = 223
              CNT(5) = NY(NYR)
              CALL ZSTCMA ( INTRPT, ON )
            END IF
          END IF
        IF (IRET .EQ. 1  .AND.  CNT(NYR) .LE. 2) GO TO 300
C       write (99,*) '---  in wcclod:  got criteria =', nyrs
      END IF
C
      IF (IRET .EQ. 1) THEN
C       set number of points based on number of years criteria
        NPRT = 0
Ckmf    write (98,3000)
        DO 460 I = 1,NSITES
          DO 440 J = 1,I
            SXY = 0.0
            SX = 0.0
            SY = 0.0
            SX2 = 0.0
            SY2 = 0.0
            N = 0
            DO 420 K = 1,MXYRS
              IF (ANNDAT(K,I).GT.0.0 .AND. ANNDAT(K,J).GT.0.0) THEN
                N = N + 1
Cgdt            May 31, 2001
Cgdt            had been using annual peaks in CFS to compute cross
Cgdt            correlation, should be logs of annual peaks
Cgdt            SX = SX + DBLE(ANNDAT(K,I))
Cgdt            SX2 = SX2 + DBLE(ANNDAT(K,I)**2)
Cgdt            SY = SY + DBLE(ANNDAT(K,J))
Cgdt            SY2 = SY2 + DBLE(ANNDAT(K,J)**2)
Cgdt            SXY = SXY + DBLE(ANNDAT(K,I)*ANNDAT(K,J))
                SX  = SX  + DBLE ( ALOG10 (ANNDAT(K,I) ) )
                SX2 = SX2 + DBLE ( ALOG10 (ANNDAT(K,I) ) **2 )
                SY  = SY  + DBLE ( ALOG10 (ANNDAT(K,J) ) )
                SY2 = SY2 + DBLE ( ALOG10 (ANNDAT(K,J) ) **2 )
                SXY = SXY + DBLE ( ALOG10 (ANNDAT(K,I) )
     $                           * ALOG10 (ANNDAT(K,J) ) )
              END IF
 420        CONTINUE
            IF (N .LT. 10) THEN
              RHOC(I,J) = -999.0
            ELSE
C             concurrent values, so compute
              S1 = SX2 - SX*SX/DBLE(N)
              S2 = SY2 - SY*SY/DBLE(N)
              S0 = SXY - SX*SY/DBLE(N)
              IF (S1 .GT. 1.0D-50 .AND. S2 .GT. 1.0D-50) THEN
                RHOC(I,J) = S0/(DSQRT(S1*S2))
Ckmf            write (98,3001) i, j, rhoc(i,j), s0, s1, s2
              ELSE
C               all zero values for dataset & or &
                RHOC(I,J) = -999.0
                NPRT = NPRT + 1
                IF (NPRT .EQ. 1) WRITE (ERRFL,2401)
                WRITE (ERRFL,2402) DSNBUF(I), DSNBUF(J)
Ckmf            write (98,3005) i, j, s0, s1, s2,
Ckmf $                          dsnbuf(i), dsnbuf(j), nprt, n1
              END IF
            END IF
 440      CONTINUE
 460    CONTINUE
        IF (NPRT .GT. 0) THEN
C         warn user about 
          SGRP = 224
          CALL Q1INIT ( MESSFL, SCLU, SGRP )
          CALL QSETI  ( L1, NPRT )
          CALL Q1EDIT ( IRET )
        END IF

C       cross-correlations computed; processing: 1-continue, 2-stop
        SGRP = 225
        CALL QRESP ( MESSFL, SCLU, SGRP, IRET )
        IF (IRET .EQ. 2) IRET = 7
C
        IF (IRET .EQ. 1) THEN
Ckmf      March 4, 2004, gpinit is called in ccdplt,
Ckmf      should not need to also be called here
C         fill plot buffer
Ckmf      CALL GPINIT
CKMF      end March 4, 2004 change
          YMIN(2) = 1.0E9
          YMIN(1) = 1.0E9
          YMAX(1) = -1.0E9
          YMAX(2) = -1.0E9
          NPTS = CNT(NYR)
          ISTEP = 1
          IF (NPTS .GT. 200) THEN
C           only 200 points will be selected for plotting
            SGRP = 226
            CALL Q1INIT ( MESSFL, SCLU, SGRP )
            CALL QSETI  ( L1, NPTS )
            CALL Q1EDIT ( IRET )
            ISTEP = NPTS/200
            NPTS = 200
          END IF
          IF (IRET .EQ. 1) THEN
Ckmf---------------------------------------------------------Note
Ckmf                                                         Note
Ckmf        The code checks for a value of 99 for attribute  Note
Ckmf        statcd, but prior to 10/26/2004, neither partial Note
Ckmf        record option (manual nor stedinger) set statcd. Note
Ckmf                                                         Note
Ckmf        If the pre 10/26/04 behavior is required, change Note
Ckmf        knti in subroutine prtnew in prtpro.f from       Note
Ckmf        9 to 8.                                          Note
Ckmf                                                         Note
Ckmf        IDXP was not initialized, added zipi 9/22/04     Note
Ckmf                                                         Note
Ckmf        Why is numb. of points to be plotted limited to  Note
Ckmf        200 when xx and yy are both dimensioned to 900?  Note
Ckmf                                                         Note
Ckmf---------------------------------------------------------Note
            N = 0
            ICNT = 0
            INDX = 57
            CALL ZIPI ( NSITES, 0, IDXP )
            DO 540 I = 1,NSITES
C             check for partial record sites
              CALL WDBSGI (WDMSFL,DSNBUF(I),INDX,L1,PRS,RETCOD)
              IF (PRS .EQ. 99) IDXP(I) = 1
              DO 520 J = 1,I
                IF (I.NE.J .AND. IDXP(I).NE.1 .AND. IDXP(J).NE.1) THEN
C                 eliminate diagonals and partial record sites
                  IF (MCON(I,J) .GE. NYRS) THEN
C                   set index for plot data
                    ICNT = ICNT + 1
                    IF (MOD(ICNT,ISTEP) .EQ. 0) THEN
                      N = N + 1
                      IF (N .LE. NPTS) THEN
C                       should always be the case, extra protection
                        XX(N) = DIST(I,J)
                        IF (DIST(I,J) .GT. YMAX(2)) YMAX(2)=DIST(I,J)
                        IF (DIST(I,J) .LT. YMIN(2)) YMIN(2)=DIST(I,J)
                        YY(N) = REAL(RHOC(I,J))
                        IF (REAL(RHOC(I,J)) .GT. YMAX(1))
     $                    YMAX(1) = REAL(RHOC(I,J))
                        IF (REAL(RHOC(I,J)) .LT. YMIN(1))
     $                    YMIN(1) = REAL(RHOC(I,J))
                      END IF
                    END IF
                  END IF
                END IF
 520          CONTINUE
 540        CONTINUE
            IF (YMAX(1) .GT. 0.999) YMAX(1) = 0.999
            IF (YMIN(1) .LT. -0.999) YMIN(1) = -0.999
C
            CALL CCDPLT (MESSFL,NPTS,N,NYRS,YY,XX,YMIN,YMAX,
     $                   ALPHA,THETA)
C
C           note: if you intend to use network analysis program,
C           write down these numbers
            WRITE (ERRFL,2600) ALPHA, THETA
            SGRP = 227
            RVAL(1) = ALPHA
            RVAL(2) = THETA
            CALL Q1INIT ( MESSFL, SCLU, SGRP )
            CALL QSETR  ( L2, RVAL )
            CALL Q1EDIT ( IRET )
C
            IF (IRET .EQ. 1) THEN
C             use equation to compute cross-correlation matrix
              DO 640 I = 1,NSITES
                DO 620 J = 1,I
                  RHOC(I,J) = DBLE(THETA**(DIST(I,J)/
     $                        (ALPHA*DIST(I,J)+1.0)))
 620            CONTINUE
 640          CONTINUE
C             cross-correlations recomputed
              SGRP = 228
              CALL Q1INIT ( MESSFL, SCLU, SGRP )
              CALL QSETI ( L1, NSITES )
              CALL Q1EDIT ( IRET )
C
              IF (IRET .EQ. 1) THEN
C               close status window and turn off option
                CALL ZQUIET
                CALL ZSTCMA ( STATUS, OFF )
              END IF
            END IF
          END IF
        END IF
      END IF
C   
C     turn off interupt
      CALL ZSTCMA ( INTRPT, OFF )
C
      RETURN
      END
C
C
C
      SUBROUTINE   CNTYRS
     I                    (WDMSFL, MESSFL, DSN, NSITES,
     O                     X)
C
C     + + + PURPOSE + + +
C     This routine gets annual data from the users WDM file.
C
C     + + + KEYWORDS + + +
C     WDM file
C
C     + + + PARAMETERS + + +
      INCLUDE 'pmxyrs.inc'
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL, MESSFL, NSITES, DSN(NSITES)
      REAL      X(MXYRS,NSITES)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     MESSFL - Fortran unit number for GLSNET message file
C     DSN    - dataset number on WDM file
C     NSITES - number of data sets
C     X      - array of annual values
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      I, J, K, L, N, L1, L12, L78, LEN, KLEN, IB,
     $             SCLU, SGRP, FLUSH, ERRFL, NVAL, NPRT,
     $             DTYPE, QFLG, TS, TC, TR, GPFLG, TDSFRC,
     $             TABID, TBCNT, LREC, GRP, QNU, TGRPT, J407FG, INITFG,
     $             SYR(6), EYR(6), WYR(MXYRS), NROW, IRET, RETCOD
      REAL         PK(MXYRS), FILL
      CHARACTER*1  C(12), CFLG(16,MXYRS), MFID(2)
      CHARACTER*16 TNAME
      CHARACTER*78 PRTROW(25)
C
C     + + + FUNCTIONS + + +
      INTEGER   SIMAX, SIMIN, LENSTR, WDCKDT
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDCKDT, WTFNDT, WDTGET, WDTBFX, GETTB
      EXTERNAL   SIMAX,  SIMIN,  LFTSTR, LENSTR, ZIPR
      EXTERNAL   Q1INIT, Q1EDIT, QGTCTF, Q2INIT, Q2SCTF, Q2EDIT
C
C     + + + FORMATS + + +
 2001 FORMAT (  I8, '    WARN:  begin year', I5, ' before earliest ',
     $              'allowed, changed to', I5 )
 2002 FORMAT (  I8, '    WARN:  end year', I5, ' after latest ',
     $              'allowed, changed to', I5 )
 2003 FORMAT (  I8, '  ERROR:  problem retrieving annual data values, ',
     $              'retc =', I5 )
 2004 FORMAT (  I8, '   WARN:  peakfq analysis period', I5, ' -', I5,
     $              ' outside', I5, ' -', I5 )
 2005 FORMAT (  I8, '  ERROR:  problem retrieving peak flows, ',
     $              'retc =', I5 )
 2006 FORMAT (  I8, '  ERROR:  problem retrieving info about peak ',
     $              'data set, retc =', I5 )
 2007 FORMAT (  I8, '  ERROR:  data set not expected type, ',
     $              'dtype =', I5 )
 2020 FORMAT ( ' +-- problems getting annual data (cntyrs) -----' )
 2021 FORMAT ( ' | dsn =', A )
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  SCLU, FILL, L1, L12, L78
     $    /  106, -999., 1,  12,  78 /
      DATA QFLG, TS, TC, TR, GPFLG
     $    /  30,  1,  6,  0,     1 /
      DATA J407FG, INITFG, TABID, TNAME
     $    /     1,      1,     1, 'AN.PEAKS        ' /
C
C     + + + END SPECIFICATIONS + + +
C
C     return codes
C     general:   0 - everything is O.K.
C              -81 - data set does not exist
C              -82 - data set exists, but is wrong DSTYP
C              -84 - data set number out of range
C              -85 - trying to write to a read-only data set
C     wtfndt:   -6 - no data present
C     wdtget:   -8 - invalid date
C              -14 - date specified not within valid range for data set
C              -20 - problem with one or more of following:
C                    GPFLG, DXX, NVAL, QUALVL, LTSTEP, LTUNIT
C              -21 - date from WDM doesn't match expected date
C     wdtbfx:    0 - table found, pointer and other info returned
C                1 - table not found
C     gettb:  -321 - table templete names didn't match
C
      C(1)  = 'Z'
      NPRT  = 0
      NVAL  = MXYRS * NSITES
      FLUSH = 0
      ERRFL = 99
      CALL ZIPR ( NVAL, FILL, X )
C
      DO 500 N = 1, NSITES
        DTYPE = WDCKDT (WDMSFL, DSN(N))
        IF (DTYPE .EQ. 1) THEN
C         time series, get period of record
          CALL WTFNDT ( WDMSFL, DSN(N), GPFLG,
     O                  TDSFRC, SYR, EYR, RETCOD )
          IF (RETCOD .EQ. 0) THEN
C           retrieve data from time series data set
            IF (SYR(1) .LT. YRFRST) THEN
C             record begins before expected first year
              NPRT = NPRT + 1
              WRITE (PRTROW(NPRT),2001) DSN(N), SYR(1), YRFRST
              SYR(1) = YRFRST
            END IF
            NVAL = EYR(1) - SYR(1) + 1
            IF (EYR(1) .GT. YRLAST) THEN
C             record ends after expected last date
              NPRT = NPRT + 1
              WRITE (PRTROW(NPRT),2002) DSN(N), EYR(1), YRLAST
              EYR(1) = YRLAST
            END IF
            NVAL = EYR(1) - SYR(1) + 1
            IB = SYR(1) - YRFRST + 1
C           fill arrays
            CALL WDTGET ( WDMSFL, DSN(N), TS, SYR, NVAL, TR, QFLG, TC,
     O                    X(IB,N), RETCOD )
          ELSE
            NPRT = NPRT + 1
            WRITE (PRTROW(NPRT),2003) DSN(N), RETCOD
            WRITE(99,*) 'Data set', DSN(N), 'had no time-series values.'
          END  IF
        ELSE IF (DTYPE .EQ. 2) THEN
C         assume peak flow table data set
          IF (C(1) .EQ. 'Z') THEN
C           qualification codes to drop peak from analysis
            SGRP = 138
            CALL Q1INIT ( MESSFL, SCLU, SGRP )
            CALL Q1EDIT ( IRET )
            CALL QGTCTF ( L1, L12, C )
            CALL LFTSTR ( LEN, C )
            KLEN = LENSTR ( LEN, C )
          END IF
          CALL WDTBFX ( WDMSFL, DSN(N), TABID, TNAME,
     O                  TBCNT, LREC, TGRPT, MFID, GRP, QNU, NROW,
     O                  RETCOD )
          IF (RETCOD .EQ. 0 .AND. NROW .GT. 0) THEN
C           get data for period used in j407 analysis (j407fg=1)
            CALL GETTB ( MESSFL, TNAME, WDMSFL, DSN(N), MXYRS,
     I                   J407FG, INITFG, 
     O                   NROW, PK, WYR, CFLG, RETCOD )
            IF (RETCOD .EQ. 0) THEN
              SYR(1) = SIMIN ( NROW, WYR )
              EYR(1) = SIMAX ( NROW, WYR )
Ckmf---------------------------------------------------------Note
Ckmf                                                         Note
Ckmf          potential problem with period of record if     Note
Ckmf          period of record for peakfq is greater than    Note
Ckmf          GLSNet period YRFRST - YRLAST                  Note
Ckmf                                                         Note
Ckmf          should the data set be skipped?                Note
Ckmf                                                         Note
Ckmf          Currently (10/12/04) station is kept but       Note
Ckmf          peaks are dropped.                             Note
Ckmf                                                         Note
Ckmf---------------------------------------------------------Note
              IF (SYR(1) .LT. YRFRST  .OR.  EYR(1) .GT. YRLAST) THEN
C               period used for peakfq calculations is greater
C               than period permitted by GLSNet YRFRST - YRLAST
                NPRT = NPRT + 1
                WRITE (PRTROW(NPRT),2004) DSN(N), SYR(1), EYR(1),
     $                              YRFRST, YRLAST
                IF (SYR(1) .LT. YRFRST) SYR(1) = YRFRST
                IF (EYR(1) .GT. YRLAST) EYR(1) = YRLAST
              END IF
              DO 190 I = 1, NROW
                IF (YRFRST .LE. WYR(I) .AND. WYR(I) .LE. YRLAST) THEN
C                 peak within requested & valid time span
                  J = WYR(I) - YRFRST + 1
                  X(J,N) = PK(I)
                  IF (KLEN .GT. 0) THEN
C                   may be peaks to be excluded
                    DO 180 K = 1, KLEN
                      IF (C(K) .NE. ' ') THEN
                        DO 170 L = 1, 12
                          IF (C(K) .EQ. CFLG(L,I)) X(J,N) = -999999.
 170                    CONTINUE
                      END IF
 180                CONTINUE
                  END IF
                END IF
 190          CONTINUE
            ELSE
C             no data or other unknow problem getting peaks
              NPRT = NPRT + 1
              WRITE (PRTROW(NPRT),2005) DSN(N), RETCOD
            END IF
          ELSE
C           problem getting information about data set
            NPRT = NPRT + 1
            WRITE (PRTROW(NPRT),2006) DSN(N), RETCOD
          END IF
        ELSE
C         unexpected or unknown type of data set
          NPRT = NPRT + 1
          WRITE (PRTROW(NPRT),2007) DSN(N), DTYPE
        END IF
        IF (NPRT .GT. 20) THEN
          IF (FLUSH .EQ. 0) THEN
C           warn/error buffer apporaching full for first time
            FLUSH = 1
            WRITE (ERRFL,2020)
            WRITE (ERRFL,2021) (PRTROW(I), I = 1, NPRT)
            SGRP = 130
            CALL Q2INIT ( MESSFL, SCLU, SGRP )
            CALL Q2SCTF ( L1, L78, NPRT, PRTROW )
            CALL Q2EDIT ( NPRT, IRET )
          ELSE
            WRITE (ERRFL,2021) (PRTROW(I), I = 1, NPRT)
          END IF
          NPRT = 0
        END IF
 500  CONTINUE
C
      IF (NPRT .GT. 0) THEN
        IF (FLUSH .EQ. 0) THEN
C         warn/error buffer never approached full
          WRITE (ERRFL,2020)
          WRITE (ERRFL,2021) (PRTROW(I), I = 1, NPRT)
          SGRP = 130
          CALL Q2INIT ( MESSFL, SCLU, SGRP )
          CALL Q2SCTF ( L1, L78, NPRT, PRTROW )
          CALL Q2EDIT ( NPRT, IRET )
        ELSE
          WRITE (ERRFL,2021) (PRTROW(I), I = 1, NPRT)
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   CCDPLT
     I                   (MESSFL, NPTS, N, NYRS,Y,X,YMIN,YMAX,
     O                    ALPHA, THETA)
C
C     + + + PURPOSE + + +
C     This routine plots cross-correlation coefficients vs distance
C     to help user to get ALPHA and THETA parameters for the relation.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   NPTS, N, NYRS, MESSFL
      REAL      ALPHA, THETA, Y(NPTS), X(NPTS), YMIN(18), YMAX(18)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number for GLSNET message file
C     NPTS   - space allocated for possible number of pairs
C     N      - actual number of pairs to plot
C     NYRS   - number of years for analysis
C     Y      - data to plot
C     X      - data to plot
C     YMIN   - minimum value
C     YMAX   - maximum value
C     ALPHA  - parameter selected by the user for the relation
C     THETA  - parameter selected by the user for the realtion
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   LEN, SGRP, SCLU, LOC, L3, L4, L6, WHICH(6), YTYPE(2), 
     $          L40, L240, L2, L1, JUST, RESP, TICS(4), I, OLEN, LOC2, 
     $          XTYPE, CPR, CTYPE(18), SYMBL(18), LNTYP(18), NCRV, IRET,
     $          NVAR, RETCOD, NCHR, PATTRN(18), COLOR(18), TRANSF(18), 
     $          BVALFG(4), L19,  IND, DEVCOD, DEVTYP, WSID, 
     $          IWAIT, ICLOS, L5, CHKTYP, ICHK(7), WNDFLG, GMOD
Ckmf  add cmptyp
      INTEGER   CMPTYP
      REAL      R1, D1, RMIN, XD(3), XDIF, ALEN, FYT, FXT, PLMN(4), 
     $          PLMX(4),  SIZEL, XLEN, YLEN,           XVAR(20), 
     $          YVAR(20), YSET
      CHARACTER*1  TXTN(80), BLNK, CTXT(120), YLABL(80), YXLABL(80), 
     $             TITL(240), YALABL(80), LBV(20, 18),  LBC(20, 18)
      CHARACTER*8  WNAM(2)
      LOGICAL      CURVE1
C
C     + + + INTRINSICS + + +
      INTRINSIC   ALOG, REAL
C
C     + + + EXTERNALS + + +
      EXTERNAL   ANPRGT, GPDEVC, PSTUPW, PLTONE, PDNPLT, GGXYLN, GGLSIZ
      EXTERNAL   SCALIT, GPDATR, GPLABL, GPCURV, GPWCXY, GPLBXB, GGDVTY
      EXTERNAL   GPSCLE, GPVAR, GPTEXT, DOPLOT, GPNCRV, GPINIT
      EXTERNAL   Q1EDIT, Q1INIT, QGETRB, QGTCOB, QSETRB, GETTXT
      EXTERNAL   CHRCHR, DECCHR, INTCHR, ZIPC
C
C     + + + INPUT FORMATS + + +
C1000 FORMAT(2X,130A1)
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  BLNK, LBV,     LBC,     YALABL, WNAM
     $    /  ' ', 360*' ', 360*' ', 80*' ', 'Process','GP' /
      DATA  ALEN, TRANSF, BVALFG, TICS,        ICHK
     $    /    0,   18*1,    4*1, 10,10,10,10, 1,2,1,1,1,1,1 /
      DATA  L1, L2, L3, L4, L5, L6, L19, L40, L240, SCLU
     $    /  1,  2,  3,  4,  5,  6,  19,  40,  240,  106 /
C                   points  dash  point
      DATA  CTYPE  /   6,     6,    6,   15*0 /
      DATA  LNTYP  /   0,     2,    0,   15*0 /
      DATA  COLOR  /   1,     1,    2,   15*0 /
      DATA  PATTRN /   1,     1,    0,   15*0 /
      DATA  SYMBL  /   4,     0,    3,   15*0 /
C
C    + + + END SPECIFICATIONS + + +
C
      RMIN = 0.1
      D1 = YMIN(2) * 0.67 + YMAX(2) * 0.33
      YSET = YMIN(1)
      IF (YSET .LT. 0.01) YSET = 0.01
      R1 = YSET + 0.3*(YMAX(1) - YSET)
      RMIN = R1 * 0.5
      GMOD = 1
      RESP = 1
      CURVE1 = .TRUE.
C
      CALL GPINIT
C
C     first time thru, not plot curve
C     not special case
      NCRV = 1
      NVAR = 2
      CALL GPNCRV (NCRV, NVAR)
      WHICH(1) = 1
      WHICH(2) = 4
C     standard x-y plot
      CALL GPWCXY (L1,L1,L2)
      LOC = 1
      CALL GPDATR (L1, LOC, N, Y(1), RETCOD)
      LOC = LOC + N
      CALL GPDATR (L2, LOC, N, X(1), RETCOD)
      XTYPE = 1
      YTYPE(1) = 1
      YTYPE(2) = 0
C     set buffer location for 2nd + plots
      LOC2 = LOC + N
C     dist vs cross-correlation
      SGRP = 56
      OLEN = 40
      CALL GETTXT (MESSFL, SCLU, SGRP, OLEN, YXLABL)
      CALL ZIPC (L40, BLNK, YXLABL(41))
      SGRP = 70
      OLEN = 40
      CALL GETTXT (MESSFL, SCLU, SGRP, OLEN, YLABL)
      CALL ZIPC (L40, BLNK, YLABL(41))
      CALL ZIPC (L240, BLNK, TITL(1))
C     Minimum years of concurrent data
Caml  SGRP = 177
Caml  OLEN = 40
Caml  CALL GETTXT (MESSFL,SCLU,SGRP,OLEN,TITL(1))
Caml  JUST = 0
Caml  LOC = OLEN + 2
Caml  CALL INTCHR (NYRS,L2,JUST,OLEN,TITL(LOC))
      PLMN(1) = -0.25
      PLMX(1) = 1.0
      CALL SCALIT (L1, YMIN(2), YMAX(2), PLMN(4), PLMX(4))
      CALL GPCURV (CTYPE, LNTYP, SYMBL, COLOR, PATTRN, LBC)
      CALL GPLBXB (YXLABL)
      CALL GPLABL (XTYPE, YTYPE, ALEN, YLABL, YXLABL, YALABL, TITL)
      CALL GPSCLE (PLMN, PLMX, TICS, BVALFG)
C
C     set device code
Ckmf  IND = 40      revised, March 4, 2004
      DEVTYP = 1
      IND = 39 + DEVTYP
      CALL ANPRGT (IND,DEVCOD)
      CALL GPDEVC (DEVTYP,DEVCOD)
Ckmf  get computer type added March 4, 2004
      IND = 1
      CALL ANPRGT ( IND, CMPTYP )
Ckmf  end March 4, 2004 addition
C
 10   CONTINUE
C       loop for plotting and replotting cross-corr vs dist
C       plot the values
C
        IF (RESP .EQ. 2) THEN
C         add curve to the plot (if 2nd time around)
          NCRV = 3
          NVAR = 6
          CALL GPNCRV (NCRV, NVAR)
          WHICH(1) = 1
          WHICH(2) = 4
          WHICH(3) = 1
          WHICH(4) = 4
          WHICH(5) = 1
          WHICH(6) = 4
          CALL GPWCXY (L2,L3,L4)
          CALL GPWCXY (L3,L5,L6)
C         fill buffer with data (19 line segments)
          XDIF = (YMAX(2) - YMIN(2))/19.0
          DO 20 I = 1,20
            XVAR(I) = YMIN(2) + REAL(I-1)*XDIF
            YVAR(I) = THETA**(XVAR(I)/(ALPHA*XVAR(I)+1.0))
 20       CONTINUE
          CALL GPDATR (L3,LOC2,L19,YVAR(1),RETCOD)
          LOC2 = LOC2 + 19
          CALL GPDATR (L4,LOC2,L19,XVAR(1),RETCOD)
          LOC2 = LOC2 + 19
          CALL GPDATR (L5,LOC2,L1,R1,RETCOD)
          LOC2 = LOC2 + 1
          CALL GPDATR (L6,LOC2,L1,D1,RETCOD)
          IF (CURVE1) THEN
C           1st time curve added to plot, assign curve spec.s 
            CALL GPCURV (CTYPE, LNTYP, SYMBL, COLOR, PATTRN, LBC)
            CURVE1 = .FALSE.
C           write equation on plot
            LEN = 10
            SGRP = 44
            OLEN = 80
            CALL GETTXT (MESSFL, SCLU, SGRP, OLEN, TXTN)
            LOC = 1
            L4 = 4
            L6 = 6
            JUST = 1
            CALL ZIPC (L40, BLNK, CTXT(1))
            CALL CHRCHR (L4, TXTN(1), CTXT(LOC))
            LOC = LOC + L4
            CALL DECCHR (THETA, LEN, JUST, OLEN, CTXT(LOC))
            LOC = LOC + OLEN
            CALL CHRCHR (L6, TXTN(6), CTXT(LOC))
            LOC = LOC + L6
            CALL DECCHR (ALPHA, LEN, JUST, OLEN, CTXT(LOC))
            LOC = LOC + OLEN
            CALL CHRCHR (L6, TXTN(13), CTXT(LOC))
            CALL CHRCHR (L40, TXTN(41), CTXT(41))
            CALL GGXYLN (XLEN, YLEN)
            CALL GGLSIZ (SIZEL)
            FYT = (YLEN - 3.0 * SIZEL) / YLEN
            FXT = (XLEN - 30.0 * SIZEL) / XLEN
            CPR = 40
            NCHR = 80
            CALL GPTEXT (NCHR, CPR, FYT, FXT, CTXT)
          END IF
        END IF
C
        CALL GPVAR (YMIN, YMAX, WHICH, TRANSF, LBV)
C
C       create the plot
Ckmf    March 4, 2004
Ckmf    WSID = DEVTYP
        WSID = 1
        IWAIT = 0
Ckmf    ICLOS = 0
        CALL PSTUPW (WSID, RETCOD)
        CALL PLTONE
Ckmf    add code for closing on PC March 4, 2004
        IF (CMPTYP .EQ. 1) THEN
C         ICLOS = 1
        ELSE
          ICLOS = 0
        END IF
Ckmf    end March 4 addition
        CALL PDNPLT (WSID,ICLOS,IWAIT)
C
C       get RMIN from user, get coordinate from user
C       Do you want to plot the equation? (1-N,2-Y)
        SGRP = 54
        CALL Q1INIT (MESSFL,SCLU,SGRP)
        XD(1) = D1
        XD(2) = R1
        XD(3) = RMIN
        CALL QSETRB (L3, L1, XD)
        CALL Q1EDIT (IRET)
        CALL QGETRB (L3, L1, XD)
        CALL QGTCOB (L1, L1, RESP)
        CALL QGTCOB (L1, L2, GMOD)
        D1 = XD(1)
        R1 = XD(2)
        RMIN = XD(3)
C
C       calculate alpha and theta
        ALPHA = (-ALOG(R1))/(D1*(ALOG(R1)-ALOG(RMIN)))
        THETA = RMIN**ALPHA
C
        IF (GMOD .EQ. 2) THEN
C         user wants to modify graphics--save current device type
          CHKTYP = DEVTYP
          CALL PROPLT (MESSFL, ICHK, WNAM, WNDFLG)
C         see if user changed device
          CALL GGDVTY (DEVTYP)
          IF (CHKTYP .NE. DEVTYP) THEN
Ckmf        March 4, 2002
Ckmf        close the current device
            IWAIT = 0
Ckmf        end March 4 addition
            ICLOS = 1
            CALL PDNPLT (CHKTYP, ICLOS, IWAIT)
          END IF
          
C         in case user confused make sure to replot 
          RESP = 2
        END IF
C
      IF (RESP .EQ. 2) GO TO 10
C
C     close workstation
      ICLOS = 1
      CALL PDNPLT (WSID,ICLOS,IWAIT)
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDATGT
     I                    (WDMSFL, NSITES, NCODES, CODES, ILOW, NMPAR,
     I                     DSNBMX, DSNBUF,
     O                     ATTVAL, IBD, BADDSN, IBDATT, STANO, ERRCOD)
C
C     + + + PURPOSE + + +
C     This routine gets values of pre-selected attributes from the
C     users WDM file and put them in a buffer.
C
C     + + + PARAMETERS + + +
      INCLUDE 'pglsiz.inc'
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER      WDMSFL, NSITES, NCODES, CODES(NCODES), ILOW, NMPAR,
     $             DSNBMX, DSNBUF(DSNBMX), IBD, BADDSN(DSNBMX), 
     $             IBDATT(NCODES), ERRCOD
      REAL         ATTVAL(MAXPTS, MAXINP)
      CHARACTER*1  STANO(8,NSITES)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     NSITES - number of stations or sites
C     NCODES - number of codes or variables
C     CODES  - index number of variables
C     ILOW   - low-flow flag
C              1 - low flow
C              0 - other
C     NMPAR  - number of partial record data sets (data sets w/o mean
c              or stddev)
C     DSNBMX - size of buffer for dataset numbers
C     DSNBUF - buffer of dataset numbers to use
C     ATTVAL - values for variables (attributes)
C     IBD    - number of datasets in BADDSN buffer which had bad values
C              for an attribute
C     BADDSN - dataset numbers that do not have an attribute
C     IBDATT - bad attribute flag
C              0 - ok
C              1 - bad
C     STANO  - station number for the site
C     ERRCOD - return code
C              0 - ok
C              1 - NSITES>DSNBMX
C              used NSITES = DSNBMX
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      IC, ISTA, L8, I, L20, IZ, JUST, OLEN, 
     $             L16, IBCHK, N, NS, RETCOD, L1
      CHARACTER*1  BLNK,CTMP(16)
C
C     + + + EXTERNALS + + +
      EXTERNAL     WDBSGI, WDBSGC, WDBSGR
      EXTERNAL     CHRCHR, INTCHR, ZIPI, ZIPC
C
C     + + + DATA INITIALIZATION + + +
      DATA  BLNK, L1, L8, L16, L20
     $    /  ' ',  1,  8,  16,  20 /
C
C     + + + END SPECIFICATIONS + + +
C
      IZ = 0
      JUST = 0
      IBCHK = 0
      NS = NSITES
      IF (NS .GT. DSNBMX) THEN
        NS = DSNBMX
        ERRCOD = 1
      ELSE
        ERRCOD = 0
      END IF
C     get the values for the selected variables from wdm attributes
      IBD = 0
      CALL ZIPI (DSNBMX, IZ, BADDSN)
      CALL ZIPI (NCODES, IZ, IBDATT)
      DO 50 I = 1,NS
C       get station id
        IC = 51
        CALL WDBSGI (WDMSFL, DSNBUF(I), IC, L1, ISTA, RETCOD)
        IF (RETCOD .EQ. 0) THEN
C         got id, put in array
          CALL INTCHR (ISTA,L8,JUST,OLEN,STANO(1,I))
        ELSE
C         no integer id, try char string
          IC = 2
          CALL WDBSGC (WDMSFL, DSNBUF(I), IC, L16, CTMP, RETCOD)
          IF (RETCOD .EQ. 0) THEN
C           found it
            CALL CHRCHR (L8,CTMP,STANO(1,I))
          ELSE
C           no station id info
            CALL ZIPC (L8,BLNK,STANO(1,I))
          END IF
        END IF
        IBCHK = 0
        DO 30 N = 1, NCODES
C         get attribute
          CALL WDBSGR (WDMSFL, DSNBUF(I), CODES(N), L1,
     O                 ATTVAL(I,N), RETCOD)
          IF (RETCOD.NE.0 .AND. 
     $       .NOT.(ILOW.EQ.1 .AND. I.GT.NSITES-NMPAR)) THEN
            IF (IBCHK .EQ. 0) THEN
              IBD = IBD + 1
C             new bad dataset
              BADDSN(IBD) = DSNBUF(I)
              IBCHK = 1
            END IF
            IBDATT(N) = 1
          END IF
 30     CONTINUE
 50   CONTINUE
C
      RETURN
      END
C
C
C
      SUBROUTINE   VWDATA
     I                    (MESSFL, SCLU, NCODES, NROW,
     I                     MAXINP, MAXPTS,  XLABS, Z)
C
C     + + + PURPOSE + + +
C     This routine displays the data to be used in the GLS
C     analysis to an AIDE screen.
C
C     + + + DUMMY ARGUMENTS + + + 
      INTEGER   MESSFL, SCLU, NCODES, NROW, MAXINP, MAXPTS
      CHARACTER*1 XLABS(8,MAXINP)
      DOUBLE PRECISION Z(MAXPTS,MAXINP)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number for applications message file
C     SCLU   - cluster number on message file
C     NCODES - number of dependent and explanatory variables
C     NROW   - number of rows in the Z array
C     MAXINP - maximum number of independent and dependent variables
C     MAXPTS - maximum number of cases (stations)
C     XLABS  - labels for the variables
C     Z      - data to be shown   
C     
C     + + + LOCAL VARIABLES + + + 
      INTEGER      AGAIN, I, INIT, IWRT, IRET, LOC, COLWID, LEN,
     $             L78, IROW, JUST, OLEN, ISCREN, NCOL,
     $             CMD, INO, IYES, N1, N2, SGRP, FORL, L4, L8
      REAL         X
      CHARACTER*1  BUFF(78), HEADER(78), BLNK
      CHARACTER*48 WNDNAM
C
C     + + + FUNCTIONS + + +
      INTEGER      LENSTR
C
C     + + + INTRINSICS + + + 
      INTRINSIC    REAL
C
C     + + + EXTERNALS + + +
      EXTERNAL     ZBLDWR, ZSTCMA, ZGTRET, ZWNSET
      EXTERNAL     CHRCHR, ZIPC, DECCHR, INTCHR, LENSTR
C 
C     + + + END SPECIFICATIONS + + +
C
C     turn on prev
      IYES = 1
      INO = 0
      CMD = 4
      CALL ZSTCMA (CMD,IYES)
C     set window name
      WNDNAM = 'View (GPV)'
      CALL ZWNSET (WNDNAM)
C
      IF (NCODES .GT. 10) THEN
C       too many columns, first or last set?
        SGRP = 174
        CALL QRESP (MESSFL, SCLU, SGRP, FORL)
        IF (FORL .EQ. 1) THEN
C         first set
          NCOL = (NCODES+1)/2
          N1 = 1
          N2 = NCOL
        ELSE
          NCOL = NCODES/2
          N1 = NCODES + 1 - NCOL
          N2 = NCODES
        END IF
      ELSE
C       all columns fit
        NCOL = NCODES
        N1 = 1
        N2 = NCODES
      END IF
C
C     get return code
      CALL ZGTRET (IRET)
      IF (IRET .EQ. 1) THEN
C       not prev so continue
        IF (NCOL .EQ. 1) THEN
          COLWID = 40
        ELSE IF (NCOL .EQ. 2) THEN
          COLWID = 25
        ELSE
          COLWID = 74/NCOL
        END IF
        L4 = 4
        L78 = 78
        L8 = 8
        BLNK = ' '
        JUST = 0
C
C       build header line
        CALL ZIPC (L78,BLNK,HEADER)
C       determine space between columns
        LOC = 5     
        DO 10 I = N1,N2 
          LEN = LENSTR (L8,XLABS(1,I))
          LOC = LOC + COLWID - LEN
          CALL CHRCHR (LEN, XLABS(1,I), HEADER(LOC))
          LOC = LOC + LEN 
 10     CONTINUE
C
C       make intrpt available, but not help
        CMD = 16  
        CALL ZSTCMA (CMD,IYES)
        CMD = 1
        CALL ZSTCMA (CMD,INO)

        IROW = 1       
 15     CONTINUE
C         write header
          IWRT = 1
          INIT = 1
          CALL ZBLDWR (L78,HEADER,INIT,IWRT,IRET) 
          INIT = 0 
          ISCREN = 1
C         loop to write 14 rows
 20       CONTINUE
            LOC = 1
            CALL ZIPC (L78,BLNK,BUFF)
C           put row number on screen
            CALL INTCHR (IROW,L4,JUST,OLEN,BUFF(LOC)) 
            LOC = LOC + 4
            DO 30 I = N1,N2  
              X = REAL(Z(IROW,I))
              CALL DECCHR (X,COLWID,JUST,OLEN,BUFF(LOC))
              LOC = LOC + COLWID
 30         CONTINUE
C       
C           write the line
            IF (ISCREN.EQ.14 .OR. IROW.EQ.NROW) THEN
C             set flag to wait for user response
              IWRT = 0
            END IF
            CALL ZBLDWR (L78,BUFF,INIT,IWRT,IRET)  
            IROW = IROW + 1
            ISCREN = ISCREN + 1
          IF (ISCREN .LE. 14 .AND. IROW .LE. NROW) GO TO 20
C
          AGAIN = 0
          IF (IRET .EQ. 1) THEN
            IF (IROW .LE. NROW) AGAIN = 1
          ELSE IF (IRET .EQ. 2) THEN
            IROW = IROW - (ISCREN-1) - 14
            IF (IROW .GE. 1) AGAIN = 1
          END IF
C
        IF (AGAIN .EQ. 1) GO TO 15
      END IF

C     make prev, intrpt unavailable, and help available
      INO = 0
      CMD = 16
      CALL ZSTCMA (CMD,INO)
      CMD = 4
      CALL ZSTCMA (CMD,INO)
      CMD = 1
      CALL ZSTCMA (CMD,IYES)
C
      RETURN
      END
C
C
C
      SUBROUTINE   STATVR
     I                    ( NCODES, XLBS, OPTN )
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER      NCODES, OPTN
      CHARACTER*1  XLBS(8,NCODES)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     NCODES - number of variables
C     XLBS   - character array of variable names
C     OPTN   - display option
C              1 - variable names with index number
C              2 - variable names
C              3 - variables to be plotted
C
C     + + + LOCAL VARIABLES + + +
      INTEGER       I, K
      CHARACTER*312 PRTROW
C
C     + + + EXTERNALS + + +
      EXTERNAL   ZSTADD
C
C     + + + OUTPUT FORMATS + + +
 2001 FORMAT ( 20( I3, 2X, 8A1 ) )
 2002 FORMAT ( 5X, 7( 8A1, 1X ), 16X, 7( 8A1, 1X ), 16X, 7( 8A1, 1X ) )
 2003 FORMAT ( ' Input variables that can be plotted:', 40X,
     $         5X, 7( 8A1, 1X ), 16X, 7( 8A1, 1X ), 16X, 7( 8A1, 1X ) )
C
C     + + + END SPECIFICATIONS + + +
C
      PRTROW = ' '
C
      IF (OPTN .EQ. 1) THEN
C       display variable names with index number
        WRITE (PRTROW,2001)
     $        ( I, ( XLBS(K,I), K = 1, 8 ), I = 1, NCODES )
      ELSE IF (OPTN .EQ. 2) THEN
C       display variable names
        WRITE (PRTROW,2002)
     $        ( ( XLBS(K,I), K = 1, 8 ), I = 1, NCODES )
      ELSE IF (OPTN .EQ. 3) THEN
C       display variable names that can be plotted
        WRITE (PRTROW,2003)
     $        ( ( XLBS(K,I), K = 1, 8 ), I = 1, NCODES )
      END IF
C
      K = 0
      DO 100 I = 1, 235, 78
C       put text in status window
        K = K + 1
        CALL ZSTADD ( K, PRTROW(I:I+77) )
 100  CONTINUE
C
      RETURN
      END
