C
C
C
      SUBROUTINE   PCGLS
     I                   ( OPT, DESCR )
C
C     + + + PURPOSE + + +
C     Print elements from common block cgls
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER      OPT
      CHARACTER*20 DESCR
C
C     + + + ARGUMENT DEFINITIONS + + +
C     OPT    - print options
C              1 - integer variables
C              2 - real and selected double precision
C              3 - additional double precision
C              9 - all
C
C     + + + PARAMETERS + + +
      INCLUDE 'pglsiz.inc'
C
C     + + + COMMONS + + +
      INCLUDE 'cgls.inc'
C
C     + + + SAVES + + +
      INTEGER   OT
      SAVE      OT
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I, J, K
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT (  '***********************************************',
     $        /, '*** ',
     $        /, '*** common block cgls',
     $        /, '***           in ', a,
     $        /, '***          opt =', i5,
     $        /, '*** ' )
 2100 FORMAT (   '***     maxinp =', i8,
     $        /, '***     maxpts =', i8,
     $        /, '***     numpar =', i8,
     $        /, '***     nsites =', i8,
     $        /, '***         nv =', i8,
     $        /, '***       nexp =', i8,
     $        /, '***       ilow =', i8,
     $        /, '***        iys =', i8,
     $        /, '***' )
 2101 FORMAT (   '***    i   xlabs     ylabs        icol',
     $        /, '*** ----  --------  --------  --------',
     $        /,('***', i5, 2x, 8a1, 2x, 8a1, i10 ) )
 2102 FORMAT (   '*** stano(8,maxpts):',
     $        /, '*** -------- -------- -------- -------- -------- ',
     $           '-------- -------- -------- -------- --------',
     $        /,('*** ', 8a1, 1x, 8a1, 1x, 8a1, 1x, 8a1, 1x, 8a1, 1x,
     $            8a1, 1x, 8a1, 1x, 8a1, 1x, 8a1, 1x, 8a1) )
 2103 FORMAT (/, '*** mcon(maxpts,maxpts):',
     $        /, '*** --', 15('  -------') )
 2104 FORMAT (    i6, 15i9,
     $        /, (6x, 15i9 ) )
 2200 FORMAT (   '***      hard2 =', g16.4,
     $        /, '***      avgsk =', g16.4,
     $        /, '***     sressq =', g16.4,
     $        /, '***     gamasq =', g16.4,
     $        /, '***     sigam2 =', g16.4,
     $        /, '***         aj =', g16.4,
     $        /, '***     recinv =', g16.4,
     $        /, '***' )
 2201 FORMAT (/, '         asku    xmeans      xsig    sigols',
     $           '      ak         e        et       ys(1)',
     $           '     ys(2)     ys(3)      dlat      dlng  ',
     $        /, ( i6, 12G10.4 ) )
 2410 FORMAT (/, '*** ', a,
     $        /, '*** --  ----------  ----------  ----------',
     $           ' ----------  ----------  ----------  ----------',
     $           ' ----------  ----------  ----------' )
 2411 FORMAT (    i6, 10G12.4,
     $        /, (6x, 10g12.4 ) )
 2412 FORMAT (    6x, 10g12.4   )
 2413 FORMAT (    i6, 10G12.4 )


C---+----1----+----2----+----3----+----4----+----5----+----6----+----7--
 2202 FORMAT ( //, '****',
     $          /, '****',
     $          /, '**** sta array',
     $          /, 5x, 20i8,
     $          /, (i5, 20f8.1) )
C
C     + + + DATA INTITIALIZATIONS + + +
      DATA   OT  / -98 /
C
C     + + + END SPECIFICATIONS + + +
C
      IF (OT .LT. 0) THEN
C       first time here, open output file
        OT = -OT
        OPEN ( UNIT = OT,
     $         FILE = 'cgls.err',
     $       STATUS = 'UNKNOWN' )
      END IF
      WRITE (OT,2000) DESCR, OPT
C
      IF (OPT .EQ. 1  .OR.  OPT .EQ. 9) THEN
        WRITE (OT,2100) MAXINP, MAXPTS, NUMPAR, NSITES, NV,
     $                   NEXP, ILOW, IYS
        WRITE (OT,2101) ( I, (XLABS(J,I),J=1,8),
     $                        (YLABS(J,I),J=1,8), ICOL(I),
     $                     I = 1, MAXINP )
        IF (NSITES .GT. 0) THEN
          WRITE (OT,2102) ( ( STANO(J,I),J=1,8), I = 1, NSITES )
          WRITE (OT,2103)
          DO 100 I = 1, NSITES+1
            WRITE (OT,2104) I, ( MCON(I,J), J = 1, NSITES+1)
 100      CONTINUE
        END IF
      END IF
C
      IF (OPT .EQ. 2  .OR.  OPT .EQ. 9) THEN
        WRITE (OT,2200) HARD2, AVGSK, SRESSQ, GAMASQ, SIGAM2, AJ,
     $                   RECINV
        WRITE (OT,2201) ( K, ASKU(K), XMEANS(K), XSIG(K,1),
     $                     SIGOLS(K), AK(K), E(K,1),
     $                     ET(1,K), (YS(K,J),J=1,3),
     $                     DLAT(K), DLNG(K), K = 1, NSITES )
      END IF
      IF (OPT .EQ. 3  .OR.  OPT .EQ. 9) THEN
        WRITE (OT,2410) 'x(maxpts,maxvar):'
        DO 310 I = 1, NEXP+1
          WRITE (OT,2411) I, ( X(J,I), J = 1, MAXVAR )
 310    CONTINUE
        WRITE (OT,2410) 'bhat(maxvar,1)'
        WRITE (OT,2412) ( BHAT(K,1), K = 1, MAXVAR )
      END IF
C
      IF (OPT .EQ. 4  .OR.  OPT .EQ. 9) THEN
        WRITE (OT,2410) 'xtxinv(maxvar,maxvar):'
        DO 400 I = 1, MAXVAR
          WRITE (OT,2413) I, (XTXINV(I,J), J = 1, MAXVAR)
 400    CONTINUE
        IF (NSITES .GT. 0) THEN
          WRITE (OT,2410) 'xt(maxvar,maxpts):    '
          DO 401 I = 1, NSITES+1
            WRITE (OT,2411)  I, (XT(J,I), J = 1, MAXVAR)
 401      CONTINUE
          WRITE (OT,2410) 'z(maxpts,maxinp):     '
          DO 405 I = 1, NSITES+1
            WRITE (OT,2411) I, ( Z(I,J), J = 1, MAXINP)
 405      CONTINUE
          WRITE (OT,2410) 'cov(maxpts, maxpts):  '
          DO 410 I = 1, NSITES+1
            WRITE (OT,2411) I, (COV(I,J), J = 1, NSITES+1)
 410      CONTINUE
          WRITE (OT,2410) 'covinv(maxpts,maxpts):'
          DO 415 I = 1, NSITES+1
            WRITE (OT,2411) I, (COVINV(I,J), J = 1, NSITES+1)
 415      CONTINUE
          WRITE (OT,2410) 'sta(maxpts,maxpts):   '
          DO 420 I = 1, NSITES+1
            WRITE (OT,2411) I, (STA(I,J), J = 1, NSITES+1)
 420      CONTINUE
          WRITE (OT,2410) 'rhoc(maxpts,maxpts):  '
          DO 425 I = 1, NSITES+1
            WRITE (OT,2411) I, (RHOC(I,J), J = 1, NSITES+1)
 425      CONTINUE
        END IF
      END IF
c                           ----+----1----+----2
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7--
C
      RETURN
      END
