C
C
C
      SUBROUTINE   PROGLS
     I                    (MESSFL,WDMSFL,ERRFL,VERSN)
C
C     + + + PURPOSE + + +
C     This routine calls all the routines for Generalized Least Squares
C     analysis.
C
C     + + + KEYWORDS + + +
C     message file
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, WDMSFL, ERRFL
      CHARACTER*64 VERSN
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     SMESFL - Fortran unit number of data wdm file
C     ERRFL  - Fortran unit number of output error file
C     VERSN  - current version number and date of program
C
C     + + + LOCAL VARIABLES + + +
      INTEGER        DEL,DONEFG,RETCOD,SCLU,SGRP,GOPT,
     &          IANS,FNET,FINV,FINC,FIN8,FOUT,INFLG,OTFLG,  IRET,
     &          EFLG1,EFLG2,EFLG3,EFLG4,EFLG1A,EFLG2A,EFLG3A
      REAL     ALPHA, THETA
C
C     + + + EXTERNALS + + +
      EXTERNAL   PRNTXT, QRESP, QFOPEN, SIVLOD, WIVLOD, WCRLOD
      EXTERNAL   SCRLOD, WCCLOD, SCCLOD, GLSCAL, QFCLOS, VARDMP
C
C     + + + END SPECIFICATIONS + + +
C
      ALPHA = -999.
      THETA = -999.
      DONEFG = 0
      SCLU = 106
      IANS = 1
      INFLG = 0
      OTFLG = 0
      EFLG1 = -1
      EFLG2 = -1
      EFLG3 = -1
      EFLG4 = -1
      EFLG1A = -1
      EFLG2A = -1
      EFLG3A = -1
C
 10   CONTINUE
C
C       options:  1-Process wdm, 2-Save processed data to file
C                 3-Open processed data file, 4-open GLS print file
C                 5-Open network print file, 6-Execute GLS, 7-Return
        SGRP = 1
        CALL QRESP(MESSFL,SCLU,SGRP,GOPT)
C
C     ------------------------------------------ gopt = 1 - wdm
        IF (GOPT .EQ. 1) THEN
          IF (WDMSFL .EQ. 0) THEN
C           must open WDM file first
            SGRP = 2
            CALL PRNTXT (MESSFL, SCLU, SGRP)
            GOPT = 7
          ELSE
C           develop input from WDM file
            CALL WIVLOD (MESSFL,WDMSFL,DONEFG)
            IF (DONEFG .EQ. 1) THEN
C             compute from WDM file
C             concurrent record from WDM file.
              CALL WCRLOD (MESSFL,WDMSFL,IRET)
              IF (IRET .EQ. 1) THEN
C               cross-correlation from WDM file.
                CALL WCCLOD (MESSFL, WDMSFL, ALPHA, THETA, IRET)
                IF (IRET .EQ. 1) INFLG = 1
              END IF
            END IF
          END IF
C
C     ------------------------------------------ gopt = 2 - save
        ELSE IF (GOPT .EQ. 2) THEN
C         create sequential files of input
          IF (INFLG .EQ. 0) THEN
C           must process Input with WDM option first
            SGRP = 159
            CALL PRNTXT (MESSFL, SCLU, SGRP)
            GOPT = 1
          ELSE
C           create three files
C           write ASCII sequential files of input
              CALL VARDMP (MESSFL)
            GOPT = 4
          END IF
C
C     ------------------------------------------ gopt = 3 - open
        ELSE IF (GOPT .EQ. 3) THEN
C         input from sequential file
C         Name of file with variables?
          SGRP = 144
          CALL QFOPEN (MESSFL, SCLU, SGRP, FINV, EFLG1)
          IF (EFLG1 .EQ. 0) THEN
            CALL SIVLOD (MESSFL,FINV,EFLG1A)
            IF (EFLG1A .EQ. 0) THEN
C             name of file for concurrent record
              SGRP = 143
              CALL QFOPEN (MESSFL, SCLU, SGRP, FIN8, EFLG2)
              IF (EFLG2 .EQ. 0) THEN
                CALL SCRLOD (MESSFL,FIN8,EFLG2A)
C               cross-correlation from sequential file
                SGRP = 142
                CALL QFOPEN (MESSFL, SCLU, SGRP, FINC, EFLG3)
                IF (EFLG3 .EQ. 0) THEN
                  CALL SCCLOD (FINC,MESSFL,EFLG3A)
                  INFLG =1
                END IF
              END IF
            END IF
            GOPT = 4
          END IF
C
C     ------------------------------------------ gopt = 4 - gls print file
        ELSE IF (GOPT .EQ. 4) THEN
C         Name of output file
          SGRP = 140
          CALL QFOPEN (MESSFL, SCLU, SGRP, FOUT, RETCOD)
          IF (RETCOD .EQ. 0) OTFLG = 1
          GOPT = 6
C
C     ------------------------------------------ gopt = 5 - network print file
        ELSE IF (GOPT .EQ. 5) THEN
C         file name
          SGRP = 141
          CALL QFOPEN (MESSFL, SCLU, SGRP, FNET, EFLG4)
          IANS = 2
          IF (EFLG4 .NE. 0) IANS = 1
          GOPT = 6
C
C     ------------------------------------------ gopt = 6 - execute
        ELSE IF (GOPT .EQ. 6) THEN
          IF (INFLG .EQ. 0) THEN
C           can't analyze until input option successfully completed.
            SGRP = 48
            CALL PRNTXT (MESSFL, SCLU, SGRP)
            GOPT = 3
          ELSE IF (OTFLG .EQ. 0) THEN
C           can't analyze until output file successfully opened.
            SGRP = 49
            CALL PRNTXT (MESSFL, SCLU, SGRP)
            GOPT = 4
          ELSE
C           run generalized least squares
            CALL GLSCAL (FNET, MESSFL, IANS, FOUT,
     I                   ALPHA, THETA, VERSN)
C           Process complete
            SGRP = 98
            CALL PRNTXT (MESSFL, SCLU, SGRP)
C           reinitialize
            IF (IANS .EQ. 2) CALL QFCLOS (FNET,DEL)
            IF (EFLG1 .EQ. 0) CALL QFCLOS (FINV,DEL)
            IF (EFLG3 .EQ. 0) CALL QFCLOS (FINC,DEL)
            IF (EFLG2 .EQ. 0) CALL QFCLOS (FIN8,DEL)
            IF (EFLG4 .EQ. 0) CALL QFCLOS (FOUT, DEL)
            IANS = 1
            INFLG = 0
            OTFLG = 0
            EFLG1 = -1
            EFLG2 = -1
            EFLG3 = -1
            EFLG4 = -1
            EFLG1A = -1
            EFLG2A = -1
            EFLG3A = -1
          END IF
        END IF
      IF (GOPT .NE. 7) GO TO 10
C
C     close all files used
      DEL = 0
      IF (IANS .EQ. 2) CALL QFCLOS (FNET,DEL)
      IF (EFLG1 .EQ. 0) CALL QFCLOS (FINV,DEL)
      IF (EFLG3 .EQ. 0) CALL QFCLOS (FINC,DEL)
      IF (EFLG2 .EQ. 0) CALL QFCLOS (FIN8,DEL)
      IF (EFLG4 .EQ. 0) CALL QFCLOS (FOUT, DEL)
C
      RETURN
      END
C
C
C
      SUBROUTINE   VARDMP
     I                    ( MESSFL )
C
C     + + + PURPOSE + + +
C     This routine writes sequential files of matrices calculated
C     from the WDM file.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL
C
C     + + + KEYWORDS + + +
C     message file
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of GLSNET message file
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'pglsiz.inc'
      INCLUDE 'cgls.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I, J, FO(3), SGRP, SCLU, DELFG, IOS, IOSK(2),
     $          IRET, AGAIN, L2, L3
      CHARACTER*64 FLNAME(3)
C
C     + + + EXTERNALS + + +
      EXTERNAL   Q1INIT, QSETFN, QSETI, Q1EDIT, QGETF, PRNTXT
      EXTERNAL   QFCLOS
C
C     + + + OUTPUT FORMATS + + +
 2001 FORMAT (8A1,25E13.5)
 2002 FORMAT (20I4)
 2003 FORMAT (20F4.2)
C
C     + + + DATA INTITIALIZATION
      DATA  FLNAME
     $     / 'variable.txt', 'ConRec.txt', 'CrsCor.txt' /
C
C     + + + END SPECIFICATIONS + + +
C
      L2   = 2
      L3   = 3
      SCLU = 106
C
 100  CONTINUE
        SGRP = 146
        CALL Q1INIT ( MESSFL, SCLU, SGRP )
        CALL QSETFN ( L3, FLNAME )
        CALL Q1EDIT ( IRET )
        IF (IRET .EQ. 1) THEN
C         Accept, continue
          CALL QGETF ( L3, FO )
          DO 200 I = 1, NSITES
C           stations and variable values
            WRITE (FO(1),2001) (STANO(J,I),J=1,8),(Z(I,J),J=1,NV)
C           concurrent record matrix
            WRITE (FO(2),2002,IOSTAT=IOS) (MCON(I,J),J=1,I)
            IF (IOS .GT. 0) IOSK(1) = IOSK(1) + 1
C           cross-correlation matrix
            WRITE (FO(3),2003,IOSTAT=IOS) (RHOC(I,J),J=1,I)
            IF (IOS .GT. 0) IOSK(2) = IOSK(2) + 1
 200      CONTINUE
          IF (IOSK(1) .GT. 0  .OR.  IOSK(2) .GT. 0) THEN
C           error writing concurrent record or cross-correlation
            SCLU = 147
            CALL Q1INIT ( MESSFL, SCLU, SGRP )
            CALL QSETI ( L2, IOSK )
            CALL Q1EDIT (IRET )
          END IF
          AGAIN = 0
        ELSE IF (IRET .EQ. -1) THEN
C         oops, try again
          AGAIN = 1
        ELSE
C         assume Prev or Intrpt
C         file(s) not opened, data not written
          SGRP = 148
          CALL PRNTXT (MESSFL, SCLU, SGRP)
          AGAIN = 0
        END IF
      IF (AGAIN .EQ. 1) GO TO 100
C
C     close files and free units
      DO 300 I = 1, L3
        DELFG = 0
        IF (FO(I) .GT. 0) THEN
          CALL QFCLOS ( FO(I), DELFG )
        END IF
 300  CONTINUE
C
      RETURN
      END
