C
C
C
      SUBROUTINE   PRONET
     I                    (MESSFL, VERSN)
C
C     This routine gets data from the user and user's file and calls
C     routines for analysis and final output and plotting.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL
      CHARACTER*64 VERSN
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of GLSNET message file
C     VERSN  - current version number and date of program
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cntwrk.inc'
C
C     + + + LOCAL VARIABLES + + +
      REAL       KP, KQ, KSKEW,LATDIF,LNGDIF,PLOT(MXS,2),DIST,
     &           LATAVE,OP1,OP2,OP3,A,E2, RVAL(2)
      DOUBLE PRECISION   WORK(MXS,MXV), WORK1(MXV,1), WORK2(MXV,MXS),
     &                   STCOST,  BUDGET, DERMIN, DDIST,
     &                   DET, RHAT, SIGME, SUM, SUM1, SUM2, TRACE,
     &                   ALPHA, THETA, RADIAN, R0, ADD, D1,
     $                   XSAVE(MXS,MXV), SUMMIN, RECL,DFAC
Ckmf $                                          , X2(MXS,MXV),
Ckmf &                   XT2(MXV,MXS), DINV(MXS,MXS),
Ckmf &                   X2X(MXV,MXV), X2XINV(MXV,MXV)
      INTEGER   ISAVE(MXS), FI, FO, FT, I, IFLG, II, IHAVE, L0, L1, L,
     &          IPH, ISTEP, ISV, J, K, NNEW, NOLD, SCLU, SGRP,
     &          RTNCOD, RESPI, OPT, L2, IRET, MXL, SCNFG, IWRT, LNCT,
     &          NCT, ICOLS(MXV), ICOLT(MXV), NCS, STAOPT, IVAL(3),
     &          MAXP, IDX, KPART, KPARS, STOPFG, DELFG, OUTFLG, INFLG,
     &          INUM, NTE, ITEST
      CHARACTER*1  STAT(8),DISCON(8,MXS)
C
C     + + + FUNCTIONS + + +
      REAL     GAUSEX, WILFRT
C
C     + + + INTRINSICS + + +
      INTRINSIC   DEXP, DSQRT, SNGL, ABS, SIN, COS, DBLE, SQRT
C
C     + + + EXTERNALS + + +
      EXTERNAL   ZIPD, QFOPEN, QRESP, QRESPI, MULTPY, ZIPI
      EXTERNAL   PLTCST, COVMTX, INVERT, GAUSEX, WILFRT, NETINP
      EXTERNAL   PRNTXI, GSTCON, GNUDAT, QFCLOS, PRNTXT
      EXTERNAL   Q1EDIT, Q1INIT, QGETRB, PMXTXI, PMXCNW
C
C     + + + DATA INITIALIZATION + + +
      DATA  L0, L1, L2,  R0, STAT
     $     / 0,  1,  2, 0.0, ' ',' ','N','O','N','E',' ',' ' /
C
C     + + + OUTPUT FORMATS + + +
C2005 FORMAT(' AVERAGE SAMPLING ERROR = ',F12.5)
C2006 FORMAT(2X,8A1,2X,F13.5,6X,F13.5)
C2007 FORMAT(T3,'STATION',T13,'SAMPLING ERROR',T33,' HAT DIAGONAL')
C2009 FORMAT(' AVERAGE SAMPLING ERROR OVER OLD STATIONS = ',F12.5)
C2011 FORMAT(//,' STATION',T11,' REC. LENGTH',T28,' CODE',T38,
C    1 ' 1000(dJ/dN)/COST',T60,'  COST IN PLANNING HORIZON',/)
 2020 FORMAT(2X,8A1,6X,I4,9X,I1,8X,G13.5,10X,F10.0)
 2030 FORMAT(2X,I3,7X,8A1,1X,G14.5,5X,F10.0,10X,I5)
 2039 FORMAT(//11X,A38//
     & ' This program begins with all stations being operated during'/
     & ' a planning horizon and discontinues stations one at a time.'/
     & ' This results in a lower cost for each step and a general'/
     & ' increase in sampling error.'//)
 2040 FORMAT(//,' Planning horizon is ',I3,' years.',//,
     1' Step',
     1T13,'Discontinued',T28,'Average',T46,'Cost',T60,
     2'Number',/,T13,'stations',T28,'sampling',T60,'of',/,
     3T28,'error',T60,'stations',/)
 2041    FORMAT(' The following stations are not eligible to be disconti
     1nued:')
 2042    FORMAT(10(2X,8A1))
C2050 FORMAT(1X,'GENERATE A PLOT.',/,1X,'INPUT DATA.',/,
C    11X,'"SAMERR"')
C2051 FORMAT(1X,F10.0,5X,F10.5)
C2052 FORMAT(1X,'END OF DATA.',/,1X,'X AXIS LABEL "COST".',
C    1/,1X,'CURVE 1 STRAIGHT.',
C    1/,1X,'CURVE 1 SYMBOL COUNT 1.',/,
C    11X,'Y AXIS LABEL "AVERAGE SAMPLING VARIANCE, IN THOUSANDTHS".',
C    1/,1X,'GO.',/,1X,'**FILE**')
C
C     + + + END SPECIFICATIONS + + +
C
      INFLG = -1
      OUTFLG = -1
      IPH = 10
      D1 = 1.0
      SCLU = 107
      CALL ZIPD (MXS*MXV,R0,OMT)
C
 10   CONTINUE
C     main network menu for input, output, parameters, stations, analyze and
C       graphics
      SGRP = 1
      CALL QRESP (MESSFL, SCLU, SGRP, OPT)
C
C     enter name of input file from gls output
      IF (OPT .EQ. 1) THEN
        SGRP = 2
        CALL QFOPEN (MESSFL, SCLU, SGRP, FI, INFLG)
C
        IF (INFLG .EQ. 0) THEN
C         input data from GLS output file
          CALL NETINP (FI, NOLD, ALPHA, THETA, KPARS, KPART,NTE,
     &                 NCS, ICOLS, NCT, ICOLT, SIGME, RHAT, KP,
     &                 INFLG)
          IF (INFLG .NE. 0) THEN
C           error reading input file on line ___
            SGRP = 8
            CALL PRNTXI (MESSFL, SCLU, SGRP, INFLG)
          END IF
C         close file so can reopen again
          DELFG = 0
          CALL QFCLOS (FI, DELFG)
        END IF
C       set force-to-continue flags to no and costs to 1.0
        CALL ZIPI (MXS,L1,ISAVE)
        CALL ZIPD (MXS, D1, COST)
        NNEW = 0
        IHAVE = 0
        NSITES = NOLD
C
      ELSE IF (OPT .EQ. 2) THEN
C       enter name of output file
        SGRP = 3
        CALL QFOPEN (MESSFL, SCLU, SGRP, FO, OUTFLG)
C
      ELSE IF (OPT .EQ. 3) THEN
C       enter planning horizon in years
        SGRP = 4
        CALL QRESPI (MESSFL, SCLU, SGRP, IPH)
C
      ELSE IF (OPT .EQ. 4) THEN
        IF (INFLG .NE. 0) THEN
C         have not opened input file
          SGRP = 32
          CALL PRNTXT (MESSFL,SCLU,SGRP)
        ELSE
 15       CONTINUE
C           old, new stations to identify
            SGRP = 17
            CALL QRESP (MESSFL, SCLU, SGRP, STAOPT)
            IF (STAOPT .EQ. 1) THEN
C             specify stations that must be continued
              CALL GSTCON (MESSFL, NOLD, ISAVE, IHAVE)
            ELSE IF (STAOPT .EQ. 2) THEN
 18           CONTINUE
                IFLG = 0
C               how many proposed sites will be added?
                SGRP = 6
                NNEW = MXS - NOLD
                CALL QRESPI (MESSFL, SCLU, SGRP, NNEW)
                NSITES = NOLD + NNEW
C
                IF (NSITES .GT. MXS) THEN
C                 Program is sized for maximum of __ sites.
C                 Since there are __ existing sites,
C                 only __ sites (or less) may be added.
C                 Contact OSW,USGS if you must add more.
                  SGRP = 9
                  MXL = 10
                  SCNFG = 1
                  IWRT = 0
                  NNEW = MXS - NOLD
                  INUM = 3
                  IVAL(1) = MXS
                  IVAL(2) = NOLD
                  IVAL(3) = NNEW
                  CALL PMXTXI (MESSFL, SCLU, SGRP, MXL, SCNFG, IWRT,
     &                         INUM, IVAL)
                  IFLG = 1
                END IF
              IF (IFLG .EQ. 1) GO TO 18
C
              RESPI = 1
C             check if valid ALPHA/THETA when NNEW > 0
              IF (NNEW .GT. 0 .AND. ALPHA .LT. -998.0) THEN
C               need valid alpha and theta
C               do you have those values
                SGRP = 27
                CALL QRESP (MESSFL, SCLU, SGRP, RESPI)
                IF (RESPI .EQ. 1) THEN
C                 enter alpha and theta
                  SGRP = 28
                  CALL Q1INIT (MESSFL, SCLU, SGRP)
                  CALL Q1EDIT (IRET)
                  CALL QGETRB (L2, L1, RVAL)
                  ALPHA = DBLE(RVAL(1))
                  THETA = DBLE(RVAL(2))
                END IF
              END IF
C
              IF (RESPI .EQ. 1) THEN
                IF (NNEW .GT. 0) THEN
C                 enter data on new sites
                  CALL GNUDAT (MESSFL, NTE, NOLD, NNEW)
                  DO 26 I = NOLD+1,NSITES
                    DO 24 J = 1,I
                      MCON(I,J) = 0
 24                 CONTINUE
 26               CONTINUE
                END IF
              END IF
            END IF
          IF (STAOPT .NE. 3) GO TO 15
        END IF
      ELSE IF (OPT .EQ. 5) THEN
        IF (INFLG .NE. 0) THEN
C         have not successfully opened and read an input file
          SGRP = 18
          CALL PRNTXT (MESSFL, SCLU, SGRP)
        ELSE IF (KPART .GT. 6) THEN
C         too many variables in the t-regression
          SGRP = 26
          CALL PRNTXI (MESSFL, SCLU, SGRP, KPART)
        ELSE IF (OUTFLG .NE. 0) THEN
C         no output file name
          SGRP = 7
          CALL PRNTXT (MESSFL, SCLU, SGRP)
        ELSE
C         do the analysis
C         beginning analysis
          ISTEP = -1
          SGRP = 33
          MXL = 10
          SCNFG = 1
          IWRT = 1
          CALL PMXCNW (MESSFL, SCLU, SGRP, MXL, SCNFG, IWRT, LNCT)
C         compute values from sigma regression data
          DO 30 I=1,NSITES
            X(I,1)=1.0
            DO 28 J = 1,NCS
              X(I,J+1) = EXV(ICOLS(J),I)
 28         CONTINUE
            SUM=0.
            DO 25 J=1,KPARS
              SUM=SUM+X(I,J)*BHAT(J)
 25         CONTINUE
            SIGOLS(I)=DEXP(SUM)
 30       CONTINUE
C
C         fill x-array and x-transpose from EXV buffer
C         for T-yr regression
          DO 40 I=1,NSITES
            X(I,1)=1.0
            XT(1,I)=1.0
            DO 33 J = 1,NCT
              X(I,J+1) = EXV(ICOLT(J),I)
 33         CONTINUE
            DO 35 J=2,KPART
              XT(J,I)=X(I,J)
 35         CONTINUE
 40       CONTINUE
C         following added 09/28/89
          CALL MULTPY (XT,X,KPART,NOLD,KPART,MXV,MXV,MXS,WT)
C
C         compute cross-correlation coefficient for the stations
C         CONVERT TO RADIANS
          RADIAN = 3.14159265/180.0
          A = 6378206.0
          E2 = 0.00676866
C         DO 47 I = 1,NSITES
C           DLAT(I) = DLAT(I)*RADIAN
C           DLNG(I) = DLNG(I)*RADIAN
C47       CONTINUE
C
Ckmf---------------------------------------------------------Note
Ckmf                                                         Note
Ckmf    Should the following be double precision?            Note
Ckmf                                                         Note
Ckmf           RADIAN, A, E2                                 Note
Ckmf           LATDIF, LNGDIF, LATAVE                        Note
Ckmf           OP1, OP2, OP3                                 Note
Ckmf           DIST                                          Note
Ckmf                                                         Note
Ckmf    In WCCLOD,                                           Note
Ckmf                                                         Note
Ckmf         DIST is real from common CDIST                  Note
Ckmf         the other variables are real                    Note
Ckmf                                                         Note
Ckmf    In PRONET,                                           Note
Ckmf                                                         Note
Ckmf         RADIAN is double precision                      Note
Ckmf         DIST is real, but then set to DDIST which is    Note
Ckmf         double precision                                Note
Ckmf         the other variables are real                    Note
Ckmf                                                         Note
Ckmf    Also, in PRONET, DLAT is converted to Single         Note
Ckmf    precision (SNGL) in the computation of LATDIF        Note
Ckmf    and LNGDIF.                                          Note
Ckmf                                                         Note
Ckmf---------------------------------------------------------Note
          IF (NNEW .GT. 0) THEN
C           compute values for new stations
            DO 49 I = NOLD+1,NSITES
              DO 48 J = 1,I
C               compute distance based on lat long
C               COMPUTE DISTANCE BETWEEN STATIONS
                LATDIF = ABS (SNGL(DLAT(I)-DLAT(J))) * RADIAN
                LNGDIF = ABS (SNGL(DLNG(I)-DLNG(J))) * RADIAN
                LATAVE = (DLAT(I)+DLAT(J))*0.5 * RADIAN
                OP1 = A/SQRT(1.0-E2*SIN(LATAVE)**2)
                OP2 = ((1.0-E2)**2*(LATDIF)**2)/((1.0-E2*SIN(LATAVE)
     &                **2)**2)
                OP3 = COS(LATAVE)**2 * LNGDIF**2
                DIST = (OP1*SQRT(OP2+OP3))/1000.0
C               CONVERT TO MILES FROM KILOMETERS
                DDIST = DBLE(DIST/1.609)
C               compute cross correlation
                RHOC(I,J) = THETA**(DDIST/(ALPHA*DDIST+1.0))
 48           CONTINUE
 49         CONTINUE
          END IF
C
          IF(KP.GT.0.)THEN
            KP=1./KP
            KP=GAUSEX(KP)
            DO 80 I=1,NSITES
              KQ=SNGL(ASKU(I))
              KSKEW=WILFRT(KQ,KP,RTNCOD)
              AK(I)=DBLE(KSKEW)
 80         CONTINUE
          ELSE
            DO 78 I=1,NSITES
              AK(I)=0.0
 78         CONTINUE
          END IF
          DO 72 I=1,NSITES
            ICODE(I)=1
C
C           deleted because regression on mean dropped, AMUME not
C           computed and not written to file and not read by NETINP
C           AMOD(I)=AMUME+AK(I)**2*SIGOLS(I)**2*(DEXP(SIGME)-1.)
C    &      +2.0*AK(I)*SIGOLS(I)*RHAT*DSQRT(AMUME)*DSQRT(DEXP(SIGME)-1.)
C
            AMOD(I) = RHAT
 72       CONTINUE
C
C         update concurrent record
          DO 84 I=1,NSITES
Cgt  10/22/97 comment out 82 add mcon(i,i)=mcon(i,i)+iph
Cgt         DO 82 J=1,I
Cgt           MCON(I,J)=MCON(I,J)+ICODE(I)*ICODE(J)*IPH
C82gt       CONTINUE
            MCON(I,I)=MCON(I,I)+IPH
            DO 83 J=1,KPART
              XSAVE(I,J) = X(I,J)
 83         CONTINUE
 84       CONTINUE
          CALL MULTPY(XT,X,KPART,NSITES,KPART,MXV,MXV,MXS,ZTZ)
C
C         write heading
          WRITE(FO,2039) VERSN(6:43)
          IF(IHAVE.EQ.1) THEN
            WRITE(FO,2041)
            II=0
            DO 90 I=1,NSITES
              IF(ISAVE(I).EQ.2) THEN
                II=II+1
                DO 88 J = 1,8
                  DISCON(J,II)=STATN(J,I)
 88             CONTINUE
              END IF
 90         CONTINUE
            WRITE(FO,2042)((DISCON(J,I),J=1,8),I=1,II)
          END IF
          WRITE(FO,2040)IPH
          ISV=0
C
C         begin loop for dropping stations
          K = KPART
          IDX = 0
          ITEST=1
 100      CONTINUE
C           COMPUTE COEFFICIENT MATRIX
            CALL COVMTX
C
C           ADD MODEL ERROR AND INVERT
            DO 112 I=1,NSITES
              COV(I,I)=COV(I,I)+AMOD(I)
 112        CONTINUE
            CALL INVERT(NSITES,MXS,COV,L0,FO,DET,COVINV)
C
C           COMPUTE SAMPLE ERROR AND HAT MATRIX
            SUM=0.
            SUM1=0.
C           WRITE(FO,2007)
            CALL MULTPY(COVINV,X,NSITES,NSITES,K,MXS,MXS,MXS,WORK)
            CALL MULTPY(XT,WORK,K,NSITES,K,MXV,MXV,MXS,XTX)
            CALL INVERT(K,MXV,XTX,L0,FO,DET,XTXINV)
            DO 120 I=1, NOLD+NNEW
              DO 115 J = 1, KPART
                XO(1,J)=XSAVE(I,J)
                XTO(J,1)=XSAVE(I,J)
 115          CONTINUE
              CALL MULTPY(XTXINV,XTO,K,K,L1,MXV,MXV,MXV,WORK1)
              CALL MULTPY(XO,WORK1,L1,K,L1,L1,L1,MXV,C)
              SUM=SUM+C(1,1)
              IF (I.LE.NOLD) SUM1=SUM1+C(1,1)
C             WRITE(FO,2006)(STATN(J,I),J=1,8),C(1,1),HAT(I,I)
 120        CONTINUE
            SUM=SUM/(NOLD+NNEW)
            SUM1=SUM1/NOLD
            IF(ITEST.EQ.1) SUMMIN=SUM 
Cgt 10/22/97 comment out next line
Cgt         SUM=DMAX1(SUM,SUMMIN)
            SUMMIN=SUM
            ITEST=0
C
C           write out final record lengths for this strategy
            BUDGET=0.
            DO 145 I=1,NSITES
              BUDGET=BUDGET+COST(I)*ICODE(I)
C             WRITE(FO,2020)(STATN(J,I),J=1,8), MCON(I,I), ICODE(I),
C    &                      DER(I), COST(I)
C             WRITE(99,2020)(STATN(J,I),J=1,8), MCON(I,I), ICODE(I),
C    &                      DER(I), COST(I)
 145        CONTINUE
            ISTEP=ISTEP+1
            WRITE(FO,2030)ISTEP,  STAT, SUM, BUDGET, NSITES
            SUM2=SUM*1000.
C
C           write progress message to user
            SGRP = 10
            CALL PMXTXI (MESSFL,SCLU,SGRP,MXL,SCNFG,IWRT,L1,ISTEP)
C           set info for plot
            IDX = IDX + 1
            PLOT(IDX,1) = BUDGET
            PLOT(IDX,2) = SUM2
C
C           COMPUTE OMEGA
            CALL MULTPY(X,XTXINV,NSITES,K,K,MXS,MXS,MXV,WORK)
            CALL MULTPY(COVINV,WORK,NSITES,NSITES,K,MXS,MXS,MXS,OMEGA)
C
C           TRANSPOSE
            DO 125 I=1,NSITES
              DO 124 J=1,K
                OMEGAT(J,I)=OMEGA(I,J)
 124          CONTINUE
 125        CONTINUE
C
C           COMPUTE dJ/dN
            ADD = 0.0
            DERMIN=999999.
C           above added 1/23/89
            DO 140 I=1,NSITES
              IF (ISAVE(I) .EQ. 1  .AND.  ICODE(I) .EQ. 1) THEN
C               next 10 lines modified 09/28/89
                DO 135 J = 1,NSITES
                  DO 134 L=1,J
                    IF (L.NE.I .AND. J.NE.I) THEN
C                     element not in ith row or column
                      D(J,L) = 0.0
                    ELSE IF (I.EQ.J  .AND. I.EQ.L) THEN
C                     element is on the diagonal
                      D(J,L) = (COV(J,L)-AMOD(I))*MCON(I,I)
                    ELSE
C                     not on diagonal and not on ith row or column
                      D(J,L) = COV(J,L)*MCON(I,I)
                    END IF
                    D(L,J) = D(J,L)
 134              CONTINUE
 135            CONTINUE
                CALL MULTPY(OMEGAT,D,K,NSITES,NSITES,MXV,MXV,MXS,OMT)
C               end chages for 09/28/89
                CALL MULTPY(OMT,OMEGA,K,NSITES,K,MXV,MXV,MXS,WORK2)
                CALL MULTPY(ZTZ,WORK2,K,K,K,MXV,MXV,MXV,TR)
                TRACE=0.
                DO 136 J=1,K
                TRACE=TRACE+TR(J,J)
 136            CONTINUE
                RECL=FLOAT(MCON(I,I)-IPH)
                DFAC = -1. / (RECL ** 2 + 3.0 * RECL + 2.0)
                DER(I)= TRACE*DFAC
                DO 138 J=1,K
                  OMT(J,I)=0.
 138            CONTINUE
C               find minimum derivative
                STCOST = COST(I)
                IF (STCOST .LE. 0.0) STCOST = 0.01
                DER(I) = ABS(DER(I))/STCOST
                IF (DER(I).LT.DERMIN) THEN
                  DERMIN = DER(I)
                  ISV=I
                END IF
              END IF
 140        CONTINUE
C
            IF (DERMIN.LT. 999998.) THEN
              ICODE(ISV)=0
              DO 151 I = 1,8
                STAT(I) = STATN(I,ISV)
 151          CONTINUE
C             UPDATE MCON ETC.
              IF (ISV.LE.NOLD) THEN
Cgt 10/22/97 comment out next 3 lines
C               DO 152 J=1,ISV-1
C                 MCON(ISV,J)=MCON(ISV,J) - ICODE(J)*IPH
C152            CONTINUE
                MCON(ISV,ISV)=MCON(ISV,ISV)-IPH
Cgt 10/22/97 comment out next 3 lines
C               DO 154 I=ISV+1,NSITES
C                 MCON(I,ISV)=MCON(I,ISV) - ICODE(I)*IPH
C154            CONTINUE
              ELSE
                DO 180 I=ISV+1,NSITES
                  SIGOLS(I-1)=SIGOLS(I)
                  AMOD(I-1)=AMOD(I)
                  ASKU(I-1)=ASKU(I)
                  COST(I-1)=COST(I)
                  AK(I-1)=AK(I)
                  ICODE(I-1)=ICODE(I)
                  ISAVE(I-1)=ISAVE(I)
                  DO 172 J = 1,8
                    STATN(J,I-1)=STATN(J,I)
 172              CONTINUE
                  DO 174 J=1,K
                    X(I-1,J)=X(I,J)
                    XT(J,I-1)=X(I,J)
 174              CONTINUE
                  DO 176 J=1,ISV-1
                    MCON(I-1,J)=MCON(I,J)
                    RHOC(I-1,J)=RHOC(I,J)
 176              CONTINUE
                  DO 178 J=ISV+1,I
                    MCON(I-1,J-1)=MCON(I,J)
                    RHOC(I-1,J-1)=RHOC(I,J)
 178              CONTINUE
 180            CONTINUE
                NSITES=NSITES-1
              END IF
              STOPFG = 0
            ELSE
              STOPFG = 1
            END IF
          IF (STOPFG .EQ. 0) GO TO 100
C
        END IF
C       reset INFLG so must reenter data to do another analysis
        INFLG = -1
      ELSE IF (OPT .EQ. 6) THEN
C       make a plot
        MAXP = IDX
        CALL PLTCST (MESSFL,MXS,PLOT,MAXP)
      END IF
C
      IF (OPT .NE. 7) GO TO 10
C
      IF (OUTFLG .EQ. 0) ENDFILE (FO)
C
      DELFG = 0
      CALL QFCLOS (FT,DELFG)
      DELFG = 0
      CALL QFCLOS (FO,DELFG)
C
      RETURN
      END
C
C
C
      SUBROUTINE   NETINP
     I                    (FI,
     O                     NOLD, ALPHA,THETA,KPARS,KPART,NTE,NCS,ICOLS,
     O                     NCT,ICOLT,SIGME,RHAT,KP,ERRFLG)
C
C     This routine read file from output from GLS option in ANNIE and
C     puts the data in buffers in COMMON blocks for use in the network
C     analysis.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER           FI,NOLD,KPARS,KPART,NTE,NCS,ICOLS(10),NCT,
     $                  ICOLT(10),ERRFLG
      REAL              KP
      DOUBLE PRECISION  ALPHA, THETA, SIGME, RHAT
C
C     + + + ARGUMENT DEFINITION + + +
C     FI     - Fortran unit number of input file created by GLS
C              analysis
C     NOLD   - number of existing stations used in analysis
C     ALPHA  - coefficient used in equation of cross-correlation vs.
C              distance
C     THETA  - coefficient used in equation of cross-correlation vs.
C              distance
C     KPARS  - number of parameters in the sigma regression
C     KPART  - number of parameters in the t regression
C     NTE    - number of unique parameters in the simga and t regressions
C     NCS    - number of variables in SIGMA regression
C     ICOLS  - array of columns numbers for variables in SIGMA
C              regression
C     NCT    - number of variables in T-yr regression
C     ICOLT  - array of column numbers for varaiables in T-yr
C              regression
C     SIGME  - error term from GLS analysis
C     RHAT   - error term from GLS analysis
C     KP     -
C     ERRFLG - line number on file with read error
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cntwrk.inc'

C     + + + LOCAL VARIABLES + + +
      INTEGER   I,J,LINE
      REAL    A1, T1
C
C     + + + INTRINSICS + + +
      INTRINSIC   DBLE
C
C     + + + INPUT FORMATS + + +
 1000 FORMAT (I5)
 1001 FORMAT (20I4)
 1002 FORMAT (20F4.0)
 1004 FORMAT(9F13.7)
 1005 FORMAT(2X,8A1,13F12.0)
 1006 FORMAT(D12.4)
 1008 FORMAT(8A1)
C
C     + + + END SPECIFICATIONS + + +
C
      ERRFLG = 0
      LINE = 1
C
C     READ NUMBER OF STATIONS
      READ(FI,1001,END=99,ERR=99)NOLD
      LINE = LINE + 1
C
C     read alpha and theta
      READ (FI,1004,END=99,ERR=99) A1, T1
      ALPHA = DBLE(A1)
      THETA = DBLE(T1)
      LINE = LINE + 1
C
C     READ CONCURRENT RECORD LENGTHS
      DO 10 I=1,NOLD
        READ(FI,1001,END=99,ERR=99) (MCON(I,J),J=1,I)
        LINE = LINE + 1 + (I-1)/20
 10   CONTINUE
C
C     READ CORRELATION MATRIX
      DO 20 I=1,NOLD
        READ(FI,1002,END=99,ERR=99) (RHOC(I,J),J=1,I)
        LINE = LINE + 1 + (I-1)/20
 20   CONTINUE
C
C     READ NUMBER OF PARAMETERS IN SIGMA REGRESSION
      READ(FI,1001,END=99,ERR=99) KPARS
      LINE = LINE + 1
C
C     READ COEFFICIENTS FOR SIGMA REGRESSION
      READ(FI,1004,END=99,ERR=99)(BHAT(J),J=1,KPARS)
      LINE = LINE + 1
C
C     read columns in explanatory variables matrix (EXV) used
C     insigma regression
      READ (FI,1001,END=99,ERR=99) NCS, (ICOLS(I),I=1,NCS)
      LINE = LINE + 1
C
C
C     READ AND CALCULATE MODEL ERROR
      READ(FI,1006,END=99,ERR=99)SIGME
      LINE = LINE + 1
      READ(FI,1006,END=99,ERR=99)RHAT
      LINE = LINE + 1
      READ(FI,1006,END=99,ERR=99)KP
      LINE = LINE + 1
C
C     READ STATION DATA FOR T-YR FLOW REGRESSION
      READ(FI,1000,END=99,ERR=99) KPART
      LINE = LINE + 1
C
C     read columns in explanatory variable matrix (EXV) used in
C     T-yr regression
      READ (FI,1001,END=99,ERR=99) NCT, (ICOLT(I),I=1,10)
      LINE = LINE + 1
C
C     read explanatory variables
      READ (FI,1001,END=99,ERR=99) NTE
      LINE = LINE + 1
      DO 32 I = 1,NOLD
        READ (FI,1005,END=99,ERR=99) (STATN(J,I),J=1,8),DLAT(I),DLNG(I),
     &                 ASKU(I),(EXV(J,I),J=1,NTE)
        LINE = LINE + 1
 32   CONTINUE
C
C     read name of explanatory variables
      DO 33 I = 1,NTE
        READ (FI,1008,END=99,ERR=99) (EXVNAM(J,I),J=1,8)
        LINE = LINE + 1
 33   CONTINUE
C
      GO TO 100
 99   CONTINUE
C       error reading input file
        ERRFLG = LINE
 100  CONTINUE
C
      RETURN
      END
C
C
C
      SUBROUTINE   GSTCON
     I                      (MESSFL, NOLD,
     O                       ISAVE, IHAVE)
C
C     This routine get input from user of GLS analysis on the cost of
C     existing stations and which stations must be continued.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, NOLD, IHAVE
      INTEGER   ISAVE(NOLD)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of GLSNET message file
C     NOLD   - number of existing stations in analysis
C     ISAVE  - flag for which stations must be continued
C     IHAVE  - flag to indicate at least one station must be continued
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cntwrk.inc'
C
C     + + + PARAMETERS + + +
      INTEGER   MXS3
      PARAMETER (MXS3 = 3*MXS)
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   J, INUM, RNUM, CNUM, IVAL(1), NROW, L11,
     &          SCNFG, SGRP, SCLU, I, L8, L40, L2, IR1, IR2, L10,
     &          JUST, OLEN, CVAL(2,3,MXS)
      CHARACTER*1   TBUFF(80,11), BLNK, CNO(2)
      REAL      RVAL(11), R1, SDUM
      DOUBLE PRECISION    D1
C
C     + + + INTRINSICS + + +
      INTRINSIC   DBLE, SNGL
C
C     + + + EXTERNALS + + +
      EXTERNAL   QRESCX, CHRCHR, ZIPC, ZIPD, DECCHR
C
C     + + + DATA INITIALIZATION + + +
      DATA BLNK, CNO,    L8, L40, L2,  R1, L11, L10
     &     /' ','N','O',  8,  40,  2, 1.0,  11, 10/
C
C     + + + END SPECIFICATIONS + + +
C
      INUM = 1
      RNUM = 1
      CNUM = 2
      NROW = 11
      SCNFG = 1
      SCLU = 107
      SGRP = 5
      IR1 = 1
      IR2 = 11
      D1 = 1.0
      CALL ZIPD (NOLD, D1, COST)
      IHAVE = 0
 5    CONTINUE
        DO 10 I = IR1,IR2
C         fill TBUFF with initial values
          J = I + 1 - IR1
          CALL ZIPC (L40,BLNK,TBUFF(1,J))
          CALL CHRCHR (L8,STATN(1,I),TBUFF(1,J))
          CALL CHRCHR (L2,CNO,TBUFF(19,J))
          SDUM = SNGL(COST(I))
          CALL DECCHR (SDUM,L10,JUST,OLEN,TBUFF(21,J))
          RVAL(J) = SNGL(COST(I))
 10     CONTINUE
        CALL QRESCX (MESSFL, SCLU, SGRP, INUM, RNUM, CNUM,
     &               NROW, SCNFG, IVAL, RVAL, CVAL, TBUFF)
C       set flag if stations must be continued
        DO 15 I = IR1,IR2
          J = I + 1 - IR1
          COST(I) = DBLE(RVAL(J))
          ISAVE(I) = CVAL(2,1,J)
          IF (ISAVE(I) .EQ. 2) IHAVE = 1
 15     CONTINUE
C
        IR1 = IR1 + 11
        IR2 = IR2 + 11
        IF (IR2 .GT. NOLD) THEN
          IR2 = NOLD
          NROW = IR2 - IR1 + 1
        END IF
      IF (IR1 .LE. NOLD) GO TO 5
C
      RETURN
      END
C
C
C
      SUBROUTINE   GNUDAT
     I                     (MESSFL, KTPART, NOLD, NNEW)
C
C     For the proposed new stations for GLS, get station number,
C     latitude, longitude, cost, skew coefficient, and [KTPART] basin
C     characteristics.  The values are placed in the _NET common
C     blocks.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, KTPART, NOLD, NNEW
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number for GLSNET message file
C     KTPART - number of explanatory variables to be used
C     NOLD   - number of existing stations in the analysis
C     NNEW   - number of proposed stations
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cntwrk.inc'
C
C     + + + PARAMETERS + + +
      INTEGER   MXBC
      PARAMETER (MXBC = 7*MXS)
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      L1, L2, L3, L8, L10, L240, JUSTR, OLEN, LOCN, SCLU,
     $             SGRP, I, K, K1, J, IVAL(3,MXS), NROW, IO, KNTBC,
     $             COL, RETC
      REAL         RVAL(MXBC), ZERO, COSTR(MXS), ASKUR(MXS)
      CHARACTER*1  CVAR(10), TBUFF(80,3), BLNK
C
C     + + + FUNCTIONS + + +
      REAL   CNVTDG
C
C     + + + INTRINSICS + + +
      INTRINSIC   DBLE
C
C     + + + EXTERNALS + + +
      EXTERNAL   CHRCHR, INTCHR, CNVTDG, ZIPC, ZIPR
      EXTERNAL   Q2INIT, Q2SETI, Q2STRB, ZSTADQ
      EXTERNAL   Q2EDIT, Q2GETI, Q2GTRB
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  L1, L2, L3, L8, L10, L240, ZERO, JUSTR
     &     / 1,  2,  3,  8,  10,  240,  0.0,     0 /
      DATA  BLNK,  CVAR
     $     / ' ',  'V','A','R','I','A','B','L','E','S',':' /
C
C     + + + END SPECIFICATIONS + + +
C
      SCLU = 107
      KNTBC = KTPART
C
C     list out required explanatory variables
      CALL ZIPC ( L240, BLNK, TBUFF )
      CALL CHRCHR ( L10, CVAR, TBUFF (5,1) )
      NROW = 1
      LOCN = 16
      I    = 1
 100  CONTINUE
C       add name of each basin characteristic
        CALL INTCHR ( I, L2, JUSTR, OLEN, TBUFF(LOCN,NROW) )
        TBUFF(LOCN+3,NROW) = '-'
        CALL CHRCHR ( L8, EXVNAM(1,I), TBUFF(LOCN+5,NROW) )
        LOCN = LOCN + 15
        I    = I + 1
        IF (LOCN .GT. 61  .AND.  I .LE. KNTBC) THEN
C         start a new row
          NROW = NROW + 1
          LOCN = 16
        END IF
      IF (I .LE. KNTBC) GO TO 100
C     update status window, display now (io=1)
      IO = 1
      DO 110 I = 1, NROW
        CALL ZSTADQ ( I, TBUFF(1,I), IO )
 110  CONTINUE
C
      NROW = NNEW
C     initialize station, latitude, longitude, cost, and skew
      DO 200 I = 1, NROW
        IVAL(1,I) = 990000 + I
        IVAL(2,I) = 350000
        IVAL(3,I) = 950000
        COSTR(I)  = 1.0
        ASKUR(I)  = 0.0
 200  CONTINUE
C     initialize basin characteristics
      I = NROW * KNTBC
      CALL ZIPR ( I, ZERO, RVAL )
C
C     fill screen (sgrp: 19 - 1 basin char, ... 25 - 7 basin char)
      SGRP = 18 + KNTBC
      CALL Q2INIT ( MESSFL, SCLU, SGRP )
      CALL Q2SETI ( L3, NROW, IVAL )
      COL = 1
      CALL Q2STRB ( L1, COL, NROW, COSTR )
      COL = 2 + KNTBC
      CALL Q2STRB ( L1, COL, NROW, ASKUR )
      COL = 2
      CALL Q2STRB ( KNTBC, COL, NROW, RVAL )
C
C     sta, lat, lng, cost, basin char, skew coef
      CALL Q2EDIT ( NROW, RETC )
C
C     retrieve the values, foolishly ignoring RETC!
      CALL Q2GETI ( L3, NROW, IVAL )
      COL = 1
      CALL Q2GTRB ( L1, COL, NROW, COSTR )
      COL = 2 + KNTBC
      CALL Q2GTRB ( L1, COL, NROW, ASKUR )
      COL = 2
      CALL Q2GTRB ( KNTBC, COL, NROW, RVAL )
C
C     convert reals to double precision, station no to char
      K1 = 0
      DO 350 I = 1, NROW
        J = NOLD + I
        COST(J) = DBLE ( COSTR(I) )
        ASKU(J) = DBLE ( ASKUR(I) )
        DLAT(J) = DBLE ( CNVTDG ( IVAL(2,I) ) )
        DLNG(J) = DBLE ( CNVTDG ( IVAL(3,I) ) )
        CALL INTCHR ( IVAL(1,I), L8, JUSTR, OLEN, STATN(1,J) )
        DO 320 K = 1, KNTBC
          K1 = K1 + 1
          EXV(K,J) = DBLE ( RVAL(K1) )
 320    CONTINUE
 350  CONTINUE
C
      RETURN
      END
C
C
C
      SUBROUTINE   PLTCST
     I                    (MESSFL,MAXS,PLOT,MAXP)
C
C     This routine calls routines to make a special plot for the
C     network program. It plots cost of stations verses information
C     content (inverse error term).
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER    MESSFL, MAXS, MAXP
      REAL      PLOT(MAXS,9)
C
C     + + + ARGUMENT DEFINITION + + +
C     MESSFL - Fortran unit number of GLSNET message file
C     MAXS   - size of PLOT array
C     PLOT   - array of values to plot (1=budget, 2=error)
C     MAXP   - number of points in PLOT to plot
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I, SGRP,SCLU,  OLEN,     CNT,L20,ICHK(7),
     &          BVALFG(4),COLOR(1),SYMBL(1),PATTRN(1),TICS(4),LNTYP(1),
     &          YTYPE(2),XTYPE,CTYPE(1),WHICH(2),NVAR,NCRV,L1,L2,RETCOD,
     &          TRANSF(4),POPT,IND,DEVCOD,DEVTYP,MAXP1,IWAIT,ICLOS,WSID,
     &          WNDFLG
      REAL      YY(900),PLMN(4),PLMX(4),VMAX(2),VMIN(2),ALEN,
     &    SIZEL,XLEN,YLEN,XPAGE,YPAGE,XPHYS,YPHYS,XX(900)
      CHARACTER*1   TITLE(240),LBV(20,18),YLABL(80),XLABL(80),
     &              YALABL(80)
      CHARACTER*8   WNAME
C
C     + + + EXTERNALS + + +
      EXTERNAL   PROPLT, GETTXT, GPINIT, CHRCHR
      EXTERNAL   GPDATR, GPCURV, GPNCRV, GPLABL, GPVAR, SCALIT
      EXTERNAL   ANPRGT, GPDEVC, GPSIZE, QRESP, GPSCLE
      EXTERNAL   GPWCXY, PLTONE, PSTUPW, PDNPLT, GPLBXB
C
C     + + + DATA INITIALIZATION + + +
      DATA   ICHK/1,2,1,1,1,1,1/,  L20/20/
      DATA  TICS/10,10,2,10/, BVALFG/4*1/, TRANSF/4*1/
      DATA  TITLE/240*' '/, YALABL/80*' '/, ALEN/0.0/
      DATA  L1,L2/1,2/, WNAME/'(ONA)   '/,  XLABL/80*' '/
      DATA  YLABL/80*' '/
C
C     + + + END SPECIFICATIONS + + +
C
      WNDFLG = 0
C
      CALL GPINIT
C
      SCLU = 107
C     get y-axis label (AVERAGE SAMPLING ERROR)
      OLEN = 40
      SGRP = 12
      CALL GETTXT (MESSFL,SCLU,SGRP,OLEN,YLABL)
      CALL CHRCHR (L20, YLABL, LBV(1,1))
C     get x-axis label (BUDGET, IN DOLLARS)
      OLEN = 40
      SGRP = 11
      CALL GETTXT (MESSFL,SCLU,SGRP,OLEN,XLABL)
      CALL CHRCHR (L20, XLABL, LBV(1,2))
C
      NVAR = 2
      NCRV = 1
      CALL GPNCRV (NCRV, NVAR)
      VMAX(1) = -1.0E9
      VMAX(2) = -1.0E9
      VMIN(1) = 1.0E9
      VMIN(2) = 1.0E9
      CNT = 0
      DO 10 I = 1,MAXP
        IF (PLOT(I,1) .LT. 990000.) THEN
C         error (y-axis)
          CNT = CNT + 1
          YY(CNT) = 0.001*PLOT(I,2)
          IF (YY(CNT) .GT. VMAX(1)) VMAX(1) = YY(CNT)
          IF (YY(CNT) .LT. VMIN(1)) VMIN(1) = YY(CNT)
C         budget (x-axis)
          XX(CNT) = PLOT(I,1)
          IF (XX(CNT) .GT. VMAX(2)) VMAX(2) = XX(CNT)
          IF (XX(CNT) .LT. VMIN(2)) VMIN(2) = XX(CNT)
        END IF
 10   CONTINUE
      CALL GPDATR(L1,L1,MAXP,YY(1),RETCOD)
      MAXP1 = MAXP + 1
      CALL GPDATR(L2,MAXP1,MAXP,XX(1),RETCOD)
C     set which variables for the curve
      CALL GPWCXY (L1,L1,L2)
C
      WHICH(1) = 1
      WHICH(2) = 4
      CTYPE(1) = 6
      XTYPE = 1
      YTYPE(1) = 1
      YTYPE(2) = 0
      LNTYP(1) = 0
      PATTRN(1) = 0
      SYMBL(1) = 4
      COLOR(1) = 1
      CALL GPCURV (CTYPE,LNTYP,SYMBL,COLOR,PATTRN,LBV)
      CALL GPLABL (XTYPE,YTYPE,ALEN,YLABL,XLABL,YALABL,TITLE)
      CALL GPLBXB (XLABL)
      CALL GPVAR (VMIN,VMAX,WHICH,TRANSF,lBV)
      CALL SCALIT (L1,VMIN(1),VMAX(1),PLMN(1),PLMX(1))
      CALL SCALIT (L1,VMIN(2),VMAX(2),PLMN(4),PLMX(4))
      CALL GPSCLE (PLMN,PLMX,TICS,BVALFG)
C     set device to screen
      DEVTYP = 1
      IND = 40
      CALL ANPRGT (IND,DEVCOD)
      CALL GPDEVC (DEVTYP,DEVCOD)
C     set screen size
      SIZEL = 0.1
      XPAGE = 6.0
      YPAGE = 6.0
      XPHYS = 1.0
      YPHYS = 1.0
      XLEN = 4.5
      YLEN = 4.5
      CALL GPSIZE (SIZEL, XPAGE,YPAGE, XPHYS,YPHYS, XLEN,YLEN,ALEN)
C
 50   CONTINUE
C       plot, modify or done
        SGRP = 31
        CALL QRESP (MESSFL, SCLU, SGRP, POPT)
        IF (POPT .EQ. 2) THEN
C         modify plot
          CALL PROPLT (MESSFL,ICHK,WNAME,
     O                 WNDFLG)            
          IF (WNDFLG .EQ. 1) THEN
C           close current workstation and reset device type
C           and code
            IWAIT = 0
            ICLOS = 1
            CALL PDNPLT (WSID,ICLOS,IWAIT)
          END IF
        ELSE IF (POPT .EQ. 1) THEN
C         make a plot
          ICLOS = 0
          WSID = 1
          IWAIT = 0
          CALL PSTUPW (WSID,RETCOD)
          CALL PLTONE
          CALL PDNPLT (WSID,ICLOS,IWAIT)
        ELSE
C         done so close workstation
          ICLOS = 1
          WSID = 1
          IWAIT = 0
          CALL PDNPLT (WSID,ICLOS,IWAIT)
        END IF
      IF (POPT .NE. 3) GO TO 50
C
      RETURN
      END
C
C
C
      SUBROUTINE   COVMTX
C
C     This routine calculates the covariance matrices of Y-hat, if
C     at-site estimators of MU and SIGMA**2 are employed.  Note: no
C     weighting matrices are needed in this case.  The covariance of
C     of Y-hat are calculated in two ways.  SIGOLS is used to get STA
C     used by GLS while SIGBEST is used to provide a better estimate
C     of the true sampling covariance matrix to be used to improve our
C     estimate of the accuracy of the GLS-BETAS.
C
      INCLUDE 'cntwrk.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I, J
      DOUBLE PRECISION   RHO, AJ
C
C     + + + INTRINSICS + + +
      INTRINSIC   DBLE
C
C     + + + END SPECIFICATIONS + + +
C
      AJ = 1.0
      DO 100 I = 1,NSITES
        DO 90 J = 1,I
          IF( I.NE.J ) THEN
            RHO = RHOC(I,J)
          ELSE
            RHO = 1
          END IF
          COV(I,J)=(AJ+AJ*AK(I)*ASKU(I)*0.5+AJ*AK(J)*ASKU(J)*0.5
     1            +AK(I)*AK(J)*0.5*
     1            (RHO+0.75*ASKU(I)*ASKU(J)))*
     1            RHO*DBLE(MCON(I,J))*SIGOLS(I)*SIGOLS(J)
     1            /DBLE(MCON(I,I)*MCON(J,J))
C         NOTE: AML REPLACED L WITH MCON DIAGONAL  9/4/86
          COV(J,I) = COV(I,J)
 90     CONTINUE
 100  CONTINUE
C
      RETURN
      END
