C
C
C
      SUBROUTINE   PROSLS
     I                   (MESSFL,WDMSFL)
C
C     + + + PURPOSE + + +
C     This routine pre- and post- processes data for simple least
C     squares analysis of x on y.  Input is from the terminal or
C     a WDM file.  Output options include plots that use GKS.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL, MESSFL
C
C     + + + ARGUMENT DEFINITION + + +
C     MESSFL - Fortran unit number of main ANNIE message file
C     WDMSFL - Fortran unit number of users WDM file
C
C     + + + PARAMETERS + + +
      INCLUDE 'pglsiz.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   TORW, NPTS, SGRP, SCLU, DELFG, IRET, IWRT,
     &          ERRFLG, M, OTFLG, DSNMX, JUST, OLEN, SCF, NROW,
     &          SDATE(6), EDATE(6), L16, DSNCNT, DSNBUF(MAXPTS), LOC,
     &          RETCOD, TU, TS, CODES(20), II, IC, IR, L0,AGAIN,
     &          L2, IT, DATFLG, DATLEN, DATNVL, FLG, DTRAN, QFLG, NUM,
     &          SCNFG, MXLN, OTUNIT, BADDSN(MAXPTS),IBDATT(MAXPTS),IBD,
     &          AXTYP(2), L6, L8, L80, L1, I, J, IVAL(6), L96,
     &          CVAL(3,6), EXECFG, DATAFG, DSNBMX
      CHARACTER*1   XLABS(8,20), BUFF(80), BLNK, CDS(16), TBUFF(80),
     &              STANO(8,MAXPTS), YLAB(80), XLAB(80), CMATCH(6)
      REAL      T0,T1,B0,B1,SB0,SB1,P0,P1,SE,R2,XBAR,YBAR,RVAL(14),
     &          SY2, SX2, YX(1000), RVL2(8,12), ZERO
      CHARACTER*8   PTHNAM
      CHARACTER*48  WNDNAM
C
C     + + + INTRINSICS + + +
      INTRINSIC   REAL, SQRT
C
C     + + + EXTERNALS + + +
      EXTERNAL   QRESP, QRESPI, QRSPRA, QFOPEN, QFCLOS, ZIPR
      EXTERNAL   DATES, TIMDIF, PRNTXI, WDTGET, PRNTXT, INTCHR
      EXTERNAL   LREG1, CHRCHR, ZIPC, PLTSLS, PMXTFR, QTSTR
      EXTERNAL   GTTSTU, WDATGT, PRWMSE, PMXTXR, LOGTRN
      EXTERNAL   Q1INIT, Q1EDIT, QGTCTF, QRESCN, WDSAFI
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  BLNK,L2,L6,L8,L16,L80,L1/' ', 2, 6, 8, 16, 80, 1/
      DATA  CDS/'D','a','t','a',' ','s','e','t',' ','n','u','m','b',
     &          'e','r',' '/
C
C     + + + FORMATS + + +
 2001 FORMAT (/' Ordinary least squares results'/
     &         '   Number of points             =',I10/
     &         '   R squared                    =',F10.3/
     &         '   Correlation coefficient      =',F10.3/
     &         '   Mean Y                       =',F10.3/
     &         '   Mean X                       =',F10.3/
     &         '   Variance Y                   =',F10.3/
     &         '   Variance X                   =',F10.3/
     &         '   Standard deviation Y         =',F10.3/
     &         '   Standard deviation X         =',F10.3/
     &         '   Standard error of regression =',F10.3/
     &         '   Intercept                    =',F10.3/
     &         '   Slope                        =',F10.3/
     &         '   T statistic of intercept     =',F10.3/
     &         '   T statistic of slope         =',F10.3/)
 2002 FORMAT (///'Data used in least squares'/(2F13.3))
C
C     + + + END SPECIFICATIONS + + +
C
      SCLU = 104
C
      CALL ZIPC (L80,BLNK,YLAB)
      CALL ZIPC (L80,BLNK,XLAB)
      L0 = 0
      L96 = 96
      ZERO = 0.0
      CALL ZIPR (L96, ZERO, RVL2)
      EXECFG = 0
      OTFLG = 1
      DATAFG = 0
      NPTS = 0
      DSNBMX = MAXPTS
      DSNCNT = 0
C
 10   CONTINUE
C       source of data(1-terminal, 2-WDM file attributes,
C       3-WDM file timeseries, 4-open output file,  
C       5-transform to log, 6-execute, 7-plot, 8-done)
        SGRP = 2
        CALL QRESP (MESSFL, SCLU, SGRP, TORW)
C
        IF (TORW .EQ. 4) THEN
C         open print file, but close old one first it needed
          IF (OTFLG .EQ. 1) THEN
            DELFG = 0
            CALL QFCLOS (DELFG,OTUNIT)
          END IF
          SGRP = 1
          CALL QFOPEN (MESSFL, SCLU, SGRP, OTUNIT, OTFLG)
C
        ELSE IF (TORW .EQ. 1) THEN
C         input from terminal
C         Enter name of dependent & explanatory variables.
          NPTS = -999
          SGRP = 3
          CALL Q1INIT (MESSFL, SCLU, SGRP)
          CALL Q1EDIT (IRET)
          CALL QGTCTF (L1, L6, YLAB)
          CALL QGTCTF (L1, L6, XLAB)
C         enter up to 48 pairs
          SCF = 1
          II = 1
          IC = 1
          IR = 8
          NROW = 12
          SGRP = 4
          CALL QRESCN (MESSFL,SCLU,SGRP,II,IR,IC,NROW,SCF,IVAL,RVL2,
     &                 CVAL,TBUFF)
          LOC = 0
          DO 13 I=1,7,2
            DO 12 J=1,12
              IF (RVL2(I,J) .GT. 0.0 .AND. RVL2(I+1,J) .GT. 0.0) THEN
                LOC = LOC + 1
                YX(LOC) = RVL2(I,J)
                YX(LOC+48) = RVL2(I+1, J)
              END IF
 12         CONTINUE
 13       CONTINUE
          NPTS = LOC
          DO 14 I=1,NPTS
            YX(NPTS+I) = YX(48+I)
 14       CONTINUE
          IF (NPTS .GT. 2) THEN
            RETCOD = 0
            DATAFG = 1
          ELSE
C           not enough points to analyze
            SGRP = 16
            CALL PRNTXT (MESSFL, SCLU, SGRP)
            RETCOD = -999
          END IF
C
        ELSE IF (TORW .EQ. 2) THEN
C         WDM file
          IF (WDMSFL .LE. 0) THEN
C           no WDM file, must open
            SGRP = 17
            CALL PRNTXT(MESSFL, SCLU, SGRP)
          ELSE
C           input attributes from WDM file
C           select datasets
            PTHNAM= 'OA'
            CALL PRWMSE (MESSFL, WDMSFL, DSNBMX, PTHNAM,
     O                   DSNBUF, DSNCNT)
            NPTS = DSNCNT
C           Now select attributes
            AGAIN = 0
 15         CONTINUE
              IF (AGAIN .NE. 0) THEN
C               one or more attribute names not ok
                SGRP = 61
                CALL PRNTXT (MESSFL, SCLU, SGRP)
              END IF
C             Only two attributes may be selected
              SGRP = 5
              CALL Q1INIT (MESSFL, SCLU, SGRP)
              CALL Q1EDIT (IRET)
              CALL QGTCTF (L1, L8, XLABS(1,1))
              CALL QGTCTF (L2, L8, XLABS(1,2))
              CODES(1) = 1
              CODES(2) = 1
              CALL WDSAFI (MESSFL,XLABS(1,1),CODES(1),CMATCH,RETCOD)
              IF (RETCOD .EQ. 0) THEN
                CALL CHRCHR (L6,XLABS(1,1),YLAB)
                CALL WDSAFI (MESSFL,XLABS(1,2),CODES(2),CMATCH,RETCOD)
                IF (RETCOD .EQ. 0) THEN
                  CALL CHRCHR (L6,XLABS(1,2),XLAB)
                ELSE
                  AGAIN = 1
                END IF
              ELSE
                AGAIN = 1
              END IF
            IF (AGAIN .NE. 0) GO TO 15
C
C           get attribute data for first variable
            CALL WDATGT (WDMSFL,NPTS,L1,CODES(1),L0,L0,DSNBMX,DSNBUF,
     &                   YX,IBD,BADDSN,IBDATT(1),STANO,RETCOD)
            IF (RETCOD.EQ.0 .AND. IBD.EQ.0 .AND. IBDATT(1).EQ.0) THEN
C             get attribute data for second variable
              CALL WDATGT (WDMSFL,NPTS,L1,CODES(2),L0,L0,DSNBMX,DSNBUF,
     &                    YX(NPTS+1),IBD,BADDSN,IBDATT(2),STANO,RETCOD)
            END IF
C           check for bad values
C           CALL CHKBAD
            IF (RETCOD.NE.0) THEN
C             Could not get data, return code is &.
              SGRP = 15
              CALL PRNTXI (MESSFL, SCLU, SGRP, RETCOD)
            ELSE IF (IBD.NE.0) THEN
C             Could not get data for some of the data sets.
              SGRP = 19
              CALL PRNTXT (MESSFL, SCLU, SGRP)
            ELSE IF (IBDATT(1).NE.0 .OR. IBDATT(2).NE.0) THEN
C             Could not get data values for one of the attributes.
              SGRP = 20
              CALL PRNTXT (MESSFL, SCLU, SGRP)
            ELSE
C             got data
              DATAFG = 1
            END IF
          END IF

        ELSE IF (TORW .EQ. 3) THEN
          IF (WDMSFL .LE. 0) THEN
C           no WDM file, must open
            SGRP = 17
            CALL PRNTXT(MESSFL, SCLU, SGRP)
          ELSE
C           input timeseries from WDM file
 27         CONTINUE
C             select 2 datasets for time series
C             select dependent variable first
              SGRP = 38
              CALL PRNTXT (MESSFL,SCLU,SGRP)
              DSNMX = 2
              PTHNAM = 'OT'
              CALL PRWMSE (MESSFL, WDMSFL, DSNMX, PTHNAM,
     O                     DSNBUF, DSNCNT)
              IF (DSNCNT .NE. 2) THEN
C               Select only 2 time series. Enter again.
                SGRP = 18
                CALL PRNTXT (MESSFL, SCLU, SGRP)
              END IF
            IF ( DSNCNT .NE. 2) GO TO 27
 35           CONTINUE
C             get default dates and select common period
              DATFLG = 3
              IT = 0
              DATLEN = 5
              CALL DATES (IT,DATFLG,DATLEN,SDATE,EDATE,DATNVL,BUFF)
C             get time step time units
              WNDNAM = 'Time step/units (OT)'
              CALL GTTSTU (WNDNAM,TS,TU)
              CALL TIMDIF (SDATE,EDATE,TU,TS,NPTS)
              FLG = 0
              IF (NPTS .GT. DSNBMX/2) THEN
C               Too many points, max is &. Change dates or time step.
                SGRP = 9
                CALL PRNTXI (WDMSFL, SCLU, SGRP, DSNBMX/2)
                FLG = 1
              END IF
            IF (FLG .EQ. 1) GO TO 35
C           get first variable
            CALL WDTGET (WDMSFL,DSNBUF(1),TS,SDATE,NPTS,DTRAN,QFLG,TU,
     &                   YX(1),RETCOD)
            IF (RETCOD .EQ. 0) THEN
              CALL CHRCHR (L16,CDS,YLAB)
              JUST = 0
              CALL INTCHR (DSNBUF(1),L6,JUST,OLEN,YLAB(L16+1))
C             Get second time series
              M = NPTS + 1
              CALL WDTGET (WDMSFL,DSNBUF(2),TS,SDATE,NPTS,DTRAN,QFLG,TU,
     &                     YX(M),RETCOD)
              CALL CHRCHR (L16,CDS,XLAB)
              CALL INTCHR (DSNBUF(2),L6,JUST,OLEN,XLAB(L16+1))
            END IF
            IF (RETCOD .NE. 0) THEN
C             Could not get data, return code is &.
              SGRP = 15
              CALL PRNTXI (MESSFL, SCLU, SGRP, RETCOD)
            ELSE
C             got data
              DATAFG = 1
            END IF
          END IF
C
        ELSE IF (TORW .EQ. 5) THEN
          IF (DATAFG .EQ. 0) THEN
C           no data to take logs
            SGRP = 11
            CALL PRNTXT (MESSFL, SCLU, SGRP)
          ELSE
C           got data
            M = NPTS + 1
C           take the logs
            CALL LOGTRN (NPTS, L1, YX(1), YX(M), ERRFLG)
            IF (ERRFLG .NE. 0) THEN
C             could not take logs
              SGRP = 10
              CALL PRNTXT (MESSFL, SCLU, SGRP)
              DATAFG = 0
            END IF
          END IF
C
        ELSE IF (TORW .EQ. 6) THEN
          IF (DATAFG .EQ. 0) THEN
C           no data to analyze
            SGRP = 11
            CALL PRNTXT (MESSFL,SCLU,SGRP)
          ELSE
C           Good data, continue
            M = NPTS + 1
            write(99,*) 'npts=',npts
            write(99,*) 'yx=',yx
            CALL LREG1 (NPTS, YX(1), YX(M),
     &                  R2, YBAR, XBAR, SY2, SX2, SE,
     &                  B0, B1, SB0, SB1, T0, T1, P0, P1)
C
C           Print results
            RVAL(1) = REAL(NPTS)
            RVAL(2) = R2
            RVAL(3) = SQRT(R2)
            RVAL(4) = YBAR
            RVAL(5) = XBAR
            RVAL(6) = SY2
            RVAL(7) = SX2
            RVAL(8) = SQRT(SY2)
            RVAL(9) = SQRT(SX2)
            RVAL(10) = SE
            RVAL(11) = B0
            RVAL(12) = B1
            RVAL(13) = T0
            RVAL(14)= T1
C           write results to screen
            NUM = 14
            IWRT = 0
            SCNFG = 1
            MXLN = 10
            SGRP = 13
            CALL PMXTXR (MESSFL,SCLU,SGRP,MXLN,SCNFG,IWRT,NUM,RVAL)
            IF (OTFLG .EQ. 0) THEN
C             Also write to users file
              WRITE (OTUNIT,2001) (RVAL(I), I=1,14)
              WRITE (OTUNIT,2002) (YX(I), YX(NPTS+I), I=1,NPTS)
            END IF
            EXECFG = 1
          END IF
C
        ELSE IF (TORW .EQ. 7) THEN
C         plot results
          IF (EXECFG .EQ. 0) THEN
C           Can't plot results, least squares analysis not executed
            SGRP = 12
            CALL PRNTXT (MESSFL, SCLU, SGRP)
          ELSE
C           set axis type to arithmetic
            AXTYP(1) = 1
            AXTYP(2) = 1
            CALL PLTSLS  (MESSFL,SCLU,AXTYP,NPTS,YX(1),YX(M),YLAB,
     &                    XLAB,B0,B1,R2)
          END IF
        END IF
      IF (TORW .LT. 8) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   LREG1
     I                   (NPTS, YY, XX,
     O                    R2, YBAR, XBAR, SY2, SX2, SE, B0, B1,
     O                    SB0, SB1, T0, T1, P0, P1)
C
C     + + + PURPOSE + + +
C     This routine does least squares analysis of x on y  and
C     computes several statistics on the fit.
C
C     + + +DUMMY ARGUMENTS + + +
      INTEGER   NPTS
      REAL      R2, SE, B0, B1, P0, P1, T0, T1, SB0, SB1, YBAR, XBAR,
     &          XX(NPTS), YY(NPTS), SY2, SX2
C
C     + + + ARGUMENT DEFINITIONS + + +
C     NPTS   - number of points
C     YY     - y-values (dependent variable)
C     XX     - x-values (independent variable)
C     R2     - r squared
C     SE     - standard error of estimate
C     YBAR   - mean of Y
C     XBAR   - mean of X
C     SX2    - variance of X
C     SY2    - variance of Y
C     B0     - intercept
C     B1     - slope
C     SB0    - standard error of B0
C     SB1    - standard error of B1
C     T0     -
C     T1     -
C     P0     -
C     P1     -
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I, NDF
      REAL      TV4, PV4
      DOUBLE PRECISION   X, Y, SX, SY, SXY, SXX, SYY, DNPTS,
     &                   SE2, DONE, DNPTS1, DNPTS2, BD1
C
C     + + + INTRINSICS + + +
      INTRINSIC   DBLE, DSQRT, ABS
C
C     + + + FUNCTIONS + + +
      REAL   STUTP
C
C     + + + EXTERNALS + + +
      EXTERNAL   STUTP
C
C     + + + END SPECIFICATIONS + + +
C
C
      SX = 0.0
      SY = 0.0
      SXY = 0.0
      SXX = 0.0
      SYY = 0.0
      DONE = 1.0
      DNPTS = DBLE(NPTS)
      DNPTS1 = DBLE(NPTS-1)
      DNPTS2 = DBLE(NPTS-2)
      DO 10 I = 1,NPTS
        X = DBLE(XX(I))
        Y = DBLE(YY(I))
        SX = SX + X
        SY = SY + Y
        SXX = SXX + X**2
        SYY = SYY + Y**2
        SXY = SXY + X*Y
 10   CONTINUE
C
      B1 = (SXY-SX*SY/DNPTS)/(SXX-SX**2/DNPTS)
      YBAR = SY/DNPTS
      XBAR = SX/DNPTS
      B0 = YBAR-B1*XBAR
      SY2 = (SYY-SY**2/DNPTS)/DNPTS1
      SX2 = (SXX-SX**2/DNPTS)/DNPTS1
      BD1 = (DBLE(B1))**2
      SE2 = (DBLE(SY2)-BD1*DBLE(SX2))*DNPTS1/DNPTS2
      SE = DSQRT(SE2)
      R2 = BD1*SX2/SY2
      SB1 = DBLE(SE)/DSQRT(SX2*DNPTS1)
      SB0 = DBLE(SE)*(DSQRT((DONE/DNPTS)+(DBLE(XBAR)**2)
     &      /(DNPTS1*SX2)))
      T0 = B0/SB0
      TV4 = ABS(T0)
      NDF = NPTS - 2
      PV4 = 2.0*STUTP(-TV4,NDF)
      IF (PV4 .LT. 0.0001) PV4 = 0.0001
      P0 = PV4
      T1 = B1/SB1
      TV4 = ABS(T1)
      PV4 = 2.0*STUTP(-TV4,NDF)
      IF (PV4 .LT. 0.0001) PV4 = 0.0001
      P1 = PV4
C
      RETURN
      END
C
C
C
      SUBROUTINE   PLTSLS
     I                   (MESSFL,SCLU,AXTYP,MAXP,YPT,XPT,
     I                    YLAB, XLAB, B0, B1, R2)
C
C     + + + PURPOSE + + +
C     This routines calls routines to plot the results
C     of a simple leasts squares analysis.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     AXTYP(2),MAXP,MESSFL,SCLU
      REAL        YPT(MAXP), XPT(MAXP), R2, B0, B1
      CHARACTER*1  XLAB(80), YLAB(80)
C
C     + + + ARGUMENT DEFINITION + + +
C     MESSFL - Fortran unit number of message file
C     SCLU   - cluster number for message file
C     AXTYP - type of axis - 1- arith, 2-log, 1-Y,2-X
C     MAXP  - number of points in PTS to plot
C     YPT   - array of Y values to plot
C     XPT   - array of X values to plot
C     YLAB - y label for plot
C     XLAB - x label for plot
C     B0     - intercept on leasts squares fit
C     B1     - slope of leasts squares fit
C     R2     - correlation coefficient of leasts squares fit
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,J,IPOS,RETCOD,WHICH(4),GTICS(4),L40,L1,L4,
     1            GBVALF(4),GCTYP(5),GCOLOR(5),ICHK(7),L2,
     2            GPATRN(5),GTRANF(4),GXTYP,GYTYP(2),CPR,L120,
     3            L26,OLEN,JUST,LOC,LEN,MAXLN,SGRP,IND,DEVTYP,DEVCOD,
     4            GLNTYP(2),GSYMBL(2),L3,MORE,WSID,IWAIT,ICLOS,WNDFLG
      REAL        SIZEL,XPAGE,YPAGE,XPHYS,YPHYS,XLEN,YLEN,ALEN, R,
     &            GVMIN(4),GVMAX(4),PLMN(4),PLMX(4),FX,FY,YC(2),XC(2)
      CHARACTER*1 LABV(20,4), BLNK,
     &            CC(26), CTXT(120), LABC(20,2), TITLE(240), CLOG(3)
      CHARACTER*4  WNAM
C
C     + + + FUNCTIONS + + +
      REAL   SRMIN, SRMAX
C
C     + + + INTRINSICS + + +
      INTRINSIC   ABS, ALOG10, SQRT
C
C     + + + EXTERNALS + + +
      EXTERNAL   GPNCRV,GPDATR,GPCURV,GPVAR,SCALIT,GPSCLE,GPLABL
      EXTERNAL   GPSIZE,PROPLT,ZIPI,ZIPC,GPTEXT,DECCHR,GPINIT,CHRCHR
      EXTERNAL   SRMIN, SRMAX, QRESP, ANPRGT, GPDEVC, GGDVTY
      EXTERNAL   GPLBXB, GPWCXY, PLTONE, PSTUPW, PDNPLT
C
C     + + + DATA INITIALIZATIONS + + +
      DATA   SIZEL,XPAGE,YPAGE,XPHYS,YPHYS,XLEN,YLEN,ALEN
     &      /  0.12, 10.0, 8.0,   1.5,  1.5, 7.5, 5.0, 0.0/
      DATA  ICHK/1,1,1,1,1,1,1/
      DATA  BLNK,L2,L3,L40/' ', 2, 3, 40/,  WNAM/'(OG)'/
      DATA  L26,L120/26,120/,   L1,L4/1,4/
      DATA  CLOG/'L','o','g'/
      DATA CC/'C','o','r','r','e','l','a','t','i','o','n',' ','c',
     &        'o','e','f','f','i','c','i','e','n','t',' ','=',' '/
      DATA TITLE/'S','i','m','p','l','e',' ','L','e','a','s','t',' ',
     &           'S','q','u','a','r','e','s',220*' '/
      DATA  LABV/'Y','-','v','a','r','i','a','b','l','e',10*' ',
     &           'X','-','v','a','r','i','a','b','l','e',10*' ',
     &           'c','o','m','p','u','t','e','d','-','X',10*' ',
     &           'c','o','m','p','u','t','e','d','-','Y',10*' '/
C
C     + + + END SPECIFICATIONS + + +
C
      WNDFLG = 0
C
C     initialize graphics buffer
      CALL GPINIT
C     set device type and code to graphics monitor
      DEVTYP = 1
      IND = 40
      CALL ANPRGT (IND, DEVCOD)
      CALL GPDEVC (DEVTYP, DEVCOD)
C     plot results
      MAXLN = 2
C     number of curves and variables
      CALL GPNCRV(MAXLN,MAXLN*2)
C     set line types and symbols
      GLNTYP(1) = 0
      GLNTYP(2) = 1
      GSYMBL(1) = 3
      GSYMBL(2) = 0
C     computed Y
      XC(1) = SRMIN(MAXP,XPT)
      XC(2) = SRMAX(MAXP,XPT)
      YC(1) = B0 + B1*XC(1)
      YC(2) = B0 + B1*XC(2)
      IF (AXTYP(1) .EQ. 2) THEN
C       untransform logs
        DO 5 I = 1,MAXP
          YPT(I) = 10.0**YPT(I)
          XPT(I) = 10.0**XPT(I)
 5      CONTINUE
        DO 6 I = 1,2
          YC(I) = 10.0**YC(I)
          XC(I) = 10.0**XC(I)
 6      CONTINUE
      END IF
C     set legend to blanks
      CALL ZIPC (L40, BLNK, LABC)
C     set extra info (equation)
      CALL ZIPC (L120, BLNK, CTXT)
      CPR = 36
      JUST = 1
      IF (AXTYP(1) .EQ. 1) THEN
C       linear
        LOC = 7
      ELSE
C       log linear
        LOC = 2
        CALL CHRCHR (L3,CLOG,CTXT(LOC))
        LOC = LOC + 3
      END IF
      CTXT(LOC) = 'Y'
      CTXT(LOC+2) = '='
      LEN = 8
      LOC = LOC + 4
      CALL DECCHR(B0,LEN,JUST,OLEN,CTXT(LOC))
      LOC = LOC + OLEN + 1
      IF (B1 .GE. 0.0) THEN
        CTXT(LOC) = '+'
      ELSE
        CTXT(LOC) = '-'
      END IF
      LEN = 8
      LOC = LOC + 2
      CALL DECCHR(ABS(B1),LEN,JUST,OLEN,CTXT(LOC))
      LOC = LOC + 1 + OLEN
      IF (AXTYP(1) .EQ. 2) THEN
C       log linear
        CALL CHRCHR (L3,CLOG,CTXT(LOC))
        LOC = LOC + 3
      END IF
      CTXT(LOC) = 'X'
C     second line, correlation coeficient
      CALL CHRCHR (L26, CC, CTXT(37))
      LEN = 8
      R = SQRT(R2)
      CALL DECCHR (R,LEN,JUST,OLEN,CTXT(63))
      FX = 0.05
      FY = 0.95
      CALL GPTEXT (L120,CPR,FY,FX,CTXT)
C
C     set values to plot
      IPOS= 1
C     save the Y data
      CALL GPDATR (L1,IPOS,MAXP,YPT,RETCOD)
C     y data transformations
      GTRANF(1)= AXTYP(1)
C     save the X data
      IPOS= IPOS+ MAXP
      CALL GPDATR (L2,IPOS,MAXP,XPT,RETCOD)
C     x data transformations
      GTRANF(2)= AXTYP(2)
C     data for least squares line
C     save x data again
      IPOS = IPOS + MAXP
      CALL GPDATR (L3,IPOS,L2,YC,RETCOD)
C     y data transformations
      GTRANF(3)= AXTYP(1)
C     save computed y data
      IPOS = IPOS + 2
      CALL GPDATR (L4,IPOS,L2,XC,RETCOD)
C     x data transformations
      GTRANF(4)= AXTYP(2)
C     set which variable for each curve
      CALL GPWCXY (L1,L1,L2)
      CALL GPWCXY (L2,L3,L4)
C     save curve info
      DO 15 I= 1,MAXLN
C       xy plot
        GCTYP(I) = 6
C       black/white color
        GCOLOR(I)= 1
C       no pattern
        GPATRN(I)= 0
 15   CONTINUE
      CALL GPCURV (GCTYP,GLNTYP,GSYMBL,GCOLOR,GPATRN,LABC)
C     save data ranges
      WHICH(1)= 1
      WHICH(2)= 4
      WHICH(3) = 1
      WHICH(4) = 4
      GVMIN(1) = 1.0E30
      GVMIN(2) = 1.0E30
      GVMAX(1) = -1.0E30
      GVMAX(2) = -1.0E30
      DO 30 J= 1,MAXLN
        DO 20 I= 1,MAXP
          IF (YPT(I).GT.GVMAX(1)) GVMAX(1)= YPT(I)
          IF (YPT(I).LT.GVMIN(1)) GVMIN(1)= YPT(I)
          IF (XPT(I).GT.GVMAX(2)) GVMAX(2)= XPT(I)
          IF (XPT(I).LT.GVMIN(2)) GVMIN(2)= XPT(I)
 20     CONTINUE
 30   CONTINUE
      GVMIN(3) = GVMIN(1)
      GVMIN(4) = GVMIN(2)
      GVMAX(3) = GVMAX(1)
      GVMAX(4) = GVMAX(2)
      CALL GPVAR (GVMIN,GVMAX,WHICH,GTRANF,LABV)
C     scale data, Y then X
      CALL SCALIT(AXTYP(1),GVMIN(1),GVMAX(1),
     O            PLMN(1),PLMX(1))
      GTICS(1) = 10
      CALL SCALIT(AXTYP(2),GVMIN(2),GVMAX(2),
     O            PLMN(4),PLMX(4))
      GTICS(4) = 10
      CALL ZIPI(4,0,GBVALF)
C     set up axis scaling
      CALL GPSCLE(PLMN,PLMX,GTICS,GBVALF)
C     define axes
      GXTYP= AXTYP(2)
      GYTYP(1)= AXTYP(1)
      GYTYP(2)= 0
      CALL GPLABL (GXTYP,GYTYP,ALEN,YLAB,XLAB,LABC,TITLE)
      CALL GPLBXB (XLAB)
C     set up sizes
      CALL GPSIZE(SIZEL,XPAGE,YPAGE,XPHYS,YPHYS,XLEN,YLEN,ALEN)
C
C     make the plot
C
      ICLOS = 0
      WSID = 1
 60   CONTINUE
C       plot, modify, done
        SGRP = 60
        CALL QRESP (MESSFL, SCLU, SGRP, MORE)
        IF (MORE .EQ. 1) THEN
C         create the plot
          IWAIT = 0
          CALL PSTUPW (WSID,RETCOD)
          CALL PLTONE
          CALL PDNPLT (WSID,ICLOS,IWAIT)
        ELSE IF (MORE .EQ. 2) THEN
C         modify specs
          CALL PROPLT (MESSFL, ICHK, WNAM,
     O                 WNDFLG)
C         check if user changed device type
          CALL GGDVTY (DEVTYP)
          IF (DEVTYP .NE. 1) THEN
C           device not monitor, change workstation id
            WSID = 2         
            ICLOS = 1
          ELSE
            WSID = 1
            ICLOS = 0
          END IF
        ELSE IF (MORE .EQ. 3) THEN
C         close the workstation
          ICLOS = 1
          IWAIT = 0
          WSID = 1
          CALL PDNPLT (WSID,ICLOS,IWAIT)
        END IF
      IF (MORE .LE. 2) GO TO 60

C
      IF (AXTYP(1) .EQ. 2) THEN
C       transform data back to logs
        DO 40 I = 1,MAXP
          YPT(I) = ALOG10(YPT(I))
          XPT(I) = ALOG10(XPT(I))
 40     CONTINUE
      END IF
C
      RETURN
      END
