C
C
C
      SUBROUTINE   PRTPRO
     I                   (MESSFL,WDMSFL,ERRFL)
C
C     + + + PURPOSE + + +
C     Partial record processing
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER      MESSFL,WDMSFL,ERRFL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     WDMSFL - Fortran unit number of WDM file
C     ERRFL  - Fortran unit number for diagnostic output
C
C     + + + PARAMETERS + + +
      INTEGER    DSNMX
      PARAMETER  (DSNMX=12)
C
C     + + + LOCAL VARIABLES + + +
      INTEGER       I0,I1,I2,I3,I4,I16,SCLU,SGRP,RESP,NSTAT,FLAG,N,
     1            SAIND,      RETCOD,DSNP(DSNMX),NDAY(DSNMX),
     2            ITYP(2),CLEN(1),ISTANO,ISTANX,ARESP
      REAL        RVAL
      CHARACTER*1 CTYPE(4),STANO(16),STANX(16)
      CHARACTER*8 PTHNAM
      DOUBLE PRECISION DVAL
C
C     + + + FUNCTIONS + + +
      INTEGER     CHRINT, CHKSTR
C
C     + + + EXTERNALS + + +
      EXTERNAL    QRESP, PRWMSE, WDBSGC, WDBSGI, PMXTXM, PRTNEW, PRTADD
      EXTERNAL    CHRINT, CHKSTR, PRNTXT, ZIPI
C
C     + + + DATA INITIALIZATIONS + + +
      DATA   I0,I1,I2,I3,I4,I16/0,1,2,3,4,16/
C
C     + + + END SPECIFICATIONS + + +
C
C     cluster for partial record processing
      SCLU = 152
C     no stations initially available
      NSTAT= 0
      CALL ZIPI (DSNMX,I0,NDAY)
C     assume good stations
      FLAG = 0
C     assume create
      RESP = 2
C
C     begin loop for options
 10   CONTINUE
C       1-select existing, 2-create new, 3-add to existing, 4-done
        SGRP= 1
        CALL QRESP (MESSFL,SCLU,SGRP,RESP)
C
        IF (RESP .EQ. 1) THEN
C         select existing partial record datasets
          PTHNAM= 'P'
          CALL PRWMSE (MESSFL,WDMSFL,DSNMX, PTHNAM,
     M                 DSNP,NSTAT)
C         assume good stations
          FLAG= 0
C         are they valid partial record datasets?
          IF (NSTAT .GT. 0) THEN
            N= 0
 12         CONTINUE
              N= N+ 1
C             get TSTYPE
              SAIND= 1
              CALL WDBSGC (WDMSFL,DSNP(N),SAIND,I4,CTYPE,RETCOD)
              NDAY(N)= CHRINT(I3,CTYPE(2))
              IF (NDAY(N) .EQ. 0) THEN
C               This dataset has wrong TSTYPE. Last 3 char must be
C               integer numbers
                ITYP(1)= 1
                ITYP(2)= 4
                CLEN(1)= 4
                SGRP= 2
                CALL PMXTXM (MESSFL,SCLU,SGRP,I16,I1,I2,ITYP,I0,
     1                       DSNP(N),RVAL,DVAL,CLEN,CTYPE)
                FLAG= 1
              END IF
              IF (CTYPE(1) .NE. 'L') THEN
C               This data set has wrong TSTYPE attribute.  It must
C               begin with 'L'.
                ITYP(1)= 1
                ITYP(2)= 4
                CLEN(1)= 4
                SGRP= 3
                CALL PMXTXM (MESSFL,SCLU,SGRP,I16,I1,I2,ITYP,I0,
     1                       DSNP(N),RVAL,DVAL,CLEN,CTYPE)
                FLAG= 1
              END IF
            IF (FLAG .EQ. 0 .AND. N .LT. NSTAT) GO TO 12
C
            IF (FLAG .EQ. 0 .AND. NSTAT .GT. 1) THEN
              WRITE(ERRFL,*) 'checking for same station id'
              SAIND= 2
              CALL WDBSGC (WDMSFL,DSNP(1),SAIND,I16,
     O                     STANO(1),RETCOD)
              IF (RETCOD .NE. 0) THEN
C               must be integer sta id
                WRITE(ERRFL,*) 'look for integer station id'
                SAIND= 51
                CALL WDBSGI (WDMSFL,DSNP(1),SAIND,I1,
     O                       ISTANO,RETCOD)
              ELSE
                WRITE(ERRFL,*) 'found character station id'
              END IF
              IF (RETCOD .EQ. 0) THEN
C               got station id, now check
                DO 14 N = 2, NSTAT
                  IF (SAIND .EQ. 2) THEN
C                   character station id
                    CALL WDBSGC (WDMSFL,DSNP(N),SAIND,I16,
     O                           STANX(1),RETCOD)
                    IF (CHKSTR(I16,I1,STANO,STANX) .NE. 1) THEN
C                     character station id's don't match
                      WRITE(ERRFL,*) '**** char id ',DSNP(N),' fails'
                      FLAG= 2
                    ELSE
                      WRITE(ERRFL,*) 'char id ',DSNP(N),' matches'
                    END IF
                  ELSE
C                   integer sta id
                    CALL WDBSGI (WDMSFL,DSNP(N),SAIND,I1,
     O                           ISTANX,RETCOD)
                    IF (ISTANO .NE. ISTANX) THEN
C                     integer station id's don't match
                      WRITE(ERRFL,*) '**** int id ',DSNP(N),' fails'
                      FLAG= 2
                    ELSE
                      WRITE(ERRFL,*) 'integer id',DSNP(N),' matches'
                    END IF
                  END IF
 14             CONTINUE
C
                IF (FLAG .EQ. 2) THEN
C                 Data sets not all same station (STANO or ISTANO).
                  SGRP= 4
                  CALL PRNTXT (MESSFL,SCLU,SGRP)
                END IF
              END IF
            END IF
          END IF
          RESP = 3
C
        ELSE IF (RESP .EQ. 2) THEN
C         create partial record datasets
Ckmf---------------------------------------------------------Note
Ckmf                                                         Note
Ckmf      Seems like if there should not be data sets in the Note
Ckmf      buffer, they should automatically be cleared.      Note
Ckmf                                                         Note
Ckmf---------------------------------------------------------Note
          IF (NSTAT .GT. 0) THEN
C           stations in buffer, keep it?
            ARESP= 2
            SGRP = 7
            CALL QRESP (MESSFL,SCLU,SGRP,ARESP)
          ELSE
C           no problem
            ARESP= 1
          END IF
C
          IF (ARESP .EQ. 1) THEN
C           no stations in buffer
            NSTAT= 0
C           create datasets
            CALL PRTNEW (MESSFL,SCLU,WDMSFL,ERRFL,DSNMX,
     M                   NSTAT,NDAY,
     O                   DSNP)
            FLAG= 0
          END IF
          RESP = 3
C
        ELSE IF (RESP .EQ. 3) THEN
C         add partial record data
          IF (NSTAT .EQ. 0) THEN
C           no stations to add data for
            SGRP= 5
            CALL PRNTXT (MESSFL,SCLU,SGRP)
          ELSE IF (FLAG .NE. 0) THEN
C           error in selection, must reselect first
            SGRP= 6
            CALL PRNTXT (MESSFL,SCLU,SGRP)
          ELSE
C           add partial record data
            CALL PRTADD (MESSFL,SCLU,WDMSFL,ERRFL,NSTAT,DSNP,NDAY)
          END IF
          RESP = 2
        END IF
      IF (RESP .NE. 4) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   PRTNEW
     I                   ( MESSFL, SCLU, WDMSFL, ERRFL, DSNMX,
     M                     NSTAT, NDAY,
     O                     DSNP )
C
C     + + + PURPOSE + + +
C     This routine creates a new data set for a partial record site
C     and adds basic attributes and basin characteristics.  It returns
C     assigned data set numbers.
C
C     + + + HISTORY + + +
C     13Apr2004 - combined General attributes and Duration screens into
C                 a single screen.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     MESSFL, SCLU, WDMSFL, ERRFL, DSNMX,
     $            NSTAT, NDAY(DSNMX), DSNP(DSNMX)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     SCLU   - Cluster containing text information for this routine
C     WDMSFL - Fortran unit number of WDM file
C     ERRFL  - Fortran unit number for diagnostic output
C     DSNMX  - Maximum number of datasets allowed in buffer
C     NSTAT  - Number of stations in buffer
C     NDAY   - Durations for new datasets
C     DSNP   - Datasets added
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      SGRP, SGRP2, RESP, DSNX, DSNEXT, RETC, MAX,
     $             I, N, I0, I1, I2, I4, I12, I14, I56, I78, IPT, IPR,
     $             DSTYP, SPACE, RTCMND, GFLG, MAKFG, MAKER, IRET,
     $             INDXI(9), INDXR(23), INDXC(3), KNTI, KNTR, KNTC,
     $             VALI(9), ATLNG, LENC(3), NBC,IVAL(14), AGAIN
      REAL         VALR(23)
      CHARACTER*1  VALC(60), BLNK
      CHARACTER*4  CTYP(12)
      CHARACTER*6  NAMEI(9), NAMER(23), NAMEC(3)
      CHARACTER*78 PRTROW(12)
C
C     + + + LOCAL DEFINITIONS + + +
C     MAKFG  - flag indicating make status of labels
C              0 - not made
C              >0- number of data sets made
C     MAKER  - flag indicating make failures
C              0 - no failures
C              >0- number of data sets not made
C     NBC    - number of basin characteristics specified
C              (initialized to 0)
C     GFLG   - flag indicating status of general attributes
C              0 - not input yet
C              1 - general attributes have been input
C              2 - not input yet, but user still wants to
C                  (attempted make)
C
C     + + + EXTERNALS + + +
      EXTERNAL  Q1INIT, QSETI, QSETR, QSETCT
      EXTERNAL  Q1EDIT, QGETI, QGETR, QGETCT
      EXTERNAL  QRESP,  PRNTXT, ZSTCMA
      EXTERNAL  WDSNAD
      EXTERNAL  INPATR, SVATSM
      EXTERNAL  ZIPC, ZIPI
C
C     + + + DATA INITIALIZATIONS + + +
C
C     attributes
      DATA  NAMEI / 'ISTAID', 'VBTIME', 'TCODE ', 'TSSTEP', 'TGROUP',
     $              'TSBYR ', 'TSFORM', 'COMPFG', 'STATCD'  /,
     $      INDXI /    51,       85,       17,       33,       34,
     $                 27,       84,       83,       57     /,
     $      VALI  /     0,        1,        6,        1,        7,
     $               1800,        5,        1,       99     /
      DATA  NAMER / 'LATDEG', 'LNGDEG', 'TSFILL', 20*'      ' /,
     $      INDXR /     8,        9,        32,   20*0        /,
     $      VALR  /   0.0,      0.0,    -999999., 20*0.0      /
      DATA  NAMEC / 'STANAM', 'AGENCY', 'TSTYPE' /,
     $      INDXC /    45,       40,        1    /,
     $      LENC  /    48,        8,        4    /
Ckmf  DATA  NAMEC / 'AGENCY', 'STANAM', 'TSTYPE' /,
Ckmf $      INDXC /    40,       45,        1    /,
Ckmf $      LENC  /     8,       48,        4    /
      DATA  ATLNG, MAX, KNTI, KNTR, KNTC
     $     /   60,  20,   9,    0,    3 /
      DATA  DSTYP, SPACE, I0, I1, I2, I4, I12, I14, I56, I78, BLNK
     $     /    1,     2,  0,  1,  2,  4,  12,  14,  56,  78, ' ' /
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT ( 'L', I3.3 )
 2301 FORMAT ( 4A1 )
 2311 FORMAT ( I6, 2X, A4, I6, 1X, 'Successfully created dsn ',
     $                             'and added attributes' )
 2312 FORMAT ( I6, 2X, A4, I6, 1X, 'Problem adding attributes',
     $                             '    !! WARNING !!' )
 2313 FORMAT ( I6, 2X, A4, I6, 1X, 'Problem creating data set',
     $                             '    !! WARNING !!' )
C
C     + + + END SPECIFICATIONS + + +
C
Ckmf---------------------------------------------------------Note
Ckmf                                                         Note
Ckmf      Subroutine wcrlod in code group glswdm.f checks    Note
Ckmf      for a value of 99 for attribute statcd.  However,  Note
Ckmf      prior to 10/22/04, neither this routine nor the    Note
Ckmf      manual nor stedinger routines set statcd.  This    Note
Ckmf      version of prtnew sets statcd to 99.               Note
Ckmf                                                         Note
Ckmf      If knti above is changed from 9 to 8, this routine Note
Ckmf      will stop adding attribute statcd.                 Note
Ckmf                                                         Note
Ckmf---------------------------------------------------------Note
C     initialize flags and counters
      MAKFG= 0
      MAKER= 0
      NBC  = 0
      GFLG = 0
      DSNX = -999
      CALL ZIPC ( ATLNG, BLNK, VALC )
      CALL ZIPI ( I14, -999,  IVAL )
      VALI(1) = -999
      VALR(1) = -999.
      VALR(2) = -999.
      DO 5 I = 4, 23
        NAMER(I) = '      '
        VALR(I)  = -999.
 5    CONTINUE
Ckmf---------------------------------------------------------Note
Ckmf                                                         Note
Ckmf  Should NDAY be initialized to none or go with what     Note
Ckmf  happens to be there?  NDAY is initialized in the       Note
Ckmf  the calling routine, so it is probably better to       Note
Ckmf  not initialize it.                                     Note
Ckmf                                                         Note
Ckmf---------------------------------------------------------Note
C
C     default to Define durations
      RESP = 1
 10   CONTINUE
C       Which create option?
C          1 - Define durations and descriptive attributes
C          2 - Input study-specific characteristics
C          3 - Make partial record data set(s)
C          4 - Return to Partial screen
        SGRP = 20
        CALL QRESP ( MESSFL, SCLU, SGRP, RESP )
        GO TO (100,200,300,400), RESP
C
C       Define durations and descriptive attributes
        IVAL(1)  = VALI(1)
        CALL COPYI ( I12, NDAY, IVAL(2) )
        IVAL(14) = DSNX
 100    CONTINUE
          IVAL(1)  = VALI(1)
          CALL COPYI ( I12, NDAY, IVAL(2) )
          IVAL(14) = DSNX
 110      CONTINUE
            SGRP = 22
            AGAIN = 0
            CALL Q1INIT ( MESSFL, SCLU, SGRP )
            CALL QSETCT ( I2, LENC, I56, VALC )
            CALL QSETR  ( I2, VALR )
            CALL QSETI  ( I14, IVAL )
            CALL Q1EDIT ( IRET )
            IF (IRET .EQ. -1) THEN
C             oops, try again
              AGAIN = 1
            ELSE IF (IRET .EQ. 2) THEN
C             Previous, take no action
              AGAIN = -1
            ELSE
C             assume Accept, user wants to continue (1)
              CALL QGETCT ( I2, LENC, I56, VALC )
              CALL QGETR  ( I2, VALR )
              CALL QGETI  ( I14, IVAL )
              DSNX   = IVAL(14)
              VALI(1) = IVAL(1)
C             count durations
              IPT = 0
              IPR = 13
              DO 140 I = 2, 13
                IF (IVAL(I) .NE. 0) THEN
C                 user specified a duration
                  IPT = IPT + 1
                  NDAY(IPT) = IVAL(I)
                  WRITE (CTYP(IPT),2000) NDAY(IPT)
                ELSE
C                 no duration specified, fill from end with zero
                  IPR = IPR - 1
                  NDAY(IPR) = 0
                END IF
 140          CONTINUE
              IF (IPT .GT. 0) NSTAT = IPT
              GFLG = 1
              RESP = 2
            END IF
          IF (AGAIN .EQ. 1) GO TO 110
          GO TO 10
C
C       input study-specific basin characteristics (attributes)
 200    CONTINUE
          SGRP = 25
          SGRP2= 0
          CALL INPATR ( MESSFL, SCLU, SGRP, SGRP2, ERRFL, MAX,
     M                  NAMER(4), INDXR(4), VALR(4),
     O                  NBC, RETC )
      KNTR = 3 + NBC
C         make prev not available
          I= 4
          CALL ZSTCMA(I,I0)
          RESP = 3
          GO TO 10
C
C       Make the labels
 300    CONTINUE
          IF (GFLG .EQ. 0  .OR.  NSTAT .EQ. 0) THEN
C           can't add labels without general attributes and durations
            SGRP= 28
            CALL PRNTXT(MESSFL,SCLU,SGRP)
            RESP = 1
          ELSE IF (NSTAT .EQ. 0) THEN
C           no durations available
            SGRP= 32
            CALL PRNTXT(MESSFL,SCLU,SGRP)
            RESP = 1
          ELSE
C           create data set and add attributes
            DSNEXT = DSNX - 1
            DO 350 N = 1, NSTAT
C             add one data set for each duration
C             starting with data set DSNX, increment by 1 as needed
C             to define nstat new data sets.  It may be that data
C             sets are not contiguous.
              DSNEXT = DSNEXT + 1
              DSNP(N)= DSNEXT
              CALL WDSNAD ( WDMSFL, DSTYP, SPACE,
     M                      DSNEXT, DSNP(N),
     O                      RETC )
              IF (RETC .EQ. 0) THEN
C               data set created, add attributes
                READ (CTYP(N),2301) (VALC(I), I = 57, 60)
                CALL SVATSM ( MESSFL, SCLU, SGRP, WDMSFL,
     I                        ERRFL, DSNP(N),
     I                        KNTI, INDXI, NAMEI, VALI,
     I                        KNTR, INDXR, NAMER, VALR,
     I                        KNTC, INDXC, NAMEC, VALC, LENC, ATLNG,
     O                        RTCMND )
                IF (RTCMND .EQ. 0) THEN
                  WRITE (PRTROW(N),2311) DSNP(N), CTYP(N), RETC
                ELSE
                  WRITE (PRTROW(N),2312) DSNP(N), CTYP(N), RETC
                END IF
                MAKFG = MAKFG + 1
              ELSE
C               problem creating data set
                WRITE (PRTROW(N),2313) DSNP(N), CTYP(N), RETC
                SGRP = 29
                CALL PRNTXA ( MESSFL, SCLU, SGRP, I4, VALC(57) )
              END IF
 350        CONTINUE
C           report results
            SGRP = 29
            CALL Q2INIT ( MESSFL, SCLU, SGRP )
            CALL Q2SCTF ( I1, I78, NSTAT, PRTROW )
            CALL Q2EDIT ( NSTAT, IRET )
          END IF
          RESP = 4
          GO TO 10
C
C       user wants to return to Partial screen
 400    CONTINUE
          IF (GFLG .EQ. 1  .AND.  MAKFG .EQ. 0) THEN
C           general info but no labels created, which create option
C           1 - Define durations and descriptive attributes
C           2 - Input study-specific characteristics
C           3 - Make partial record data set(s)
C           4 - Return to Partial screen
            RESP= 3
            SGRP = 31
            CALL QRESP ( MESSFL, SCLU, SGRP, RESP )
          END IF
C
          GO TO (100,200,300,500), RESP
C
C     finished
 500  CONTINUE
C
      RETURN
      END
C
C
C
      SUBROUTINE   PRTADD
     I                   (MESSFL,SCLU,WDMSFL,ERRFL,NSTAT,DSNP,NDAY)
C
C     + + + PURPOSE + + +
C     This routine adds data for a partial record site using the
C     Stedinger technique or with manual input from the terminal
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     MESSFL,SCLU,WDMSFL,ERRFL,NSTAT,DSNP(NSTAT),
     &            NDAY(NSTAT)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     SCLU   - Cluster containing text information for this routine
C     WDMSFL - Fortran unit number of WDM file
C     ERRFL  - Fortran unit number for diagnostic output
C     NSTAT  - Number of stations in buffer
C     DSNP   - Datasets to add data into
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      SGRP,RESP
C
C     + + + EXTERNALS + + +
      EXTERNAL     QRESP,PRTSTE,PRTMAN
C
C     + + + END SPECIFICATIONS + + +
C
      RESP= 1
C     add option:  1-Stedinger, 2-Manual, 3-Return
      SGRP= 40
      CALL QRESP (MESSFL,SCLU,SGRP, RESP)
      IF (RESP .EQ. 1) THEN
C       compute with stedinger technique
        CALL PRTSTE (MESSFL,WDMSFL,ERRFL,NSTAT,DSNP,NDAY)
      ELSE IF (RESP .EQ. 2) THEN
C       manually add data
        CALL PRTMAN (MESSFL,SCLU,WDMSFL,ERRFL,NSTAT,DSNP,NDAY)
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   PRTMAN
     I                   ( MESSFL, SCLU, WDMSFL, ERRFL,
     I                     NSTAT, DSNP, NDAY )
C
C     + + + PURPOSE + + +
C     This routine adds data for a partial record site using manual
C     data entry from terminal
C
C     + + + HISTORY + + +
C     27May2004 - added NDAY to dummy argument list
C     19Aug2004 - manual option has been adding the  2, 10, & 20 -year
C                 recurrences for 7-day flows, independent of what the
C                 data set is.  Corrected to add 2, 10, & 20 -year
C                 for 1, 3, 7, 14, 30, & 90 n-days and to warn that
C                 attributes not available for other n-days.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, SCLU, WDMSFL, ERRFL,
     $          NSTAT, DSNP(NSTAT), NDAY(NSTAT)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     SCLU   - Cluster containing text information for this routine
C     WDMSFL - Fortran unit number of WDM file
C     ERRFL  - Fortran unit number for diagnostic output
C     NSTAT  - Number of datasets in buffer (max of MXNDY)
C     DSNP   - Datasets to add data into
C     NDAY   - Durations for new data sets
C
C     + + + PARAMETERS + + +
      INTEGER   MXNDY
      PARAMETER (MXNDY = 12)
C     pmxyrs contains mxyrs, mxrns
      INCLUDE 'pmxyrs.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER       KNTNOS, KNTSTA, KNTBAD, NPRT,
     $              TSTEP, TCODE, TS, TU, TRAN, QGT, QPT, OVWR,
     $              I, J, K, N, JPT, KPT, L1, L78, IRET, ICOL,
     $              GSTAT, GTIME, GPFLG, DATW(6),
     $              IVAL(6,2), INDX(3,6), NODY(6), NDURS, YRBASE, NVAL,
     $              SDAT(6,MXNDY), EDAT(6,MXNDY), NYRS, YRBG,
     $              TSBYR(MXNDY), IPTN, NPT(MXNDY), FLAG(MXNDY),
     $              SGRP, SGRP1, SGRP2, SGRP3, RESP, RETC, RETC2, AGAIN
      REAL          TSFILL(MXNDY), YRMEAS(MXYRS),
     $              RECUR(6,3), XMISS
      CHARACTER*4   TSTYPE(MXNDY)
      CHARACTER*6   NAME(3,6)
      CHARACTER*16  STAID(MXNDY)
      CHARACTER*48  STANAM(MXNDY)
      CHARACTER*78  PRTROW(20)
C
C     + + + LOCAL DEFINITIONS + + +
C     YFLG   - indicator flag for years to add
C              0 - none
C     FFLG   - indicator flag for discharges to add
C              0 - none
C
C     flow statistic atributes currently (may 24,2004) include:
C       L01002 L01010 L01020
C                            L04003
C       L03002 L03010 L03020        L07005 L07050 L07100
C       L07002 L07010 L07020
C       L14002 L14010 L14020   Note:  only the 2, 10, and 20 year
C       L30002 L30010 L30020          recurrence attributes can be
C       L90002 L90010 L90020          added under this option.
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDGTTM, GTINFO
      EXTERNAL   WDBSGI, WDBSGR, WDBSAI, WDBSAR, WDTGET, WDTPUT
      EXTERNAL   Q2INIT, Q2STRB, Q2STIB, Q2SCTF, QRESP
      EXTERNAL   Q2EDIT, Q2GTRB
      EXTERNAL   RUNABT
C
C     + + + OUTPUT FORMATS + + +
 2001 FORMAT (   3X, I5, 2X, I5, 2X, I7, 2X,
     $             'data set missing or wrong type' )
 2002 FORMAT (   3X, I5, 2X, I5, 2X, I7, 2X,
     $             'time step is not annual' )
 2003 FORMAT (   3X, I5, 2X, I5, 2X, I7, 2X,
     $             'problem retrieving existing data' )
 2004 FORMAT (   3X, I5, 2X, I5, 2X, '    ---', 2X,
     $             'statistics not available for this n-day' )
 2005 FORMAT (   3X, I5, 2X, I5, 2X, I7, 2X,
     $             'unexpected problem with this data set' )
 2006 FORMAT (   3X, I5, 2X, I5, 2X, 7X, 2X,
     $             'conflict with start, expected', I5,
     $             ' found', I5 )
C
C     + + + DEBUG FORMATS + + +
 3001 format (   'prtman <-- wdgttm:       i =', i5,
     $         /,'                 :    dsnp =', i5,
     $         /,'                 :    sdat =', i5,
     $         /,'                 :    edat =', i5,
     $         /,'                 : ts & tc =', i5, i5 )
 3002 format (   '                 :  tsfill =', f10.2
     $         /,'                 :    retc =', i5 )
 3003 format (   'prtman <-- gtinfo:  tstype =', 1x, a,
     $         /,'prtman <-- wdbsgi:   tsbyr =', i5,
     $         /,'                 :    retc =', i5 )
 3040 format (   'prtman: 40 loop - done finding out about dsn(s)',
     $         /,'                      nprt =', i5,
     $         /,'                     nstat =', i5,
     $         /,'                    kntsta =', i5,
     $         /,'                    kntnos =', i5,
     $         /,'                    kntbad =', i5 )
 3099 format (   'prtman:  START 100 :   sgrp1 =', i5,
     $         /,'                   :   sgrp2 =', i5,
     $         /,'                   :   sgrp3 =', i5,
     $         /,'                   :   gpflg =', i5,
     $         /,'                   :   gstat =', i5,
     $         /,'                   :   gtime =', i5,
     $         /,'                   :   nstat =', i5,
     $         /,'                   :    flag =', 6i5,
     $         /,'                   :          ', 6i5,
     $         /,'                   :     npt =', 6i5,
     $         /,'                   :          ', 6i5 )
 3110 format (   'prtman:  RETURN    :   gpflg =', i5 )
 3120 format (   'prtman:  ADD       :   gpflg =', i5,
     $         /,'                   :   gstat =', i5,
     $         /,'                   :   gtime =', i5,
     $         /,'                   :   nstat =', i5,
     $         /,'                   :    flag =', 6i5,
     $         /,'                   :          ', 6i5,
     $         /,'                   :     npt =', 6i5,
     $         /,'                   :          ', 6i5,
     $         /,'                   :  yrbase =', i5,
     $         /,'                   :    yrbg =', i5,
     $         /,'                   :    nyrs =', i5 )
 3121 format (   '                   :  messfl =', i5,
     $         /,'                   :  wdmsfl =', i5,
     $         /,'         <-- wdbsar:  i  n  dsnp  k indx(n,k)',
     $           '    recur  retc' )
 3122 format (    20x, 2i3, i6, i3, i6, 4x, f10.2, i6 )
 3125 format (   '         --> wdtput:    dsnp =', i5,
     $         /,'                   :    sdat =', i5,
     $         /,'                   :    nval =', i5,
     $         /,'                   :    iptn =', i5 )
 3126 format (   '         <-- wdtput:    retc =', i5 )
 3300 format (   'prtman:  YEARS     :',
     $         /,'         --> runabt:  yrbase =', i5,
     $         /,'                   :  tsfill =', f10.2 )
 3301 format (   '         <-- runabt:    yrbg =', i5,
     $         /,'                   :    nyrs =', i5,
     $         /,'                   :   gtime =', i5,
     $         /,'                   :   gpflg =', i5 )
 3400 format (   'prtman:  STATS     :     kpt =', I5,
     $            '     k  dsn   n-day    2-year   10-year  20-year')
 3401 format (    19x, ':                  ', i3, i6, i6, 3f10.2  )
 3404 format (  '          --> q2init:    sgrp =', i5,
     $          '      call   columns column length value' )
 3405 format (   37x, a10, i7, i8, i7, i12 )
 3406 format (   37x, a10, i7, i8, i7, f12.2 )
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  TS, TU, QGT, QPT, TRAN, OVWR, L1, DATW
     $    /  1,  6,  31,   0,    0,    1,  1, 0,1,1,0,0,0 /
      DATA NDURS, NODY
     $    /    6, 1,3,7,14,30,90 /
      DATA NAME /'L01002', 'L01010', 'L01020',
     $           'L03002', 'L03010', 'L03020',
     $           'L07002', 'L07010', 'L07020',
     $           'L14002', 'L14010', 'L14020',
     $           'L30002', 'L30010', 'L30020',
     $           'L90002', 'L90010', 'L90020'  /
      DATA INDX /    156,      157,      158,
     $               159,      160,      161,
     $               162,      164,      165,
     $               166,      167,      168,
     $               169,      170,      171,
     $               172,      173,      174  /
C     DATA   NODY, NAME, INDX
C    $    /    1,        3,        7,       14,       30,       90,
C    $      'L01002', 'L03002', 'L07002', 'L14002', 'L30002', 'L90002',
C    $      'L01010', 'L03010', 'L07010', 'L14010', 'L30010', 'L90010',
C    $      'L01020', 'L03020', 'L07020', 'L14020', 'L30020', 'L90020',
C    $          156,      159,      162,      166,      169,      172,
C    $          157,      160,      164,      167,      170,      173,
C    $          158,      161,      165,      168,      171,      174 /
C
C     + + + END SPECIFICATIONS + + +
C
      GSTAT = 0
      GTIME = 0
      GPFLG = 0
      NPRT  = 0
C
      KNTNOS = 0
      KNTSTA = 0
      KNTBAD = 0
      NYRS   = 0
      XMISS = -999.
      N = 3 * NDURS
      CALL ZIPR ( N, XMISS, RECUR )
C
C     find out about the data set(s)
      DO 40 I = 1, NSTAT
        NPT(I) = 0
        CALL WDGTTM ( WDMSFL, DSNP(I),
     O                SDAT(1,I), EDAT(1,I), TSTEP, TCODE,
     O                TSFILL(I), RETC )
Ckmf    write (errfl,3001) i,dsnp(i),sdat(1,i),edat(1,i),tstep,tcode
Ckmf    write (errfl,3002) tsfill(i), retc
        IF (RETC .EQ. -81  .OR. RETC .EQ. -82  .OR. RETC .EQ. -85) THEN
C         problem:  retc = -81 - data set does not exist
C                          -82 - data set exists, but not a time series
C                          -85 - trying to write to read-only data set
          FLAG(I) = -99
          KNTBAD  = KNTBAD + 1
          NPRT = NPRT + 1
          WRITE (PRTROW(NPRT),2001) DSNP(I), NDAY(I), RETC
          WRITE (ERRFL,2001) DSNP(I), NDAY(I), RETC
        ELSE IF (TCODE .NE. 6  .AND.  TSTEP .NE. 1) THEN
C         wrong time step
          FLAG(I) = -98
          KNTBAD  = KNTBAD + 1
          NPRT = NPRT + 1
          WRITE (PRTROW(NPRT),2002) DSNP(I), NDAY(I), RETC
          WRITE (ERRFL,2002) DSNP(I), NDAY(I), RETC
        ELSE IF (RETC .EQ.  0  .OR.  RETC .EQ. -6) THEN
C         no problems:  retc = 0 - everything ok,  -6 - no data present
          FLAG(I) = RETC
          CALL GTINFO ( WDMSFL, DSNP(I),
     O                  STAID(I), STANAM(I), TSTYPE(I) )
          CALL WDBSGI ( WDMSFL, DSNP(I), 27, 1,
     O                  TSBYR(I), RETC2 )
Ckmf      write (errfl,3003) tstype(i), tsbyr(i), retc2
          IF (RETC2 .EQ. -107  .OR.  TSBYR(I) .EQ. -999) THEN
C           retc = -107 - base year attribute not present
            IF (RETC .EQ. -6) THEN
C             no data present, set to 1800
              TSBYR(I) = 1800
              CALL WDBSAI ( WDMSFL, DSNP(I), MESSFL, 27, 1, TSBYR(I),
     O                      RETC2 )
              IF (RETC2 .NE. 0) THEN
C               problem adding base year, go with default
                TSBYR(I) = 1900
              END IF
            ELSE
C             data present, use default of 1900
              TSBYR(I) = 1900
            END IF
          END IF
          IF (I .EQ. 1) THEN
C           all durations are expected to equal the first time series
            YRBASE = TSBYR(I)
            IF (FLAG(I) .EQ. 0) THEN
C             get time series data
              NYRS = EDAT(1,I) - SDAT(1,I) + 1
              IPTN = SDAT(1,I) - YRBASE + 1
              CALL WDTGET ( WDMSFL, DSNP(I), TS, SDAT(1,I), NYRS,
     I                      TRAN, QGT, TU,
     O                      YRMEAS(IPTN), RETC )
              IF (RETC .EQ. 0) THEN
                KNTSTA = KNTSTA + 1
              ELSE
                FLAG(I) = -97
                KNTBAD  = KNTBAD + NSTAT
                NPRT = NPRT + 1
                WRITE (PRTROW(NPRT),2003) DSNP(I), NDAY(I), RETC
                WRITE (ERRFL,2003) DSNP(I), NDAY(I), RETC
              END IF
            ELSE
C             no existing time series
              CALL ZIPR ( MXYRS, TSFILL(I), YRMEAS )
              NYRS = 0
              YRBG = 0
              FLAG(I) = 0
              KNTNOS = KNTNOS + 1
            END IF
          ELSE
            FLAG(I) = 0
          END IF
C         match up requested n-day to available attributes
C         i - range of requested n-day
C         j - range of possible n-days with 2,10,20 recurrences
C         k - range of requested n-days with 2,10,20 recurrences
          JPT = 0
          KPT = 0
          J   = 0
          K   = 0
 20       CONTINUE
            J = J + 1
            IF (NDAY(I) .EQ. NODY(J)) THEN
C             for this nday, 2, 10, &20 -year recruurences available
              JPT = J
              NPT(I) = J
            END IF
          IF (J .LT. NDURS  .AND.  JPT .EQ. 0) GO TO 20
          IF (JPT .EQ. 0) THEN
C           no recurrences for this n-day
            NPRT = NPRT + 1
            WRITE (PRTROW(NPRT),2004) DSNP(I), NDAY(I)
            WRITE (ERRFL,2004) DSNP(I), NDAY(I)
          ELSE
C           recurrences available, add to statistics question
            K = K + 1
            IVAL(K,1) = DSNP(I)
            IVAL(K,2) = NDAY(I)
            DO 30 N = 1, 3
              CALL WDBSGR ( WDMSFL, DSNP(I), INDX(N,K), L1,
     O                      RECUR(K,N), RETC )
              IF (RETC .NE. 0) THEN
C               default to missing (assume -107-attribute not present)
                RECUR(K,N) = -999.
              END IF
 30         CONTINUE
          END IF
          KPT = K
        ELSE
C         unknown problem
          FLAG(I) = -99
          KNTBAD  = KNTBAD + 1
          NPRT = NPRT + 1
          WRITE (PRTROW(NPRT),2005) DSNP(I), NDAY(I), RETC
          WRITE (ERRFL,2005) DSNP(I), NDAY(I), RETC
        END IF
        IF (I .GT. 1) THEN
C         make sure period of record ok for time series
          IF (SDAT(1,I) .NE. SDAT(1,1)  .AND.  SDAT(1,I) .NE. 0) THEN
C           start years do not agree
            FLAG(I) = -96
            KNTBAD = KNTBAD + 1
            NPRT = NPRT + 1
            WRITE (PRTROW(NPRT),2006) DSNP(I), NDAY(I),
     $             SDAT(1,1), SDAT(1,I)
            WRITE (ERRFL,2006)  DSNP(I), NDAY(I), SDAT(1,1), SDAT(1,I)
          END IF
        END IF
 40   CONTINUE
C
Ckmf  write (errfl,3040) nprt, nstat, kntsta, kntnos, kntbad
      IF (NPRT .GT. 0) THEN
        IF (KNTBAD .GE. NSTAT) THEN
C         cannot continue
          SGRP = 45
        ELSE
          SGRP = 46
        END IF
        CALL Q2INIT ( MESSFL, SCLU, SGRP )
        CALL Q2SCTF ( L1, L78, NPRT, PRTROW )
        CALL Q2EDIT ( NPRT, IRET )
        NPRT = 0
      END IF
      IF (KNTBAD .GE. NSTAT) GO TO 999
C
C---------------------------------------------------------------------
C
      IF (KPT .GT. 0) THEN
        SGRP1 = 50
        SGRP2 = 51
        SGRP3 = 52
C       no statistics to process
      ELSE
C       don't include Statistics option
        SGRP1 = 55
        SGRP2 = 56
        SGRP3 = 57
      END IF
      RESP = 3
Ckmf  write (errfl,3099) sgrp1, sgrp2, sgrp3,
Ckmf $                   gpflg, gstat, gtime, nstat, flag, npt
 100  CONTINUE
C       1-Return, 2-Write, 3-Years, (4-Statistics)
        IF (RESP .EQ. 4  .AND. SGRP1 .EQ. 50) THEN
C         statistics not available, default to Add
          RESP = 2
        END IF
        CALL QRESP ( MESSFL, SCLU, SGRP1, RESP )
        IF (RESP .EQ. 1) THEN
C         return to Add menu
Ckmf      write (errfl,3110) gpflg
          IF (GPFLG .EQ. 1) THEN
C           data specified but not yet added, continue?
            RESP = 2
            CALL QRESP ( MESSFL, SCLU, SGRP2, RESP )
          END IF
          IF (RESP .EQ. 1) RESP = 5
        END IF
        IF (RESP .EQ. 2) THEN
C         Write data to data set(s)
Ckmf      write (errfl,3120) gpflg, gstat, gtime, nstat, flag, npt,
Ckmf $                       yrbase, yrbg, nyrs
          IF (GPFLG .EQ. 0) THEN
C           no data, 1-Return, 2[3]-Years, (3[4]-Statistics)
            CALL QRESP ( MESSFL, SCLU, SGRP3, RESP )
            IF (RESP .GT. 1) THEN
C             increment to agree with main loop
              RESP = RESP + 1
            END IF
          ELSE
Ckmf        write (errfl,3121) messfl, wdmsfl
            DO 250 I = 1, NSTAT
              IF (GSTAT .EQ. 1  .AND.  NPT(I) .GT. 0) THEN
C               write flow stats attributes for this n-day
                K = NPT(I)
                DO 220 N = 1, 3
                  CALL WDBSAR ( WDMSFL, DSNP(I), MESSFL,
     $                          INDX(N,K), L1, RECUR(I,N), RETC )
Ckmf              WRITE (ERRFL,3122) I, N, DSNP(I), K, INDX(N,K),
Ckmf $                               RECUR(I,N), RETC
 220            CONTINUE
              END IF
              IF (GTIME .EQ. 1  .AND.  FLAG(I) .EQ. 0) THEN
C               write years of data
C               NOTE:  first time series used for all data sets
                IF (SDAT(1,I) .EQ. 0) THEN
C                 no data in data set
                  DATW(1) = YRBG
                  IPTN = DATW(1) - YRBASE + 1
                  NVAL = NYRS
                ELSE IF (YRBG .GT. SDAT(1,I)) THEN
C                 origially started earlier, 
                  IPTN = SDAT(1,I) - YRBASE + 1
                  NVAL = NYRS + YRBG - SDAT(1,I)
                  DATW(1) = SDAT(1,I)
                ELSE
C                 same or earlier start
                  IPTN = YRBG - YRBASE + 1
                  NVAL = NYRS
                  DATW(1) = YRBG
                END IF
Ckmf            write (errfl,3125) dsnp(i), datw(1), nval, iptn
                CALL WDTPUT ( WDMSFL, DSNP(I), TS, DATW, NVAL,
     I                        OVWR, QPT, TU,
     O                        YRMEAS(IPTN), RETC )
Ckmf            write (errfl,3126) retc
              END IF
 250        CONTINUE
            GSTAT = 0
            GTIME = 0
            GPFLG = 0
          END IF
Ckmf---------------------------------------------------------Note
Ckmf                                                         Note
Ckmf      When Add is selected, there is a slight flash and  Note
Ckmf      the default switches to Return.  Should there be   Note
Ckmf      positive reinforcement indicating the data was     Note
Ckmf      added and then automatically return to the Manual  Note
Ckmf      menu?                                              Note
Ckmf                                                         Note
Ckmf---------------------------------------------------------Note
          RESP = 1
        ELSE IF (RESP .EQ. 3) THEN
C         Years:  1-Enter, 2-List, 3-Clear, 4-Return
Ckmf      write (errfl,3300) yrbase, tsfill(1)
          CALL RUNABT ( MESSFL, SCLU, YRBASE, TSFILL(1),
     M                  YRMEAS,
     O                  YRBG, NYRS )
          IF (NYRS .GT. 0) THEN
            GTIME = 1
            GPFLG = 1
          END IF
          RESP = 4
Ckmf      write (errfl,3301) yrbg, nyrs, gtime, gpflg
        ELSE IF (RESP .EQ. 4) THEN
C         input flow stats for available attributes
C         option not available if KPT = 0
C         indexes:  i - range of possible n-days w/ 2,10,20 recurrences
C                   j - range of requested n-days
C                   k - range of requested n-days w/ 2,10,20 recurrences
C                   n - range of recurrences (3 = 2,10,20)
Ckmf      write (errfl,3400) kpt
Ckmf      write (errfl,3401) (k, ival(k,1), ival(k,2),
Ckmf $                       (recur(k,i),i=1,3),k=1,kpt)
 400      CONTINUE
            AGAIN = 0
            SGRP = 60
Ckmf        write (errfl,3404) sgrp
            CALL Q2INIT ( MESSFL, SCLU, SGRP )
            ICOL = 1
Ckmf        write (errfl,3405) '--> q2stib', l1, icol, kpt, ival(1,1)
            CALL Q2STIB ( L1, ICOL,   KPT, IVAL(1,1) )
Ckmf        write (errfl,3405) '--> q2stib', l1, icol+1, kpt, ival(1,2)
            CALL Q2STIB ( L1, ICOL+1, KPT, IVAL(1,2) )
            DO 420 ICOL = 1, 3
Ckmf          write (errfl,3406) '--> q2strb', l1, icol, kpt,
Ckmf $                           recur(1,icol)
              CALL Q2STRB ( L1, ICOL, KPT, RECUR(1,ICOL) )
 420        CONTINUE
            CALL Q2EDIT ( KPT, AGAIN )
            IF (AGAIN .NE. -1  .AND.  AGAIN .NE. 2) THEN
C             not Oops or Prev, assume Acpt, get statistics
              DO 430 ICOL = 1, 3
                CALL Q2GTRB ( L1, ICOL, KPT, RECUR(1,ICOL) )
Ckmf            write (errfl,3406) '<-- q2strb', l1, icol, kpt,
Ckmf $                             recur(1,icol)
 430          CONTINUE
              GSTAT = 1
              GPFLG = 1
            END IF
          IF (AGAIN .EQ. -1) GO TO 400
          RESP = 2
        END IF
      IF (RESP .LT. 5) GO TO 100
C
 999  CONTINUE
C
      RETURN
      END
C
C
C
      SUBROUTINE   RUNABT
     I                   ( MESSFL, SCLU, YRBASE, MISS,
     M                     YRMEAS,
     O                     YRBG, NYRS )
C
C     + + + PURPOSE + + +
C     Identify, list, or set runs of data.
C
C     + + + PARAMETERS + + +
      INCLUDE 'pmxyrs.inc'
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, SCLU, YRBASE, YRBG, NYRS
      REAL      MISS, YRMEAS(MXYRS)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     SCLU   - Cluster containing text information for this routine
C     YRBASE - base year for time series array
C     MISS   - missing value indicator in time series array
C     YRMEAS - time series array
C     YRBG   - first non-missing year in time series array
C     NYRS   - number of values in time series array
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   PREV, OFF, ZEROI, AGAIN, SGRP, RESP,
     $          ICOL, L1, L2, LRUN,
     $          IP, YRKNT, YRB(MXRNS), YRE(MXRNS)
      integer   errfl
      REAL      FILL
C
C     + + + EXTERNALS + + +
      EXTERNAL   QRESP, Q2INIT, Q2STIB, Q2EDIT, Q2GTIB
      EXTERNAL    ZIPI,   ZIPR
      EXTERNAL  RUNGET, RUNPUT
C
C     + + + DEBUG FORMATS + + +
 3001 format (   'runabt:  --> runget: yrbase =', i5,
     $         /,'                   :   miss =', f10.2 )
 3002 format (   'runabt:  <-- runget:  yrknt =', i5,
     $         /,'                   : run(1) =', 2i5 )
 3130 format (   'runabt:  ENTER     :     l1 =', i5,
     $         /,'                   :   lrun =', i5, '   ip icol',
     $           ' yrb yre' )
 3131 format (   '                   :  -->    ', 5x, 4i5 )
 3133 format (   '                   : <--     ', 5x, 4i5 )
 3135 format (   '         --> runput: yrbase =', i5,
     $         /,'                   :   fill =', f10.2,
     $         /,'                   :   miss =', f10.2,
     $         /,'                   :  yrknt =', i5 )
 3136 format (   '         <-- runput:   yrbg =', i5,
     $         /,'                   :   nyrs =', i5,
     $         /,'                   :  yrknt =', i5 )
 3140 format (   'runabt:  LIST      :',
     $         /,'         --> runget:  yrknt =', i5 )
 3141 format (   '         <-- runget:  yrknt =', i5,
     $         /,'                   : run(1) =', 2i5,
     $         /,'                   :   yrbg =', i5 )
 3200 format (   'runabt:  RETURN    : yrbase =', i5,
     $         /,'                   :  yrknt =', i5,
     $         /,'                   : run(1) =', 2i5,
     $         /,'                   :   yrbg =', i5,
     $         /,'                <--:   nyrs =', i5 )
C
C     + + + DATA INITIALIZATIONS + + +
      DATA   FILL, ZEROI, PREV, OFF, L1, L2
     $     /  1.0,     0,    4,   0,  1,  2 /
C
C     + + + END SPECIFICATIONS + + +
C
C     PREVious not available
      CALL ZSTCMA ( PREV, OFF )
C
      LRUN = MXRNS / 5
C
      errfl = 99
Ckf   write (errfl,3001) yrbase, miss
      CALL RUNGET ( YRBASE, MISS, YRMEAS,
     O              YRKNT, YRB, YRE )
Ckf   write (errfl,3002) yrknt, yrb(1), yre(1)
      YRBG = YRB(1)
      RESP = 2
 100  CONTINUE
C       1-Return, 2-Enter, 3-List, 4-Clear
        IF (YRKNT .GT. 0) THEN
          SGRP = 70
        ELSE
          SGRP= 71
        END IF
        CALL QRESP ( MESSFL, SCLU, SGRP, RESP )
        IF (RESP .EQ. 2) THEN
C         Enter years
 110      CONTINUE
            AGAIN = 0
            SGRP = 72
            CALL Q2INIT ( MESSFL, SCLU, SGRP )
            IP = 1
Ckf         write (errfl,3130) l1, lrun
            DO 115 ICOL = 1, 9, 2
Ckf           write (errfl,3131) ip, icol
              CALL Q2STIB ( L1, ICOL,   LRUN, YRB(IP) )
              CALL Q2STIB ( L1, ICOL+1, LRUN, YRE(IP) )
              IP = IP + 5
 115        CONTINUE
            CALL Q2EDIT ( LRUN, AGAIN )
            IF (AGAIN .NE. -1  .AND.  AGAIN .NE. 2) THEN
C             not Oops or Prev, assume Acpt, get years
              IP = 1
              DO 130 ICOL = 1, 9, 2
                CALL Q2GTIB ( L1, ICOL,   LRUN, YRB(IP) )
                CALL Q2GTIB ( L1, ICOL+1, LRUN, YRE(IP) )
Ckf             write (errfl,3133) ip, icol, yrb(ip), yre(ip)
                IP = IP + 5
 130          CONTINUE
            END IF
          IF (AGAIN .EQ. -1) GO TO 110
          YRKNT = MXRNS
Ckf       write (errfl,3135) yrbase, fill, miss, yrknt
          CALL RUNPUT ( YRBASE, FILL, MISS, YRKNT, YRB, YRE,
     O                  YRBG, NYRS, YRMEAS )
Ckf       write (errfl,3136) yrbg, nyrs, yrknt
          RESP = 3
        ELSE IF (RESP .EQ. 3) THEN
C         List currently defined years
Ckf       write (errfl,3140) yrknt
          CALL RUNGET ( YRBASE, MISS, YRMEAS,
     O                  YRKNT, YRB, YRE )
          YRBG = YRB(1)
Ckf       write (errfl,3141) yrknt, yrb(1), yre(1), yrbg
          SGRP = 73
          CALL Q2INIT ( MESSFL, SCLU, SGRP )
          CALL Q2STIB ( L1, L1, YRKNT, YRB )
          CALL Q2STIB ( L1, L2, YRKNT, YRE )
          CALL Q2EDIT ( YRKNT, AGAIN )
          RESP = 2
        ELSE IF (RESP .EQ. 4) THEN
C         Clear currently defined years
          CALL ZIPI ( MXRNS, ZEROI, YRB  )
          CALL ZIPI ( MXRNS, ZEROI, YRE  )
          CALL ZIPR ( MXYRS, MISS, YRMEAS )
          YRKNT = 0
          RESP = 2
        ELSE IF (RESP .EQ. 1) THEN
C         Return
          RESP = 5
        END IF
      IF (RESP .LT. 5) GO TO 100
Ckf   write (errfl,3200) yrbase, yrknt, yrb(1), yre(1), yrbg, nyrs
C
      RETURN
      END
C
C
C
      SUBROUTINE   RUNGET
     I                   ( YRBASE, MISS, YRMEAS,
     O                     YRKNT, YRB, YRE )
C
C     + + + PURPOSE + + +
C     Scan annual time series array for runs of data.  A run is
C     defined as 1 or more consecutive years with data.  A run is
C     broken by 1 or more years of missing record.
C
C     + + + PARAMETERS + + +
      include 'pmxyrs.inc'

C     + + + DUMMY ARGUMENTS + + +
      INTEGER   YRBASE, YRKNT, YRB(MXRNS), YRE(MXRNS)
      REAL      YRMEAS(MXYRS), MISS
C
C     + + + ARGUMENT DEFINITIONS
C     YRBASE - start year of time series
C     NYRS   - number of years in time series
C     MISS   - missing value indicater
C     YRMEAS - time series array
C     YRKNT  - number of runs
C     YRB    - array containing start year of a time run
C     YRE    - array containing end year of a time run
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I, ZEROI, YRC
      integer    errfl
C
C     + + + INTRINSICS + + +
      INTRINSIC   ABS
C
C     + + + EXTERNALS + + +
      EXTERNAL    ZIPI
C
C     + + + DEBUG FORMATS + + +
 3001 format ( 20x, '| runget: yrbase =', i5,
     $       /,20x, '|       :   miss =', f10.2,
     $       /,20x, '|       : yrmeas =', f10.2, '(first)',
     $       /,20x, '|       :  yrknt =', i5,
     $       /,20x, '|       :    yrc =', i5,
     $              '    i  yrc  yrb  yre yrknt' )
 3002 format ( 43x, 5i5 )
 3100 format ( 20x, '|    <--:  yrknt =', i5,
     $       /,20x, '|       : yrmeas =', f10.2, '(first)',
     $       /,20x, '|       : run(1) =', 2i5 )
C
C     + + + DATA INITITALZATIONS + + +
      DATA  ZEROI / 0 /
C
C     + + + END SPECIFICATIONS
C
      errfl = 99
      CALL ZIPI ( MXRNS, ZEROI, YRB )
      CALL ZIPI ( MXRNS, ZEROI, YRE )
      YRC    = YRBASE - 1
      YRKNT  = 0
Ckf   write (errfl,3001) yrbase,miss, yrmeas(1), yrknt, yrc
      DO 100 I = 1, MXYRS
        YRC = YRC + 1
        IF (ABS(YRMEAS(I)-MISS) .GT. .001) THEN
          IF (YRKNT .EQ. 0) THEN
C           first year
            YRKNT = 1
            YRB(1) = YRC
            YRE(1) = YRC
          ELSE IF (YRE(YRKNT)+1 .EQ. YRC) THEN
C           run of years with non-missing values continues
            YRE(YRKNT) = YRC
Ckf         write (errfl,3002) i, yrc, yrb(yrknt), yre(yrknt), yrknt
          ELSE
C           new run
            YRKNT = YRKNT + 1
            YRB(YRKNT) = YRC
            YRE(YRKNT) = YRC
Ckf         write (errfl,3002) i, yrc, yrb(yrknt), yre(yrknt), yrknt
          END IF
        END IF
 100  CONTINUE
C
Ckf   write (errfl,3100) yrknt, yrmeas(1), yrb(1), yre(1)
      IF (YRB(1) .EQ. 0) THEN
C       no non-missing values found
        YRKNT  = 0
      END IF
Ckf   write (errfl,3100) yrknt, yrmeas(1), yrb(1), yre(1)
C
      RETURN
      END
C
C
C
      SUBROUTINE  RUNPUT
     I                   ( YRBASE, FILL, MISS, YRKNT, YRB, YRE,
     O                     YRBG, NYRS, YRMEAS )
C
C     + + + PURPOSE + + +
C     Populates a time series with the e FILL for the years
C     defined by ranges in YRB and YRE.  Remaining years are set
C     to MISS.
C
C     + + + PARAMETERS + + +
      INCLUDE 'pmxyrs.inc'
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   YRBASE, YRKNT, YRB(MXRNS), YRE(MXRNS), NYRS, YRBG
      REAL      FILL, MISS, YRMEAS(MXYRS)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     YRBASE - start year for time series array
C     FILL   - fill value for years defined by yrb-yre runs
C     MISS   - fill value for years not defined
C     YRKNT  - number of runs
C     YRB    - array containing start year of a time run
C     YRE    - array containing end year of a time run
C     YRBG   - first non-missing year in time series array
C     NYRS   - number of values in time series array
C     YRMEAS - time series array 
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I, II, I1, I2, IMIN, IMAX
C
C     + + + EXTERNALS + + +
      EXTERNAL  ZIPR
C
C     + + + END SPECIFICATIONS + + +
C
      CALL ZIPR ( MXYRS, MISS, YRMEAS )
      IMIN = MXYRS + 1
      IMAX = 0
      DO 150 I = 1, YRKNT
        IF (YRB(I) .GE. YRBASE) THEN
          I1 = YRB(I) - YRBASE + 1
          IF (YRE(I) .EQ. 0) THEN
            I2 = I1
            YRMEAS(I1) = FILL
          ELSE
            I2 = I1 + YRE(I) - YRB(I)
            DO 140 II = I1, I2
              YRMEAS(II) = FILL
 140        CONTINUE
          END IF
          IF (IMIN .GT. I1) IMIN = I1
          IF (IMAX .LT. I2) IMAX = I2
        END IF
 150  CONTINUE
C
      IF (IMIN .LE. MXYRS) THEN
        YRBG = YRBASE + IMIN - 1
        NYRS  = IMAX - IMIN + 1
      ELSE
        YRBG = 0
        NYRS  = 0
      END IF
C
      RETURN
      END
